﻿Imports System.Net
Imports System.IO.Ports
Imports System.Math

Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
'Imports System.Data
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Drawing.Printing
Imports System.Text
Imports System.Windows.Forms
Imports System.Diagnostics
Imports System.IO
Imports System.Threading

Imports System.Reflection
Imports Phidgets
'needed for the spatial class and the phidgets exception class


'Magnetic declination is the angle between magnetic north (the direction the north end of a compass needle points) and true north. The declination is positive when the magnetic north is east of true north.
'Magnetic deviation is the difference between magnetic bearings and compass bearings. Deviation varies for every compass in the same location and depends on such factors as the magnetic field of the boat, wristwatches, etc. 

'PhidgetSpacial

Public Class frmCompass

    Public Sub subCompassLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) 'Handles MyBase.Load
        Try
            Me.Timer1.Enabled = False
            frmSpatial.subPhidgetSpatialLoad(sender, e)
            Timer1.Enabled = True
        Catch ex As Exception
            Timer1.Enabled = False
            boolCompassAttached = False
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subCompassLoad")
        End Try
    End Sub


    Public Function ftnLocalizeUsingCompass(ByVal tbpEstimatedPose As typeBotPose) As typeBotPose
        Try
            ftnLocalizeUsingCompass = tbpEstimatedPose
            If Not boolSimulatedMovement Then
                If boolDebugCompass Then frmDebug.subWritePose("ftnLocalizeUsingCompass  tbpEstimatedPose ", tbpEstimatedPose)
                If boolCompassIsSuspect(tbpEstimatedPose.Location.X, tbpEstimatedPose.Location.Y) And boolCompassAttached And (tbpEstimatedPose.OrientationUncertainty >= 30) Then
                    ftnLocalizeUsingCompass.OrientationUncertainty = 30
                    ftnLocalizeUsingCompass.Orientation = Int(ftnConvertTo360(90 - intCompassOrientation - intCompassOrientationOffset))
                ElseIf Not boolCompassIsSuspect(tbpEstimatedPose.Location.X, tbpEstimatedPose.Location.Y) And boolCompassAttached And (tbpEstimatedPose.OrientationUncertainty >= 16) Then
                    ftnLocalizeUsingCompass.OrientationUncertainty = 16
                    ftnLocalizeUsingCompass.Orientation = Int(ftnConvertTo360(90 - intCompassOrientation - intCompassOrientationOffset))
                ElseIf Not boolCompassAttached And Not boolCompassIsSuspect(tbpEstimatedPose.Location.X, tbpEstimatedPose.Location.Y) And (intApiUncertainty <= tbpEstimatedPose.OrientationUncertainty) Then
                    ftnLocalizeUsingCompass.OrientationUncertainty = intApiUncertainty
                    ftnLocalizeUsingCompass.Orientation = intApiOrientation
                End If
                Dim intAngleDifference As Short = Abs(ftnAngleDifference(ftnLocalizeUsingCompass.Orientation, tbpEstimatedPose.Orientation))
                If boolCompassAttached Or (intApiUncertainty < 100) Then
                    If (intAngleDifference > tbpEstimatedPose.OrientationUncertainty) Then
                        ftnLocalizeUsingCompass = tbpEstimatedPose
                    ElseIf (intAngleDifference > 14) Then
                        ftnLocalizeUsingCompass = ftnCompassCheck(ftnLocalizeUsingCompass, tbpEstimatedPose)
                    End If
                    frmDebug.subWritePose(ftnElapsedTime(timeMoveCommandSent) & "       Pose Derived From Compass       ", ftnLocalizeUsingCompass)
                    intApiUncertainty = 9999
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnLocalizeUsingCompass")
        End Try
    End Function

    Function ftnCompassCheck(ByVal tbpCompassPose As typeBotPose, ByVal tbpEstimatedPose As typeBotPose) As typeBotPose
        ' if the compass orientation does not agree with the estimated orientation , check if it is wrong due to being near metal 
        ' or perhaps it is correct due to a collision
        Try
            If Not boolSlam And Not boolEnableRBPF Then
                If boolDebugCompass Then
                    frmDebug.subWritePose("ftnCompassCheck  tbpEstimatedPose ", tbpEstimatedPose)
                    frmDebug.subWritePose("ftnCompassCheck  tbpCompassPose ", tbpCompassPose)
                End If
                Dim tbpEstimatedPoseTemp As typeBotPose = tbpEstimatedPose
                tbpEstimatedPoseTemp.OrientationUncertainty = tbpCompassPose.OrientationUncertainty
                Dim boolGoodLocalization As Boolean = False
                Dim tbpLocalizedUsingEstimated As typeBotPose = ftnLocalize_Top(tbpEstimatedPose, boolGoodLocalization) ' Compare localizations of compass orientation vs tbpEstimatedPose.Orientation and choose best fit
                Dim tbpLocalizedUsingCompass As typeBotPose = ftnLocalize_Top(tbpEstimatedPoseTemp, boolGoodLocalization)
                If (ftnPoseUncertaintyFactor(tbpLocalizedUsingCompass) < (ftnPoseUncertaintyFactor(tbpLocalizedUsingEstimated) - 50)) Then
                    ftnCompassCheck = tbpCompassPose
                    frmDebug.subWriteLogs(Color.Black, "      (Compass Check confirms unexpected orientation)")
                Else
                    ftnCompassCheck = tbpEstimatedPose
                    frmDebug.subWriteLogs(Color.Black, "      (Compass Check cannot confirm unexpected orientation.  )")
                End If
            Else
                ftnCompassCheck = tbpEstimatedPose
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnCompassCheck")
        End Try
    End Function



    Private Sub subUpdateOrientation(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick  ' 
        Try
            Timer1.Enabled = False
            If boolPhidgetsInstalled And boolCompassAttached And Not boolBotIsMoving And Not GotABotClass.updnOrientation.Focused Then
                Me.Refresh()
                Dim intCompassOrientationCorrected As Short = Int(ftnConvertTo360(90 - intCompassOrientation - intCompassOrientationOffset))
                txtOrientation.Text = intCompassOrientationCorrected.ToString
                If boolSlam Then
                    tbpBotPose.Orientation = intCompassOrientationCorrected
                    tbpBotPose.OrientationUncertainty = 16
                    GotABotClass.subUpdateAllText(tbpBotPose)
                    subDrawBot(tbpBotPose)
                ElseIf Not boolDrivingToDestination And (Not boolDock Or boolDocked Or boolPause) Then
                    If (tbpBotPose.OrientationUncertainty >= 30) And boolCompassIsSuspect(tbpBotPose.Location.X, tbpBotPose.Location.Y) Then
                        tbpBotPose.OrientationUncertainty = 30
                        tbpBotPose.Orientation = intCompassOrientationCorrected
                        GotABotClass.subUpdateAllText(tbpBotPose)
                        subDrawBot(tbpBotPose)
                    ElseIf (tbpBotPose.OrientationUncertainty >= 16) And Not boolCompassIsSuspect(tbpBotPose.Location.X, tbpBotPose.Location.Y) Then
                        tbpBotPose.OrientationUncertainty = 16
                        tbpBotPose.Orientation = intCompassOrientationCorrected
                        GotABotClass.subUpdateAllText(tbpBotPose)
                        subDrawBot(tbpBotPose)
                    End If
                End If
            Else
                txtOrientation.Text = "---"
            End If
            Timer1.Enabled = True
        Catch ex As Exception
            boolCompassAttached = False
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subUpdateOrientation")
        End Try
    End Sub



    Private Sub me_exit(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.FormClosed
        Try
            frmSpatial.spatial_Detach(sender, e)
            boolCompassAttached = False
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in me_exit")
        End Try
    End Sub



    '  -- Settings Menu  


    Private Sub mnuOreientationOffset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOreientationOffset.Click
        On Error Resume Next
        Dim strOreientationOffset As String
        strOreientationOffset = InputBox("Enter Orientation Offset ", "Orientation Offset", Str(intCompassOrientationOffset))
        If strOreientationOffset <> "" And IsNumeric(strOreientationOffset) Then
            intCompassOrientationOffset = CInt(Int(strOreientationOffset))
            boolSettingsChanged = True
        End If
    End Sub




    Private Sub OK_Button_Click(sender As Object, e As EventArgs) Handles OK_Button.Click
        Me.Visible = False
    End Sub

    Private Sub frmCompass_Load(sender As Object, e As EventArgs) Handles MyBase.Load

    End Sub
End Class

Partial Public Class frmSpatial
    Inherits Form
    Private _assembly As Assembly
    Private _imageStream As Stream

    Public spatial As Spatial

    Private lastMsCount As Double() = {0, 0, 0}
    Private lastMsCountGood As Boolean() = {False, False, False}
    'degrees
    Private compassBearingFilter As New List(Of Double())()
    Private compassBearingFilterSize As Integer = 30

    'initalize the phidget device and link the event handler code
    Public Sub subPhidgetSpatialLoad(sender As Object, e As EventArgs)
        Try
            If Phidget.LibraryVersion <> "Dummy321" Then ' Kludge.  Causes exception if Phidget DLL not loaded.
                If boolDebugCompass Then frmDebug.subWriteLogs(Color.Red, " subPhidgetSpatialLoad 0")
                spatial = New Spatial()
                If boolDebugCompass Then frmDebug.subWriteLogs(Color.Red, " subPhidgetSpatialLoad 1")
                _assembly = Assembly.GetExecutingAssembly()
                _imageStream = _assembly.GetManifestResourceStream("1056_0_Top.png")
                If boolDebugCompass Then frmDebug.subWriteLogs(Color.Red, " subPhidgetSpatialLoad 3")

                AddHandler spatial.Attach, AddressOf spatial_Attach
                AddHandler spatial.Detach, AddressOf spatial_Detach
                AddHandler spatial.SpatialData, AddressOf spatial_SpatialData
                AddHandler spatial.Error, AddressOf spatial_Error
                Me.Visible = False
                'openCmdLine(spatial)
                boolPhidgetsInstalled = True
            End If
        Catch ex As Exception
            boolPhidgetsInstalled = False
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subPhidgetSpatialLoad: " & ex.ToString)
        End Try
    End Sub

    'When the application is being terminated, close the Phidget
    Public Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs)
        Try
            RemoveHandler spatial.Attach, AddressOf spatial_Attach
            RemoveHandler spatial.Detach, AddressOf spatial_Detach
            RemoveHandler spatial.SpatialData, AddressOf spatial_SpatialData
            boolCompassAttached = False
            'run any events in the message queue - otherwise close will hang if there are any outstanding events
            Application.DoEvents()

            spatial.close()
        Catch
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in Form1_FormClosing")
        End Try
    End Sub

    Public Sub setupCompass()
        subWait(200)
    End Sub


    'spatial attach event handler
    Public Sub spatial_Attach(sender As Object, e As Phidgets.Events.AttachEventArgs)
        Try
            Dim attached As Spatial = DirectCast(sender, Spatial)
            setupCompass()

            'Select Case attached.ID
            '    Case Phidget.PhidgetID.SPATIAL_ACCEL_3
            '        Me.Bounds = New Rectangle(Me.Location, New Size(338, 634))
            '        Exit Select
            '    Case Phidget.PhidgetID.SPATIAL_ACCEL_GYRO_COMPASS
            '        Me.Bounds = New Rectangle(Me.Location, New Size(338, 634))

            '        'Sets the parameters from the user settings file
            '        ' v300+ keeps these parameters in Flash - so we don't need to set them on every attach.
            '        If attached.Version < 301 Then
            '            setupCompass()
            '        End If

            '        Exit Select
            'End Select

            'Try
            '    Dim test As Double = attached.accelerometerAxes(0).Acceleration
            'Catch
            'End Try
            attached.DataRate = 32

            lastMsCountGood(0) = False
            lastMsCountGood(1) = False
            lastMsCountGood(2) = False
            setupCompass()
        Catch
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in spatial_Attach")
        End Try
    End Sub

    'spatial detach event handler
    Public Sub spatial_Detach(sender As Object, e As Phidgets.Events.DetachEventArgs)
        Dim detached As Spatial = DirectCast(sender, Spatial)
        boolCompassAttached = False
    End Sub

    'spatial error event handler
    Public Sub spatial_Error(sender As Object, e As Phidgets.Events.ErrorEventArgs)
        Try
            Dim phid As Phidget = DirectCast(sender, Phidget)
            Select Case e.Type
                Case PhidgetException.ErrorType.PHIDGET_ERREVENT_BADPASSWORD
                    phid.close()
                    Exit Select
            End Select
        Catch
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in spatial_Error")
        End Try
    End Sub

    Public Sub spatial_SpatialData(sender As Object, e As Phidgets.Events.SpatialDataEventArgs)
        Try
            'Even when there is a compass chip, sometimes there won't be valid data in the event.
            If spatial.compassAxes.Count > 0 AndAlso e.spatialData(0).MagneticField.Length > 0 Then
                Try
                    calculateCompassBearing()
                Catch
                    frmDebug.subWriteLogs(Color.Red, " EXCEPTION in spatial_SpatialData")
                End Try
            Else
                boolCompassAttached = False
            End If
        Catch
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in spatial_SpatialData")
        End Try
    End Sub



    Private Sub subGyroInitialize()
        Try
            spatial.zeroGyro()
            Thread.Sleep(100)
            calculateCompassBearing()
        Catch
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subGyroInitialize")
        End Try
    End Sub



    'This finds a magnetic north bearing, correcting for board tilt and roll as measured by the accelerometer
    'This doesn't account for dynamic acceleration - ie accelerations other then gravity will throw off the calculation
    'Calculations based on AN4248
    Private lastAngles As Double() = {0, 0, 0, 0}
    Private Sub calculateCompassBearing()
        boolCompassAttached = (spatial.compassAxes.Count > 0)
        gravity = {spatial.accelerometerAxes(0).Acceleration, spatial.accelerometerAxes(1).Acceleration, spatial.accelerometerAxes(2).Acceleration}

        Dim magField As Double() = {spatial.compassAxes(0).MagneticField, spatial.compassAxes(1).MagneticField, spatial.compassAxes(2).MagneticField}
        'Roll Angle - about axis 0
        '  tan(roll angle) = gy/gz
        '  Use Atan2 so we have an output os (-180 - 180) degrees
        Dim rollAngle As Double = Math.Atan2(gravity(1), gravity(2))

        'Pitch Angle - about axis 1
        '  tan(pitch angle) = -gx / (gy * sin(roll angle) * gz * cos(roll angle))
        '  Pitch angle range is (-90 - 90) degrees
        Dim pitchAngle As Double = Math.Atan(-gravity(0) / (gravity(1) * Math.Sin(rollAngle) + gravity(2) * Math.Cos(rollAngle)))

        'Yaw Angle - about axis 2
        '  tan(yaw angle) = (mz * sin(roll) – my * cos(roll)) / 
        '                   (mx * cos(pitch) + my * sin(pitch) * sin(roll) + mz * sin(pitch) * cos(roll))
        '  Use Atan2 to get our range in (-180 - 180)
        '
        '  Yaw angle == 0 degrees when axis 0 is pointing at magnetic north
        Dim yawAngle As Double = Math.Atan2(magField(2) * Math.Sin(rollAngle) - magField(1) * Math.Cos(rollAngle), magField(0) * Math.Cos(pitchAngle) + magField(1) * Math.Sin(pitchAngle) * Math.Sin(rollAngle) + magField(2) * Math.Sin(pitchAngle) * Math.Cos(rollAngle))
        Dim angles As Double() = {rollAngle, pitchAngle, yawAngle, 0}


        'we low-pass filter the angle data so that it looks nicer on-screen
        Try
            'make sure the filter buffer doesn't have values passing the -180<->180 mark
            'Only for Roll and Yaw - Pitch will never have a sudden switch like that
            For i As Integer = 0 To 3  '2 Step 2
                If Math.Abs(angles(i) - lastAngles(i)) > 3 Then
                    For Each stuff As Double() In compassBearingFilter
                        If angles(i) > lastAngles(i) Then
                            stuff(i) += 360 * Math.PI / 180.0
                        Else
                            stuff(i) -= 360 * Math.PI / 180.0
                        End If
                    Next
                End If
            Next

            lastAngles = DirectCast(angles.Clone(), Double())

            compassBearingFilter.Add(DirectCast(angles.Clone(), Double()))
            If compassBearingFilter.Count > compassBearingFilterSize Then
                compassBearingFilter.RemoveAt(0)
            End If

            yawAngle = InlineAssignHelper(pitchAngle, InlineAssignHelper(rollAngle, 0))
            For Each stuff As Double() In compassBearingFilter
                rollAngle += stuff(0)
                pitchAngle += stuff(1)
                yawAngle += stuff(2)
            Next
            yawAngle /= compassBearingFilter.Count
            pitchAngle /= compassBearingFilter.Count
            rollAngle /= compassBearingFilter.Count
            intCompassOrientation = ftnConvertTo360(yawAngle * (180.0 / Math.PI))  'Convert radians to degrees for display
        Catch
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in calculateCompassBearing")
        End Try
    End Sub


    'Parses command line arguments and calls the appropriate open
#Region "Command line open functions"
    Private Sub openCmdLine(p As Phidget)
        openCmdLine(p, Nothing)
    End Sub
    Private Sub openCmdLine(p As Phidget, pass As [String])
        Dim serial As Integer = -1
        Dim port As Integer = 5001
        Dim host As [String] = Nothing
        Dim remote As Boolean = False, remoteIP As Boolean = False
        Dim args As String() = Environment.GetCommandLineArgs()
        Dim appName As [String] = args(0)

        Try
            'Parse the flags
            For i As Integer = 1 To args.Length - 1
                If args(i).StartsWith("-") Then
                    Select Case args(i).Remove(0, 1).ToLower()
                        Case "n"
                            serial = Integer.Parse(args(System.Threading.Interlocked.Increment(i)))
                            Exit Select
                        Case "r"
                            remote = True
                            Exit Select
                        Case "s"
                            remote = True
                            host = args(System.Threading.Interlocked.Increment(i))
                            Exit Select
                        Case "p"
                            pass = args(System.Threading.Interlocked.Increment(i))
                            Exit Select
                        Case "i"
                            remoteIP = True
                            host = args(System.Threading.Interlocked.Increment(i))
                            If host.Contains(":") Then
                                port = Integer.Parse(host.Split(":"c)(1))
                                host = host.Split(":"c)(0)
                            End If
                            Exit Select
                        Case Else
                            GoTo usage
                    End Select
                Else
                    GoTo usage
                End If
            Next

            If remoteIP Then
                p.open(serial, host, port, pass)
            ElseIf remote Then
                p.open(serial, host, pass)
            Else
                p.open(serial)
            End If
            'success
            Return
        Catch
        End Try
usage:
        Dim sb As New StringBuilder()
        sb.AppendLine("Invalid Command line arguments." & Environment.NewLine)
        sb.AppendLine("Usage: " & appName & " [Flags...]")
        sb.AppendLine("Flags:" & vbTab & "-n   serialNumber" & vbTab & "Serial Number, omit for any serial")
        sb.AppendLine(vbTab & "-r" & vbTab & vbTab & "Open remotely")
        sb.AppendLine(vbTab & "-s   serverID" & vbTab & "Server ID, omit for any server")
        sb.AppendLine(vbTab & "-i   ipAddress:port" & vbTab & "Ip Address and Port. Port is optional, defaults to 5001")
        sb.AppendLine(vbTab & "-p   password" & vbTab & "Password, omit for no password" & Environment.NewLine)
        sb.AppendLine("Examples: ")
        sb.AppendLine(appName & " -n 50098")
        sb.AppendLine(appName & " -r")
        sb.AppendLine(appName & " -s myphidgetserver")
        sb.AppendLine(appName & " -n 45670 -i 127.0.0.1:5001 -p paswrd")
        MessageBox.Show(sb.ToString(), "Argument Error", MessageBoxButtons.OK, MessageBoxIcon.[Error])

        Application.[Exit]()
    End Sub
#End Region

    Private Sub panel1_Paint(sender As Object, e As PaintEventArgs)

    End Sub
    Private Shared Function InlineAssignHelper(Of T)(ByRef target As T, value As T) As T
        target = value
        Return value
    End Function
End Class
