﻿Imports System.Math

Public Class frmDock

    Private Sub subDockLoad(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        On Error Resume Next
        UpDnLocX.Value = tmcDock.X
        UpDnLocY.Value = tmcDock.Y
        updnOrientation.Value = intDockOrientation
        UpDownPCTrigger.Value = intDockTriggerPC
        txtBotBatteryTrigger.Text = sngDockTriggerBot.ToString
        chkBackIn.Checked = boolDockBackIn
    End Sub



    Private Sub UpDnLocX_ValueChanged(sender As System.Object, e As System.EventArgs) Handles UpDnLocX.ValueChanged
        On Error Resume Next
        boolSettingsChanged = True
        tmcDock.X = UpDnLocX.Value
        tmcDock = ftnCheckMapArrayLimits(tmcDock)
        UpDnLocX.Value = tmcDock.X
    End Sub


    Private Sub UpDnLocY_ValueChanged(sender As System.Object, e As System.EventArgs) Handles UpDnLocY.ValueChanged
        On Error Resume Next
        tmcDock.Y = UpDnLocY.Value
        tmcDock = ftnCheckMapArrayLimits(tmcDock)
        UpDnLocY.Value = tmcDock.Y
        boolSettingsChanged = True
    End Sub


    Private Sub updnOrientation_ValueChanged(sender As System.Object, e As System.EventArgs) Handles updnOrientation.ValueChanged
        On Error Resume Next
        intDockOrientation = updnOrientation.Value
        boolSettingsChanged = True
    End Sub


    Private Sub ChkBackIn_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkBackIn.CheckedChanged
        On Error Resume Next
        boolDockBackIn = chkBackIn.Checked()
        boolSettingsChanged = True
    End Sub

    Private Sub UpDownPCTrigger_ValueChanged(sender As System.Object, e As System.EventArgs) Handles UpDownPCTrigger.ValueChanged
        On Error Resume Next
        intDockTriggerPC = UpDownPCTrigger.Value
        boolSettingsChanged = True
    End Sub

    Private Sub txtBotBatteryTrigger_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtBotBatteryTrigger.TextChanged
        On Error Resume Next
        If (txtBotBatteryTrigger.Text <> "") Then sngDockTriggerBot = Val(txtBotBatteryTrigger.Text)
1:      boolSettingsChanged = True
    End Sub


    Private Sub OK_Button_Click(sender As System.Object, e As System.EventArgs) Handles OK_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Visible = False
        GotABotClass.subRedraw(tbpBotPose)
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(sender As System.Object, e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
        GotABotClass.mnuLoadSettings_Click(tlmLandMarkArray, e)
    End Sub


    Private Sub Exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.FormClosing
        Me.Visible = False
        GotABotClass.subRedraw(tbpBotPose)
    End Sub


    '*****************************************************************************************************************************


    Public Sub subDock()
        Try
            If Not ftnCheckForStopMode() Then
                boolDock = True
                GotABotClass.timerWatchDog.Interval = 900000
                ftnSendCommand("play phraseA 'Docking.'")
                boolRangeReadingsAreFresh = False
                tbpStartingPose = tbpBotPose
                tbpTargetPoseGlobal = tbpBotPose
                Dim boolGoodLocalization As Boolean = False
                tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                subDriveToPreDock()
                tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                Do
                    subPreDockAdjust()  ' Want accurate positioning before attempting Dock contact
                    subCheckForPause()
                    boolDocked = ftnDockMakeContact()
                    If Not boolDocked Then subUnDock(tbpBotPose)
                    tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                    If Not boolDocked And ftnIAmLost(tbpBotPose) Then ftnLostRecoveryTop(tbpBotPose)
                Loop Until boolDocked Or boolStop Or ftnIAmLost(tbpBotPose) Or boolShutDown Or (GotABotClass.picStop.BorderStyle = FormBorderStyle.Fixed3D)
                If boolDocked And Not boolStop And Not boolShutDown Then
                    If ftnIAmLost(tbpBotPose) Then
                        boolRangeReadingsAreFresh = False
                        tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                    End If
                    tbpBotPose.Location = tmcDock
                    GotABotClass.timerWatchDog.Interval = 900000
                    If Not GotABotClass.InvokeRequired Then
                        frmDebug.subWriteFinishedMessage()
                        GotABotClass.StatusDriving.ForeColor = Color.Black
                        strStatusDriving = "DOCKED"
                        GotABotClass.mnuDock.Checked = False
                    End If
                    ftnSendCommand("play phraseA 'Docking Completed.'")
                    boolDock = False
                    intMovementsSinceLocalization = 0
                    subInitParticles(tbpBotPose, intNumberOfParticles)
                    boolDocked = True
                ElseIf boolStop Then
                    boolDocked = False
                    boolDock = False
                    GotABotClass.mnuDock.Checked = False
                    GotABotClass.timerWatchDog.Interval = 60000
                Else
                    boolDocked = False
                    GotABotClass.mnuDock.Checked = False
                    GotABotClass.timerWatchDog.Interval = 60000
                    ftnSendCommand("play phraseA 'Docking Failed.'")
                    boolDock = False
                End If
            End If
            GotABotClass.subRedraw(tbpBotPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subDock")
        End Try
    End Sub

    Public Sub subUnDock(ByRef tbpEstimatedPose As typeBotPose)
        Try
            If Not boolStop And Not boolPause And (ftnLocationsEqual(tbpBotPose.Location, tmcDock) Or boolDocked) And Not boolShutDown And Not (GotABotClass.picStop.BorderStyle = FormBorderStyle.Fixed3D) Then
                frmDebug.subWriteLogs(Color.Black, "    ")
                frmDebug.subWriteLogs(Color.Black, "    ")
                frmDebug.subWriteLogs(Color.Black, "    ")
                frmDebug.subWriteLogs(Color.Black, Now() & "    --------------------------  UnDocking.  ----------------------- ")
                boolPoseConfirmedAfterCollision = True
                Dim tbpTargetPose As typeBotPose = tbpEstimatedPose
                If boolDockBackIn Then
                    tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, sngSixInches)
                Else
                    tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, sngFourInches + sngBotRadius)
                End If
                For I As Integer = 1 To 4
                    ftnSendCommand("play phrase prompt")
                    subWait(250)
                Next I
                tbpEstimatedPose = ftnBotFwd(tbpEstimatedPose, tbpTargetPose)  '  
                intMovementsSinceLocalization = 99  'Force Localization
                tbpBotPose = ftnPostMovement(tbpTargetPose, "Fwd", tbpTargetPose)
                boolDocked = False
                GotABotClass.mnuDock.Checked = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subUnDock")
        End Try
    End Sub

    Function ftnGetBatteryPreDock() As Single
        On Error Resume Next
        ftnSendCommand("battery")
        Dim timeOut As DateTime = Now().AddMilliseconds(4000)
        Do
            ftnGetBatteryPreDock = sngBotBatteryVoltage
            ftnSendCommand("battery")
        Loop Until ((ftnGetBatteryPreDock - sngBotBatteryVoltage) < (ftnGetBatteryPreDock / 100)) Or boolStop Or boolShutDown Or (Now() > timeOut) ' wait for battery voltage to stabilize
    End Function

    Sub subDriveToPreDock()
        On Error Resume Next
        tmcDestination = ftnPreDockLocation()
        ftnDriveToDestination_Top(tbpBotPose, tmcDestination)
        Dim boolGoodLocalization As Boolean = False
        tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
    End Sub

    Sub subPreDockAdjust()
        ' Turn towards preDock location
        ' Goto preDock Location
        ' Turn towards Dock 
        Try  ' Fine positioning before final docking maneuvers. Called when Bot has arrived near its pre docking position (approx 5" in front of dock)
            Dim boolLWMTemp As Boolean = boolEnableLocalizationWhileMoving
            Dim boolGoodLocalization As Boolean = False
            boolEnableLocalizationWhileMoving = False
            Dim sngPreDockOrientation As Single = intDockOrientation  ' Desired orientation when at preDock location
            If boolDockBackIn Then sngPreDockOrientation = ftnConvertTo360(sngPreDockOrientation + 180)
            Dim sngBotToPreDockOrientation As Single
            While Not (boolStop Or boolShutDown Or ftnIAmLost(tbpBotPose) Or (GotABotClass.picStop.BorderStyle = FormBorderStyle.Fixed3D)) And _
                   ((ftnDistanceBetweenLocations(tbpBotPose.Location, ftnPreDockLocation) > sngThreeInches) Or _
                   (Abs(ftnAngleDifference(tbpBotPose.Orientation, Convert.ToInt16(sngPreDockOrientation))) > 12) Or _
                   (Abs(ftnAngleDifference(tbpBotPose.Orientation, Convert.ToInt16(ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation())))) > 8))
                subDoEventsIfMainThread()
                frmDebug.subWriteLogs(Color.Black, "    ")
                frmDebug.subWriteLogs(Color.Black, "    ")
                frmDebug.subWriteLogs(Color.Black, "    ")
                frmDebug.subWriteLogs(Color.Black, Now() & "    --------------------------  PreDocking Adjustment  ----------------------- ")
                sngBotToPreDockOrientation = (ftnP1ToP2Angle(tbpBotPose.Location, ftnPreDockLocation))
                Dim sngDistanceToPreDock As Single = ftnDistanceBetweenLocations(tbpBotPose.Location, ftnPreDockLocation)
                Dim tbpTargetPose As typeBotPose = tbpBotPose
                If (Abs(ftnAngleDifference(Convert.ToInt16(sngBotToPreDockOrientation), tbpBotPose.Orientation)) > 135) And (sngDistanceToPreDock > sngThreeInches) And (sngDistanceToPreDock < sngTwelveInches) Then
                    frmDebug.subWriteLogs(Color.Red, Now() & " ***** Turn and Backup: . ***************************")
                    tbpTargetPose.Orientation = ftnConvertTo360(sngBotToPreDockOrientation - 180)
                    If (Abs(ftnAngleDifference(Convert.ToInt16(sngBotToPreDockOrientation), tbpBotPose.Orientation)) > 4) Then tbpBotPose = ftnBotTurn(tbpBotPose, True, tbpTargetPose) ' Turn to preDock Location
                    If (ftnPoseUncertaintyFactor(tbpBotPose) > 560) Then ' 560=(14+14)*20
                        tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)  ' readjust if poor localization
                        If (Abs(ftnAngleDifference(Convert.ToInt16(sngBotToPreDockOrientation), tbpBotPose.Orientation)) > 4) Then tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose) ' Turn to preDock Location
                    End If
                    subPostDockingMovement()
                    tbpTargetPose = tbpBotPose
                    tbpTargetPose.Location = ftnPreDockLocation() '
                    tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose) ' backup 
                ElseIf (sngDistanceToPreDock > sngThreeInches) Then
                    sngBotToPreDockOrientation = ((ftnP1ToP2Angle(tbpBotPose.Location, ftnPreDockLocation))) '
                    tbpTargetPose.Orientation = sngBotToPreDockOrientation
                    If (Abs(ftnAngleDifference(Convert.ToInt16(sngBotToPreDockOrientation), tbpBotPose.Orientation)) > 5) Then tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose) ' turn towards PreDock Location
                    subPostDockingMovement()
                    tbpTargetPose.Location = ftnPreDockLocation()
                    tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)  ' Goto preDock Location
                ElseIf (Abs(ftnAngleDifference(tbpBotPose.Orientation, Convert.ToInt16(sngPreDockOrientation))) > 12) Then
                    tbpTargetPose = tbpBotPose
                    tbpTargetPose.Orientation = sngPreDockOrientation
                    tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose) ' Turn to Dock
                ElseIf (Abs(ftnAngleDifference(tbpBotPose.Orientation, Convert.ToInt16(ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation())))) > 8) Then
                    tbpTargetPose = tbpBotPose
                    tbpTargetPose.Orientation = ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation())
                    tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose) ' Turn to Dock
                Else
                    sngBotToPreDockOrientation = ((ftnP1ToP2Angle(tbpBotPose.Location, ftnPreDockLocation))) '
                    tbpTargetPose.Orientation = sngBotToPreDockOrientation
                    If (Abs(ftnAngleDifference(Convert.ToInt16(sngBotToPreDockOrientation), tbpBotPose.Orientation)) > 5) Then tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose) ' turn towards PreDock Location
                    subPostDockingMovement()
                    tbpTargetPose.Location = ftnPreDockLocation()
                    tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)  ' Goto preDock Location
                End If
                subPostDockingMovement()
                tbpTargetPose.Orientation = ftnConvertTo360(ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation())) '
                If Not boolStop And (Abs(ftnAngleDifference(tbpTargetPose.Orientation, tbpBotPose.Orientation)) > 4) Then
                    tbpTargetPose = tbpBotPose
                    tbpBotPose = ftnBotTurn(tbpBotPose, True, tbpTargetPose) '  Turn towards Dock
                    subPostDockingMovement()
                End If
                tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                subDoEventsIfMainThread()
            End While
            boolEnableLocalizationWhileMoving = boolLWMTemp
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subPreDockAdjust")
        End Try
    End Sub

    Function ftnDockMakeContact() As Boolean  ' returns true if docking successful
        Try ' Final docking maneuvers - Line up charging contacts with Dock and then drive to Dock
            If Not boolStop And Not boolShutDown And Not (GotABotClass.picStop.BorderStyle = FormBorderStyle.Fixed3D) Then
                ftnDockMakeContact = False
                boolEnableLocalizationWhileMoving = False
                subDoEventsIfMainThread()
                frmDebug.subWriteLogs(Color.Black, "    ")
                frmDebug.subWriteLogs(Color.Black, "    ")
                frmDebug.subWriteLogs(Color.Black, "    ")
                frmDebug.subWriteLogs(Color.Black, Now() & "    --------  Final Docking Sequence  --------- ")

                Dim intTurns As Short = 0
                While Not ftnDockMakeContact And (intTurns < 2)
                    ftnDockMakeContact = ftnDockTurnContactsTowards()
                    intTurns += 1
                End While
                If ftnDockMakeContact Then ftnDockMakeContact = ftnDockMakeContactFinalMovement(tbpBotPose)

            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnDockMakeContact")
        End Try
    End Function

    Function ftnDockTurnContactsTowards() As Boolean
        Try
            ftnDockTurnContactsTowards = False
            If Not boolStop And Not boolPause And Not boolShutDown Then
                Dim tbpTargetPose As typeBotPose = tbpBotPose
                intDrivingSequenceNumber += 1
                tbpTargetPose.Orientation = ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation)
                frmDebug.subWriteLogs(Color.Black, Now() & "    --------  Turn Contacts Towards Dock  --------- ")
                If boolDockBackIn And Not boolStop And Not boolPause Then  ' Dock contacts are accessed via the rear of the robot
                    tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + 180)
                    tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose) ' Turn so that rear of Bot faces Dock
                    If ftnScannerEnabled() Then tbpBotPose = ftnLocalize_Top(tbpBotPose, True)
                    subPostDockingMovement()
                    ftnDockTurnContactsTowards = (Abs(ftnAngleDifference(ftnConvertTo360(tbpBotPose.Orientation + 180), ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation))) < 10)
                ElseIf Not boolStop And Not boolPause Then
                    tbpTargetPose.Location = ftnDockContactLocation()
                    tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose) ' Face the Dock
                    If ftnScannerEnabled() Then tbpBotPose = ftnLocalize_Top(tbpBotPose, True)
                    subPostDockingMovement()
                    ftnDockTurnContactsTowards = (Abs(ftnAngleDifference(tbpBotPose.Orientation, Convert.ToInt16(ftnP1ToP2Angle(tbpBotPose.Location, ftnDockContactLocation)))) < 10)
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnDockTurnContactsTowards " & ex.ToString)
        End Try
    End Function

    Function ftnDockMakeContactFinalMovement(ByRef tbpEstimatedPose As typeBotPose) As Boolean
        ' Make contact with Dock and determine success by measuring battery voltage
        Try
            ftnDockMakeContactFinalMovement = False
            If Not boolStop And Not boolPause And Not boolShutDown Then
                Dim sngBotBatteryPreDock As Single = ftnGetBatteryPreDock()  '  Bot's Battery voltage used to determine docking success
                Dim boolLWMTemp As Boolean = boolEnableLocalizationWhileMoving
                Dim sngBotLinearVelocityTemp As Single = sngBotLinearVelocity
                Dim tbpTargetPose As typeBotPose = tbpEstimatedPose
                If boolER1Selected Then  ' slower speed for making contact
                    sngBotLinearVelocity = Min(sngBotLinearVelocity, 15)
                    ftnER1_SocketCommunicate("set linear velocity " & sngBotLinearVelocity, "OK", 1000)
                    ftnER1_SocketCommunicate("set power moving " & Int(intPowerMoving * 0.6), "OK", 1000)
                End If
                If boolDockBackIn Then  ' Dock contacts are accessed via the rear of the robot
                    If boolURGConnected Then
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, ftnDistanceBetweenLocations(tbpBotPose.Location, tmcDock) + sngThreeInches)
                    Else
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, ftnDistanceBetweenLocations(tbpBotPose.Location, tmcDock) + sngFiveInches)
                    End If
                Else
                    If boolURGConnected Then
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, ftnDistanceBetweenLocations(tbpBotPose.Location, tmcDock) + sngThreeInches)
                    Else
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, ftnDistanceBetweenLocations(tbpBotPose.Location, tmcDock) + sngFiveInches)
                    End If
                End If
                frmDebug.subWriteLogs(Color.Black, Now() & "    --------  Make Contact With Dock  --------- ")
                tbpBotPose = ftnBotFwd(tbpEstimatedPose, tbpTargetPose)  ' Make contact
                intDrivingSequenceNumber += 1
                If boolSimulatedMovement Then
                    ftnDockMakeContactFinalMovement = True
                ElseIf Not boolStop And Not boolShutDown And Not boolPause Then
                    subWait(4000) ' wait for battery to charge a bit
                    Dim i As Integer = 0
                    While (i < 12) And Not ftnDockMakeContactFinalMovement And Not boolShutDown And Not boolStop And Not boolPause
                        i += 1
                        subWait(1000)
                        ftnDockMakeContactFinalMovement = ftnDocked(sngBotBatteryPreDock)
                        If boolDebugDock Then frmDebug.subWriteLogs(Color.Black, Now() & " >DOCKING CHECK: sngBotBatteryPreDock: " & sngBotBatteryPreDock & "    sngBotBatteryVoltage: " & sngBotBatteryVoltage)
                    End While
                    If Not ftnDockMakeContactFinalMovement Then
                        frmDebug.subWriteLogs(Color.Black, Now() & " >DOCKING FAILED: sngBotBatteryPreDock: " & sngBotBatteryPreDock & "    sngBotBatteryVoltage: " & sngBotBatteryVoltage)
                        Dim boolDummy As Boolean
                        tbpBotPose = ftnLocalize_Top(tbpBotPose, boolDummy)
                    End If
                End If
                boolEnableLocalizationWhileMoving = boolLWMTemp
                If boolER1Selected Then
                    sngBotLinearVelocity = sngBotLinearVelocityTemp
                    ftnER1_SocketCommunicate("set linear velocity " & sngBotLinearVelocity, "OK", 1000)
                    ftnER1_SocketCommunicate("set power moving " & intPowerMoving, "OK", 1000)
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnDockMakeContactFinalMovement " & ex.ToString)
        End Try
    End Function

    Sub subPostDockingMovement() ' TODO -Change to function, return pose
        ' Check for collision, pause
        If Not boolSimulatedMovement And Not boolStop Then
            subWait(1000)
            boolCollisionDetected = ftnCheckForCollision()
            If boolCollisionDetected Then tbpBotPose = ftnCollisionRecovery(tbpBotPose)
            intDrivingSequenceNumber += 1
            subCheckForPause()
        End If
    End Sub

    Public Function ftnPreDockLocation() As typeMapCoordinate
        Try
            Dim sngDistanceFromDock As Single
            If boolURGConnected Then
                sngDistanceFromDock = sngFiveInches  ' A URG has a short minimum distance for measurement and excellent localizing abilities
            ElseIf boolKinectConnected Then
                sngDistanceFromDock = sngTenInches ' Kinect has a long minimum distance for measurement
            Else
                sngDistanceFromDock = ftnInchesToMapUnits(8)
            End If
            If Not boolDockBackIn Then sngDistanceFromDock = -sngDistanceFromDock
            ftnPreDockLocation = ftnLocationFromLocation(tmcDock, intDockOrientation, sngDistanceFromDock)
            If ftnInWall(ftnPreDockLocation) Then ftnPreDockLocation = ftnLocationFromLocation(tmcDock, intDockOrientation, sngDistanceFromDock / 2)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnPreDockLocation")
        End Try
    End Function

    Function ftnDockContactLocation() As typeMapCoordinate
        If boolDockBackIn Then
            ftnDockContactLocation = ftnLocationFromLocation(tmcDock, intDockOrientation, -sngBotRadius)
        Else
            ftnDockContactLocation = ftnLocationFromLocation(tmcDock, intDockOrientation, +sngBotRadius)
        End If
    End Function


    Function ftnDocked(ByVal sngBotBatteryPreDock As Single) As Boolean  ' True if Bot Battery is a higher voltage than when previously measured
        On Error Resume Next
        If boolSimulatedMovement Then
            ftnDocked = True
        ElseIf Not boolStop And Not boolShutDown Then
            ftnSendCommand("battery")
            ftnDocked = (sngBotBatteryVoltage > (sngBotBatteryPreDock * 1.015)) ' And (SystemInformation.PowerStatus.BatteryChargeStatus = BatteryChargeStatus.Charging)
        End If
    End Function


End Class