﻿
'Option Strict On

'=============================================================================================================================================================

' NOTE:  This project requires that drivers for Phidgets (http://www.phidgets.com/docs/OS_-_Windows#Quick_Downloads) 
' and Kinect (http://www.microsoft.com/en-us/kinectforwindows/develop/) be installed on the PC

' intRobot_Port  = 9000
' intLocalRccPort  = 9200
' API_Port = 9100
' 2nd API_Port = 9400
' GotAGlyph Port = 9050
' RoboRealm_Port = 6060
' Face Detect Port = 9150   (GotAMissile - interface not implemented yet)
' GotAKinect Port = 9060
' GotAnArm Port = 9070

'=============================================================================================================================================================


Imports System.Net
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Text.RegularExpressions
Imports System.Threading
Imports System.EventArgs
Imports System.Net.Sockets
Imports System.Text
Imports System.Math

' Imports Microsoft.Kinect

Imports Phidgets
Imports Phidgets.Events


Public Class GotABotClass

    Dim boolMouseDown As Boolean = False
    Dim boolSettingsChangedTemp As Boolean = False
    Dim boolPlaceBot As Boolean = False
    Dim boolPlaceDestination As Boolean = False

    Public Sub New()
        InitializeComponent()
    End Sub


    Private Sub subGotABotLoad(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            Dim infoReader As System.IO.FileInfo = My.Computer.FileSystem.GetFileInfo("GotABot_Log.txt")
            If (Dir("GotABot_Log.txt") <> "") Then
                If infoReader.Length > 10000000 Then frmDebug.subWriteLogs(Color.Green, " GotABot_Log.txt is growing excessively large.  Please start a new log file")
            End If
            mnuMapUnits.Items.Add("inch")
            mnuMapUnits.Items.Add("cm")
            LoadSettings("GotABot_Settings.xml") ' load settings
            Start_Threads()
            subOpenMap("GotABot_Map.bmp")
            Me.Text = "GOTABOT       (Version " & My.Application.Info.Version.ToString(3) & ")"
            Me.StatusDriving.ForeColor = Color.Black
            System.Windows.Forms.Application.DoEvents()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subGotABotLoad")
        End Try
    End Sub


    Sub subInitialize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.Shown
        Try
            frmDebug.subWriteLogs(Color.Red, "")
            frmDebug.subWriteLogs(Color.Red, Now() & " ************************ GOTABOT       (Version " & My.Application.Info.Version.ToString(3) & ")  ********************************")
            frmDebug.subWriteLogs(Color.Red, "")
            For intRangerNumber As Short = 0 To UBound(trfRangeFinders)
                trfRangeFinders(intRangerNumber).sngMaxRange = constIR_MaxRange
            Next
            If (ticCameraResolution.X = 0) Then
                ticCameraResolution.X = 640
                ticCameraResolution.Y = 480
            End If
            frmLandMarkEdit.UpDnLocX.Maximum = imgMap.Width
            frmLandMarkEdit.UpDnLocY.Maximum = imgMap.Height
            frmLandMarkEdit.UpDnValidX.Maximum = imgMap.Width
            frmLandMarkEdit.UpDnValidY.Maximum = imgMap.Height
            frmLandMarkEdit.UpDnValidWidth.Maximum = imgMap.Width
            frmLandMarkEdit.UpDnValidHeight.Maximum = imgMap.Height
            boolStop = False

            frmRangeFinder.Visible = False
            frmPose.Visible = False
            frmDebug.Visible = boolViewDebug
            frmLandMarkEdit.Visible = boolViewLM
            frmLM_Image.Visible = False
            frmRangeFinder.Visible = False
            boolRangersAreEnabled = frmRangeFinder.ftnRangersAreEnabled()
            tbpTargetPoseGlobal = tbpBotPose
            subEndImageRecognition()
            boolSettingsChanged = False
            If boolEnableGotAGlyph And (ProcessesRunning("GotAGlyph") = 0) Then Process.Start(Environment.CurrentDirectory & "\GotAGlyph\GotAGlyph.exe", "")
            timerWatchDog.Interval = 60000
            timerWatchDog.Enabled = True
            frmCompass.Visible = False
            frmCompass.subCompassLoad(sender, e)
            ftnURGInitializeTop()
            If Not boolURGConnected Then ftnKinectInitializeTop()
            If boolHeroSelected Then
                ftnHeroConfig()
                sngMaxTurn = 90
                subCalculateScanBeamAngles()
                subCalculateScanCalCoefficients()
            ElseIf boolER1Selected Then
                ftnSendCommand("stop") ' force login for the ER1 I/F 
            End If
            strTypeOfMove = ""
            subInitializeDrivingControl(tbpBotPose, tbpBotPose)
            ftnGotAGlyph_Communicate("glyph", ">", 500)
            ftnLRCC_Communicate("events" & vbCrLf, "OK", 1000)
            ftnSendCommand("battery")
            AboutBox1.LabelVer.Text = "Version " & My.Application.Info.Version.ToString
            subRecalculateVariables()
            subConvertMapToArray()
            timeMoveCommandSent = Now()
            subConfigureMenu(sender, e)
            ftnBotStop(tbpBotPose, tbpBotPose)
            boolBotIsMoving = False
            strStatusDriving = "Waiting for command "
            subStartSpeechRecognition()
            System.Windows.Forms.Application.DoEvents()
            tbpStartingPose = tbpBotPose
            subInitParticles(tbpBotPose, intNumberOfParticles)
            For Each sp As String In My.Computer.Ports.SerialPortNames  ' Show all available COM ports.
                mnuComPortComboBox.Items.Add(sp)         'adds COMX to mnuComPortComboBox
            Next
            mnuComPortComboBox.Items.Add("None")         'adds "None" to mnuComPortComboBox
            mnuComPortComboBox.Text = strBotComPort  'selects the USB port declared in the 'Save Settings' file
            classScanner.mnuURGPortComboBox.Text = strURGComPort  'selects the USB port declared in the 'Save Settings' file
            AddHandler Me.SizeChanged, AddressOf subSizeChanged
            ftnSendCommand("play phraseA 'Ready'")
            subRedraw(tbpBotPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subInitialize")
        End Try
    End Sub

    Dim boolRedrawInProgress As Boolean = False
    Public Sub subRedraw(ByRef tbpBotPose As typeBotPose)
        Dim intParticleNumber As Short
        Try
            If Not boolRedrawInProgress Then
                boolRedrawInProgress = True
                If Not Me.myMap.InvokeRequired Then
                    myMap_Scale()
                    If (boolAllowRoboRealmToControlBot And (Not boolAllowRRToControlBotIsActive)) Then AllowRRToControlBot()
                    subLoadImage()
                    If boolPlaceBot Then
                        Me.picBot.BorderStyle = FormBorderStyle.Fixed3D
                    Else
                        Me.picBot.BorderStyle = FormBorderStyle.None
                    End If
                    If boolPlaceDestination Then
                        Me.picDestination.BorderStyle = FormBorderStyle.Fixed3D
                    Else
                        Me.picDestination.BorderStyle = FormBorderStyle.None
                    End If
                    If boolPause Then
                        Me.picPause.BorderStyle = FormBorderStyle.Fixed3D
                    Else
                        Me.picPause.BorderStyle = FormBorderStyle.None
                    End If
                    If Not boolBotIsMoving Then
                        boolViewDebug = frmDebug.Visible
                        boolSettingsChangedTemp = boolSettingsChanged
                        boolViewLM = frmLandMarkEdit.Visible
                        boolSettingsChanged = boolSettingsChangedTemp
                        If boolDock Then subDrawSmallCircle(tmcDock, Color.Purple)
                    End If
                    If Not boolDrivingToDestination Then myMap.Select()
                End If
                subUpdateAllText(tbpBotPose)
                If boolDrivingToDestination Then subShowPath(tmcDestination)
                subDrawBot(tbpBotPose)
                If boolEnableRBPF And Not boolBotIsMoving And Not boolSimulatedMovement Then
                    For intParticleNumber = 0 To intNumberOfParticles - 1 Step Max(intNumberOfParticles / 128, 1)
                        subDrawMapPixel(tbpParticlePose(intParticleNumber).Location.X, tbpParticlePose(intParticleNumber).Location.Y, Color.CornflowerBlue)
                    Next
                    If frmSlam.Visible Then subDrawMapPixel(tbpParticlePose(frmSlam.updnSelectMap.Value).Location.X, tbpParticlePose(frmSlam.updnSelectMap.Value).Location.Y, Color.Red)
                End If
                System.Windows.Forms.Application.DoEvents()
                boolRedrawInProgress = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subRedraw")
            frmDebug.subWriteLogs(Color.Red, "     intParticleNumber = " & intParticleNumber)
            frmDebug.subWriteLogs(Color.Red, "     tbpParticlePose(intParticleNumber).Location = " & tbpParticlePose(intParticleNumber).Location.X & ", " & tbpParticlePose(intParticleNumber).Location.Y)
            boolRedrawInProgress = False
        End Try
    End Sub

    Public Sub subUpdateAllText(ByRef tbpBotPose As typeBotPose)
        Try
            If Not Me.InvokeRequired Then
                If Not updnOrientation.Focused Then updnOrientation.Value = tbpBotPose.Orientation
                subUpdateStatusLine()

                If frmPose.Visible Then
                    frmPose.updnLocationX.Value = tbpBotPose.Location.X
                    frmPose.updnLocationY.Value = tbpBotPose.Location.Y
                    If Not frmPose.updnOrientation.Focused Then frmPose.updnOrientation.Value = tbpBotPose.Orientation
                    frmPose.updnUncertaintyX.Value = tbpBotPose.LocationUncertainty.X
                    frmPose.updnUncertaintyY.Value = tbpBotPose.LocationUncertainty.Y
                    frmPose.updnOrientationUncertainty.Value = tbpBotPose.OrientationUncertainty
                End If
                System.Windows.Forms.Application.DoEvents()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subUpdateAllText")
        End Try
    End Sub

    Public Sub subUpdateStatusLine()
        Try
            If Not Me.InvokeRequired Then
                If (sngLaptopBatteryPercent <> 999) Then _
                    strStatusLaptopVoltage = "Laptop: " & sngLaptopBatteryPercent.ToString & "%"
                boolLocalRCCConnected = (boolEnableLocalRCC And classLRCCClient.Connected)
                boolRRConnected = ((boolRoboRealmBotSelected Or boolEnableLocalRR) And classRoboRealmClient.Connected)
                strStatusCommunications = "Comms: "
                If boolBotConnected Then strStatusCommunications += "Bot "
                If boolCompassAttached Then strStatusCommunications += "Compass "
                If boolRRConnected Then strStatusCommunications += "RR "
                If boolLocalRCCConnected Then strStatusCommunications += "LRCC "
                If classAPI1Server.Connected Then strStatusCommunications += "API "
                If classAPI2Server.Connected Then strStatusCommunications += "API2 "
                If boolEnableGotAGlyph And classGotAGlyphClient.Connected Then strStatusCommunications += "Glyph "
                If boolKinectConnected Then _
                    strStatusCommunications += "Kinect "
                If boolURGConnected Then _
                    strStatusCommunications += "URG04 "

                Dim stbStatus As StringBuilder = New StringBuilder(strStatusDriving)
                Dim cap As Int16 = stbStatus.EnsureCapacity(191)
                stbStatus.Append("                                             ")
                stbStatus.Remove(40, stbStatus.Length - 40)
                stbStatus.Append(strStatusCommunications)
                stbStatus.Append("                                   ")
                stbStatus.Remove(70, stbStatus.Length - 70)
                stbStatus.Append(strStatusBotVoltage)
                stbStatus.Append("                 ")
                stbStatus.Remove(85, stbStatus.Length - 85)
                stbStatus.Append(strStatusLaptopVoltage)
                stbStatus.Append("                         ")
                stbStatus.Remove(105, stbStatus.Length - 105)
                stbStatus.Append(strStatusMouseCoordinates)
                stbStatus.Append("                    ")
                stbStatus.Remove(120, stbStatus.Length - 120)
                stbStatus.Append(strStatusMapContents)

                Me.StatusDriving.Text = stbStatus.ToString
                System.Windows.Forms.Application.DoEvents()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subUpdateStatusLine")
        End Try
    End Sub


    Private Sub subConfigureMenu(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuConfigure.Click
        Try
            If boolER1Selected Then
                mnuAngularVelocity.ForeColor = Color.Black
                mnuAngularAcceleration.ForeColor = Color.Black
                mnuVelocity.ForeColor = Color.Black
                mnuBotAcceleration.ForeColor = Color.Black
                If boolEnableBotSerialIF Then
                    mnuBotIP_Port.ForeColor = Color.LightGray
                    mnuBotIP.ForeColor = Color.LightGray
                    mnuBotComPort.ForeColor = Color.Black
                    mnuBotComPort.Checked = True
                    mnuPassword.ForeColor = Color.LightGray
                    mnuER1RCC.Checked = False
                    mnuER1Direct.Checked = True
                    mnuXYMotion.Visible = False
                    boolEnableXY_Motion = False
                    mnuEnableBotRCC.Visible = False
                    boolEnableBotRCC = False
                    mnuEnableLocalRCC.Visible = False
                    boolEnableLocalRCC = False
                Else
                    mnuBotIP_Port.ForeColor = Color.Black
                    mnuBotComPort.ForeColor = Color.LightGray
                    mnuBotIP.ForeColor = Color.Black
                    mnuBotComPort.Checked = False
                    mnuPassword.ForeColor = Color.Black
                    mnuER1RCC.Checked = boolER1Selected
                    mnuER1Direct.Checked = False
                    mnuXYMotion.Visible = True
                    mnuXYMotion.Checked = boolEnableXY_Motion
                    mnuEnableBotRCC.Visible = True
                    mnuEnableLocalRCC.Visible = True
                End If
                mnuXYMotion.ForeColor = Color.Black
                mnuEnableLocalizationWhileMoving.ForeColor = Color.Black
                mnuBotDiameter.ForeColor = Color.Black
                mnuBotSelect.Text = "Bot Select                   (ER1)"
                mnuSteeringBiasCorrection.Visible = False
                mnuDistanceCompensation.Visible = False
                mnuPowerMoving.Visible = True
                mnuPowerStopped.Visible = True
            ElseIf boolRoboRealmBotSelected Then
                mnuAngularVelocity.ForeColor = Color.Black
                mnuAngularAcceleration.ForeColor = Color.Black
                mnuVelocity.ForeColor = Color.Black
                mnuBotIP.ForeColor = Color.LightGray
                mnuBotIP_Port.ForeColor = Color.LightGray
                mnuBotComPort.ForeColor = Color.LightGray
                mnuXYMotion.ForeColor = Color.LightGray
                mnuPassword.ForeColor = Color.Black
                mnuEnableLocalizationWhileMoving.ForeColor = Color.Black
                mnuBotDiameter.ForeColor = Color.Black
                mnuBotSelect.Text = "Bot Select                   (RR Bot)"
                mnuSteeringBiasCorrection.Visible = False
                mnuDistanceCompensation.Visible = False
                mnuPowerMoving.Visible = False
                mnuPowerStopped.Visible = False
            ElseIf boolHeroSelected Then
                sngMaxTurn = 90
                mnuAngularVelocity.ForeColor = Color.LightGray
                mnuAngularAcceleration.ForeColor = Color.LightGray
                mnuVelocity.ForeColor = Color.LightGray
                mnuBotAcceleration.ForeColor = Color.LightGray
                mnuEnableLocalizationWhileMoving.ForeColor = Color.LightGray
                mnuBotIP.ForeColor = Color.LightGray
                mnuBotIP_Port.ForeColor = Color.LightGray
                mnuBotComPort.ForeColor = Color.Black
                mnuXYMotion.ForeColor = Color.LightGray
                mnuPassword.ForeColor = Color.LightGray
                mnuBotDiameter.ForeColor = Color.LightGray
                mnuBotSelect.Text = "Bot Select                   (Hero)"
                mnuDistanceCompensation.Visible = True
                mnuSteeringBiasCorrection.Visible = True
                mnuPowerMoving.Visible = False
                mnuPowerStopped.Visible = False
            Else
                If boolEnableBotSerialIF Then
                    mnuBotIP_Port.ForeColor = Color.LightGray
                    mnuBotIP.ForeColor = Color.LightGray
                    mnuBotComPort.ForeColor = Color.LightGray
                    mnuPassword.ForeColor = Color.LightGray
                Else
                    mnuBotIP_Port.ForeColor = Color.Black
                    mnuBotComPort.ForeColor = Color.LightGray
                    mnuBotIP.ForeColor = Color.Black
                    mnuPassword.ForeColor = Color.Black
                End If
                mnuXYMotion.ForeColor = Color.LightGray
                mnuSteeringBiasCorrection.Visible = False
                mnuPowerMoving.Visible = False
                mnuPowerStopped.Visible = False
                mnuDistanceCompensation.Visible = False
            End If
            If boolEnableLocalizationWhileMoving Then
                mnuMidCourseCorrection.ForeColor = Color.Black
            Else
                mnuMidCourseCorrection.ForeColor = Color.LightGray
            End If
            mnuParticle.Checked = boolEnableRBPF
            If boolEnableRBPF Then
                mnuNumberOfParticles.ForeColor = Color.Black
            Else
                mnuNumberOfParticles.ForeColor = Color.LightGray
            End If
            If boolSlam Then
                mnuUnits.ForeColor = Color.LightGray
                mnuGridSize.ForeColor = Color.LightGray
            Else
                mnuUnits.ForeColor = Color.Black
                mnuGridSize.ForeColor = Color.Black
            End If
            mnuWheelSeparation.Visible = boolER1Selected And boolEnableBotSerialIF
            mnuWheelSeparation.Text = "Wheel Separation           (" & sngWheelSeparation.ToString & ")"
            mnuEnableBumperSwitches.Visible = boolER1Selected
            mnuEnableEvolutionIRs.Visible = boolER1Selected And Not boolEnableBotSerialIF
            mnuUnits.Text = "Grid Units           (" & strUnits & ")"
            mnuGridSize.Text = "Grid Size           (" & sngGridSize & ")"
            mnuBotComPort.Text = "Bot Com Port            (" & mnuComPortComboBox.Text & ")"
            mnuBotIP.Text = "Bot IP Address            (" & ipRobot_IPAddress.ToString & ")"
            mnuBotIP_Port.Text = "Bot Port                      (" & intRobot_Port & ")"
            mnuBotPose.Text = "Pose                      (" & tbpBotPose.Location.X & ", " & tbpBotPose.Location.Y & "    " & tbpBotPose.Orientation & ")"
            mnuBotDiameter.Text = "Bot Diameter                (" & sngBotDiameter & ")"
            mnuCameraResolution.Text = "Camera Resolution       (" & ticCameraResolution.X & ", " & ticCameraResolution.Y & ")"
            mnuCameraFOV.Text = "Camera FOV                 (" & sngCameraFOV & ")"
            mnuCameraOffset.Text = "Camera Offset              (" & sngCameraOffset & ")"
            mnuMovementAccuracy.Text = "Movement Accuracy     (" & sngBotMovementAccuracy & ")"
            mnuMaxTravel.Text = "Max Travel                    (" & sngMaxTravel & ")"
            mnuBotAcceleration.Text = "Acceleration                  (" & sngBotLinearAcceleration & ")"
            mnuVelocity.Text = "Velocity                          (" & sngBotLinearVelocity & ")"
            mnuAngularVelocity.Text = "Angular Velocity             (" & sngBotAngularVelocity & ")"
            mnuAngularAcceleration.Text = "Angular Acceleration      (" & sngBotAngularAcceleration & ")"
            mnuRecognitionTime.Text = "Visual Localization Time  (" & sngLocalizationTime & ")"
            mnuLocalVideoDelay.Text = "Local Video Delay            (" & sngStartOfMoveDelay & ")"
            mnuNumberOfParticles.Text = "Number of Particles     (" & intNumberOfParticles & ")"
            mnuSteeringBiasCorrection.Text = "Steering Bias Correction      (" & sngSteeringBiasOffsetCorrection & ")"
            mnuPowerMoving.Text = "Power Moving            (" & intPowerMoving & ")"
            mnuPowerStopped.Text = "Power Stopped            (" & intPowerStopped & ")"
            mnuDestinationAlpha.Text = "Destination Alpha         (" & tmcDestinationAlpha.X & ", " & tmcDestinationAlpha.Y & ")"
            mnuDestinationBravo.Text = "Destination Bravo         (" & tmcDestinationBravo.X & ", " & tmcDestinationBravo.Y & ")"
            mnuDestinationCharlie.Text = "Destination Charlie       (" & tmcDestinationCharlie.X & ", " & tmcDestinationCharlie.Y & ")"
            mnuDestinationDelta.Text = "Destination Delta         (" & tmcDestinationDelta.X & ", " & tmcDestinationDelta.Y & ")"
            mnuDestinationEcho.Text = "Destination Echo          (" & tmcDestinationEcho.X & ", " & tmcDestinationEcho.Y & ")"
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subConfigure_Click")
        End Try
    End Sub


    Private Sub subSizeChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
        subRedraw(tbpBotPose)
    End Sub

    Public Sub subLoadImage()
        Try
            If Not boolShutDown Then
                myMap.Image = imgMap
                myMap.Width = CInt(sngZoom * imgMap.Width)
                myMap.Height = CInt(sngZoom * imgMap.Height)
            End If
            If (Me.WindowState <> FormWindowState.Minimized) Then
                If Me.Width > Screen.PrimaryScreen.Bounds.Width Then _
                    Me.Width = Screen.PrimaryScreen.Bounds.Width
                If Me.Height > Screen.PrimaryScreen.Bounds.Height Then _
                    Me.Height = Screen.PrimaryScreen.Bounds.Height
            End If
            Me.Refresh()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subLoadImage " & ex.ToString)
        End Try
    End Sub

    Private Sub myMap_Scale()
        Try
            If (Me.WindowState <> FormWindowState.Minimized) Then
                myMap.Height = Me.Height - 150
                myMap.Width = Me.Width - 80
                sngZoom = CSng(myMap.Height / imgMap.Height)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in myMap_Scale " & ex.ToString)
        End Try
    End Sub


    Dim boolPlacementActive As Boolean = False
    Dim tmcMouseDown As typeMapCoordinate
    Public Sub myMapNouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles myMap.MouseDown
        Try
            Dim tmcMapPoint As typeMapCoordinate = ftnMouseToMapPosition()
            boolMouseDown = (e.Button = MouseButtons.Left)

            If e.Button = MouseButtons.Right Then
                boolMouseDown = False
                MapContextMenu.Visible = True
                MapContextMenu.Left = MousePosition.X
                MapContextMenu.Top = MousePosition.Y
            ElseIf boolSlam And boolCtrlKey Then
                If (ftnDistanceBetweenLocations(tbpBotPose.Location, tmcMapPoint) < sngBotRadius) Then ftnPirouette(tbpBotPose)
            ElseIf (boolPlaceBot And boolMouseDown) Then
                subWait(200)
                If ((Control.MouseButtons & MouseButtons.Left) <> MouseButtons.Left) And Not ftnInWall(tmcMapPoint) Then
                    If boolSlam Then
                        Dim DidWork As Integer = MsgBox("Are you sure you want to move the Bot's mapped position?", MsgBoxStyle.YesNoCancel)
                        If DidWork <> DialogResult.Yes Then Exit Sub
                        boolCollisionDetected = False
                        boolCollisionPredicted = False
                        boolRangeReadingsAreFresh = False
                    End If
                    frmDebug.subWriteLogs(Color.Black, " ")
                    frmDebug.subWriteLogs(Color.Black, " ")
                    frmDebug.subWriteLogs(Color.Black, " ******************************************************************************************")
                    frmDebug.subWriteLogs(Color.Black, " ")
                    frmDebug.subWriteLogs(Color.Black, " ************  New Bot Location selected: Location = " & tmcMapPoint.X & ", " & tmcMapPoint.Y)
                    subChangeParticlePose(tmcMapPoint.X - tbpBotPose.Location.X, tmcMapPoint.Y - tbpBotPose.Location.Y, 0)
                    tbpBotPose.Location = tmcMapPoint 'Place the bot icon
                    If Not boolSlam Then subInitParticles(tbpBotPose, intNumberOfParticles)
                    boolPlacementActive = True
                    subRedraw(tbpBotPose)
                End If
            ElseIf (boolPlaceDestination And boolMouseDown) Then
                subWait(200)
                boolPlaceDestination = False
                If ((Control.MouseButtons & MouseButtons.Left) <> MouseButtons.Left) Then _
                    subDriveToUserChosenDestination(tmcMapPoint)
            ElseIf (frmLandMarkEdit.Visible And frmLandMarkEdit.boolLocationFocused And boolMouseDown) Then ' Enter a Landmark Location
                Dim tmcLMLocation As typeMapCoordinate = ftnMouseToMapPosition()
                frmLandMarkEdit.UpDnLocX.Value = tmcLMLocation.X
                frmLandMarkEdit.UpDnLocX.Text = tmcLMLocation.X
                frmLandMarkEdit.UpDnLocY.Value = tmcLMLocation.Y
                frmLandMarkEdit.UpDnLocY.Text = tmcLMLocation.Y
                subRedraw(tbpBotPose)
            ElseIf frmLandMarkEdit.Visible And frmLandMarkEdit.boolValidtyRegionFocused And boolMouseDown Then  ' Determine LandMark Validity area
                tmcMouseDown = ftnMouseToMapPosition()
            End If
            While boolPlacementActive And Not boolShutDown
                System.Windows.Forms.Application.DoEvents()
                boolPlacementActive = ((Control.MouseButtons & MouseButtons.Left) <> MouseButtons.Left)
            End While
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in myMapNouseDown")
        End Try
    End Sub


    Dim boolMap_MouseMoveBusy As Boolean = False
    Public Sub myMap_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles myMap.MouseMove
        Try
            If Not boolMap_MouseMoveBusy Then
                boolMap_MouseMoveBusy = True
                If boolLocalizationInProgress Then
                    Me.Cursor = Cursors.WaitCursor
                Else
                    Me.Cursor = Cursors.Arrow
                End If
                Dim tmcMapPoint As typeMapCoordinate = ftnMouseToMapPosition()
                myMap.Select()
                strStatusMouseCoordinates = tmcMapPoint.X.ToString("0000") & ", " & tmcMapPoint.Y.ToString("0000")
                If boolEnableRBPF Then
                    Dim intBestParticle As Short = ftnBestParticle(tbpBotPose, intNumberOfParticles)
                    strStatusMapContents = byteNavigationArray(tmcMapPoint.X, tmcMapPoint.Y).ToString & ", " & intPathArray(tmcMapPoint.X, tmcMapPoint.Y) & ", " & _
                                           intDistanceFromWallSquaredArray(tmcMapPoint.X, tmcMapPoint.Y).ToString & ", " & byteParticleMapOdds(intBestParticle, tmcMapPoint.X, tmcMapPoint.Y).ToString()
                Else
                    strStatusMapContents = byteNavigationArray(tmcMapPoint.X, tmcMapPoint.Y).ToString & ", " & intPathArray(tmcMapPoint.X, tmcMapPoint.Y) & ", " & _
                                           intDistanceFromWallSquaredArray(tmcMapPoint.X, tmcMapPoint.Y).ToString
                End If
                If e.Button <> MouseButtons.Left Then boolMouseDown = False
                If (boolPlaceBot And boolMouseDown And boolPlacementActive) Then    'Drag the bot icon
                    subChangeParticlePose(tmcMapPoint.X - tbpBotPose.Location.X, tmcMapPoint.Y - tbpBotPose.Location.Y, 0)
                    If Not ftnInWall(tmcMapPoint) Then
                        tbpBotPose.Location = tmcMapPoint
                        If Not boolSlam Then subInitParticles(tbpBotPose, intNumberOfParticles)
                        boolSettingsChanged = True
                        subRedraw(tbpBotPose)
                    End If
                ElseIf (boolPlaceDestination And boolMouseDown And boolPlacementActive) Then
                    tmcDestination = tmcMapPoint  'Place the Destination icon
                    subRedraw(tbpBotPose)
                    subDrawDestination(tmcDestination)
                ElseIf frmLandMarkEdit.Visible And boolMouseDown And frmLandMarkEdit.boolValidtyRegionFocused Then
                    subLMValidityRegion(tmcMouseDown)
                ElseIf frmLandMarkEdit.Visible And boolMouseDown And frmLandMarkEdit.boolLocationFocused Then
                    frmLandMarkEdit.UpDnLocX.Value = tmcMapPoint.X
                    frmLandMarkEdit.UpDnLocX.Text = tmcMapPoint.X
                    frmLandMarkEdit.UpDnLocY.Value = tmcMapPoint.Y
                    frmLandMarkEdit.UpDnLocY.Text = tmcMapPoint.Y
                    subRedraw(tbpBotPose)
                Else
                    subUpdateAllText(tbpBotPose)
                End If
                boolMap_MouseMoveBusy = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in myMap_MouseMove")
        End Try
    End Sub



    Public Sub myMap_DragOver(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.Activated
        On Error Resume Next
        subWait(100)
        subDrawBot(tbpBotPose)
    End Sub

    Public Sub me_DragOver(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.DragOver
        subDrawBot(tbpBotPose)
    End Sub

    Public Sub me_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.Shown
        On Error Resume Next
        subWait(100)
        subDrawBot(tbpBotPose)
    End Sub


    Sub subLMValidityRegion(ByVal tmcMouseDown As typeMapCoordinate)
        Try
            If (boolPlaceDestination = False And boolPlaceBot = False And boolMouseDown _
                And frmLandMarkEdit.Visible = True) And frmLandMarkEdit.boolValidtyRegionFocused Then  ' Determine LandMark Validity area
                If (ftnMouseToMapPosition().Y >= tmcMouseDown.Y) Then
                    frmLandMarkEdit.UpDnValidHeight.Value = ftnMouseToMapPosition().Y - tmcMouseDown.Y
                    frmLandMarkEdit.UpDnValidY.Value = tmcMouseDown.Y
                Else
                    frmLandMarkEdit.UpDnValidHeight.Value = (tmcMouseDown.Y - ftnMouseToMapPosition().Y)
                    frmLandMarkEdit.UpDnValidY.Value = ftnMouseToMapPosition().Y
                End If
                If (ftnMouseToMapPosition().X >= tmcMouseDown.X) Then
                    frmLandMarkEdit.UpDnValidWidth.Value = ftnMouseToMapPosition().X - tmcMouseDown.X
                    frmLandMarkEdit.UpDnValidX.Value = tmcMouseDown.X
                Else
                    frmLandMarkEdit.UpDnValidWidth.Value = (tmcMouseDown.X - ftnMouseToMapPosition().X)
                    frmLandMarkEdit.UpDnValidX.Value = ftnMouseToMapPosition().X
                End If
                tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.X = frmLandMarkEdit.UpDnValidX.Value
                tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.Y = frmLandMarkEdit.UpDnValidY.Value
                tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.Width = frmLandMarkEdit.UpDnValidWidth.Value
                tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.Height = frmLandMarkEdit.UpDnValidHeight.Value
                frmLandMarkEdit.UpDnValidX.Text = frmLandMarkEdit.UpDnValidX.Value.ToString
                frmLandMarkEdit.UpDnValidY.Text = frmLandMarkEdit.UpDnValidY.Value.ToString
                frmLandMarkEdit.UpDnValidWidth.Text = frmLandMarkEdit.UpDnValidWidth.Value.ToString
                frmLandMarkEdit.UpDnValidHeight.Text = frmLandMarkEdit.UpDnValidHeight.Value.ToString
                frmLandMarkEdit.subLM_Refresh()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subLMValidityRegion")
        End Try
    End Sub



    Private Sub updnOrientation_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updnOrientation.ValueChanged
        Try
            If Not Me.InvokeRequired And updnOrientation.Focused Then
                System.Windows.Forms.Application.DoEvents()
                If (tbpBotPose.Orientation <> updnOrientation.Value) Then
                    updnOrientation.Enabled = False
                    tbpBotPose.Orientation = ftnConvertTo360(Convert.ToInt16(updnOrientation.Value))
                    updnOrientation.Value = tbpBotPose.Orientation
                    frmDebug.subWriteLogs(Color.Black, " ************  New Bot Orientation selected:  = " & tbpBotPose.Orientation & " Degrees")
                    subChangeParticlePose(0, 0, ftnAngleDifference(Convert.ToInt16(updnOrientation.Value), tbpBotPose.Orientation))
                    tbpTargetPoseGlobal = tbpBotPose
                    subRedraw(tbpBotPose)
                    updnOrientation.Enabled = True
                End If
            End If
        Catch
            updnOrientation.Enabled = True
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in updnOrientation_ValueChanged")
        End Try
    End Sub



    Private Sub picPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picPause.DoubleClick
        On Error Resume Next
        boolPause = Not boolPause
        subRedraw(tbpBotPose)
        If boolPause Then frmDebug.subWriteLogs(Color.Black, Now() & "    >>>>  PAUSE button was pushed  >>> ")
    End Sub

    Private Function ftnMouseToMapPosition() As typeMapCoordinate
        Try
            ftnMouseToMapPosition.X = CShort((MousePosition.X - Me.Location.X - myMap.Location.X - myMap.Padding.Left - myMap.Margin.Left - 5) / sngZoom)
            ftnMouseToMapPosition.Y = (MousePosition.Y - Me.Location.Y - myMap.Location.Y - myMap.Padding.Top - myMap.Margin.Top - 27) / sngZoom
            ftnMouseToMapPosition = ftnCheckMapArrayLimits(ftnMouseToMapPosition)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnMouseToMapPosition")
        End Try
    End Function









    '==========================  MENUS  ==================================================



    '==========================  File Menu  ==================================================

    Public Sub mnuLoadSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLoadSettings.Click
        On Error Resume Next
        Me.StatusDriving.ForeColor = Color.Black
        LoadSettings("GotABot_Settings.xml")
        boolSettingsChanged = False
        sngZoom = CSng(myMap.Height / imgMap.Height)
        subRedraw(tbpBotPose)
        subConvertMapToArray()
        strStatusDriving = "Waiting for command "
        subInitParticles(tbpBotPose, intNumberOfParticles)
        ftnSendCommand("play phraseA 'Ready'")
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuLoadSettingsFileSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLoadSettingsFileSelect.Click
        On Error Resume Next
        Me.StatusDriving.ForeColor = Color.Black
        OpenFD.Title = "Load GotABot Settings"
        OpenFD.Filter = "xml Files(*.xml)|*.xml"
        Dim DidWork As Integer = OpenFD.ShowDialog()
        If DidWork <> DialogResult.Cancel Then _
        LoadSettings(OpenFD.FileName)
        boolSettingsChanged = False
        sngZoom = CSng(myMap.Height / imgMap.Height)
        subRedraw(tbpBotPose)
        subConvertMapToArray()
        subInitParticles(tbpBotPose, intNumberOfParticles)
        strStatusDriving = "Waiting for command "
        subRedraw(tbpBotPose)
        ftnSendCommand("play phraseA 'Ready'")
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Public Sub mnuSaveSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSaveSettings.Click
        On Error Resume Next
        SaveSettings("GotABot_Settings.xml")
        boolSettingsChanged = False
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuSaveSettingsFileSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSaveSettingsFileSelect.Click
        On Error Resume Next
        Dim saveFD As New SaveFileDialog()
        saveFD.Title = "GotABot Settings Changed - Save?"
        saveFD.Filter = "xml Files(*.xml)|*.xml"
        Dim DidWork As Integer = saveFD.ShowDialog()
        If DidWork <> DialogResult.Cancel Then _
        SaveSettings(saveFD.FileName)
        boolSettingsChanged = False
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuNewLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuNewLog.Click
        On Error Resume Next
        If (Dir("GotABot_Log.txt") <> "") Then My.Computer.FileSystem.DeleteFile("GotABot_Log.txt", _
                FileIO.UIOption.AllDialogs, FileIO.RecycleOption.DeletePermanently, FileIO.UICancelOption.DoNothing)
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuOpenMapLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOpenMapLog.Click
        On Error Resume Next
        Process.Start("notepad", "GotABot_Log.txt")
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuVerboseLogFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuVerboseLogFile.Click
        On Error Resume Next
        boolVerboseLogFile = Not (boolVerboseLogFile)
        mnuVerboseLogFile.Checked = boolVerboseLogFile
        If boolVerboseLogFile Then
            boolDebugLWM = boolVerboseLogFile
            boolDebugER1IF = boolVerboseLogFile
            boolDebugAPI_IF = boolVerboseLogFile
            boolDebugOdometry = boolVerboseLogFile
            boolDebugLocalize2D = boolVerboseLogFile
            boolDebugKinect = boolVerboseLogFile
            boolDebugDock = boolVerboseLogFile
            boolDebugDrive = boolVerboseLogFile
            boolDebugObstacle = boolVerboseLogFile
        End If
        System.Windows.Forms.Application.DoEvents()
    End Sub




    Private Sub mnuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuExit.Click
        Me.Close()
    End Sub

    Private Sub me_exit(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.FormClosed
        On Error Resume Next
        tbpBotPose = modBotMovementControl.ftnBotStop(tbpBotPose, tbpTargetPoseGlobal)
        boolAllowRoboRealmToControlBot = False
        timerWatchDog.Enabled = False
        boolKinectConnected = False
        boolURGConnected = False
        ftnSendCommand("play phrase 'Goodby'")
        boolShutDown = True
        boolStop = True
        modKinect.ftnKinectStop()
        'subCloseComBot()
        Dim proc = Process.GetProcessesByName("GotAGlyph")
        For i As Integer = 0 To proc.Count - 1
            proc(i).CloseMainWindow()
            proc(i).Kill()
        Next i
        If boolSettingsChanged Then _
            mnuSaveSettingsFileSelect_Click(sender, e)
        subWait(3000)
        'bmpMap.Dispose()
    End Sub









    '==========================  Configure Menu  ==================================================



    Private Sub mnuEditMap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditMap.Click
        Try
            OpenFD.Title = "Edit a Map"
            OpenFD.Filter = "BitMap Files(*.bmp)|*.bmp"
            Dim DidWork As Integer = OpenFD.ShowDialog()
            If DidWork <> DialogResult.Cancel Then
                If Not Me.InvokeRequired Then System.Windows.Forms.Application.DoEvents()
                imgMap.Dispose()
                bmpMap.Dispose()

                Dim editMap As Process = Process.Start("mspaint", OpenFD.SafeFileName)
                editMap.WaitForExit()

                imgMap = System.Drawing.Image.FromFile(OpenFD.FileName)
                Me.myMap.Image = imgMap
                bmpMap = CType(System.Drawing.Image.FromFile(OpenFD.FileName), Bitmap)
                Me.myMap.Height = imgMap.Height
                Me.myMap.Width = imgMap.Width
                ReDim byteNavigationArray(imgMap.Width, imgMap.Height)
                ReDim intPathArray(CInt(imgMap.Width), CInt(imgMap.Height))
                ReDim intDistanceFromWallSquaredArray(imgMap.Width, imgMap.Height)
                subRecalculateVariables()
                subConvertMapToArray()
            End If
            If Not Me.InvokeRequired Then System.Windows.Forms.Application.DoEvents() ' 
            sngZoom = CSng(myMap.Height / imgMap.Height)
            subRedraw(tbpBotPose)
            System.Windows.Forms.Application.DoEvents()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuEditMap_Click")
        End Try
    End Sub

    Public Sub mnuOpenMap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOpenMap.Click
        Try
            OpenFD.Title = "Open a New Map"
            OpenFD.Filter = "BitMap Files(*.bmp)|*.bmp"
            Dim DidWork As Integer = OpenFD.ShowDialog()
            If DidWork <> DialogResult.Cancel Then subOpenMap(OpenFD.FileName)
            subConvertMapToArray()
            subRedraw(tbpBotPose)
            System.Windows.Forms.Application.DoEvents()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuOpenMap_Click")
        End Try
    End Sub

    Private Sub mnuSaveMap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSaveMap.Click
        Try
            Dim saveFD As New SaveFileDialog()
            saveFD.Title = "Save a copy of the map"
            saveFD.Filter = "BitMap Files(*.bmp)|*.bmp"
            Dim DidWork As Integer = saveFD.ShowDialog()
            If DidWork <> DialogResult.Cancel Then _
              bmpMap.Save(saveFD.FileName)
            subRedraw(tbpBotPose)
            System.Windows.Forms.Application.DoEvents()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuSaveMap_Click")
        End Try
    End Sub


    Public Sub subOpenMap(ByVal strFileName As String)
        Try
            imgMap.Dispose()
            bmpMap.Dispose()
            imgMap = System.Drawing.Image.FromFile(strFileName)
            Me.myMap.Height = imgMap.Height * sngZoom
            Me.myMap.Width = imgMap.Width * sngZoom
            Me.Width = Me.myMap.Width + 80
            Me.Height = Me.myMap.Height + 150
            sngZoom = CSng(myMap.Height / imgMap.Height)
            ReDim byteNavigationArray(imgMap.Width, imgMap.Height)
            ReDim intPathArray(CInt(imgMap.Width), CInt(imgMap.Height))
            ReDim intDistanceFromWallSquaredArray(imgMap.Width, imgMap.Height)
            Me.myMap.Image = imgMap
            bmpMap = New Bitmap(System.Drawing.Image.FromFile(strFileName), imgMap.Width, imgMap.Height)
            subRecalculateVariables()
            subConvertMapToArray() ' Convert the Map from .bmp format to a byte array
            subInitParticles(tbpBotPose, intNumberOfParticles)
            subRedraw(tbpBotPose)
            System.Windows.Forms.Application.DoEvents()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subOpenMap")
        End Try
    End Sub


    Private Sub mnuGridSize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuGridSize.Click
        On Error Resume Next
        Dim strGridSize As String
        If boolSlam Then
            ftnSendCommand("play phrase Beep")
            MsgBox("  During Slam, the Map is fixed at 1 Grid Square = 1 inch")
        Else
            strGridSize = InputBox("How big is each grid square ? ", "Grid Size", Str(sngGridSize))
            If strGridSize <> "" And IsNumeric(strGridSize) Then
                sngGridSize = Convert.ToSingle(strGridSize)
                If (sngGridSize <= 0) Then sngGridSize = 1
            End If
            mnuGridSize.Text = "Grid Size            (" & sngGridSize & ")"
            boolSettingsChanged = True
            subRecalculateVariables()
            subConvertMapToArray()
        End If
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuMapUnits_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuMapUnits.Click
        On Error Resume Next
        If boolSlam Then
            ftnSendCommand("play phrase Beep")
            MsgBox("  During Slam, the Map is fixed at 1 Grid Square = 1 inch")
        Else
            boolSettingsChanged = True
            subRecalculateVariables()
            subConvertMapToArray()
            subRedraw(tbpBotPose)
        End If
    End Sub



    Private Sub mnuShowMore_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuShowDebugGraphics.Click
        On Error Resume Next
        boolShowMore = Not (boolShowMore)
        mnuShowDebugGraphics.Checked = boolShowMore
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub








    Private Sub mnuViewLM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuViewLM.Click
        On Error Resume Next
        boolViewLM = True
        frmLandMarkEdit.picLmLoad()
        frmLandMarkEdit.Visible = boolViewLM
        frmLandMarkEdit.Focus()
    End Sub



    Private Sub KinectConfigureToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles KinectConfigureToolStripMenuItem.Click
        On Error Resume Next
        classScanner.Visible = True
        classScanner.Focus()
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuDistanceCompensation_Click(sender As Object, e As EventArgs) Handles mnuDistanceCompensation.Click
        On Error Resume Next
        frmDistanceComp.Visible = True
        frmDistanceComp.Focus()
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub



    Private Sub mnuER1RCM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuER1RCC.Click
        On Error Resume Next
        mnuER1RCC.Checked = Not mnuER1RCC.Checked
        boolER1Selected = mnuER1RCC.Checked
        If boolER1Selected Then
            mnuRoboRealmBotSelected.Checked = False
            mnuER1Direct.Checked = False
            boolRoboRealmBotSelected = False
            boolEnableBotSerialIF = False
            mnuHeroSelected.Checked = False
            boolHeroSelected = False
            sngBotMovementAccuracy = 0.7
            subCalculateScanBeamAngles()
        End If
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuER1Direct_Click(sender As Object, e As EventArgs) Handles mnuER1Direct.Click
        Try
            mnuER1Direct.Checked = Not mnuER1Direct.Checked
            boolER1Selected = mnuER1Direct.Checked
            boolEnableBotSerialIF = mnuER1Direct.Checked
            If boolER1Selected Then
                mnuRoboRealmBotSelected.Checked = False
                boolRoboRealmBotSelected = False
                mnuER1RCC.Checked = False
                mnuHeroSelected.Checked = False
                boolHeroSelected = False
                mnuXYMotion.Checked = False
                boolEnableXY_Motion = False
                sngBotMovementAccuracy = 0.7
                intNumberOfBeamsDefault = 64
            End If
            boolSettingsChanged = True
            subConfigureMenu(sender, e)
            subRedraw(tbpBotPose)
            System.Windows.Forms.Application.DoEvents()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuER1Direct_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuHeroSelected_Click(sender As Object, e As EventArgs) Handles mnuHeroSelected.Click
        On Error Resume Next
        mnuHeroSelected.Checked = Not mnuHeroSelected.Checked
        boolHeroSelected = mnuHeroSelected.Checked
        If boolHeroSelected Then
            mnuER1RCC.Checked = False
            boolER1Selected = False
            mnuRoboRealmBotSelected.Checked = False
            boolRoboRealmBotSelected = False
            mnuAngularVelocity.ForeColor = Color.LightGray
            mnuAngularAcceleration.ForeColor = Color.LightGray
            mnuVelocity.ForeColor = Color.LightGray
            mnuBotAcceleration.ForeColor = Color.LightGray
            mnuXYMotion.Checked = False
            boolEnableXY_Motion = False
            boolEnableMidCourseCorrection = False
            mnuMidCourseCorrection.Checked = False
            boolEnableLocalizationWhileMoving = False
            mnuEnableLocalizationWhileMoving.Checked = False
            sngBotAngularAcceleration = 999
            sngBotAngularVelocity = 999
            sngBotLinearVelocity = 40
            sngBotLinearAcceleration = 40
            sngBotDiameter = ftnInchesToMapUnits(14.5)
            sngBotMovementAccuracy = 0.4
            sngMaxTravel = ftnInchesToMapUnits(48)
            sngScanFOV = 350
            tmcScanVectorOffset.X = ftnInchesToMapUnits(0)
            tmcScanVectorOffset.Y = 0
            intScanOffsetDegrees = 0
            intScanVectorsMaxRangeInches = 100
            intScanVectorsMinRangeInches = 0
            subCalculateScanBeamAngles()
            intNumberOfBeamsDefault = 40
            intNumberOfBeams = 40
            mnuBotSelect.Text = "Bot Select                   (Hero)"
        End If
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuRoboRealmBotSelected_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuRoboRealmBotSelected.Click
        On Error Resume Next
        mnuRoboRealmBotSelected.Checked = Not mnuRoboRealmBotSelected.Checked
        boolRoboRealmBotSelected = mnuRoboRealmBotSelected.Checked
        If boolRoboRealmBotSelected Then
            mnuER1RCC.Checked = False
            boolER1Selected = False
            mnuHeroSelected.Checked = False
            boolHeroSelected = False
            sngBotMovementAccuracy = 0.7
        End If
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

 
    Private Sub subComportselect_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuComPortComboBox.SelectedIndexChanged
        strBotComPort = Me.mnuComPortComboBox.Text
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuBotComPort_Click(sender As Object, e As EventArgs) Handles mnuBotComPort.MouseEnter
        Try
            mnuComPortComboBox.Items.Clear()
            For Each sp As String In My.Computer.Ports.SerialPortNames  ' Show all available COM ports.
                mnuComPortComboBox.Items.Add(sp)         'adds COMX to mnuComPortComboBox
            Next
            mnuComPortComboBox.Items.Add("None")         'adds "None" to mnuComPortComboBox
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuBotComPort_Click")
        End Try
    End Sub


    Private Sub mnuDownloadHeroS19_Click(sender As Object, e As EventArgs)
        subHeroS19Download()
        Me.Refresh()
    End Sub


    Private Sub mnuEnableBumperSwitches_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEnableBumperSwitches.Click
        On Error Resume Next
        mnuEnableBumperSwitches.Checked = Not mnuEnableBumperSwitches.Checked
        boolEnableBumperSwitches_ER1 = mnuEnableBumperSwitches.Checked
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub




    Private Sub mnuEnableEvolutionIRs_Click(sender As System.Object, e As System.EventArgs) Handles mnuEnableEvolutionIRs.Click  ' 
        On Error Resume Next
        mnuEnableEvolutionIRs.Checked = Not mnuEnableEvolutionIRs.Checked
        boolEnableEvolutionIR_ER1 = mnuEnableEvolutionIRs.Checked
        boolSettingsChanged = True
        If boolEnableEvolutionIR_ER1 Then ftnER1_SocketCommunicate("ir all threshold " & intEvolution_IR_Threshold, "OK", 1000)
        If boolEnableEvolutionIR_ER1 Then ftnER1_SocketCommunicate("ir all flash 7 ", "OK", 1000)
        If boolEnableEvolutionIR_ER1 Then ftnER1_SocketCommunicate("sense ir", "OK", 1000)
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuAdjustIR_Threshold_Click(sender As System.Object, e As System.EventArgs) Handles mnuAdjustIR_Threshold.Click
        On Error Resume Next
        Dim strEvolution_IR_Threshold As String
        strEvolution_IR_Threshold = InputBox("Enter IR Collision Threshold (1-100) ", "IR Collision Threshold", Str(intEvolution_IR_Threshold))
        If strEvolution_IR_Threshold <> "" And IsNumeric(strEvolution_IR_Threshold) Then
            intEvolution_IR_Threshold = CInt(Int(strEvolution_IR_Threshold))
            boolSettingsChanged = True
            ftnER1_SocketCommunicate("ir all threshold " & intEvolution_IR_Threshold, "OK", 1000)
        End If
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub




    Private Sub mnuBotPort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBotIP_Port.Click
        On Error Resume Next
        Dim strPort As String
        strPort = InputBox("Enter Bot Port Address ", "Port Address", Str(intRobot_Port))
        If strPort <> "" And IsNumeric(strPort) Then
            intRobot_Port = CInt(Int(strPort))
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub



    Private Sub mnuPassword_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuPassword.Click
        On Error Resume Next
        strPassword = InputBox("Enter password ", "Password", "XXXXXXXX")
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuBotDiameter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBotDiameter.Click
        On Error Resume Next
        Dim strBotDiameter As String
        strBotDiameter = InputBox("Enter Bot Diameter ", "Bot Diameter", Str(sngBotDiameter))
        If strBotDiameter <> "" And IsNumeric(strBotDiameter) Then _
            sngBotDiameter = Convert.ToSingle(strBotDiameter)
        subRecalculateVariables()
        subConvertMapToArray()
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuRangers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuRangers.Click
        On Error Resume Next
        frmRangeFinder.Visible = True
        frmRangeFinder.Focus()
    End Sub

    Private Sub mnuCameraResolution_Click(sender As System.Object, e As System.EventArgs) Handles mnuCameraResolution.Click
        On Error Resume Next
        Dim strCameraResolution As String
        strCameraResolution = InputBox("Enter Camera Resolution in the form 640, 480", "Camera Resolution", Str(ticCameraResolution.X) & ", " & Str(ticCameraResolution.Y))
        strCameraResolution &= " , 640, 480"
        Dim strParsedText As String() = strCameraResolution.Split(","c)
        ticCameraResolution.X = Convert.ToInt16(strParsedText(0))
        ticCameraResolution.Y = Convert.ToInt16(strParsedText(1))
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub CameraFOVToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCameraFOV.Click
        On Error Resume Next
        Dim strCameraFOV As String
        strCameraFOV = InputBox("Enter Camera Field Of View ", "Camera FOV", Str(sngCameraFOV))
        If strCameraFOV <> "" And IsNumeric(strCameraFOV) Then
            sngCameraFOV = Convert.ToSingle(strCameraFOV)
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuCameraOffset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCameraOffset.Click
        On Error Resume Next
        Dim strCameraOffset As String
        strCameraOffset = InputBox("Enter Camera Offset from center of Bot ", "Camera Offset", Str(sngCameraOffset))
        If strCameraOffset <> "" And IsNumeric(strCameraOffset) Then
            sngCameraOffset = Convert.ToSingle(strCameraOffset)
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuMaxTravel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuMaxTravel.Click
        On Error Resume Next
        Dim strMaxTravel As String
        strMaxTravel = InputBox("Enter Maximum Distance the Bot should travel before Localizing ", "Max Travel", Str(sngMaxTravel))
        If strMaxTravel <> "" And IsNumeric(strMaxTravel) Then
            sngMaxTravel = Convert.ToSingle(strMaxTravel)
        End If
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuPowerMoving_Click(sender As Object, e As EventArgs) Handles mnuPowerMoving.Click
        Try
            Dim strPowerMoving As String
            strPowerMoving = InputBox("Enter Power Moving (0-100) ", "Power Moving", Str(intPowerMoving))
            If strPowerMoving <> "" And IsNumeric(strPowerMoving) Then
                intPowerMoving = Convert.ToSingle(strPowerMoving)
                If (intPowerMoving > 100) Or (intPowerMoving < 0) Then
                    intPowerMoving = 60
                    ftnSendCommand("play phrase Beep")
                End If
                ftnSendCommand("set power moving " & intPowerMoving)
            End If
            subRedraw(tbpBotPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuPowerMoving_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuPowerStopped_Click(sender As Object, e As EventArgs) Handles mnuPowerStopped.Click
        Try
            Dim strPowerStopped As String
            strPowerStopped = InputBox("Enter Power Stopped (0-100) ", "Power Stopped", Str(intPowerStopped))
            If strPowerStopped <> "" And IsNumeric(strPowerStopped) Then
                intPowerStopped = Convert.ToSingle(strPowerStopped)
                If (intPowerStopped > 100) Or (intPowerStopped < 0) Then
                    intPowerStopped = 60
                    ftnSendCommand("play phrase Beep")
                End If
                ftnSendCommand("set power stopped " & intPowerStopped)
            End If
            subRedraw(tbpBotPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuPowerStopped_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuWheelSeparation_Click(sender As Object, e As EventArgs) Handles mnuWheelSeparation.Click
        Try
            Dim strWheelSeparation As String
            strWheelSeparation = InputBox("Enter WheelSeparation in cm ", "Wheel Separation", Str(sngWheelSeparation))
            If strWheelSeparation <> "" And IsNumeric(strWheelSeparation) Then
                sngWheelSeparation = Convert.ToSingle(strWheelSeparation)
                ftnSendCommand("set power stopped " & intPowerStopped)
            End If
            subRedraw(tbpBotPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuWheelSeparation_Click " & ex.ToString)
        End Try
    End Sub


    Private Sub mnuAcceleration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBotAcceleration.Click
        On Error Resume Next
        Dim strAcceleration As String
        strAcceleration = InputBox("Enter the Bot Acceleration in centimeters per second /second ", "Acceleration", Str(sngBotLinearAcceleration))
        If strAcceleration <> "" And IsNumeric(strAcceleration) Then
            sngBotLinearAcceleration = Convert.ToSingle(strAcceleration)
            If (sngBotLinearAcceleration <= 0) Then sngBotLinearAcceleration = 1
        End If
        subRecalculateVariables()
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuVelocity_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuVelocity.Click
        On Error Resume Next
        Dim strVelocity As String
        strVelocity = InputBox("Enter the Bot Linear Velocity in centimeters per second  ", "Velocity", Str(sngBotLinearVelocity))
        If strVelocity <> "" And IsNumeric(strVelocity) Then
            sngBotLinearVelocity = Convert.ToSingle(strVelocity)
        End If
        subRecalculateVariables()
        boolSettingsChanged = True
        ftnSendCommand("set linear velocity " & Int(sngBotLinearVelocity).ToString)
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuAngularVelocity_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAngularVelocity.Click
        On Error Resume Next
        Dim strAngularVelocity As String
        strAngularVelocity = InputBox("Enter the Bot Angular Velocity in degrees per second  ", "AngularVelocity", Str(sngBotAngularVelocity))
        If strAngularVelocity <> "" And IsNumeric(strAngularVelocity) Then
            sngBotAngularVelocity = Convert.ToSingle(strAngularVelocity)
        End If
        subRecalculateVariables()
        boolSettingsChanged = True
        ftnSendCommand("set angular velocity  " & Int(sngBotAngularVelocity).ToString)
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuAngularAcceleration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAngularAcceleration.Click
        On Error Resume Next
        Dim strAngularAcceleration As String
        strAngularAcceleration = InputBox("Enter the Bot Angular Acceleration in degrees per second per second ", "AngularAcceleration", Str(sngBotAngularAcceleration))
        If strAngularAcceleration <> "" And IsNumeric(strAngularAcceleration) Then
            sngBotAngularAcceleration = Convert.ToSingle(strAngularAcceleration)
            If (sngBotAngularAcceleration <= 0) Then sngBotAngularAcceleration = 1
        End If
        subRecalculateVariables()
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuMovementAccuracy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuMovementAccuracy.Click
        On Error Resume Next
        Dim strBotMovementAccuracy As String
        strBotMovementAccuracy = InputBox("Enter the Bot Movement Accuracy Coefficient" & vbCrLf & _
                                          "        Range = (0 - 1) where:" & vbCrLf & _
                                          " '1' = the Bot moves exactly as commanded" & vbCrLf & _
                                          " '0' = the Bot moves wildly inaccurately", "MovementAccuracy", Str(sngBotMovementAccuracy))
        If strBotMovementAccuracy <> "" And IsNumeric(strBotMovementAccuracy) Then
            sngBotMovementAccuracy = Convert.ToSingle(strBotMovementAccuracy)
        End If
        If (sngBotMovementAccuracy < 0.01) Then sngBotMovementAccuracy = 0.01
        If (sngBotMovementAccuracy > 1) Then sngBotMovementAccuracy = 1
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuSteeringBias_Click(sender As Object, e As EventArgs) Handles mnuSteeringBiasCorrection.Click
        Try
            Dim strSteeringBiasOffsetCorrection As String
            strSteeringBiasOffsetCorrection = InputBox("If the robot does not steer straight ahead then enter an offset correction" & vbCrLf & _
                                              " '-ve offset' = robot will steer more left" & vbCrLf & _
                                              " '+ve offset' = robot will steer more right", "SteeringBiasCorrection", Str(sngSteeringBiasOffsetCorrection))
            If strSteeringBiasOffsetCorrection <> "" And IsNumeric(strSteeringBiasOffsetCorrection) Then
                sngSteeringBiasOffsetCorrection = Convert.ToSingle(strSteeringBiasOffsetCorrection)
            End If
            boolSettingsChanged = True
            subRedraw(tbpBotPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuSteeringBias_Click")
        End Try
    End Sub


    Private Sub mnuCompass_Click(sender As Object, e As EventArgs) Handles mnuCompass.Click
        frmCompass.Visible = True
    End Sub







    Private Sub mnuViewDebug_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuViewDebug.Click
        On Error Resume Next
        boolViewDebug = True
        frmDebug.Visible = boolViewDebug
        frmDebug.Focus()
    End Sub


    Private Sub mnuToolsOptions_Click(sender As System.Object, e As System.EventArgs)
        On Error Resume Next
    End Sub



    Private Sub mnuEnableLocalRCC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEnableLocalRCC.Click
        On Error Resume Next
        mnuEnableLocalRCC.Checked = Not mnuEnableLocalRCC.Checked
        boolEnableLocalRCC = mnuEnableLocalRCC.Checked
        frmLandMarkEdit.picLmLoad()
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuEnableLocalRR_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEnableLocalRR.Click
        On Error Resume Next
        mnuEnableLocalRR.Checked = Not mnuEnableLocalRR.Checked
        boolEnableLocalRR = mnuEnableLocalRR.Checked
        frmLandMarkEdit.picLmLoad()
        boolSettingsChanged = True
        mnuTools.HideDropDown()
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuEnableBotRCC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEnableBotRCC.Click
        On Error Resume Next
        mnuEnableBotRCC.Checked = Not mnuEnableBotRCC.Checked
        boolEnableBotRCC = mnuEnableBotRCC.Checked
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuEnableGotAGlyph_Click(sender As System.Object, e As System.EventArgs) Handles mnuEnableGotAGlyph.Click
        On Error Resume Next
        mnuEnableGotAGlyph.Checked = Not mnuEnableGotAGlyph.Checked
        boolEnableGotAGlyph = mnuEnableGotAGlyph.Checked
        boolSettingsChanged = True
        If boolEnableGotAGlyph And (ProcessesRunning("GotAGlyph") = 0) Then
            Process.Start(Environment.CurrentDirectory & "\GotAGlyph\GotAGlyph.exe", "")
        End If
        ftnGotAGlyph_Communicate("glyph", ">", 500)
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuEnableAVM_Click(sender As System.Object, e As System.EventArgs) Handles mnuEnableAVM.Click
        On Error Resume Next
        mnuEnableAVM.Checked = Not mnuEnableAVM.Checked
        boolEnableAVM = mnuEnableAVM.Checked
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuRangeCalibration_Click(sender As System.Object, e As System.EventArgs) Handles mnuRangeCalibration.Click
        On Error Resume Next
        frmAvmRangeCorrection.Visible = True
        frmAvmRangeCorrection.Focus()
    End Sub


    Function ProcessesRunning(ByVal ProcessName As String) As Integer
        '  Generalized Function to Check if an Instance of Application is running in the machine
        Try
            Return Process.GetProcessesByName(ProcessName).GetUpperBound(0) + 1
        Catch
            Return 0
        End Try
    End Function



    Private Sub mnuEnableYRotation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        On Error Resume Next
        mnuEnableYRotation.Checked = Not mnuEnableYRotation.Checked
        boolEnableYRotation = mnuEnableYRotation.Checked
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuSimulatedMovement_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSimulatedMovement.Click
        On Error Resume Next
        If (boolSimulatedMovement = False) Then
            boolSimulatedMovement = True
            mnuSimulatedMovement.Checked = True
        Else
            boolSimulatedMovement = False
            mnuSimulatedMovement.Checked = False
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuLocalize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLocalize.Click
        On Error Resume Next
        boolStop = False
        intNumberOfBeams = constmaxScannerBeams
        tbpTargetPoseGlobal = tbpBotPose
        tbpStartingPose = tbpBotPose
        boolRangeReadingsAreFresh = False
        frmDebug.subWriteLogs(Color.Green, ftnElapsedTime(timeMoveCommandSent) & "                  Starting Localization ")
        Dim boolGoodLocalization As Boolean = False
        tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuSLAM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSLAM.Click
        boolStop = False
        mnuOpenMap_Click(sender, e)
        boolSlam = True
        frmSlam.subSlamInit()
        frmSlam.Visible = True
        subInitParticles(tbpBotPose, intNumberOfParticles)
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuDock_Click(sender As System.Object, e As System.EventArgs) Handles mnuDock.Click
        On Error Resume Next
        mnuDock.Checked = Not mnuDock.Checked
        boolDock = mnuDock.Checked
        If boolDock Then
            boolStop = False
            mnuTools.HideDropDown()
            frmDock.subDock()
        End If
    End Sub

    Private Sub mnuDockConfigure_Click(sender As System.Object, e As System.EventArgs) Handles mnuDockConfigure.Click
        On Error Resume Next
        frmDock.Visible = True
        frmDock.Focus()
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub RecognitionTimeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuRecognitionTime.Click
        On Error Resume Next
        Dim strRecognitionTime As String
        strRecognitionTime = InputBox("Enter the time (in seconds) the robot will look for Land Marks (Longer gives better accuracy) ", "Localization Time", Str(sngLocalizationTime))
        If strRecognitionTime <> "" And IsNumeric(strRecognitionTime) Then
            sngLocalizationTime = Convert.ToSingle(strRecognitionTime)
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuLocalVideoDelay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLocalVideoDelay.Click
        On Error Resume Next
        Dim strLocalVideoDelay As String
        strLocalVideoDelay = InputBox("Enter the time (in milliseconds) the robot video is delayed before reaching the image recognizer ", " Video Delay", Str(sngStartOfMoveDelay))
        If strLocalVideoDelay <> "" And IsNumeric(strLocalVideoDelay) Then
            sngStartOfMoveDelay = Convert.ToSingle(strLocalVideoDelay)
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuAllowRoboRealmToControlBot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAllowRoboRealmToControlBot.Click
        On Error Resume Next
        mnuAllowRoboRealmToControlBot.Checked = Not mnuAllowRoboRealmToControlBot.Checked
        boolAllowRoboRealmToControlBot = mnuAllowRoboRealmToControlBot.Checked
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        If boolAllowRoboRealmToControlBot Then AllowRRToControlBot()
    End Sub

    Private Sub mnuMute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuMute.Click
        On Error Resume Next
        boolMute = Not boolMute
        mnuMute.Checked = boolMute
        If boolMute Then
            ftnSendCommand("clear")
            ftnSendCommand("speak off")
        Else
            ftnSendCommand("clear")
            ftnSendCommand("speak on")
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuParticle_Click(sender As Object, e As EventArgs) Handles mnuParticle.Click
        On Error Resume Next
        boolEnableRBPF = Not boolEnableRBPF
        mnuParticle.Checked = boolEnableRBPF
        subInitParticles(tbpBotPose, intNumberOfParticles)
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuNumberOfParticles_Click(sender As Object, e As EventArgs) Handles mnuNumberOfParticles.Click
        On Error Resume Next
        Dim strNumberOfParticles As String
        strNumberOfParticles = InputBox("Enter Number of Particles (1-8192) ", "Number of Particles", Str(intNumberOfParticles))
        If strNumberOfParticles <> "" And IsNumeric(strNumberOfParticles) Then
            intNumberOfParticles = Convert.ToSingle(strNumberOfParticles)
        End If
        intNumberOfParticles = Min(intNumberOfParticles, 8192)
        intNumberOfParticles = Max(intNumberOfParticles, 1)
        boolSettingsChanged = True
        frmSlam.updnNumberOfParticles.Value = intNumberOfParticles
        subInitParticles(tbpBotPose, intNumberOfParticles)
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    '--------------------------------- Speech Control
    Private Sub mnuNewsURL_Click(sender As Object, e As EventArgs) Handles mnuNewsURL.Click
        On Error Resume Next
        strNewsURL = InputBox("Enter the URL of a news feed ", " News URL", strNewsURL)
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuWeatherURL_Click(sender As Object, e As EventArgs) Handles mnuWeatherURL.Click
        On Error Resume Next
        strWeatherURL = InputBox("Enter the URL of a Yahoo Weather feed.  See http://weather.yahoo.com/ for the URL of your location. ", " Yahoo Weather URL", strWeatherURL)
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub mnuDestinationAlpha_Click(sender As Object, e As EventArgs) Handles mnuDestinationAlpha.Click
        Try
            tmcDestinationAlpha = ftnGetVoiceDestination()
            boolSettingsChanged = True
            subRedraw(tbpBotPose)
            System.Windows.Forms.Application.DoEvents()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuDestinationAlpha_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuDestinationBravo_Click(sender As Object, e As EventArgs) Handles mnuDestinationBravo.Click
        Try
            tmcDestinationBravo = ftnGetVoiceDestination()
            boolSettingsChanged = True
            subRedraw(tbpBotPose)
            System.Windows.Forms.Application.DoEvents()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuDestinationBravo_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuDestinationCharlie_Click(sender As Object, e As EventArgs) Handles mnuDestinationCharlie.Click
        Try
            tmcDestinationCharlie = ftnGetVoiceDestination()
            boolSettingsChanged = True
            subRedraw(tbpBotPose)
            System.Windows.Forms.Application.DoEvents()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuDestinationCharlie_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuDestinationDelta_Click(sender As Object, e As EventArgs) Handles mnuDestinationDelta.Click
        Try
            tmcDestinationDelta = ftnGetVoiceDestination()
            boolSettingsChanged = True
            subRedraw(tbpBotPose)
            System.Windows.Forms.Application.DoEvents()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuDestinationDelta_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuDestinationEcho_Click(sender As Object, e As EventArgs) Handles mnuDestinationEcho.Click
        Try
            tmcDestinationEcho = ftnGetVoiceDestination()
            boolSettingsChanged = True
            subRedraw(tbpBotPose)
            System.Windows.Forms.Application.DoEvents()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuDestinationEcho_Click " & ex.ToString)
        End Try
    End Sub

    Function ftnGetVoiceDestination() As typeMapCoordinate
        Try
            ftnGetVoiceDestination = tbpBotPose.Location
            Dim strDestination As String = ""
            strDestination = InputBox("enter a destination in the form xx yy ", "Destination", strDestination)
            Dim strParsedDestination As String() = strDestination.Split(" ")
            If (UBound(strParsedDestination) >= 1) And (Val(strParsedDestination(0) > 0)) And (Val(strParsedDestination(1) > 0)) Then
                ftnGetVoiceDestination.X = Int(Val(strParsedDestination(0)))
                ftnGetVoiceDestination.Y = Int(Val(strParsedDestination(1)))
            Else
                ftnSendCommand("play phrase Beep")
                MsgBox(" Invalid Destination.")
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetVoiceDestination " & ex.ToString)
        End Try
    End Function



    Private Sub mnuPCVoice_Click(sender As Object, e As EventArgs) Handles mnuPCVoice.Click
        On Error Resume Next
        boolPCVoice = Not boolPCVoice
        mnuPCVoice.Checked = boolPCVoice
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub




    Private Sub mnuBotPose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBotPose.Click
        On Error Resume Next
        frmPose.updnLocationX.Value = tbpBotPose.Location.X
        frmPose.updnLocationY.Value = tbpBotPose.Location.Y
        frmPose.updnUncertaintyX.Value = tbpBotPose.LocationUncertainty.X
        frmPose.updnUncertaintyY.Value = tbpBotPose.LocationUncertainty.Y
        frmPose.updnOrientation.Value = tbpBotPose.Orientation
        frmPose.updnOrientationUncertainty.Value = tbpBotPose.OrientationUncertainty
        frmPose.Visible = True
        frmPose.Focus()
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub



    Private Sub mnuBotIP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBotIP.Click
        On Error Resume Next
        Dim strIPAddr As String
        strIPAddr = InputBox("Enter Bot IP Address in form 111.222.333.444", "IP Address", Convert.ToString(ipRobot_IPAddress)).Trim
        If strIPAddr <> "" Then
            If ftnIsValidIP(strIPAddr) Then ipRobot_IPAddress = IPAddress.Parse(strIPAddr)
        End If
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
        System.Windows.Forms.Application.DoEvents()
    End Sub



    Private Sub mnuEnableLocalizationWhileMovingToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEnableLocalizationWhileMoving.Click
        On Error Resume Next
        boolEnableLocalizationWhileMoving = Not (boolEnableLocalizationWhileMoving)
        mnuEnableLocalizationWhileMoving.Checked = boolEnableLocalizationWhileMoving
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuMidCourseCorrection_Click(sender As Object, e As EventArgs) Handles mnuMidCourseCorrection.Click
        On Error Resume Next
        boolEnableMidCourseCorrection = Not (boolEnableMidCourseCorrection)
        mnuMidCourseCorrection.Checked = boolEnableMidCourseCorrection
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    Private Sub mnuXYMotion_Click(sender As Object, e As EventArgs) Handles mnuXYMotion.Click
        On Error Resume Next
        If Not (boolEnableBotSerialIF And boolER1Selected) Then
            boolEnableXY_Motion = Not (boolEnableXY_Motion)
            mnuXYMotion.Checked = boolEnableXY_Motion
            boolSettingsChanged = True
        End If
        subRedraw(tbpBotPose)
    End Sub


    Private Sub VoiceCommandEnableToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles mnuVoiceCommandEnable.Click
        On Error Resume Next
        mnuVoiceCommandEnable.Checked = Not mnuVoiceCommandEnable.Checked
        boolVoiceCommandEnable = mnuVoiceCommandEnable.Checked
        subSpeechEnableChange()
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub

    Private Sub mnuLogFileEnable_Click(sender As Object, e As EventArgs) Handles mnuLogFileEnable.Click
        On Error Resume Next
        mnuLogFileEnable.Checked = Not mnuLogFileEnable.Checked
        boolLogFileEnable = mnuLogFileEnable.Checked
        boolSettingsChanged = True
        subRedraw(tbpBotPose)
    End Sub


    '==========================  Tool Strip  ==================================================


    Private Sub OpenToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripButton.Click
        mnuOpenMap_Click(sender, e)
    End Sub




    '==========================  Map Context Menu  ==================================================

    Private Sub ContextMenuStrip1_Opening(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MapContextMenu.Opening
        MapContextMenu.Visible = True
    End Sub



    Private Sub mnuLocalizeContext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLocalizeContext.Click
        mnuLocalize_Click(sender, e)
    End Sub


    Private Sub mnuAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAbout.Click
        AboutBox1.Visible = True
    End Sub



    '==================================== Keyboard Manual Control  =============================================
    Public Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Integer) As Integer
    Dim boolManualControl As Boolean = False
    Public boolCtrlKey As Boolean = False
    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Try
            Dim boolGoodLocalization As Boolean = False
            boolCtrlKey = (e.KeyCode = Keys.ControlKey)
            If Not boolManualControl And Not boolLocalizationInProgress And Not ftnCheckForStopMode() Then
                subDoEventsIfMainThread()
                boolManualControl = True
                boolDocked = False
                boolDock = False
                Dim tbpTargetPose As typeBotPose = tbpBotPose
                If e.KeyCode = Keys.Down Then
                    boolStop = False
                    frmDebug.subWriteLogs(Color.Purple, "))))))  Manual Control:  BACK")
                    If boolSlam Or boolHeroSelected Then
                        While GetAsyncKeyState(Keys.Down)
                            tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, sngTenInches)
                            tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                            subWait(1000)
                            GetAsyncKeyState(Keys.Down)
                        End While
                    Else
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, sngMaxTravel)
                        tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                    End If
                    If boolSlam Then tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                End If
                If e.KeyCode = Keys.Up Then
                    boolStop = False
                    frmDebug.subWriteLogs(Color.Purple, "))))))  Manual Control:  FWD")
                    If boolSlam Or boolHeroSelected Then
                        While GetAsyncKeyState(Keys.Up)
                            tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, sngTenInches)
                            tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                            subWait(1000)
                            GetAsyncKeyState(Keys.Up)
                        End While
                    Else
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, sngMaxTravel)
                        tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                    End If
                    If boolSlam Then tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                End If
                If e.KeyCode = Keys.Right Then
                    boolStop = False
                    frmDebug.subWriteLogs(Color.Purple, "))))))  Manual Control:  TURN RIGHT")
                    If boolSlam Or boolHeroSelected Then
                        While GetAsyncKeyState(Keys.Right)
                            tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation - 15)
                            tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                            subWait(1000)
                            GetAsyncKeyState(Keys.Right)
                        End While
                    Else
                        tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation - 135)
                        tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                    End If
                    If boolSlam Then tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                End If
                If e.KeyCode = Keys.Left Then
                    boolStop = False
                    frmDebug.subWriteLogs(Color.Purple, "))))))  Manual Control:  TURN LEFT")
                    If boolSlam Or boolHeroSelected Then
                        While GetAsyncKeyState(Keys.Left)
                            tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + 10)
                            tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                            subWait(1000)
                            GetAsyncKeyState(Keys.Left)
                        End While
                    Else
                        tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + 135)
                        tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                    End If
                    If boolSlam Or boolHeroSelected Then
                        While boolManualControl
                            subWait(100)
                        End While
                        tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                    End If
                End If
                If boolHeroSelected And boolManualControl Then
                    subWait(500)
                    boolCollisionDetected = False
                    boolManualControl = False
                    boolCtrlKey = False
                End If
            ElseIf (boolSlam Or boolHeroSelected) And boolManualControl And boolLocalizationInProgress Then
                MsgBox(" Wait for Localization to complete")
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in Form_KeyDown")
        End Try
    End Sub

    Private Sub Form_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp
        Try
            If boolManualControl And Not boolHeroSelected Then
                If (boolManualControl And (boolBotConnected Or (String.CompareOrdinal(strTypeOfMove, "Turn") = 0) Or strTypeOfMove = "Fwd")) Then
                    If Not boolEnableRBPF Then
                        tbpBotPose = ftnBotStop(tbpBotPose, tbpTargetPoseGlobal)
                        strTypeOfMove = ""
                        subRedraw(tbpBotPose)
                    End If
                End If
                subWait(500)
                boolCollisionDetected = False
                boolManualControl = False
                boolCtrlKey = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in Form_KeyUp")
        End Try
    End Sub








    '==================================== Tool Strip  =============================================

    Private Sub picBot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picBot.Click
        boolPlaceBot = Not boolPlaceBot
        If boolPlaceBot Then boolPlaceDestination = False
        subRedraw(tbpBotPose)
    End Sub

    Private Sub picDestination_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picDestination.Click
        Try
            boolPlaceDestination = Not boolPlaceDestination
            If boolPlaceDestination Then boolPlaceBot = False
            If boolPlaceDestination Then
                boolStop = False
                Me.picStop.BorderStyle = FormBorderStyle.None
            End If
            subRedraw(tbpBotPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in picDestination_Click")
        End Try
    End Sub

    Private Sub SaveToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripButton.MouseUp
        mnuSaveSettings_Click(sender, e)
    End Sub


    Private Sub picStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picStop.DoubleClick
        Try
            If (Me.picStop.BorderStyle = FormBorderStyle.None) Then
                Me.picStop.BorderStyle = FormBorderStyle.Fixed3D
            Else
                Me.picStop.BorderStyle = FormBorderStyle.None
            End If
            boolStop = (Me.picStop.BorderStyle = FormBorderStyle.Fixed3D)
            If boolStop Then
                tbpBotPose = ftnBotStop(tbpBotPose, tbpTargetPoseGlobal)
                boolDock = False
                boolDrivingToDestination = False
                subRedraw(tbpBotPose)
                strStatusDriving = "STOP mode"
                subRedraw(tbpBotPose)
                frmDebug.subWriteLogs(Color.Black, Now() & "    >>>>  STOP button was pushed  >>> ")
                ftnSendCommand("play phrase 'By your command.'")
            Else
                strStatusDriving = ""
                subRedraw(tbpBotPose)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in picStop_Click")
        End Try
    End Sub




    Private Sub StatusDriving_Click(sender As Object, e As EventArgs) Handles StatusDriving.Click
        Try
            ftnSendCommand("battery")
            Dim byteCollisionCode1 As Byte = Val(ftnSendCommand("bumper"))
            Select Case byteCollisionCode1
                Case 4
                    subDrawBumperSwitch(tbpBotPose, 0)
                Case 6
                    subDrawBumperSwitch(tbpBotPose, -45)
                Case 5
                    subDrawBumperSwitch(tbpBotPose, 45)
                Case 3
                    subDrawBumperSwitch(tbpBotPose, 180)
                Case Else
            End Select
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in StatusDriving_Click")
        End Try
    End Sub


    Private Sub mnuHelpContents_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHelpContents.Click
        Process.Start("GotABot User Manual.pdf")
    End Sub

    Private Sub HelpToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HelpToolStripButton.Click
        Process.Start("GotABot User Manual.pdf")
    End Sub





    '==================================== WatchDog - Dock, API Disconnect  =============================================
    Dim boolHeroDisplay1 As Boolean = False
    Private Sub timerWatchDog_Tick(sender As System.Object, e As System.EventArgs) Handles timerWatchDog.Tick
        ' check if APIs are communicating
        ' check if compass attached
        ' check battery voltages and Dock if required
        Try
            If Not boolBotIsMoving And Not boolLocalizationInProgress And Not boolShutDown Then
                timerWatchDog.Enabled = False
                subCheckForAPITimeout()
                If boolPhidgetsInstalled Then
                    If (frmSpatial.spatial IsNot Nothing) Then boolCompassAttached = ftnCompassAttached()
                End If
                ftnSendCommand("battery")  'Recheck
                If boolHeroSelected And boolHeroDisplay1 And Not boolBotIsMoving Then
                    ftnHero_Communicate("GD08374F051D88", ">", 1000) ' Write "-Hero-" to robot's display
                    boolHeroDisplay1 = False
                ElseIf boolHeroSelected And Not boolBotIsMoving Then
                    ftnHero_Communicate("GD085E1D707D88", ">", 1000) ' Write "-Gota-" to robot's display
                    boolHeroDisplay1 = True
                End If
                If (strStatusBotVoltage = "   ??   ") Or CBool(InStr(strStatusBotVoltage, "--")) Then sngBotBatteryVoltage = sngDockTriggerBot
                If boolDock And ((sngBotBatteryVoltage > sngDockTriggerBot * 1.05) And ((sngLaptopBatteryPercent > intDockTriggerPC * 1.1) Or (SystemInformation.PowerStatus.BatteryChargeStatus = BatteryChargeStatus.Charging))) Then
                    boolDock = False
                ElseIf Not boolDock And ((sngBotBatteryVoltage < sngDockTriggerBot) Or ((sngLaptopBatteryPercent < intDockTriggerPC) And Not (SystemInformation.PowerStatus.BatteryChargeStatus = BatteryChargeStatus.Charging))) Then
                    If Not boolBotIsMoving And ((sngBotBatteryVoltage < sngDockTriggerBot) Or _
                       (sngLaptopBatteryPercent < intDockTriggerPC) And Not (SystemInformation.PowerStatus.BatteryChargeStatus = BatteryChargeStatus.Charging)) And Not boolSimulatedMovement Then
                        subWait(1000)
                        ftnSendCommand("battery")  'Recheck
                        If (strStatusBotVoltage = "   ??   ") Then sngBotBatteryVoltage = sngDockTriggerBot
                        If Not boolBotIsMoving And ((sngBotBatteryVoltage < sngDockTriggerBot) Or (sngLaptopBatteryPercent < intDockTriggerPC)) Then
                            subWait(1000)
                            ftnSendCommand("battery")  'Recheck
                            If (strStatusBotVoltage = "   ??   ") Then sngBotBatteryVoltage = sngDockTriggerBot
                            If Not boolDock And Not boolCollisionDetected And ((sngBotBatteryVoltage < sngDockTriggerBot) Or (sngLaptopBatteryPercent < intDockTriggerPC)) Then
                                mnuDock.Checked = True
                                boolStop = False
                                boolPause = False
                                frmDock.subDock()
                            End If
                        End If
                    End If
                End If
                timerWatchDog.Interval = 60000
                timerWatchDog.Enabled = True
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in timerWatchDog_Tick: ")
            frmDebug.subWriteLogs(Color.Red, "    ERROR:  " & ex.Message)
        End Try
    End Sub


    Function ftnCompassAttached() As Boolean
        Try
            ftnCompassAttached = False
            If (frmSpatial.spatial IsNot Nothing) Then ftnCompassAttached = (frmSpatial.spatial.compassAxes.Count > 0)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnCompassAttached")
        End Try
    End Function




    Public Sub subAPI_Redraw()
        Try
            If Me.myMap.InvokeRequired Then
                Dim newDelegate As New DelegateevntAPI(AddressOf subAPI_Redraw)
                Me.Invoke(newDelegate)
            Else
                If Not (Me.FileToolStripMenuItem1.Selected Or Me.FileToolStripMenuItem1.Pressed _
                          Or Me.mnuConfigure.Selected _
                          Or Me.mnuTools.Selected Or Me.mnuTools.Pressed _
                          Or Me.HelpToolStripMenuItem1.Selected Or Me.HelpToolStripMenuItem1.Pressed _
                          Or Me.updnOrientation.Focused Or boolSimulatedMovement Or boolBotIsMoving _
                          Or boolDrivingToDestination) Then _
                     Me.subRedraw(tbpBotPose)
                System.Windows.Forms.Application.DoEvents()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subAPI_Redraw")
        End Try
    End Sub

End Class








