﻿Imports System.Math
Imports System.Threading


Public Class frmGotAnArm

    Private Sub frmGotAnArm_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        dxl_initialize(constDefaultPortNum, constDefaultBaudNum)
        taaArmAngles.sngBaseXZ = constBaseAngleXZ
        subInitializeDynamixels()
        tsslJoint.Text = "Base Rotate"
    End Sub

    Sub subExit() Handles Me.FormClosing
        boolShutDown = True
        dxl_terminate()
    End Sub


    ' =================================   MANUAL CONTROL ========================================
    Private Sub subSegment_MouseWheel(ByVal sender As System.Object, ByVal e As MouseEventArgs) Handles Me.MouseWheel  'gripper control
        On Error Resume Next
        Dim intNewAngle As Short
        Select Case intSegmentSelect
            Case 0
                ftnSetBaseRotatePosition(ftnNewPosition(1, e.Delta))
            Case 1
            Case 2
                ftnSetShoulderPosition(ftnNewPosition(3, -e.Delta))
            Case 3
                ftnSetElbowPosition(ftnNewPosition(4, -e.Delta))
            Case 4
                ftnSetWristRotatePosition(ftnNewPosition(6, e.Delta))
            Case 5
            Case 6
                ftnSetGripperPosition(ftnNewPosition(7, e.Delta))
        End Select
        ftnForwardKinematics(Not boolDebug)
        subDrawArm()
    End Sub

    Function ftnNewPosition(ByVal intID As Short, ByVal intIncrement As Short)
        On Error Resume Next
        ftnNewPosition = dxl_read_word(intID, constPresentPosition) + intIncrement / 10
        If (ftnNewPosition > 1023) Then ftnNewPosition = 1023
        If (ftnNewPosition < 0) Then ftnNewPosition = 0
    End Function

    Dim boolMouseDown As Boolean = False
    Private Sub subArm_MouseDown(ByVal sender As System.Object, ByVal e As MouseEventArgs) Handles pbbArm.MouseDown
        On Error Resume Next
        boolMouseDown = True
        If (e.Button = MouseButtons.Right) Then  ' Select the next arm segment
            intSegmentSelect += 1
            If (intSegmentSelect > 6) Then intSegmentSelect = 0
            Select Case intSegmentSelect
                Case 0
                    tsslJoint.Text = "Base Rotate"
                Case constBaseSegment
                    tsslJoint.Text = "Base"
                Case constShoulderSegment
                    tsslJoint.Text = "Shoulder"
                Case constElbowSegment
                    tsslJoint.Text = "Elbow"
                Case constWristRSegment
                    tsslJoint.Text = "Wrist Rotate"
                Case constWristSegment
                    tsslJoint.Text = "Wrist"
                Case constGripperSegment
                    tsslJoint.Text = "Gripper"
                Case Else
                    tsslJoint.Text = "-----"
            End Select
        ElseIf (e.Button = MouseButtons.Left) Then  ' Set a destination
            Dim tmcDestination As typeMapCoordinate = ftnMousePosition()
            Dim tpcDestination As typePointCoordinate
            tpcDestination.X = tmcDestination.X
            tpcDestination.Z = tmcDestination.Y
            Dim boolFoundSolution As Boolean = ftnReverseKinematics(tpcDestination, 0, 0)
            If boolFoundSolution And Not boolDebug Then
                subDrawArm()
                ftnSetShoulderPosition(ftnRadianToPosition(taaArmAngles.sngShoulder - taaArmAngles.sngBaseXZ))
                ftnSetElbowPosition(ftnRadianToPosition(taaArmAngles.sngElbow - taaArmAngles.sngShoulder))
            End If
            End If
    End Sub

    Private Sub subArm_MouseUp(ByVal sender As System.Object, ByVal e As MouseEventArgs) Handles pbbArm.MouseUp
        On Error Resume Next
        boolMouseDown = False
    End Sub


    Private Sub subArm_MouseMove(ByVal sender As System.Object, ByVal e As MouseEventArgs) Handles pbbArm.MouseMove  'base, shoulder, elbow, wrist control
        On Error Resume Next
        timerUpdate.Enabled = False
        Dim tmcDestination As typeMapCoordinate = ftnMousePosition()
        tsslXY.Text = tmcDestination.X & ", " & tmcDestination.Y
        timerUpdate.Enabled = True
    End Sub

    Function ftnMousePosition() As typeMapCoordinate
        On Error Resume Next
        ftnMousePosition.X = -(pbbArm.Width * 0.4 - (MousePosition.X - Me.Location.X - pbbArm.Location.X - pbbArm.Padding.Left - pbbArm.Margin.Left - 3))
        ftnMousePosition.Y = (pbbArm.Height * 0.75 - (MousePosition.Y - Me.Location.Y - pbbArm.Location.Y - pbbArm.Padding.Top - pbbArm.Margin.Top - 28))
    End Function


    '==================================== THREADS   =============================================

    '==================================== API  Thread  =============================================
    Dim WithEvents classNewAPIServer As classAPIServer
    Sub Start_Threads()
        On Error Resume Next
        classNewAPIServer = New classAPIServer()
        Dim API1MainThread As New Thread(AddressOf classAPIServer.subMain)
        API1MainThread.IsBackground = True
        API1MainThread.Start()
    End Sub


    ' ============================Timers==========================================

    Private Sub timerWatchDog_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timerWatchDog.Tick
        On Error Resume Next
        timerWatchDog.Enabled = False
        If classAPIServer.Connected And Not boolAPIActivity Then
            modApiIF.subAPITimeout()
            System.Windows.Forms.Application.DoEvents()
        End If
        boolAPIActivity = False
        Dim boolOK As Boolean = False
        For intID As Short = 1 To 9 ' check that USB2Dynamixel still working
            dxl_ping(intID)
            If (dxl_get_result() = COMM_RXSUCCESS) Then
                boolOK = True
                Exit For
            End If
        Next
        If Not boolOK Then subInitializeDynamixels()
        For intID As Short = 1 To 9 ' check for overload, overtemperature
            dxl_ping(intID)
            If (timeJointMove(intID) > Now.AddSeconds(12)) Then
                If (dxl_read_word(intID, constLoad) > 64) Then
                    dxl_write_word(intID, constGoalPosition, dxl_read_word(intID, constPresentPosition))
                    dxl_write_word(intID, constTorqueLimit, dxl_read_word(intID, constTorqueMax))
                End If
            End If
            If (dynamixel.dxl_get_rxpacket_error(dynamixel.ERRBIT_OVERLOAD) = 1) Or (dynamixel.dxl_get_rxpacket_error(dynamixel.ERRBIT_OVERHEAT) = 1) Then
                dxl_write_word(intID, constGoalPosition, dxl_read_word(intID, constPresentPosition))
                dxl_write_word(intID, constTorqueLimit, dxl_read_word(intID, constTorqueMax))
                subHighlightDynamixelError(intID)
            End If
        Next
        timerWatchDog.Enabled = True
    End Sub

    Private Sub subTimerUpdate(sender As Object, e As EventArgs) Handles timerUpdate.Tick
        On Error Resume Next
        timerUpdate.Enabled = False
        Dim tpcPosition As typePointCoordinate = ftnForwardKinematics(Not boolDebug)
        subDrawArm()
        tsslPosition.Text = tpcPosition.X & ",  " & tpcPosition.Y & ",  " & tpcPosition.Z
        subUpdateDynaParameters()
        If classAPIServer.Connected Then
            Me.tsslComStatus.ForeColor = Color.Green
            Me.tsslComStatus.Text = "API Connected"
        Else
            Me.tsslComStatus.ForeColor = Color.Red
            Me.tsslComStatus.Text = "API Not Connected"
        End If
        timerUpdate.Enabled = True
    End Sub


    ' ======================================================================

    Sub subUpdateDynaParameters()
        On Error Resume Next
        Dim strText As String = "ID" & vbTab & "Position" & vbTab & "Goal" & vbTab & "Load" & vbTab & "Temperature" & vbCrLf
        For intID As Short = 1 To 9
            strText &= intID.ToString & vbTab & dxl_read_word(intID, constPresentPosition) & vbTab & dxl_read_word(intID, constGoalPosition) & vbTab _
                    & dxl_read_word(intID, constLoad) & vbTab & dxl_read_byte(intID, constTemperature) & vbCrLf
        Next intID
        rtbDynaParam.Text = strText
    End Sub

    ' =============================== BUTTONS =============================================================

    Private Sub butReset_Click(sender As Object, e As EventArgs) Handles butReset.Click
        On Error Resume Next
        butStop_Click(sender, e)
        For intID As Short = 1 To 9
            If (dxl_read_byte(intID, constAlarmShutDown) <> 0) Then dxl_write_word(intID, constTorqueLimit, dxl_read_word(intID, constTorqueMax))
        Next
    End Sub

    Private Sub butHome_Click(sender As Object, e As EventArgs) Handles butHome.Click
        On Error Resume Next
        ftnSetShoulderPosition(900)
        ftnSetElbowPosition(150)
        ftnSetWristRotatePosition(512)
        ftnSetBaseRotatePosition(512)
    End Sub

    Private Sub butStop_Click(sender As Object, e As EventArgs) Handles butStop.Click
        On Error Resume Next
        For intID As Short = 1 To 9
            dxl_write_word(intID, constGoalPosition, dxl_read_word(intID, constPresentPosition))
            dxl_write_word(intID, constTorqueLimit, dxl_read_word(intID, constTorqueMax))
        Next
    End Sub


    Private Sub CCW40_Click(sender As Object, e As EventArgs) Handles CCW40.Click
        subBaseRotate(40)
    End Sub

    Private Sub CW40_Click(sender As Object, e As EventArgs) Handles CW40.Click
        subBaseRotate(-40)
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        ftnSetBaseRotatePosition(dxl_read_word(1, constPresentPosition) - 40 * 1024 / 300)
    End Sub



 End Class
