﻿
Imports System.Globalization
Imports System.IO
Imports System.Math
Imports System.EventArgs
Imports System.Threading
Imports System.Net


Public Class classScanner

    Private Sub frmScannerConfigure_Load(sender As Object, e As EventArgs) Handles Me.Load
        On Error Resume Next
        Me.Visible = True
        updnOffsetX.Value = tmcScanVectorOffset.X
        updnOffsetY.Value = tmcScanVectorOffset.Y
        sliderScannerRangeCalibrate.Value = sngScannerCalibrate * 100
        sliderScannerDepthCurveAdjust.Value = (sngScannerCurveAdjust + 1) * 100
        updnScannerOffsetDegrees.Value = intScanOffsetDegrees
        chkContinuous.Checked = False
        ftnURGInitializeTop()
        If Not boolURGConnected Then  ftnKinectInitializeTop()
        For Each sp As String In My.Computer.Ports.SerialPortNames  ' Show all available COM ports.
            mnuURGPortComboBox.Items.Add(sp)         'adds COMX to mnuURGPortComboBox
        Next
        mnuURGPortComboBox.Items.Add("None")         'adds "None" to mnuURGPortComboBox
        mnuURGPortComboBox.Text = strURGComPort  'selects the USB port declared in the 'Save Settings' file
        timerScannerWatchdog.Enabled = True
    End Sub

    Private Sub updnOffsetX_ValueChanged(sender As Object, e As EventArgs) Handles updnOffsetX.ValueChanged
        On Error Resume Next
        If updnOffsetX.ContainsFocus Then
            tmcScanVectorOffset.X = updnOffsetX.Value
            boolSettingsChanged = True
        End If
    End Sub

    Private Sub updnOffsetY_ValueChanged(sender As Object, e As EventArgs) Handles updnOffsetY.ValueChanged
        On Error Resume Next
        If updnOffsetY.ContainsFocus Then
            tmcScanVectorOffset.Y = updnOffsetY.Value
            boolSettingsChanged = True
        End If
    End Sub

    Private Sub trbRangeCalibrate_Scroll(sender As Object, e As EventArgs) Handles sliderScannerRangeCalibrate.Scroll
        On Error Resume Next
        sngScannerCalibrate = sliderScannerRangeCalibrate.Value / 100
        boolSettingsChanged = True
        subCalculateScanCalCoefficients()
    End Sub

    Private Sub chkContinuous_CheckedChanged(sender As Object, e As EventArgs) Handles chkContinuous.Click
        Try
            If chkContinuous.ContainsFocus Then
                Me.Refresh()
                While chkContinuous.Checked And Me.Visible And Not boolShutDown
                    subDoEventsIfMainThread()
                    boolRangeReadingsAreFresh = False
                    frmRangeFinder.subGetRangerReadings()
                    ftnGetScanVectors(tbpBotPose, True)
                    subWait(200)
                End While
                If Not Me.Visible Then chkContinuous.Checked = False
                GotABotClass.subRedraw(tbpBotPose)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in chkContinuous_CheckedChanged")
        End Try
    End Sub


    Private Sub updnScannerOffsetDegrees_ValueChanged(sender As Object, e As EventArgs) Handles updnScannerOffsetDegrees.ValueChanged
        On Error Resume Next
        If updnScannerOffsetDegrees.ContainsFocus Then
            intScanOffsetDegrees = updnScannerOffsetDegrees.Value
            subCalculateScanBeamAngles()
            boolSettingsChanged = True
        End If
    End Sub


    Private Sub sliderScannerDepthCurveAdjust_Scroll(sender As Object, e As EventArgs) Handles sliderScannerDepthCurveAdjust.Scroll
        On Error Resume Next
        If sliderScannerDepthCurveAdjust.ContainsFocus Then
            sngScannerCurveAdjust = sliderScannerDepthCurveAdjust.Value / 100 - 1
            boolSettingsChanged = True
            subCalculateScanCalCoefficients()
        End If
    End Sub

    Private Sub Cancel_Button_Click(sender As Object, e As EventArgs) Handles Cancel_Button.Click
        On Error Resume Next
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Dim tbpTempPose As typeBotPose = tbpBotPose ' make sure we aren't throwing away important stuff!
        Dim tlmTempLandMarkArray(128) As typeLandMark
        tlmTempLandMarkArray = tlmLandMarkArray
        GotABotClass.mnuLoadSettings_Click(trfRangeFinders, e)
        tbpBotPose = tbpTempPose
        tlmLandMarkArray = tlmTempLandMarkArray
        strStatusDriving = ""
        GotABotClass.subRedraw(tbpBotPose)
        Me.Close()
    End Sub

    Private Sub OK_Button_Click(sender As Object, e As EventArgs) Handles OK_Button.Click
        On Error Resume Next
        Me.Visible = False
        On Error Resume Next
        strStatusDriving = ""
        GotABotClass.subRedraw(tbpBotPose)
        subCalculateScanBeamAngles()
        subCalculateScanCalCoefficients()
        Me.Close()
    End Sub

    Private Sub me_exit(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.FormClosed
        On Error Resume Next
        System.GC.Collect()
    End Sub


    Delegate Sub DelegateUpdateLabel(ByVal strNewText As String, ByVal colText As Color)
    Public Sub subUpdateStatusLabel1(ByVal strNewText As String, ByVal colText As Color)
        Try
            If InvokeRequired And Not boolShutDown Then
                Dim newDelegate As New DelegateUpdateLabel(AddressOf subUpdateStatusLabel1)
                Invoke(newDelegate, New Object() {strNewText, colText})
                System.Windows.Forms.Application.DoEvents()
            ElseIf Not boolShutDown Then
                tsslKinectStatus.ForeColor = colText
                tsslKinectStatus.Text = strNewText
            End If '
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subUpdateStatusLabel1")
        End Try
    End Sub

    '--------------------------------------  MENU BAR   -----------------------------------------------------

    Private Sub mnuDefaultElevation_Click(sender As Object, e As EventArgs) Handles mnuDefaultElevation.Click
        On Error Resume Next
        Dim strDefaultElevation As String
        strDefaultElevation = InputBox("Enter Default Elevation Angle (-27 to 27 degrees) ", "Elevation Angle", Str(intDefaultElevation))
        If strDefaultElevation <> "" And IsNumeric(strDefaultElevation) Then
            intDefaultElevation = Convert.ToInt16(strDefaultElevation)
            If (intDefaultElevation < -27) Then intDefaultElevation = -27
            If (intDefaultElevation > 27) Then intDefaultElevation = 27
            K_Sensor.ElevationAngle() = intDefaultElevation
            boolSettingsChanged = True
        End If
        Me.Refresh()
        System.Windows.Forms.Application.DoEvents()
    End Sub


    Private Sub mnuComboBoxBeams_Click(sender As Object, e As EventArgs) Handles mnuComboBoxBeams.TextChanged
        On Error Resume Next
        intNumberOfBeamsDefault = Val(Me.mnuComboBoxBeams.Text)
        boolSettingsChanged = True
        frmSlam.mnuComboBoxBeams.ValueMember = intNumberOfBeamsDefault
        frmSlam.Refresh()
        mnuBeams.Text = "Beams           (" & intNumberOfBeamsDefault & ")"
        If mnuComboBoxBeams.Visible Then
            SettingsToolStripMenuItem.HideDropDown()
        End If
        Me.Refresh()
    End Sub

    Private Sub SettingsToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SettingsToolStripMenuItem.Click
        On Error Resume Next
        mnuBeams.Text = "Beams           (" & intNumberOfBeamsDefault & ")"
        mnuComboBoxBeams.Text = intNumberOfBeamsDefault
    End Sub

    Dim boolWatchdogInProgress As Boolean = False
    Public Sub timerScannerWatchdog_Tick(sender As Object, e As EventArgs) Handles timerScannerWatchdog.Tick
        Try
            timerScannerWatchdog.Enabled = False
            If Not boolWatchdogInProgress Then
                boolWatchdogInProgress = True
                If Not boolShutDown And Not boolURGConnected Then
                    boolURGConnected = ftnGetURGScanVectors()
                    ftnURGInitializeTop()
                End If
                If Not boolShutDown And Not boolURGConnected And Not boolKinectConnected Then _
                    ftnKinectInitializeTop()
                subReportScannerStatus()
            End If
            boolWatchdogInProgress = False
            timerScannerWatchdog.Enabled = True
        Catch ex As Exception
            timerScannerWatchdog.Enabled = True
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in timerScannerWatchdog_Tick")
            frmDebug.subWriteLogs(Color.Red, "    ERROR:  " & ex.Message)
        End Try
    End Sub

    Sub subReportScannerStatus()
        Try
            If boolURGConnected Then
                subUpdateStatusLabel1("URG Connected", Color.Black)
                If boolDebugURG Then frmDebug.subWriteLogs(Color.Red, " URG Connected")
            ElseIf boolKinectConnected Then
                subUpdateStatusLabel1("Kinect Connected", Color.Black)
            ElseIf boolHeroSelected Then
                subUpdateStatusLabel1("Hero Selected", Color.Black)
                If boolDebugHero Then frmDebug.subWriteLogs(Color.Red, "Hero Selected")
            Else
                subUpdateStatusLabel1("No Scanner", Color.Red)
                If boolDebugKinect And (K_Sensor IsNot Nothing) Then _
                    frmDebug.subWriteLogs(Color.Red, " Kinect Sensor status: " & K_Sensor.Status.ToString)
                If boolDebugKinect Or boolDebugURG Then frmDebug.subWriteLogs(Color.Red, "subReportScanner Status:  No Scanner Connected!")
            End If
        Catch ex As Exception
            boolKinectDriversInstalled = False
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subReportScannerStatus")
        End Try
    End Sub
    '====================================================================================================================================================

    Private Sub mnuURGPortComboBox_Click(sender As Object, e As EventArgs) Handles mnuURGPortComboBox.TextChanged
        If mnuURGPortComboBox.Focused Then
            strURGComPort = mnuURGPortComboBox.Text
            boolSettingsChanged = True
        End If
    End Sub

    Private Sub mnuSelectURGPort_Click(sender As Object, e As EventArgs) Handles mnuSelectURGPort.MouseEnter
        Try
            mnuURGPortComboBox.Items.Clear()
            For Each sp As String In My.Computer.Ports.SerialPortNames  ' Show all available COM ports.
                mnuURGPortComboBox.Items.Add(sp)         'adds COMX to mnuURGPortComboBox
            Next
            mnuURGPortComboBox.Items.Add("None")         'adds "None" to mnuURGPortComboBox
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuSelectURGPort_Click")
        End Try
    End Sub
End Class