﻿Imports System.Drawing.Imaging
Imports System.Drawing


Public Class frmSlam
    Dim boolEnableRBPF_Old As Boolean
    Dim sngMaxTravel_Old As Single
    Dim sngMaxTurn_Old As Single
    Dim boolEnableMidCourseCorrection_Old As Boolean
    Dim boolEnableLocalizationWhileMoving_Old As Boolean
    Dim boolEnableXY_Motion_Old As Boolean


    Sub subSlamInit()
        Try
            boolSlam = True
            sngGridSize = 1
            sngBotDiameter = ftnMapUnitsToInches(sngBotDiameter)
            sngMaxTurn = ftnMapUnitsToInches(sngMaxTurn)
            strUnits = "inch"
            subRecalculateVariables()
            subConvertMapToArray()
            GotABotClass.subRedraw(tbpBotPose)
            updnSelectMap.Maximum = intNumberOfParticles - 1
            updnNumberOfParticles.Value = intNumberOfParticles
            mnuComboBoxBeams.Text = intNumberOfBeams
            updnSelectMap.Visible = True 'boolDebugSlam
            txtParticlePose.Visible = True 'boolDebugSlam
            Label1.Visible = True 'boolDebugSlam
            Label2.Visible = True 'boolDebugSlam
            Label3.Visible = boolDebugSlam
            Label4.Visible = True 'boolDebugSlam
            Label6.Visible = True 'boolDebugSlam
            txtResample.Visible = boolDebugSlam
            txtWeight.Visible = True 'boolDebugSlam
            txtBest.Visible = True 'boolDebugSlam
            boolEnableRBPF_Old = boolEnableRBPF
            boolEnableRBPF = True
            boolEnableXY_Motion_Old = boolEnableXY_Motion
            boolEnableXY_Motion = False
            sngMaxTravel_Old = sngMaxTravel
            sngMaxTravel = sngfortyInches
            sngMaxTurn_Old = sngMaxTurn
            sngMaxTurn = sngScanFOV * 0.75
            boolEnableMidCourseCorrection_Old = boolEnableMidCourseCorrection
            boolEnableMidCourseCorrection = False
            boolEnableLocalizationWhileMoving_Old = boolEnableLocalizationWhileMoving
            boolEnableLocalizationWhileMoving = False
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subSlamInit")
        End Try
    End Sub

    Private Sub butAutoMap_Click(sender As System.Object, e As System.EventArgs) Handles butAutoMap.Click
        boolStop = False
        boolSlam = True
        modSLAM.subAutoSlamTop(sender, e)
        Me.Refresh()
    End Sub

    Private Sub subSlamQuit(sender As System.Object, e As System.EventArgs) Handles Me.FormClosed
        Try
            boolSlam = False
            boolEnableRBPF = boolEnableRBPF_Old
            sngMaxTravel = sngMaxTravel_Old
            sngMaxTurn = sngMaxTurn_Old
            boolEnableMidCourseCorrection = boolEnableMidCourseCorrection_Old
            boolEnableLocalizationWhileMoving = boolEnableLocalizationWhileMoving_Old
            boolEnableXY_Motion = boolEnableXY_Motion_Old
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subSlamQuit")
        End Try
    End Sub

    Private Sub butOK_Click(sender As System.Object, e As System.EventArgs) Handles butOK.Click
        boolSlam = False
        Me.Close()
    End Sub

    Private Sub frmSlam_Load(sender As Object, e As EventArgs) Handles MyBase.Load

    End Sub

    Private Sub updnSelectMap_ValueChanged(sender As Object, e As EventArgs) Handles updnSelectMap.ValueChanged
        Try
            If updnSelectMap.Focused Then
                subConvertParticleOddsToBMP(updnSelectMap.Value)
                subUpdateSlamFrameText(updnSelectMap.Value)
                txtParticlePose.Text = tbpParticlePose(updnSelectMap.Value).Location.X & ", " & tbpParticlePose(updnSelectMap.Value).Location.Y & " at " & tbpParticlePose(updnSelectMap.Value).Orientation
                Me.Refresh()
                GotABotClass.subRedraw(tbpParticlePose(updnSelectMap.Value))
                If boolLocalizationInProgress Then subDrawScanVectors(tbpParticlePose(updnSelectMap.Value), False)
            Else
                subDrawMapPixel(tbpParticlePose(updnSelectMap.Value).Location.X, tbpParticlePose(updnSelectMap.Value).Location.Y, Color.Red)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in updnSelectMap_ValueChanged")
        End Try
    End Sub

    Private Sub updnNumberOfParticles_ValueChanged(sender As Object, e As EventArgs) Handles updnNumberOfParticles.ValueChanged
        Try
            If updnNumberOfParticles.Focused Then
                Dim DidWork As Integer = MsgBox("Warning:  This will reinitiaize the particle filter.  Proceed?", MsgBoxStyle.YesNoCancel)
                If DidWork = DialogResult.Yes Then
                    intNumberOfParticles = updnNumberOfParticles.Value
                    subInitParticles(tbpBotPose, intNumberOfParticles)
                    boolSettingsChanged = True
                    Me.Refresh()
                    GotABotClass.subRedraw(tbpBotPose)
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in updnNumberOfParticles_ValueChanged")
        End Try
    End Sub

    Public Sub subUpdateSlamFrameText(ByVal intParticleNumber As Short)
        Try
            If Me.Visible Then
                updnSelectMap.Maximum = intNumberOfParticles - 1
                Me.updnSelectMap.Value = intParticleNumber
                Me.txtBest.Text = intBestParticle.ToString
                Me.txtWeight.Text = sngParticleWeight(intParticleNumber)
                Me.txtParticlePose.Text = tbpParticlePose(intParticleNumber).Location.X & ", " & tbpParticlePose(intParticleNumber).Location.Y & " at " & tbpParticlePose(intParticleNumber).Orientation
                Me.Refresh()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subUpdateSlamFrameText")
        End Try
    End Sub

    Private Sub butLock_Click(sender As Object, e As EventArgs) Handles butLock.Click
        Try
            subLockAMap(updnSelectMap.Value)
            subConvertParticleOddsToBMP(updnSelectMap.Value)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in butLock_Click")
        End Try
    End Sub


    Private Sub butLockAll_Click(sender As Object, e As EventArgs)
        Try
            subLockAllMaps()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in butLockAll_Click")
        End Try
    End Sub

    Private Sub butUnlockAll_Click(sender As Object, e As EventArgs) Handles butUnlockMap.Click
        Try
            subUnlockParticleMap(updnSelectMap.Value)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in butLockAll_Click")
        End Try
    End Sub

    Private Sub butPirouette_Click(sender As Object, e As EventArgs) Handles butPirouette.Click
        Try
            tbpBotPose = ftnPirouette(tbpBotPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in butPiroette_Click")
        End Try
    End Sub

    Private Sub subDeleteParticle(sender As Object, e As EventArgs) Handles butDelete.Click
        Try
            sngParticleWeight(updnSelectMap.Value) = 0
            intBestParticle = ftnBestParticle(tbpBotPose, intNumberOfParticles)
            subCopyParticle(intBestParticle, updnSelectMap.Value)
            subConvertParticleOddsToBMP(updnSelectMap.Value)
            tbpBotPose = tbpParticlePose(updnSelectMap.Value)
            subUpdateSlamFrameText(updnSelectMap.Value)
            GotABotClass.subRedraw(tbpParticlePose(updnSelectMap.Value))
            Me.Refresh()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subDeleteParticle")
        End Try
    End Sub

    Private Sub butDuplicate_Click(sender As Object, e As EventArgs) Handles butDuplicate.Click
        Try
            sngParticleWeight(updnSelectMap.Value) *= 1.1
            Dim intWorstParticle As Short = ftnWorstParticle(intNumberOfParticles)
            If (intWorstParticle <> updnSelectMap.Value) Then _
                subCopyParticle(updnSelectMap.Value, intWorstParticle)
            subUpdateSlamFrameText(updnSelectMap.Value)
            GotABotClass.subRedraw(tbpParticlePose(updnNumberOfParticles.Value))
            Me.Refresh()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in butDuplicate_Click")
        End Try
    End Sub


    Private Sub butSelect_Click(sender As Object, e As EventArgs) Handles butSelect.Click
        Try
            For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                If (intParticleNumber <> updnSelectMap.Value) Then _
                    subCopyParticle(updnSelectMap.Value, intParticleNumber)
            Next
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in butSelect_Click")
        End Try
    End Sub


    Public Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Integer) As Integer
    Dim boolMovementInProgress As Boolean = False
    Private Sub butFWD_Click(sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles butFWD.MouseDown
        Try
            Dim boolGoodLocalization As Boolean
            If Not boolMovementInProgress Then
                boolMovementInProgress = True
                boolStop = False
                frmDebug.subWriteLogs(Color.Purple, "))))))  Manual Control:  Forward")
                While (GetAsyncKeyState(1)) ' Left Mouse Button
                    tbpTargetPoseGlobal.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, sngTenInches)
                    tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPoseGlobal)
                    subWait(100)
                End While
                While (GetAsyncKeyState(2)) ' Right Mouse Button
                    tbpTargetPoseGlobal.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, sngfortyInches)
                    tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPoseGlobal)
                    subWait(100)
                End While
                tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                boolMovementInProgress = False
            End If
            ftnSendCommand("play phrase Beep")
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in butFWD_Click")
        End Try
    End Sub

    Private Sub butBACK_Click(sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles butBACK.MouseDown
        Try
            Dim boolGoodLocalization As Boolean
            If Not boolMovementInProgress Then
                boolMovementInProgress = True
                boolStop = False
                frmDebug.subWriteLogs(Color.Purple, "))))))  Manual Control:  Back")
                While (GetAsyncKeyState(1)) ' Left Mouse Button
                    tbpTargetPoseGlobal.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, sngTenInches)
                    tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPoseGlobal)
                    subWait(100)
                End While
                While (GetAsyncKeyState(2)) ' Right Mouse Button
                    tbpTargetPoseGlobal.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, sngfortyInches)
                    tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPoseGlobal)
                    subWait(100)
                End While
                tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                boolMovementInProgress = False
            End If
            ftnSendCommand("play phrase Beep")
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in butBACK_Click")
        End Try
    End Sub

    Private Sub butLEFT_Click(sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles butLEFT.MouseDown
        Try
            Dim boolGoodLocalization As Boolean
            If Not boolMovementInProgress Then
                boolMovementInProgress = True
                boolStop = False
                frmDebug.subWriteLogs(Color.Purple, "))))))  Manual Control:  Left")
                While (GetAsyncKeyState(1))  ' Left Mouse Button
                    tbpTargetPoseGlobal = tbpBotPose
                    tbpTargetPoseGlobal.Orientation = ftnConvertTo360(tbpTargetPoseGlobal.Orientation + 15)
                    tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPoseGlobal)
                    subWait(100)
                End While
                While (GetAsyncKeyState(2))  ' Right Mouse Button
                    tbpTargetPoseGlobal = tbpBotPose
                    tbpTargetPoseGlobal.Orientation = ftnConvertTo360(tbpTargetPoseGlobal.Orientation + 45)
                    tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPoseGlobal)
                    subWait(100)
                End While
                tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                boolMovementInProgress = False
            End If
            ftnSendCommand("play phrase Beep")
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in butLEFT_Click")
        End Try
    End Sub

    Private Sub butRight_Click(sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles butRight.MouseDown
        Try
            Dim boolGoodLocalization As Boolean
            If Not boolMovementInProgress Then
                boolMovementInProgress = True
                boolStop = False
                frmDebug.subWriteLogs(Color.Purple, "))))))  Manual Control:  Right")
                While (GetAsyncKeyState(1))  ' Left Mouse Button
                    tbpTargetPoseGlobal = tbpBotPose
                    tbpTargetPoseGlobal.Orientation = ftnConvertTo360(tbpTargetPoseGlobal.Orientation - 15)
                    tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPoseGlobal)
                    subWait(100)
                End While
                While (GetAsyncKeyState(2))  ' Right Mouse Button
                    tbpTargetPoseGlobal = tbpBotPose
                    tbpTargetPoseGlobal.Orientation = ftnConvertTo360(tbpTargetPoseGlobal.Orientation - 45)
                    tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPoseGlobal)
                    subWait(100)
                End While
                tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                boolMovementInProgress = False
            End If
            ftnSendCommand("play phrase Beep")
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in butRight_Click")
        End Try
    End Sub

    Private Sub mnuComboBoxBeams_SelectedIndexChanged(sender As Object, e As EventArgs) Handles mnuComboBoxBeams.SelectedIndexChanged
        Try
            intNumberOfBeamsDefault = Val(Me.mnuComboBoxBeams.Text)
            boolSettingsChanged = True
            Me.Refresh()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in mnuComboBoxBeams_SelectedIndexChanged")
        End Try
    End Sub
End Class