﻿
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Threading
Imports System.EventArgs
Imports System.Math

Module modAPICommands

    Public Function ftnAPICommands(ByVal strAPIMessage As String, ByRef boolLoggedIn As Boolean) As String
        ftnAPICommands = ""
        Try
            If Not GotABotClass.InvokeRequired Then
                If boolDebugAPI_IF Then frmDebug.subWriteLogs(Color.Green, " \\\\\  API Received Command: " & strAPIMessage & vbCrLf)
                Dim strParsedMessage As String()
                strParsedMessage = strAPIMessage.Split(vbCr)
                strAPIMessage = strParsedMessage(0)
                strStatusAPIMessage = "API: " & strAPIMessage
                strAPIMessage = String.Concat(strAPIMessage, " * ", "* ", "* ", "* ", "* ", "* ", "* ", "* ")
                strParsedMessage = strAPIMessage.Split(vbCr)
                strParsedMessage = strParsedMessage(0).Split(" "c)

                If (strParsedMessage(0) = "API_Timeout") Then
                    strAPIMessage = "API Timeout" & vbCrLf & "PLEASE LOGIN"
                ElseIf (strParsedMessage(0) = "login") Then
                    strAPIPasswordReceived = strParsedMessage(1)
                    If (strAPIPasswordReceived = strPassword) Then
                        strAPIMessage = "LOGIN ACCEPTED" & vbCrLf & "OK"
                        boolLoggedIn = True
                    Else
                        strAPIMessage = "ERROR: INCORRECT PASSWORD"
                        boolLoggedIn = False
                    End If
                ElseIf (Not boolLoggedIn) Then
                    strAPIMessage = "PLEASE LOGIN"
                ElseIf (strParsedMessage(0) = "") Then
                    strAPIMessage = "OK"
                ElseIf ((strParsedMessage(0) = "set") And (strParsedMessage(1) = "diameter") And (Val(strParsedMessage(2)) > 0)) Then
                    sngBotDiameter = Convert.ToSingle(Val(strParsedMessage(2)))
                    GotABotClass.subAPI_Redraw()
                    subRecalculateVariables()
                    subConvertMapToArray()
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "set") And (strParsedMessage(1) = "ltime") And (Val(strParsedMessage(2)) > 0) Then
                    sngLocalizationTime = Convert.ToSingle(Val(strParsedMessage(2)))
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "set") And (strParsedMessage(1) = "size") And (Val(strParsedMessage(2)) > 0) Then
                    sngGridSize = Convert.ToSingle(Val(strParsedMessage(2)))
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "set") And (strParsedMessage(1) = "units") And ((strParsedMessage(2) = "inch") Or (strParsedMessage(2) = "cm")) Then
                    strUnits = strParsedMessage(2)
                    GotABotClass.mnuMapUnits.Text = strUnits
                    subRecalculateVariables()
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "set") And (strParsedMessage(1) = "offset") And (Val(strParsedMessage(2)) > 0) Then
                    sngCameraOffset = Convert.ToSingle(Val(strParsedMessage(2)))
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "set") And (strParsedMessage(1) = "simulated") And ((strParsedMessage(2) = "true") Or (strParsedMessage(2) = "false")) Then
                    GotABotClass.mnuSimulatedMovement.Checked = strParsedMessage(2)
                    boolSimulatedMovement = strParsedMessage(2)
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "set") And (strParsedMessage(1) = "velocity") Then
                    sngBotLinearVelocity = Convert.ToSingle(Val(strParsedMessage(2)))
                    subRecalculateVariables()
                    ftnSendCommand("set linear velocity " & sngBotLinearVelocity)
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "set") And (strParsedMessage(1) = "angular") And (strParsedMessage(2) = "velocity") Then
                    sngBotAngularVelocity = Convert.ToSingle(Val(strParsedMessage(3)))
                    subRecalculateVariables()
                    ftnSendCommand("set angular velocity " & sngBotAngularVelocity)
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "set") And (strParsedMessage(1) = "max") And (Val(strParsedMessage(2)) > 0) Then
                    sngMaxTravel = Convert.ToSingle(Val(strParsedMessage(2)))
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "set") And (strParsedMessage(1) = "pose") Then
                    If (Val(strParsedMessage(2)) >= 0) Then tbpBotPose.Location.X = Int(Val(strParsedMessage(2)))
                    If (Val(strParsedMessage(3)) >= 0) Then tbpBotPose.Location.Y = Int(Val(strParsedMessage(3)))
                    If (Val(strParsedMessage(4)) >= 0) Then tbpBotPose.LocationUncertainty.X = Int(Val(strParsedMessage(4)))
                    If (Val(strParsedMessage(5)) >= 0) Then tbpBotPose.LocationUncertainty.Y = Int(Val(strParsedMessage(5)))
                    If (Val(strParsedMessage(6)) >= 0) Then tbpBotPose.Orientation = Int(Val(strParsedMessage(6)))
                    If (Val(strParsedMessage(7)) >= 0) Then tbpBotPose.OrientationUncertainty = Int(Val(strParsedMessage(7)))
                    GotABotClass.subAPI_Redraw()
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "set") And (strParsedMessage(1) = "ranger") Then
                    If (Val(strParsedMessage(2)) >= 0) And (Val(strParsedMessage(3)) >= 0) Then
                        If (Val(strParsedMessage(2)) > intHighestEnabledRangerNumber) Then
                            intHighestEnabledRangerNumber = Val(strParsedMessage(2))
                            frmRangeFinder.updnFinderNumber.Maximum = intHighestEnabledRangerNumber
                        End If
                        trfRangeFinders(Val(strParsedMessage(2))).intOrientation = Val(strParsedMessage(3))
                        trfRangeFinders(Val(strParsedMessage(2))).sngRange = ftnCmToMapUnits(Val(strParsedMessage(4)))
                        trfRangeFinders(Val(strParsedMessage(2))).boolEnable = True
                        If (Val(strParsedMessage(5)) >= 0) Then
                            trfRangeFinders(Val(strParsedMessage(2))).sngMaxRange = ftnCmToMapUnits(Val(strParsedMessage(5)))
                        Else
                            trfRangeFinders(Val(strParsedMessage(2))).sngMaxRange = constIR_MaxRange
                        End If
                        boolRangersAreEnabled = True
                    End If
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "set") And (strParsedMessage(1) = "orientation") And (Val(strParsedMessage(2)) >= 0) And (Val(strParsedMessage(3)) >= 0) Then
                    intApiOrientation = ftnConvertTo360(Convert.ToInt16(Val(strParsedMessage(2))))
                    intApiUncertainty = Int(Val(strParsedMessage(3)))
                    If boolSlam Then
                        tbpBotPose.Orientation = intApiOrientation
                        tbpBotPose.OrientationUncertainty = intApiUncertainty
                        If Not boolBotIsMoving And Not GotABotClass.updnOrientation.Focused Then GotABotClass.subUpdateAllText(tbpBotPose)
                        subDrawBot(tbpBotPose)
                    End If
                    If Not boolDrivingToDestination And (Not boolDock Or boolDocked Or boolPause) Then
                        If (intApiUncertainty <= tbpBotPose.OrientationUncertainty) Then
                            tbpBotPose.OrientationUncertainty = intApiUncertainty
                            tbpBotPose.Orientation = intApiOrientation
                            If Not boolBotIsMoving And Not GotABotClass.updnOrientation.Focused Then GotABotClass.subUpdateAllText(tbpBotPose)
                        End If
                    End If
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "set") And (strParsedMessage(1) = "bearing") And (Val(strParsedMessage(2)) >= 0) And (Val(strParsedMessage(3)) >= 0) Then
                    intApiOrientation = ftnConvertTo360(90 - Convert.ToInt16(Val(strParsedMessage(2))))
                    intApiUncertainty = Int(Val(strParsedMessage(3)))
                    If boolSlam Then
                        tbpBotPose.Orientation = intApiOrientation
                        tbpBotPose.OrientationUncertainty = Min(intApiUncertainty, tbpBotPose.OrientationUncertainty)
                        If Not boolBotIsMoving Then GotABotClass.subUpdateAllText(tbpBotPose)
                        subDrawBot(tbpBotPose)
                    End If
                    If Not boolDrivingToDestination And (Not boolDock Or boolDocked Or boolPause) Then
                        If (intApiUncertainty <= tbpBotPose.OrientationUncertainty) Then
                            tbpBotPose.OrientationUncertainty = intApiUncertainty
                            tbpBotPose.Orientation = intApiOrientation
                        End If
                    End If
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "set") And (strParsedMessage(1) = "laptop_battery") Then
                    If (Val(strParsedMessage(2)) >= 0) Then
                        sngLaptopBatteryPercent = Int(Val(strParsedMessage(2)) * 100)
                        GotABotClass.subUpdateAllText(tbpBotPose)
                    End If
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(1) = "destination") Then
                    If (Val(strParsedMessage(2)) >= 0) Then tmcDestination.X = Int(Val(strParsedMessage(2)))
                    If (Val(strParsedMessage(3)) >= 0) Then tmcDestination.Y = Int(Val(strParsedMessage(3)))
                    tmcDestination = ftnCheckMapArrayLimits(tmcDestination)
                    subDriveToUserChosenDestination(tmcDestination)
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "dock") Then
                    GotABotClass.mnuDock.Checked = True
                    frmDock.subDock()
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "localize") Then
                    ftnSendCommand("events")
                    Dim boolGoodLocalization As Boolean = False
                    tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                    strAPIMessage = "Pose = " & tbpBotPose.Location.X & " " & tbpBotPose.Location.Y & " " & _
                                 tbpBotPose.LocationUncertainty.X & " " & tbpBotPose.LocationUncertainty.Y & " " & _
                                 tbpBotPose.Orientation & " " & tbpBotPose.OrientationUncertainty & vbCrLf
                    strAPIMessage = strAPIMessage & "OK"
                ElseIf (strParsedMessage(0) = "stop") Then
                    frmDebug.subWriteLogs(Color.Navy, "API Command Received: stop")
                    tbpBotPose = modBotMovementControl.ftnBotStop(tbpBotPose, tbpTargetPoseGlobal)
                    boolPoseConfirmedAfterCollision = False '

                    boolDock = False
                    GotABotClass.subAPI_Redraw()
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "bumper") Then
                    Select Case strParsedMessage(1)
                        Case "left" : byteCollisionCode_API = 5
                        Case "right" : byteCollisionCode_API = 6
                        Case "front" : byteCollisionCode_API = 4
                        Case "rear" : byteCollisionCode_API = 3
                    End Select
                    ftnCheckForCollision()
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "load" And (strParsedMessage(1) = "settings") And (Dir(strParsedMessage(2)) <> "")) Then
                    LoadSettings(strParsedMessage(2))
                    GotABotClass.subAPI_Redraw()
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "load" And (strParsedMessage(1) = "map") And (Dir(strParsedMessage(2)) <> "")) Then
                    GotABotClass.subOpenMap(strParsedMessage(2))
                    GotABotClass.subAPI_Redraw()
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "save" And (strParsedMessage(1) = "settings")) Then
                    GotABotClass.mnuSaveSettings_Click(tlmLandMarkArray, Nothing)
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "get" And (strParsedMessage(1) = "pose")) Then
                    strAPIMessage = "POSE = " & tbpBotPose.Location.X & " " & tbpBotPose.Location.Y & " " & _
                                     tbpBotPose.LocationUncertainty.X & " " & tbpBotPose.LocationUncertainty.Y & " " & _
                                     tbpBotPose.Orientation & " " & tbpBotPose.OrientationUncertainty & vbCrLf
                    strAPIMessage = strAPIMessage & "OK"
                ElseIf (strParsedMessage(0) = "get" And (strParsedMessage(1) = "rangers")) Then
                    strAPIMessage = ""
                    For intRangerNumber As Integer = 1 To intHighestEnabledRangerNumber
                        If trfRangeFinders(intRangerNumber).boolEnable Then
                            trfRangeFinders(intRangerNumber).sngRange = frmRangeFinder.ftnRangeFinderRange(intRangerNumber) ' Get the Range Finder reading
                            strAPIMessage = strAPIMessage & intRangerNumber & " " & trfRangeFinders(intRangerNumber).sngRange & " " & trfRangeFinders(intRangerNumber).intOrientation & " " & _
                                                              trfRangeFinders(intRangerNumber).intOffset.X & " " & trfRangeFinders(intRangerNumber).intOffset.Y & vbCrLf
                        End If
                    Next intRangerNumber
                    strAPIMessage = strAPIMessage & "OK"
                ElseIf (strParsedMessage(0) = "get" And (strParsedMessage(1) = "status")) Then
                    If boolDocked Then
                        strAPIMessage = "docked" & vbCrLf & "OK"
                    ElseIf Not boolBotIsMoving Then
                        strAPIMessage = "stopped" & vbCrLf & "OK"
                    Else
                        strAPIMessage = "moving" & vbCrLf & "OK"
                    End If
                ElseIf (strParsedMessage(0) = "get" And (strParsedMessage(1) = "path")) Then
                    strAPIMessage = "PATH = " & vbCrLf
                    Dim tmcOldDestination As typeMapCoordinate
                    Dim tbpOldBotPose As typeBotPose = tbpBotPose
                    tmcOldDestination = tmcDestination
                    tmcDestination.X = Convert.ToSingle(Val(strParsedMessage(2)))
                    tmcDestination.Y = Convert.ToSingle(Val(strParsedMessage(3)))
                    tmcDestination = ftnCheckMapArrayLimits(tmcDestination)
                    subGeneratePathArray()
                    ftnGeneratePathCosts(tmcDestination, tbpBotPose.Location)
                    While Not ftnLocationsEqual(tmcDestination, tbpBotPose.Location) And Not boolStop And Not boolShutDown
                        tbpBotPose = ftnFindTargetPose(tbpBotPose, tmcDestination)
                        strAPIMessage = strAPIMessage & " " & tbpBotPose.Location.X & "  " & tbpBotPose.Location.Y & vbCrLf
                    End While
                    tbpBotPose = tbpOldBotPose
                    tmcDestination = tmcOldDestination
                    strAPIMessage = strAPIMessage & "OK"
                ElseIf (strParsedMessage(0) = "transmit") Then
                    If CBool(InStr(strAPIMessage, "transmit")) Then _
                       strAPIMessage = strAPIMessage.Replace("transmit ", "")
                    If CBool(InStr(strAPIMessage, "*")) Then _
                      strAPIMessage = strAPIMessage.Replace("*", "")
                    ftnSendCommand(strAPIMessage & vbCrLf)
                    strAPIMessage = "OK"
                ElseIf (strParsedMessage(0) = "subReceive") Then
                    strAPIMessage = ftnGetER1Response(1000)
                    strAPIMessage = strAPIMessage & "OK"
                ElseIf (strParsedMessage(0) = "help") Or (strParsedMessage(0) = "?") Then
                    strAPIMessage = "VALID COMMANDS :" & vbCrLf
                    strAPIMessage = strAPIMessage & "  " & vbCrLf
                    strAPIMessage = strAPIMessage & "    set diameter xxx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    set ltime xxx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    set size xxx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    set units xxx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    set velocity xxx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    set angular velocity xxx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    set pose xxx xxx xx xx xxx xx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    set ranger x xxx xx " & vbCrLf
                    strAPIMessage = strAPIMessage & "    set orientation xx xx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    set bearing xx xx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    set laptop_battery xx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    set destination xxxx xxx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    set simulated xx " & vbCrLf
                    strAPIMessage = strAPIMessage & "    set max xx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    set offset xx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    localize" & vbCrLf
                    strAPIMessage = strAPIMessage & "    stop" & vbCrLf
                    strAPIMessage = strAPIMessage & "    dock" & vbCrLf
                    strAPIMessage = strAPIMessage & "    bumper xxxx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    get pose" & vbCrLf
                    strAPIMessage = strAPIMessage & "    get rangers" & vbCrLf
                    strAPIMessage = strAPIMessage & "    get path xxx xxx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    get status" & vbCrLf
                    strAPIMessage = strAPIMessage & "    login xxx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    load settings xxx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    save settings " & vbCrLf
                    strAPIMessage = strAPIMessage & "    load map xxx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    transmit xxxxxxx" & vbCrLf
                    strAPIMessage = strAPIMessage & "    subReceive" & vbCrLf
                    strAPIMessage = strAPIMessage & "OK"
                Else
                    strAPIMessage = "ERROR  UNRECOGNIZED COMMAND"
                End If   '(strAPIPasswordReceived = strPassword)
                strAPIMessage = strAPIMessage & " >"
                ftnAPICommands = strAPIMessage
                If boolDebugAPI_IF Then frmDebug.subWriteLogs(Color.Green, " \\\\\  API Response: " & strAPIMessage)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnAPICommands")
        End Try
    End Function


End Module

