﻿
Imports System.Drawing

Module modDrawArm

    Public Sub subDrawArm()
        On Error Resume Next
        If Not frmGotAnArm.InvokeRequired Then
            frmGotAnArm.pbbArm.CreateGraphics.Clear(Color.LightGray)
            Dim tpcTurnTableBottom As typePointCoordinate
            subDrawVector(tpcTurnTableBottom, tpcTurnTableBottom, constBaseRSegment, False)
            subDrawVector(tpcTurnTableBottom, tjcJointCoordinates.tpcShoulderBase, constBaseRSegment, False)
            subDrawVector(tjcJointCoordinates.tpcShoulderBase, tjcJointCoordinates.tpcShoulder, constBaseSegment, False)
            subDrawVector(tjcJointCoordinates.tpcShoulder, tjcJointCoordinates.tpcElbow, constShoulderSegment, False)
            subDrawVector(tjcJointCoordinates.tpcElbow, tjcJointCoordinates.tpcWristRotateB4Offset, constElbowSegment, False)
            subDrawVector(tjcJointCoordinates.tpcWristRotateB4Offset, tjcJointCoordinates.tpcWrist, constWristRSegment, False)
            Dim tpcGripperStart As typePointCoordinate = ftnPointFromPoint(tjcJointCoordinates.tpcWrist, taaArmAngles.sngGripperOpening / 2, taaArmAngles.sngWrist + 1.570796)
            subDrawVector(tjcJointCoordinates.tpcWrist, tpcGripperStart, constGripperSegment, False)
            Dim tpcGripperTip As typePointCoordinate = ftnPointFromPoint(tpcGripperStart, constWristToGripper, taaArmAngles.sngWrist)
            subDrawVector(tpcGripperStart, tpcGripperTip, constGripperSegment, False)
            tpcGripperStart = ftnPointFromPoint(tjcJointCoordinates.tpcWrist, taaArmAngles.sngGripperOpening / 2, taaArmAngles.sngWrist - 1.570796)
            subDrawVector(tjcJointCoordinates.tpcWrist, tpcGripperStart, constGripperSegment, False)
            tpcGripperTip = ftnPointFromPoint(tpcGripperStart, constWristToGripper, taaArmAngles.sngWrist)
            subDrawVector(tpcGripperStart, tpcGripperTip, constGripperSegment, False)
        End If
    End Sub

  
    Public Sub subDrawVector(ByVal tpcStartCoordinate As typePointCoordinate, ByVal tpcEndCoordinate As typePointCoordinate, ByVal intSegment As Short, ByVal boolError As Boolean)    ' Draw a vector from point-point
        On Error Resume Next
        If Not frmGotAnArm.InvokeRequired Then
            tpcStartCoordinate.X += frmGotAnArm.pbbArm.Width * 0.4
            tpcStartCoordinate.Z += frmGotAnArm.pbbArm.Height * 0.25
            tpcStartCoordinate.Z = frmGotAnArm.pbbArm.Height - tpcStartCoordinate.Z
            tpcEndCoordinate.X += frmGotAnArm.pbbArm.Width * 0.4
            tpcEndCoordinate.Z += frmGotAnArm.pbbArm.Height * 0.25
            tpcEndCoordinate.Z = frmGotAnArm.pbbArm.Height - tpcEndCoordinate.Z
            If boolError Then
                Dim widePen As New Pen(Brushes.Crimson)
                widePen.Width = 8.0F
                frmGotAnArm.pbbArm.CreateGraphics.DrawLine(widePen, tpcStartCoordinate.X, tpcStartCoordinate.Z, tpcEndCoordinate.X, tpcEndCoordinate.Z)
            ElseIf (intSegment = intSegmentSelect) Then
                Dim widePen As New Pen(Brushes.Green)
                widePen.Width = 8.0F
                frmGotAnArm.pbbArm.CreateGraphics.DrawLine(widePen, tpcStartCoordinate.X, tpcStartCoordinate.Z, tpcEndCoordinate.X, tpcEndCoordinate.Z)
            Else
                Dim widePen As New Pen(Brushes.Black)
                widePen.Width = 8.0F
                frmGotAnArm.pbbArm.CreateGraphics.DrawLine(widePen, tpcStartCoordinate.X, tpcStartCoordinate.Z, tpcEndCoordinate.X, tpcEndCoordinate.Z)
            End If
            subDrawSmallCircle(tpcEndCoordinate, (intSegment <> intSegmentSelect))
            frmGotAnArm.pbbArm.CreateGraphics.Flush()
            frmGotAnArm.pbbArm.CreateGraphics.Dispose()
        End If
    End Sub

    Public Sub subDrawSmallCircle(ByVal tpcCoordinate As typePointCoordinate, ByVal boolBlue As Boolean)    ' Draw a small circle 
        On Error Resume Next
        If Not frmGotAnArm.InvokeRequired Then
            If Not (tpcCoordinate.X = 0 And tpcCoordinate.Z = 0) And boolBlue Then
                frmGotAnArm.pbbArm.CreateGraphics.DrawArc(Pens.Blue, tpcCoordinate.X - 12, tpcCoordinate.Z - 12, 24, 24, 0, 360)
                frmGotAnArm.pbbArm.CreateGraphics.FillEllipse(Brushes.Blue, tpcCoordinate.X - 12, tpcCoordinate.Z - 12, 24, 24)
            ElseIf Not (tpcCoordinate.X = 0 And tpcCoordinate.Z = 0) Then
                frmGotAnArm.pbbArm.CreateGraphics.DrawArc(Pens.Green, tpcCoordinate.X - 12, tpcCoordinate.Z - 12, 24, 24, 0, 360)
                frmGotAnArm.pbbArm.CreateGraphics.FillEllipse(Brushes.Green, tpcCoordinate.X - 12, tpcCoordinate.Z - 12, 24, 24)
            End If
            frmGotAnArm.pbbArm.CreateGraphics.Flush()
            frmGotAnArm.pbbArm.CreateGraphics.Dispose()
        End If
    End Sub



End Module
