﻿

Imports System.Math


Module modJoint



    Public Sub subInitializeDynamixels()
        On Error Resume Next
        If (dxl_initialize(constDefaultPortNum, constDefaultBaudNum) = 0) Then
            ' MsgBox("Failed to open USB2Dynamixel!")
            frmGotAnArm.tsslArmStatus.ForeColor = Color.Red
            frmGotAnArm.tsslArmStatus.Text = "Simulated"
            boolDebug = True
            taaArmAngles.sngShoulder = 0 + taaArmAngles.sngBaseXZ
            taaArmAngles.sngElbow = -2.5 + taaArmAngles.sngShoulder
        Else
            frmGotAnArm.tsslArmStatus.ForeColor = Color.Green
            frmGotAnArm.tsslArmStatus.Text = "Operating"
        End If
        If Not boolDebug Then
            dxl_write_byte(5, constCWComplianceMargin, 2)  ' Dual Dynamixel Joint.  Dont fight other dynamixel
            dxl_write_byte(4, constCWComplianceMargin, 2)  ' Dual Dynamixel Joint.  Dont fight other dynamixel
            dxl_write_byte(2, constCWComplianceMargin, 2)  ' Dual Dynamixel Joint.  Dont fight other dynamixel
            dxl_write_byte(3, constCWComplianceMargin, 2)  ' Dual Dynamixel Joint.  Dont fight other dynamixel
            dxl_write_word(1, constMovingSpeed, 100)  ' Base = Slow Moving Speed 
            dxl_write_word(2, constMovingSpeed, 50)  ' Shoulder = Slow Moving Speed 
            dxl_write_word(3, constMovingSpeed, 50)  ' Shoulder = Slow Moving Speed 
            dxl_write_word(4, constMovingSpeed, 100)  ' Elbow = Slow Moving Speed 
            dxl_write_word(5, constMovingSpeed, 100)  ' Elbow = Slow Moving Speed 
            ftnForwardKinematics(True)
            subDrawArm()
        End If
    End Sub

    Public Function ftnSetBaseRotatePosition(ByVal intPosition As Short) As Boolean
        On Error Resume Next
        ftnSetBaseRotatePosition = ftnSetDynamixelPosition(1, intPosition)
    End Function

    Public Function ftnSetShoulderPosition(ByVal intPosition As Short) As Boolean
        On Error Resume Next
        ftnSetShoulderPosition = ftnSetDynamixelPosition(2, 1024 - intPosition) And ftnSetDynamixelPosition(3, intPosition)
    End Function

    Public Function ftnSetElbowPosition(ByVal intPosition As Short) As Boolean
        On Error Resume Next
        ftnSetElbowPosition = ftnSetDynamixelPosition(4, intPosition) And ftnSetDynamixelPosition(5, 1024 - intPosition)
    End Function


    Public Function ftnSetWristRotatePosition(ByVal intPosition As Short) As Boolean
        On Error Resume Next
        ftnSetWristRotatePosition = ftnSetDynamixelPosition(6, intPosition)
    End Function

    Public Function ftnSetGripperPosition(ByVal intPosition As Short) As Boolean
        On Error Resume Next
        ftnSetGripperPosition = ftnSetDynamixelPosition(7, intPosition)
    End Function

    Public Function ftnSetDynamixelPosition(ByVal intID As Short, ByVal intPosition As Short) As Boolean
        On Error Resume Next
        ftnSetDynamixelPosition = False
        If (intPosition > 1023) Then intPosition = 1023
        If (intPosition < 0) Then intPosition = 0
        If Not boolDebug Then
            dxl_write_word(intID, constGoalPosition, intPosition)
            ftnSetDynamixelPosition = (dxl_get_result() = COMM_RXSUCCESS) And Not (dynamixel.dxl_get_rxpacket_error(dynamixel.ERRBIT_OVERLOAD) = 1) And Not (dynamixel.dxl_get_rxpacket_error(dynamixel.ERRBIT_OVERHEAT) = 1)
            timeJointMove(intID) = Now()
            If Not ftnSetDynamixelPosition Then
                dxl_write_word(intID, constGoalPosition, dxl_read_word(intID, constPresentPosition))
                dxl_write_word(intID, constTorqueLimit, dxl_read_word(intID, constTorqueMax))
                subHighlightDynamixelError(intID)
            End If
        End If
    End Function

    Sub subDisplayDynamixelValues(ByVal intID As Short)   'UNUSED
        On Error Resume Next
        MsgBox("ERROR:  " & vbCrLf & _
    "Goal (R) = " & dxl_read_word(intID, constGoalPosition) & vbCrLf & _
    "Present Position = " & dxl_read_word(intID, constPresentPosition) & vbCrLf & _
    "Speed = " & dxl_read_word(intID, 32) & vbCrLf & _
    "CW Angle Limit = " & dxl_read_word(intID, 6) & vbCrLf & _
    "CCW Angle Limit = " & dxl_read_word(intID, 8) & vbCrLf & _
    "CW Compliance = " & dxl_read_byte(intID, 26) & vbCrLf & _
    "CCW Compliance = " & dxl_read_byte(intID, 27) & vbCrLf & _
    "Torque Limit = " & dxl_read_word(intID, constTorqueLimit) & vbCrLf & _
    "Torque Enable = " & dxl_read_byte(intID, 24) & vbCrLf & _
    "Timeout = " & (dxl_get_result() = COMM_RXTIMEOUT) & vbCrLf & _
    "High limit T = " & dxl_read_byte(intID, 11) & vbCrLf & _
   "Temperature = " & dxl_read_byte(intID, 43) & vbCrLf & _
    "Low limit V = " & dxl_read_byte(intID, 12) & vbCrLf & _
    "High limit V = " & dxl_read_byte(intID, 13) & vbCrLf & _
    "Voltage = " & dxl_read_byte(intID, 42) & _
    "Alarm Shutdown = " & dxl_read_byte(intID, constAlarmShutDown))
    End Sub

    Public Sub subHighlightDynamixelError(ByVal intID As Short)
        On Error Resume Next
        frmGotAnArm.timerUpdate.Enabled = False
        Dim tpcTurnTableBottom As typePointCoordinate
        Select Case intID
            Case 1
                subDrawVector(tpcTurnTableBottom, tjcJointCoordinates.tpcShoulderBase, constBaseRSegment, True)
            Case 2
                subDrawVector(tjcJointCoordinates.tpcShoulder, tjcJointCoordinates.tpcElbow, constShoulderSegment, True)
            Case 3
                subDrawVector(tjcJointCoordinates.tpcShoulder, tjcJointCoordinates.tpcElbow, constShoulderSegment, True)
            Case 4
                subDrawVector(tjcJointCoordinates.tpcElbow, tjcJointCoordinates.tpcWristRotate, constElbowSegment, True)
            Case 5
                subDrawVector(tjcJointCoordinates.tpcElbow, tjcJointCoordinates.tpcWristRotate, constElbowSegment, True)
            Case 6
                subDrawVector(tjcJointCoordinates.tpcWristRotate, tjcJointCoordinates.tpcWrist, constWristRSegment, True)
            Case 7
                subDrawVector(tjcJointCoordinates.tpcWrist, tjcJointCoordinates.tpcGripperEnd, constGripperSegment, True)
            Case 8
                subDrawVector(tjcJointCoordinates.tpcShoulderBase, tjcJointCoordinates.tpcShoulder, constBaseSegment, True)
            Case 9
                subDrawVector(tjcJointCoordinates.tpcWrist, tjcJointCoordinates.tpcGripperEnd, constWristSegment, True)
            Case Else
        End Select
        Beep()
        subWait(2000)
        frmGotAnArm.timerUpdate.Enabled = True
    End Sub

    Public Function ftnGetJointAngle(ByVal intID As Short) As Single
        On Error Resume Next
        If Not boolDebug Then
            ftnGetJointAngle = ftnPositionToRadian(dxl_read_word(intID, constPresentPosition))
        Else
            ftnGetJointAngle = 0
        End If
    End Function

End Module
