﻿
Imports System.Math

Module modKinematic

    ' NOTE - dimensions are mmm and radians

    'http://www.cerebralmeltdown.com/Robot%20Arm/Robot%20Arm%20Math/index.html

    Public Function ftnForwardKinematics(ByVal boolUpdateAngles As Boolean) As typePointCoordinate
        On Error Resume Next
        If boolUpdateAngles Then
            taaArmAngles.sngBaseYX = dxl_read_word(1, constPresentPosition) * 0.00511327 - 2.61799
            taaArmAngles.sngShoulder = taaArmAngles.sngBaseXZ + ftnGetJointAngle(3)
            taaArmAngles.sngElbow = taaArmAngles.sngShoulder + ftnGetJointAngle(4)
            taaArmAngles.sngWrist = taaArmAngles.sngElbow
            Dim intGripperPosition As Short = dxl_read_word(7, constPresentPosition)
            If (intGripperPosition < constGripperOpenPosition) Then intGripperPosition = constGripperOpenPosition + (constGripperOpenPosition - intGripperPosition)
            taaArmAngles.sngGripperOpening = (constGripperClosedPosition - intGripperPosition) * 55 / (constGripperClosedPosition - constGripperOpenPosition) ' note - opening is in mm, not radians
        End If
            taaArmAngles.sngWrist = taaArmAngles.sngElbow - 0  'dxl_read_word(8, constPresentPosition) * 0.00511327 + 4.1887902
            tjcJointCoordinates.tpcShoulderBase.Z = constBaseHeight
            tjcJointCoordinates.tpcShoulder = ftnPointFromPoint(tjcJointCoordinates.tpcShoulderBase, constBaseToShoulder, constBaseAngleXZ)
            tjcJointCoordinates.tpcElbow = ftnPointFromPoint(tjcJointCoordinates.tpcShoulder, constShoulderToElbow, taaArmAngles.sngShoulder)
            tjcJointCoordinates.tpcWristRotateB4Offset = ftnPointFromPoint(tjcJointCoordinates.tpcElbow, constElbowToWristR, taaArmAngles.sngElbow)
            tjcJointCoordinates.tpcWristRotate = ftnPointFromPoint(tjcJointCoordinates.tpcWristRotateB4Offset, constWristROffset, taaArmAngles.sngWrist - 1.570796)
            tjcJointCoordinates.tpcWrist = ftnPointFromPoint(tjcJointCoordinates.tpcWristRotate, constWristRToWrist, taaArmAngles.sngElbow)
            tjcJointCoordinates.tpcGripperEnd = ftnPointFromPoint(tjcJointCoordinates.tpcWrist, constWristToGripper, taaArmAngles.sngWrist)
            ftnForwardKinematics = tjcJointCoordinates.tpcGripperEnd
    End Function

 
    ' http://freespace.virgin.net/hugo.elias/models/m_ik2.htm

    Public Function ftnReverseKinematics(ByVal tpcTarget As typePointCoordinate, ByVal sngGripperAngleXZ As Single, _
                                         ByVal sngGripperAngleXY As Single) As Boolean
        On Error Resume Next
        ftnReverseKinematics = False
        Dim taaOriginalArmAngles As typeArmAngles = taaArmAngles
        taaArmAngles.sngShoulder = 0 + taaArmAngles.sngBaseXZ
        taaArmAngles.sngElbow = -2.5 + taaArmAngles.sngShoulder
        Dim timeOut As DateTime = Now().AddSeconds(10)
        Dim boolKeepAdjusting As Boolean = True
        While (ftnDistanceBetweenPoints(tpcTarget, tjcJointCoordinates.tpcGripperEnd) >= 10) And _
                  (Now() < timeOut) And boolKeepAdjusting And Not boolShutDown
            ftnFindBetterAngles(tpcTarget) ' find incrementally better shoulder, elbow angles
            If boolDebug Then
                subDrawArm()
                frmGotAnArm.Refresh()
                System.Windows.Forms.Application.DoEvents()
            End If
        End While

        If (ftnDistanceBetweenPoints(tpcTarget, tjcJointCoordinates.tpcGripperEnd) < 10) And ftnValidKinematics() Then
            ftnReverseKinematics = True
        Else
            taaArmAngles = taaOriginalArmAngles
            If boolDebug Then
                subDrawArm()
                frmGotAnArm.Refresh()
                System.Windows.Forms.Application.DoEvents()
            End If
        End If
    End Function

    Function ftnFindBetterAngles(ByVal tpcGripperTarget As typePointCoordinate) As Boolean
        On Error Resume Next
        Dim sngBestErrorDistance, sngStartingShoulderAngle, sngStartingAngleElbow As Single
        Dim sngBestShoulderAngle, sngBestElbowAngle As Single
        ftnForwardKinematics(False)
        sngStartingShoulderAngle = taaArmAngles.sngShoulder
        sngStartingAngleElbow = taaArmAngles.sngElbow
        sngBestShoulderAngle = sngStartingShoulderAngle
        sngBestElbowAngle = sngStartingAngleElbow
        sngBestErrorDistance = ftnDistanceBetweenPoints(tpcGripperTarget, tjcJointCoordinates.tpcGripperEnd)  ' error if no change in angle
        Dim sngAngleAdjustment As Single = ftnAngleAdjustment(sngBestErrorDistance)

        ftnFindBetterAngles = ftnFindBetterAngles Or _
                             ftnTryDifferentAngles(sngBestErrorDistance, tpcGripperTarget, _
                                                   sngStartingShoulderAngle + sngAngleAdjustment, sngBestShoulderAngle, _
                                                   sngStartingAngleElbow + sngAngleAdjustment, sngBestElbowAngle) ' + shoulder + elbow angles
        ftnFindBetterAngles = ftnFindBetterAngles Or _
                             ftnTryDifferentAngles(sngBestErrorDistance, tpcGripperTarget, _
                                                   sngStartingShoulderAngle + sngAngleAdjustment, sngBestShoulderAngle, _
                                                   sngStartingAngleElbow - sngAngleAdjustment, sngBestElbowAngle) ' + shoulder - elbow angles
        ftnFindBetterAngles = ftnFindBetterAngles Or _
                             ftnTryDifferentAngles(sngBestErrorDistance, tpcGripperTarget, _
                                                   sngStartingShoulderAngle - sngAngleAdjustment, sngBestShoulderAngle, _
                                                   sngStartingAngleElbow - sngAngleAdjustment, sngBestElbowAngle) ' - shoulder - elbow angles
        ftnFindBetterAngles = ftnFindBetterAngles Or _
                             ftnTryDifferentAngles(sngBestErrorDistance, tpcGripperTarget, _
                                                   sngStartingShoulderAngle - sngAngleAdjustment, sngBestShoulderAngle, _
                                                   sngStartingAngleElbow + sngAngleAdjustment, sngBestElbowAngle) ' - shoulder + elbow angles
        ftnFindBetterAngles = ftnFindBetterAngles Or _
                             ftnTryDifferentAngles(sngBestErrorDistance, tpcGripperTarget, _
                                                   sngStartingShoulderAngle, sngBestShoulderAngle, _
                                                   sngStartingAngleElbow + sngAngleAdjustment, sngBestElbowAngle) '  same shoulder + elbow angles
        ftnFindBetterAngles = ftnFindBetterAngles Or _
                              ftnTryDifferentAngles(sngBestErrorDistance, tpcGripperTarget, _
                                                    sngStartingShoulderAngle, sngBestShoulderAngle, _
                                                    sngStartingAngleElbow - sngAngleAdjustment, sngBestElbowAngle) ' same shoulder - elbow angles
        ftnFindBetterAngles = ftnFindBetterAngles Or _
                             ftnTryDifferentAngles(sngBestErrorDistance, tpcGripperTarget, _
                                                   sngStartingShoulderAngle + sngAngleAdjustment, sngBestShoulderAngle, _
                                                   sngStartingAngleElbow, sngBestElbowAngle) ' + shoulder same elbow angles
        ftnFindBetterAngles = ftnFindBetterAngles Or _
                              ftnTryDifferentAngles(sngBestErrorDistance, tpcGripperTarget, _
                                                    sngStartingShoulderAngle - sngAngleAdjustment, sngBestShoulderAngle, _
                                                    sngStartingAngleElbow, sngBestElbowAngle) ' - shoulder same elbow angles

        taaArmAngles.sngShoulder = sngBestShoulderAngle
        taaArmAngles.sngElbow = sngBestElbowAngle
    End Function

    Function ftnTryDifferentAngles(ByVal sngBestErrorDistance As Single, ByVal tpcGripperTarget As typePointCoordinate, _
                                   ByVal sngShoulderAngle As Single, ByRef sngBestShoulderAngle As Single, _
                                   ByVal sngElbowAngle As Single, ByRef sngBestElbowAngle As Single) As Boolean
        On Error Resume Next
        Dim sngErrorDistance2 As Single
        ftnTryDifferentAngles = False
        taaArmAngles.sngShoulder = sngShoulderAngle
        taaArmAngles.sngElbow = sngElbowAngle
        ftnForwardKinematics(False)
        sngErrorDistance2 = ftnDistanceBetweenPoints(tpcGripperTarget, tjcJointCoordinates.tpcGripperEnd)  ' error if angle changed
        If (sngErrorDistance2 < sngBestErrorDistance) Then
            sngBestShoulderAngle = taaArmAngles.sngShoulder
            sngBestElbowAngle = taaArmAngles.sngElbow
            sngBestErrorDistance = sngErrorDistance2
            ftnTryDifferentAngles = True
        End If
    End Function


    Function ftnAngleAdjustment(ByVal sngError As Single) As Single
        On Error Resume Next
        If (sngError > 100) Then
            ftnAngleAdjustment = 0.15
        ElseIf (sngError > 30) Then
            ftnAngleAdjustment = 0.05
        Else
            ftnAngleAdjustment = 0.03
        End If
    End Function

    Function ftnValidKinematics() As Boolean
        On Error Resume Next
        ftnValidKinematics = True
        Dim sngJointAngle As Single
        sngJointAngle = ftnConvertToPI(taaArmAngles.sngShoulder - taaArmAngles.sngBaseXZ)
        If (sngJointAngle > 2.6) Or (sngJointAngle < -2.6) Then ftnValidKinematics = False
        sngJointAngle = ftnConvertToPI(taaArmAngles.sngElbow - taaArmAngles.sngShoulder)
        If (sngJointAngle > 2.6) Or (sngJointAngle < -2.6) Then ftnValidKinematics = False
    End Function
End Module
