﻿
Imports System.Math

Module modCollision
    ' bumper switches are active low
    ' rear = DI2
    ' left front = DI1
    ' right front = DI0

    Public Function ftnCheckForCollision() As Boolean
        Try
            ftnCheckForCollision = False
            If Not boolStop Then
                If boolCollisionDetectionEnable Then
                    If (boolSimulatedMovement Or Not boolBotConnected) Then
                        ftnCheckForCollision = False
                        byteCollisionCode = 7
                    ElseIf boolCollisionDetected Or (byteCollisionCode <> 7) Then  '  
                        ftnCheckForCollision = True
                        frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  WARNING: Collision Detected. byteCollisionCode = " & byteCollisionCode)
                    ElseIf (byteCollisionCode_API <> 7) Then ' don't overwrite if set by API
                        byteCollisionCode = byteCollisionCode_API
                        byteCollisionCode_API = 7
                    ElseIf boolER1Selected And boolEnableBumperSwitches_ER1 Then
                        byteCollisionCode = Val(ftnSendCommand("bumper"))  ' should send blank line here but that would reduce loop rate 
                        If (byteCollisionCode = 7) And Not boolEnableBotSerialIF Then ftnSendCommand("events") '  
                    End If
                    If boolER1Selected And boolEnableEvolutionIR_ER1 And Not boolEnableBotSerialIF Then
                        If CBool(InStr(strMoveResponseForEvolutionIRs, "ir 1")) Then
                            byteCollisionCode = 5 ' Left front
                        ElseIf CBool(InStr(strMoveResponseForEvolutionIRs, "ir 2")) Then
                            byteCollisionCode = 4 ' Front
                        ElseIf CBool(InStr(strMoveResponseForEvolutionIRs, "ir 3")) Then
                            byteCollisionCode = 6 ' Right front
                        End If
                    End If

                    If (byteCollisionCode <> 7) Then
                        tbpBotPose = ftnLocalizeUsingDeadReckoning(tbpStartingPose, 0.2, timeMoveCommandSent, tbpStartingPose, tbpTargetPoseGlobal, strTypeOfMove, True) '  ' assume that Collision was detected / communicated 0.2 seconds after the event  
                        boolCollisionDetected = True
                        If boolBotIsMoving Then tbpBotPose = ftnBotStop(tbpBotPose, tbpTargetPoseGlobal) ' ISSUE STOP COMMAND
                        ftnCheckForCollision = True
                        frmDebug.subWritePose(Now() & ":   Collision - Pose Derived From Dead Reckoning:", tbpBotPose)
                        boolPoseConfirmedAfterCollision = False '
                        Select Case byteCollisionCode
                            Case 4
                                If Not GotABotClass.InvokeRequired Then
                                    GotABotClass.StatusDriving.ForeColor = Color.Red
                                    subDrawBumperSwitch(tbpBotPose, 0)
                                End If
                                strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED -  Front"
                                frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  WARNING: Collision Detected -  Front")
                            Case 6
                                If Not GotABotClass.InvokeRequired Then
                                    GotABotClass.StatusDriving.ForeColor = Color.Red
                                    subDrawBumperSwitch(tbpBotPose, -45)
                                End If
                                strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED - Right Front"
                                frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  WARNING: Collision Detected - Right Front")
                            Case 5
                                If Not GotABotClass.InvokeRequired Then
                                    GotABotClass.StatusDriving.ForeColor = Color.Red
                                    subDrawBumperSwitch(tbpBotPose, 45)
                                End If
                                strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED - Left Front"
                                frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  WARNING: Collision Detected - Left Front")
                            Case 3
                                If Not GotABotClass.InvokeRequired Then
                                    GotABotClass.StatusDriving.ForeColor = Color.Red
                                    subDrawBumperSwitch(tbpBotPose, 180)
                                End If
                                strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED - Rear"
                                frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  WARNING: Collision Detected - Rear")
                            Case Else
                                If Not GotABotClass.InvokeRequired Then
                                    GotABotClass.StatusDriving.ForeColor = Color.Red
                                    subDrawBumperSwitch(tbpBotPose, 180)
                                    subDrawBumperSwitch(tbpBotPose, 45)
                                    subDrawBumperSwitch(tbpBotPose, -45)
                                    subDrawBumperSwitch(tbpBotPose, 0)
                                End If
                                strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED "
                                frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  WARNING: Collision Detected ")
                        End Select
                    End If
                    GotABotClass.subUpdateStatusLine()
                End If
                End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnCheckForCollision")
        End Try
    End Function

    Public boolSlamCollision As Boolean = False
    Public Function ftnCollisionRecovery(ByVal tbpEstimatedPose As typeBotPose) As typeBotPose
        Try
            ftnCollisionRecovery = tbpEstimatedPose
            If boolSlam Then
                boolStop = True
                boolDrivingToDestination = False
                boolCollisionDetected = False
                byteCollisionCode = 7
                subDoEventsIfMainThread()
                MsgBox(" There was a collision and GotABot cannot determine the resulting pose accurately!" & vbCrLf & _
                       "Move the Bot away from whatever it collided with and adjust the Pose " & vbCrLf & _
                       "(Press Configure->Pose) to reflect the actual Pose.  " & vbCrLf & _
                       "Press Tools->Localization to perform a final correction.")
            Else
                Dim boolGoodLocalization As Boolean = False
                If Not boolStop And Not (GotABotClass.picStop.BorderStyle = FormBorderStyle.Fixed3D) And Not boolShutDown Then
                    subDoEventsIfMainThread()
                    boolCollisionDetectionEnable = False
                    frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  WARNING: Collision Recovery Initiated")
                    subWait(250)
                    Dim boolEnableBumperSwitches_ER1_Temp As Boolean = boolEnableBumperSwitches_ER1
                    boolEnableBumperSwitches_ER1 = False
                    boolCollisionDetected = False
                    ftnSendCommand("play phraseA dough!!")
                    Dim intFrequentBumpMultiplier As Integer = ftnFrequentCollisionMultiplier()
                    intCollisions += 1
                    Dim tbpTargetPose As typeBotPose = tbpEstimatedPose
                    Dim sngBackupDistance As Single = Min(sngTenInches, ftnRangerBackupObstacleDistance() - sngOneInch)
                    tbpTargetPoseGlobal = tbpEstimatedPose
                    Select Case byteCollisionCode
                        Case 6
                            ftnCollisionRecovery = ftnPoseAfterCollision(tbpEstimatedPose, -90)
                            strStatusDriving = intDrivingSequenceNumber & ": COLLISION Recovery - Right Front"
                            GotABotClass.subRedraw(ftnCollisionRecovery)
                            tbpTargetPose.Location = ftnLocationFromEstimatedPose(ftnCollisionRecovery, 180, sngBackupDistance)
                            ftnCollisionRecovery = ftnBotFwd(ftnCollisionRecovery, tbpTargetPose) ' back up
                            ftnSendCommand("play phrase 'it jumped in front of me!'")
                            ftnCollisionRecovery = ftnLocalize_Top(ftnCollisionRecovery, boolGoodLocalization)
                            Dim intTurnAngle As Short = ftnConvertTo360(intFrequentBumpMultiplier * 25)
                            tbpTargetPose = ftnCollisionRecovery
                            tbpTargetPose.Orientation = ftnConvertTo360(ftnCollisionRecovery.Orientation + intTurnAngle)
                            ftnCollisionRecovery = ftnBotTurn(ftnCollisionRecovery, False, tbpTargetPose) ' collision on right so turn left
                            ftnCollisionRecovery = ftnLocalize_Top(ftnCollisionRecovery, boolGoodLocalization)
                            tbpTargetPose.Location = ftnLocationFromEstimatedPose(ftnCollisionRecovery, 0, sngSixInches)
                            ftnCollisionRecovery = ftnBotFwd(ftnCollisionRecovery, tbpTargetPose) ' forward
                        Case 5
                            ftnCollisionRecovery = ftnPoseAfterCollision(tbpEstimatedPose, 90)
                            strStatusDriving = intDrivingSequenceNumber & ": COLLISION Recovery - Left Front"
                            GotABotClass.subRedraw(ftnCollisionRecovery)
                            tbpTargetPose.Location = ftnLocationFromEstimatedPose(ftnCollisionRecovery, 180, sngBackupDistance)
                            ftnCollisionRecovery = ftnBotFwd(ftnCollisionRecovery, tbpTargetPose) ' back up
                            ftnSendCommand("play phrase 'pardon me!'")
                            ftnCollisionRecovery = ftnLocalize_Top(ftnCollisionRecovery, boolGoodLocalization)
                            Dim intTurnAngle As Short = ftnConvertTo360(-intFrequentBumpMultiplier * 25)
                            tbpTargetPose = ftnCollisionRecovery
                            tbpTargetPose.Orientation = ftnConvertTo360(ftnCollisionRecovery.Orientation + intTurnAngle)
                            ftnCollisionRecovery = ftnBotTurn(ftnCollisionRecovery, False, tbpTargetPose)  ' collision on left so turn right
                            ftnCollisionRecovery = ftnLocalize_Top(ftnCollisionRecovery, boolGoodLocalization)
                            tbpTargetPose.Location = ftnLocationFromEstimatedPose(ftnCollisionRecovery, 0, sngSixInches)
                            ftnCollisionRecovery = ftnBotFwd(ftnCollisionRecovery, tbpTargetPose) ' forward
                        Case 4
                            ftnCollisionRecovery = ftnPoseAfterCollision(tbpEstimatedPose, 0)
                            strStatusDriving = intDrivingSequenceNumber & ": COLLISION Recovery -  Front"
                            GotABotClass.subRedraw(ftnCollisionRecovery)
                            tbpTargetPose.Location = ftnLocationFromEstimatedPose(ftnCollisionRecovery, 180, sngBackupDistance)
                            ftnCollisionRecovery = ftnBotFwd(ftnCollisionRecovery, tbpTargetPose) ' back up
                            ftnSendCommand("play phrase 'get out of my way!'")
                        Case 3
                            ftnCollisionRecovery = ftnPoseAfterCollision(tbpEstimatedPose, 180)
                            strStatusDriving = intDrivingSequenceNumber & ": COLLISION Recovery - Rear"
                            GotABotClass.subRedraw(ftnCollisionRecovery)
                            strTypeOfMove = "Fwd"
                            tbpTargetPoseGlobal.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, Min(sngTenInches, ftnObstacleForwardDistance(ftnObstacleVectorTop(ftnCollisionRecovery, strTypeOfMove, tbpTargetPose)) - sngTwoInches))
                            ftnCollisionRecovery = ftnBotFwd(ftnCollisionRecovery, tbpTargetPose) ' go forward
                            ftnSendCommand("play phrase 'it snuck up on me!'")
                        Case Else
                            frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  No Action taken:  Bumper switch no longer registers a collision")
                    End Select
                    If Not GotABotClass.InvokeRequired Then GotABotClass.StatusDriving.ForeColor = Color.Black
                    ftnCollisionRecovery.Location = ftnCheckMapArrayLimits(ftnCollisionRecovery.Location)
                    subDrawBot(ftnCollisionRecovery)
                    If ftnInWall(ftnCollisionRecovery.Location) Then ftnCollisionRecovery.Location = tbpEstimatedPose.Location
                    boolCollisionDetected = False
                    byteCollisionCode = 7
                    boolCollisionDetectionEnable = True
                    boolEnableBumperSwitches_ER1 = boolEnableBumperSwitches_ER1_Temp
                End If
                subDoEventsIfMainThread()
                ftnCollisionRecovery = frmCompass.ftnLocalizeUsingCompass(ftnCollisionRecovery)
                ftnCollisionRecovery = ftnLocalize_Top(ftnCollisionRecovery, boolGoodLocalization)
                subDrawBot(ftnCollisionRecovery)
                ftnSendCommand("battery")
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnCollisionRecovery")
        End Try
    End Function

    Private Function ftnPoseAfterCollision(ByVal tbpEstimatedPose As typeBotPose, ByVal sngCollisionAngle As Single) As typeBotPose
        'assume that the bot is off course by a bot quarter diameter - direction determined by which collision sensor was activated
        Try
            subWait(500)  ' wait for compass to update orientation
            If boolVerboseLogFile Then frmDebug.subWritePose("Pose at start of Pose correction after collision", tbpEstimatedPose)
            tbpEstimatedPose.OrientationUncertainty += 30
            tbpEstimatedPose.LocationUncertainty.X += sngSixInches / sngGridSize
            tbpEstimatedPose.LocationUncertainty.Y += sngSixInches / sngGridSize
            tbpEstimatedPose = frmCompass.ftnLocalizeUsingCompass(tbpEstimatedPose)
            tbpTargetPoseGlobal = tbpEstimatedPose
            Dim boolGoodLocalization As Boolean = False
            ftnPoseAfterCollision = ftnLocalize_Top(tbpEstimatedPose, boolGoodLocalization)
            Dim boolDummy As Boolean = False
            ftnPoseAfterCollision.Location = ftnLocationFromEstimatedPose(tbpEstimatedPose, sngCollisionAngle, sngBotDiameter / 4)
            ftnPoseAfterCollision = ftnValidatePose(ftnPoseAfterCollision, tbpEstimatedPose, boolDummy)
            If (sngCollisionAngle <> 180) Then ftnPoseAfterCollision.Orientation = ftnConvertTo360(tbpEstimatedPose.Orientation + sngCollisionAngle / 5)
            subChangeParticlePose(ftnPoseAfterCollision.Location.X - tbpEstimatedPose.Location.X, ftnPoseAfterCollision.Location.Y - tbpEstimatedPose.Location.Y, ftnAngleDifference(ftnPoseAfterCollision.Orientation, tbpEstimatedPose.Orientation)) ' update each particles pose
            'tbpStartingPose = ftnPoseAfterCollision
            frmDebug.subWritePose("Pose corrected due to collision ", ftnPoseAfterCollision)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnPoseAfterCollision")
        End Try
    End Function



    Function ftnFrequentCollisionMultiplier() As Integer ' Bigger movements if frequent bumps
        If (intLastCollisionSequenceNumber > intDrivingSequenceNumber) Then intLastCollisionSequenceNumber = intDrivingSequenceNumber
        ftnFrequentCollisionMultiplier = 3 - (intDrivingSequenceNumber - intLastCollisionSequenceNumber) \ 2
        If ftnFrequentCollisionMultiplier < 1 Then ftnFrequentCollisionMultiplier = 1
        intLastCollisionSequenceNumber = intDrivingSequenceNumber
    End Function

End Module
