﻿Imports System.Speech


' This is the top level interface to the Bot.  Commands are parsed, interpreted and sent to the specific Bot IF.
' COMMAND SYNTAX
'    Move 10 i
'    Move 90 degrees
'    battery
'    position
'    input analog 1
'    input digital
'    play 
'    bumper
'    set
'    stop


Module modIF_BotTop
    Dim strRecv As String

    Public Function ftnSendCommand(ByRef strCommand As String) As String
        ftnSendCommand = ""
        Try
            Dim strParsedText As String() = strCommand.Split(" "c)
            If (Not boolSimulatedMovement) Or (strParsedText(0) = "play") Then ' 
                If boolER1Selected And Not boolEnableBotSerialIF Then
                    ftnSendCommand = ftnER1_SocketCommand(strCommand)
                ElseIf boolER1Selected Then
                    ftnSendCommand = ftnER1_SerialCommand(strCommand)
                ElseIf boolHeroSelected Then
                    ftnSendCommand = ftnHeroCommand(strCommand)
                ElseIf boolRoboRealmBotSelected Then
                    ftnSendCommand = ftnRoboRealmCommand(strCommand)
                Else
                End If
            End If
            If boolSimulatedMovement Then subWait(1000)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnSendCommand " & ex.ToString)
        End Try
    End Function

    Public Sub subSpeak(ByVal strCommand As String)
        Try
            subDisableSpeechRecognition()
            If Not boolMute Then
                If (strCommand = "play phrase Beep") Then
                    Beep()
                    subWait(300)
                ElseIf (strCommand = "play phrase prompt") Then
                    subPlaySoundFile("C:\Windows\Media\Windows Ding.wav")
                ElseIf (strCommand = "play phraseA 'Oh Oh. Obstacle Detected'") Then
                    subPlaySoundFile("C:\Windows\Media\Windows Hardware Fail.wav")
                ElseIf (strCommand = "play phrase notify") Then
                    subPlaySoundFile("C:\Windows\Media\Windows Notify.wav")
                ElseIf (strCommand = "play phrase wrong") Then
                    subPlaySoundFile("C:\Windows\Media\Speech Off.wav")
                Else
                    Dim synth As New Synthesis.SpeechSynthesizer
                    If CBool(InStr(strCommand, "phraseA")) Then
                        strCommand = strCommand.Replace("play phraseA", "")
                        strCommand = strCommand.Replace("'", "")
                        synth.SpeakAsync(strCommand)
                    Else
                        strCommand = strCommand.Replace("play phrase", "")
                        strCommand = strCommand.Replace("'", "")
                        synth.Speak(strCommand)
                    End If
                    subStartSpeechRecognition()
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subSpeak " & ex.ToString)
        End Try
    End Sub

    Private Sub subPlaySoundFile(ByRef strSoundFile As String)
        Try
            If (Dir(strSoundFile) <> "") Then
                My.Computer.Audio.Play(strSoundFile, AudioPlayMode.Background)
            Else
                Beep()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subPlaySoundFile " & ex.ToString)
        End Try
    End Sub
 
End Module
