﻿Imports System.Speech.Synthesis
Imports System.Speech
Imports System.Math
Imports System.Threading

'TODO
' curved
' Debug position
' 

'
' This code is loosely based upon MotionLib and RSlib.dll, taken from http:'web.ing.puc.cl/~asoto/IIC-3684/codes_en.htm

Module modIF_ER1_Serial_Top
    Public Function ftnER1_SerialCommand(ByRef strCommand As String) As String
        ftnER1_SerialCommand = ""
        Try
            Dim strParsedText As String() = strCommand.Split(" "c)
            If (Not boolSimulatedMovement) Or (strParsedText(0) = "play") Then ' 
                Select Case strParsedText(0)
                    Case "move" : If Not boolStop Then _
                            ftnER1_SerialCommand = ftnMoveCommand(strParsedText, strCommand)
                    Case "battery" : ftnER1_SerialCommand = ftnGetBattery(strParsedText, strCommand)
                    Case "input" : If (UBound(strParsedText) > 0) Then
                            If (strParsedText(1) = "analog") Then  ' get  voltage
                                ftnER1_SerialCommand = ftnGetAnalog(strParsedText, strCommand)
                            End If
                        End If
                    Case "play" : ftnER1_SerialCommand = ftnSpeak(strCommand)
                    Case "position" : ftnER1_SerialCommand = ftnGetPosition(strParsedText) ' get odometry data
                    Case "bumper" : ftnER1_SerialCommand = ftnGetBumper(strParsedText, strCommand) ' get bumper switch status
                    Case "stop" : ftnER1_SerialCommand = ftnStop(strParsedText, strCommand) 'stop
                        'Case Else : ftnER1_SerialCommand = ftnER1_Serial_Communicate(strCommand, "OK")
                End Select
                If boolDebugER1IF Then
                    frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}==== ")
                    frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}====     Sent to Bot:    " & strCommand)
                    frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}====     Received From Bot: " & ftnER1_SerialCommand)
                    frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}==== ")
                Else
                    frmDebug.subDebugLog(Color.Purple, " }}}}}}}}}}==== ")
                    frmDebug.subDebugLog(Color.Purple, " }}}}}}}}}}====     Sent to Bot:    " & strCommand)
                    frmDebug.subDebugLog(Color.Purple, " }}}}}}}}}}====     Received From Bot: " & ftnER1_SerialCommand)
                    frmDebug.subDebugLog(Color.Purple, " }}}}}}}}}}==== ")
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnER1_SerialCommand " & ex.ToString)
        End Try
    End Function


    Private Function ftnMoveCommand(ByRef strParsedText As String(), ByVal strCommand As String) As String
        ftnMoveCommand = "OK"
        Try
            If (String.CompareOrdinal(strTypeOfMove, "Turn") = 0) Then
                ftnMoveTurn(strParsedText)
                timeMoveCommandSent = Now().AddMilliseconds(-300)
            ElseIf (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Then
                ftnMoveFwd(strParsedText)
                timeMoveCommandSent = Now()
            End If
            boolBotIsMoving = True
            While ftnIsMoving() And Not boolStop And Not boolShutDown
                If ftnCheckForCollision() Then Exit While
                tbpBotPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, 0, timeMoveCommandSent, tbpStartingPose, tbpTargetPoseGlobal, strTypeOfMove, False)
                subUpdateMapDuringMove()
            End While
            subSetPower(intPowerStopped * 32768 / 100)
            subUpdateAll()
            tbpBotPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, 0, timeMoveCommandSent, tbpStartingPose, tbpTargetPoseGlobal, strTypeOfMove, False)
            boolBotIsMoving = False
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnMoveCommand")
        End Try
    End Function

    Function ftnMoveTurn(ByRef strParsedText As String()) As String
        ftnMoveTurn = "OK"
        Try
            Dim intSpeed As Integer = (4200 * sngBotAngularVelocity)
            Dim sngAngle As Single = Convert.ToSingle(Val(strParsedText(1)))
            If (sngAngle > 0) Then
                sngAngle += constER1TurnHysterises + sngAngle / 30
            Else
                sngAngle -= constER1TurnHysterises + sngAngle / 30
            End If
            Dim sngArcDistance As Single = -Math.PI * sngWheelSeparation / 360.0 * sngAngle ' 
            Dim intSteps As Integer = (ftnCmsToSteps(sngArcDistance))
            If boolDebugER1_Serial Then frmDebug.subWriteLogs(Color.Red, " sngAngle = " & sngAngle)
            If boolDebugER1_Serial Then frmDebug.subWriteLogs(Color.Red, " intSteps = " & intSteps)
            subResetWheels(PLProfile.Trapezoidal)
            subMoveCommand(-intSteps, -intSteps, intSpeed, intSpeed)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnMoveTurn")
        End Try
    End Function

    Function ftnMoveFwd(ByRef strParsedText As String()) As String
        ftnMoveFwd = "OK"
        Try
            Dim intSpeed As Integer = (27000 * sngBotLinearVelocity)
            Dim sngMoveDistance As Single = Convert.ToSingle(Val(strParsedText(1)))
            If (sngMoveDistance > 0) Then
                sngMoveDistance += ftnInchesToMapUnits(constER1FwdHysterises)
            Else
                sngMoveDistance -= ftnInchesToMapUnits(constER1FwdHysterises * 0.33333)
            End If
            Dim intSteps As Integer = (ftnCmsToSteps(ftnMapUnitsToCm(sngMoveDistance)) * 80.0 / 77.0)
            subResetWheels(PLProfile.Trapezoidal)
            subMoveCommand(-intSteps, intSteps, intSpeed, intSpeed)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnMoveFwd")
        End Try
    End Function

    Function ftnMoveCurved(ByRef strParsedText As String()) As String 'strParsedText is of form move x (value) y (value) cm
        ftnMoveCurved = "OK"
        Try
            Dim intSpeed As Integer = (27000 * sngBotLinearVelocity)
            'Dim sngMoveDistance As Single = Convert.ToSingle(Val(strParsedText(1)))
            'If (sngMoveDistance > 0) Then
            '    sngMoveDistance += ftnInchesToMapUnits(constER1FwdHysterises)
            'Else
            '    sngMoveDistance -= ftnInchesToMapUnits(constER1FwdHysterises * 0.33333)
            'End If
            'Dim iNumSteps As Integer = (ftnCmsToSteps(ftnMapUnitsToCm(sngMoveDistance)) * 80.0 / 77.0)
            'subResetWheels(PLProfile.Trapezoidal)
            'subMoveCommand(-iNumSteps * intSpeedR / intSpeedL, -iNumSteps * intSpeedL / intSpeedR, intSpeedL, intSpeedR)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnMoveCurved " & ex.ToString)
        End Try
    End Function


    Private Function ftnGetPosition(ByVal strParsedText As String()) As String
        'Return position as x,y in map units
        tbpBotPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, 0, timeMoveCommandSent, tbpStartingPose, tbpTargetPoseGlobal, strTypeOfMove, True)
        ftnGetPosition = "OK " & tbpBotPose.Location.X.ToString & " " & tbpBotPose.Location.Y.ToString
        Try
            'Dim sngAngleTraveled, sngDistanceFromStart As Single
            'Dim tbpPose As typeBotPose
            'Dim sngCms0 As Single = ftnStepsToCms(ftnSendER1SerialCommand(8, 0, PilotSet.GetActualPostion, 0, 0, 0, 0, 0, 0, 4)) ' 
            'Dim sngCms1 As Single = ftnStepsToCms(ftnSendER1SerialCommand(8, 1, PilotSet.GetActualPostion, 0, 0, 0, 0, 0, 0, 4))
            'If (String.CompareOrdinal(strTypeOfMove, "Turn") = 0) Then
            '    sngAngleTraveled = (sngCms0 - sngCms1) * 180 / sngWheelSeparation / Math.PI
            '    tbpPose = ftnTurnDR(tbpStartingPose, sngAngleTraveled, False)
            'ElseIf (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Then
            '    sngDistanceFromStart = ftnCmToMapUnits(Sqrt(sngCms0 * sngCms0 + sngCms1 * sngCms1))
            '    tbpPose = ftnFwdDR(tbpStartingPose, sngDistanceFromStart, False)
            '    'ElseIf (String.CompareOrdinal(strTypeOfMove, "XY") = 0) Then
            '    '    sngDistanceFromStart = ftnDistanceFromStart(tbpStartingPose, tbpTargetPose, sngElapsedTime, strTypeOfMove)
            '    '    ftnLocalizeUsingDeadReckoning = ftnXY_DR(tbpStartingPose, sngDistanceFromStart, tbpTargetPose, boolCalculateUncertainties)
            '    'Else
            '    '    ftnLocalizeUsingDeadReckoning = tbpEstimatedPose
            'End If
            'ftnGetPosition = tbpPose.Location.X.ToString & ", " & tbpPose.Location.Y.ToString
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetPosition")
        End Try
    End Function


    Private Function ftnGetBumper(ByRef strParsedText As String(), ByRef strCommand As String) As String
        ftnGetBumper = "7"
        Try
            If boolEnableBumperSwitches_ER1 Then
                Dim byteGetDigital As Byte = ftnSendER1SerialCommand(6, 0, PilotSet.ReadIO, 0, 0, 0, 0, 0, 0, 2) And 7
                If (byteGetDigital = 0) Then
                    ftnGetBumper = "7"  '  probably a COM error, ignore
                Else
                    ftnGetBumper = byteGetDigital.ToString
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetBumper")
        End Try
    End Function



    Private Function ftnStop(ByVal strParsedText As String(), ByVal strCommand As String) As String
        ftnStop = "OK"
        Try
            ftnSendER1SerialCommand(6, 0, PilotSet.SetStopMode, 0, 1, 0, 0, 0, 0, 0)
            ftnSendER1SerialCommand(6, 1, PilotSet.SetStopMode, 0, 1, 0, 0, 0, 0, 0)
            ftnSendER1SerialCommand(6, 1, PilotSet.SetMotorCommand, 0, 0, 0, 0, 0, 0, 0)
            ftnSendER1SerialCommand(6, 0, PilotSet.SetMotorCommand, 0, 0, 0, 0, 0, 0, 0)
            subSetPower(intPowerStopped * 32768 / 100)
            subUpdateAll()
            tbpBotPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, 0, timeMoveCommandSent, tbpStartingPose, tbpTargetPoseGlobal, strTypeOfMove, False)
        Catch ex As Exception
            ftnStop = ""
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnStop")
        End Try
    End Function



    Private Function ftnGetBattery(ByVal strParsedText As String(), ByRef strCommand As String) As String
        Try
            sngBotBatteryVoltage = Val(ftnSendER1SerialCommand(6, 1, PilotSet.ReadAnalog, 0, 7, 0, 0, 0, 0, 2)) / 65536.0 * 16.4
            strStatusBotVoltage = "Bot: " & sngBotBatteryVoltage.ToString("N1") & "V"
            If (sngBotBatteryVoltage = 0) Then
                strStatusBotVoltage = "   ??   "
                ftnER1_SerialCommand("play phrase 'No power'")
            End If
            ftnGetBattery = strStatusBotVoltage
            sngLaptopBatteryPercent = Int(SystemInformation.PowerStatus.BatteryLifePercent * 100)
            GotABotClass.subUpdateAllText(tbpBotPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetBattery " & ex.ToString)
            ftnGetBattery = ""
        End Try
    End Function


    Private Function ftnGetAnalog(ByVal strParsedText As String(), ByRef strCommand As String) As String
        ftnGetAnalog = "OK "
        Try
            Dim intInput As Byte
            For i = 2 To UBound(strParsedText)
                intInput = Val(strParsedText(i))
                If (intInput < 8) Then
                    ftnGetAnalog &= " " & ftnSendER1SerialCommand(6, 0, PilotSet.ReadAnalog, 0, intInput, 0, 0, 0, 0, 2).ToString
                Else
                    ftnGetAnalog &= " " & ftnSendER1SerialCommand(6, 1, PilotSet.ReadAnalog, 0, intInput - 8, 0, 0, 0, 0, 2).ToString
                End If
            Next
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetAnalog")
        End Try
    End Function


    Private Function ftnSpeak(ByVal strCommand As String) As String
        Try
            ftnSpeak = "OK"
            subSpeak(strCommand)
        Catch ex As Exception
            ftnSpeak = ""
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnSpeak")
        End Try
    End Function




    Public Sub subResetWheels(ByRef byteProfile As Byte)
        Try
            subResetWheel(0, byteProfile)
            subResetWheel(1, byteProfile)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subResetWheels " & ex.ToString)
        End Try
    End Sub

    Sub subResetWheel(ByRef byteWheel As Byte, ByRef byteProfile As Byte)  ' 
        Try
            ftnSendER1SerialCommand(4, byteWheel, PilotSet.Reset, 0, 0, 0, 0, 0, 0, 0)
            ftnSendER1SerialCommand(6, byteWheel, PilotSet.SetLimitSwitchMode, 0, 0, 0, 0, 0, 0, 0)  'LimitSwitch=Off
            ftnSendER1SerialCommand(6, byteWheel, PilotSet.SetProfileMode, 0, byteProfile, 0, 0, 0, 0, 0)
            ftnSendER1SerialCommand(6, byteWheel, PilotSet.SetSampleTime, ftnHiByte(ER1Default.Cycle), ftnLoByte(ER1Default.Cycle), 0, 0, 0, 0, 0)
            Dim intAcceleration As Integer = ER1Default.Acceleration
            If strTypeOfMove = "Turn" Then
                intAcceleration *= sngBotAngularAcceleration / 200   'guesstimate
            Else
                intAcceleration *= sngBotLinearAcceleration / 100   'guesstimate
            End If
            ftnSendER1SerialCommand(8, byteWheel, PilotSet.SetAcceleration, ftnHiByte(ftnHiWord(intAcceleration)), ftnLoByte(ftnHiWord(intAcceleration)), ftnHiByte(ftnLoWord(intAcceleration)), ftnLoByte(ftnLoWord(intAcceleration)), 0, 0, 0)
            ftnSendER1SerialCommand(8, byteWheel, PilotSet.SetDeceleration, ftnHiByte(ftnHiWord(intAcceleration)), ftnLoByte(ftnHiWord(intAcceleration)), ftnHiByte(ftnLoWord(intAcceleration)), ftnLoByte(ftnLoWord(intAcceleration)), 0, 0, 0)
            ftnSendER1SerialCommand(8, byteWheel, PilotSet.SetJerk, &H3, &H29, &HA, &HBB, 0, 0, 0)
            ftnSendER1SerialCommand(4, byteWheel, PilotSet.Update, 0, 0, 0, 0, 0, 0, 0)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subResetWheel " & ex.ToString)
        End Try
    End Sub



    Sub subMoveCommand(ByVal intStepsR As Integer, ByVal intStepsL As Integer, ByVal intSpeedL As Integer, ByVal intSpeedR As Integer)
        Try
            ftnSendER1SerialCommand(6, 0, PilotSet.SetMotionCompleteMode, 0, PLMotionCompleteMode.Commanded, 0, 0, 0, 0, 0) ' motion complete when velocity ramps down to 0
            ftnSendER1SerialCommand(6, 1, PilotSet.SetMotionCompleteMode, 0, PLMotionCompleteMode.Commanded, 0, 0, 0, 0, 0)
            ftnSendER1SerialCommand(6, 0, PilotSet.ResetEventStatus, &HFF, &HFE, 0, 0, 0, 0, 0) ' Event = motion complete
            ftnSendER1SerialCommand(6, 1, PilotSet.ResetEventStatus, &HFF, &HFE, 0, 0, 0, 0, 0)

            ' set distance to travel
            ftnSendER1SerialCommand(8, 0, PilotSet.SetPosition, ftnHiByte(ftnHiWord(intStepsL)), ftnLoByte(ftnHiWord(intStepsL)), ftnHiByte(ftnLoWord(intStepsL)), ftnLoByte(ftnLoWord(intStepsL)), 0, 0, 0)
            ftnSendER1SerialCommand(8, 1, PilotSet.SetPosition, ftnHiByte(ftnHiWord(intStepsR)), ftnLoByte(ftnHiWord(intStepsR)), ftnHiByte(ftnLoWord(intStepsR)), ftnLoByte(ftnLoWord(intStepsR)), 0, 0, 0)

            subSetPower(intPowerMoving * 32768 / 100)
            subSetWheelVelocity(intSpeedL, intSpeedR)
            subUpdateAll()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subMoveCommand " & ex.ToString)
        End Try
    End Sub

    Sub subSetWheelVelocity(ByRef intSpeedL As UInteger, ByRef intSpeedR As UInteger)
        Try
            ftnSendER1SerialCommand(8, 0, PilotSet.SetVelocity, ftnHiByte(ftnHiWord(intSpeedL)), ftnLoByte(ftnHiWord(intSpeedL)), ftnHiByte(ftnLoWord(intSpeedL)), ftnLoByte(ftnLoWord(intSpeedL)), 0, 0, 0)
            ftnSendER1SerialCommand(8, 1, PilotSet.SetVelocity, ftnHiByte(ftnHiWord(intSpeedR)), ftnLoByte(ftnHiWord(intSpeedR)), ftnHiByte(ftnLoWord(intSpeedR)), ftnLoByte(ftnLoWord(intSpeedR)), 0, 0, 0)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subSetWheelVelocity " & ex.ToString)
        End Try
    End Sub

    Sub subSetPower(ByVal intPower As UShort)
        Try
            ftnSendER1SerialCommand(6, 1, PilotSet.SetMotorCommand, ftnHiByte(intPower), ftnLoByte(intPower), 0, 0, 0, 0, 0) ' ex: 13.7% = 13.7 *32,768/100 = 4,489
            ftnSendER1SerialCommand(6, 0, PilotSet.SetMotorCommand, ftnHiByte(intPower), ftnLoByte(intPower), 0, 0, 0, 0, 0)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subSetPower " & ex.ToString)
        End Try
    End Sub

    Sub subUpdateAll()
        Try
            ftnSendER1SerialCommand(4, 1, PilotSet.Update, 0, 0, 0, 0, 0, 0, 0)
            ftnSendER1SerialCommand(4, 0, PilotSet.Update, 0, 0, 0, 0, 0, 0, 0)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subUpdateAll " & ex.ToString)
        End Try
    End Sub

    Function ftnGetTime(ByVal byteWheel As Byte) As UInt32
        Try
            ftnGetTime = ftnSendER1SerialCommand(4, byteWheel, PilotSet.GetTime, 0, 0, 0, 0, 0, 0, 4)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetTime " & ex.ToString)
        End Try
    End Function

    Function ftnIsMoving() As Boolean
        Try
            Dim bStatus0 As Byte = ftnSendER1SerialCommand(4, 0, PilotSet.GetEventStatus, 0, 0, 0, 0, 0, 0, 2) And &H1
            Dim bStatus1 As Byte = ftnSendER1SerialCommand(4, 1, PilotSet.GetEventStatus, 0, 0, 0, 0, 0, 0, 2) And &H1
            ftnIsMoving = (bStatus0 = 0) Or (bStatus1 = 0)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnIsMoving " & ex.ToString)
        End Try
    End Function


    Function ftnCmsToSteps(ByVal sngCms As Single) As Single
        Try
            ftnCmsToSteps = sngCms * ER1Metrics.CountsPerRev / ER1Metrics.WheelPer
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnCmsToSteps " & ex.ToString)
        End Try
    End Function

    Function ftnStepsToCms(ByVal intSteps As Integer) As Single
        Try
            ftnStepsToCms = intSteps * ER1Metrics.WheelPer / ER1Metrics.CountsPerRev
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnCmsToSteps " & ex.ToString)
        End Try
    End Function




    Function ftnLoByte(ByRef intValue As UShort) As Byte
        ftnLoByte = intValue And &HFF
    End Function

    Function ftnHiByte(ByRef intValue As UShort) As Byte
        ftnHiByte = intValue >> 8
    End Function

    Function ftnLoWord(ByRef intValue As UInt32) As UShort
        ftnLoWord = intValue And &HFFFF
    End Function

    Function ftnHiWord(ByRef intValue As UInt32) As UShort
        ftnHiWord = intValue >> 16
    End Function






    Public Class ER1Default
        Public Const Acceleration As Integer = &HF5
        Public Const Deceleration As Integer = &HF5
        Public Const Cycle As Short = 204 ' Cycle time in microsecond
    End Class

    Public Class ER1Metrics
        Public Const CountsPerRev As Integer = 52000
        Public Const WheelPer As Double = 31.3
    End Class

    Public Class PLProfile
        Public Const Trapezoidal As Byte = 0
        Public Const Contouring As Byte = 1
        Public Const SCurve As Byte = 2
    End Class

    Public Class PLMotionCompleteMode
        Public Const Commanded As Short = 0
        Public Const Actual As Short = 1
    End Class


    Public Class PilotSet
        Public Const ClearInterrupt As Byte = &HAC
        Public Const AdjustActualPostion As Byte = &HF5
        Public Const ClearPositionError As Byte = &H47
        Public Const GetActivityStatus As Byte = &HA6
        Public Const GetActualVelocity As Byte = &HAD
        Public Const GetCaptureValue As Byte = &H36
        Public Const GetChecksum As Byte = &HF8
        Public Const GetCommandedAcceleration As Byte = &HA7
        Public Const GetCommandedPostion As Byte = &H1D
        Public Const GetCommandedVelocity As Byte = &H1E
        Public Const GetCurrentMotorCommand As Byte = &H3A
        Public Const GetDerivative As Byte = &H9B
        Public Const GetEventStatus As Byte = &H31
        Public Const GetHostIOError As Byte = &HA5
        Public Const GetIntegral As Byte = &H9A
        Public Const GetInterruptAxis As Byte = &HE1
        Public Const GetPhaseCommand As Byte = &HEA
        Public Const GetPositionError As Byte = &H99
        Public Const GetSignalStatus As Byte = &HA4
        Public Const GetTime As Byte = &H3E
        Public Const GetTraceCount As Byte = &HBB
        Public Const GetTraceStatus As Byte = &HBA
        Public Const GetVersion As Byte = &H8F
        Public Const InitializPhase As Byte = &H7A
        Public Const NoOperation As Byte = &H0
        Public Const ReadAnalog As Byte = &HEF
        Public Const ReadBuffer As Byte = &HC9
        Public Const ReadIO As Byte = &H83
        Public Const Reset As Byte = &H39
        Public Const ResetEventStatus As Byte = &H34
        Public Const SetAcceleration As Byte = &H90
        Public Const GetAcceleration As Byte = &H4C
        Public Const SetActualPostion As Byte = &H4D
        Public Const GetActualPostion = &H37
        Public Const SetActualPostionUnits As Byte = &HBE
        Public Const GetActualPostionUnits As Byte = &HBF
        Public Const SetAutoStopMode As Byte = &HD2
        Public Const GetAutoStopMode As Byte = &HD3
        Public Const SetAxisMode As Byte = &H87
        Public Const GetAxisMode As Byte = &H88
        Public Const SetAxisOutSource As Byte = &HED
        Public Const GetAxisOutSource As Byte = &HEE
        Public Const SetBreakpoint As Byte = &HD4
        Public Const GetBreakpoint As Byte = &HD5
        Public Const SetBreakpointValue As Byte = &HD6
        Public Const GetBreakpointValue As Byte = &HD7
        Public Const SetBufferFunction As Byte = &HCA
        Public Const GetBufferFunction As Byte = &HCB
        Public Const SetbufferLength As Byte = &HC2
        Public Const GetBufferLength As Byte = &HC3
        Public Const SetBufferReadIndex As Byte = &HC6
        Public Const GetBufferReadIndex As Byte = &HC7
        Public Const SetBufferStart As Byte = &HC0
        Public Const GetBufferStart As Byte = &HC1
        Public Const SetBufferWriteIndex As Byte = &HC4
        Public Const GetBufferWriteIndex As Byte = &HC5
        Public Const SetCaptureSource As Byte = &HD8
        Public Const GetCaptureSource As Byte = &HD9
        Public Const SetCommutationMode As Byte = &HE2
        Public Const GetCommutationMode As Byte = &HE3
        Public Const SetDeceleration As Byte = &H91
        Public Const GetDeceleration As Byte = &H92
        Public Const SetDerivativeTime As Byte = &H9C
        Public Const GetDerivativeTime As Byte = &H9D
        Public Const SetDiagnosticPortMode As Byte = &H89
        Public Const GetDiagnosticPortMode As Byte = &H8A
        Public Const SetEncoderModulus As Byte = &H8D
        Public Const GetEncoderModulus As Byte = &H8E
        Public Const SetEncoderSource As Byte = &HDA
        Public Const GetEncoderSource As Byte = &HDB
        Public Const SetEncoderToStepRatio As Byte = &HDE
        Public Const GetEncoderToStepRatio As Byte = &HDF
        Public Const SetIntegrationLimit As Byte = &H95
        Public Const GetIntegrationLimit As Byte = &H96
        Public Const SetInterruptMask As Byte = &H2F
        Public Const GetInterruptMask As Byte = &H56
        Public Const SetJerk As Byte = &H13
        Public Const GetJerk As Byte = &H58
        Public Const SetKaff As Byte = &H93
        Public Const GetKaff As Byte = &H94
        Public Const SetKd As Byte = &H27
        Public Const GetKd As Byte = &H52
        Public Const SetKi As Byte = &H26
        Public Const GetKi As Byte = &H51
        Public Const SetKout As Byte = &H9E
        Public Const GetKout As Byte = &H9F
        Public Const SetKp As Byte = &H25
        Public Const GetKp As Byte = &H50
        Public Const SetKvff As Byte = &H2B
        Public Const GetKvff As Byte = &H54
        Public Const SetLimitSwitchMode As Byte = &H80
        Public Const GetLimitSwitchMode As Byte = &H81
        Public Const SetMotionCompleteMode As Byte = &HEB
        Public Const GetMotionCompleteMode As Byte = &HEC
        Public Const SetMotorBias As Byte = &HF
        Public Const GetMotorBias As Byte = &H2D
        Public Const SetMotorCommand As Byte = &H77
        Public Const GetMotorCommand As Byte = &H69
        Public Const SetMotorLimit As Byte = &H6
        Public Const GetMotorLimit As Byte = &H7
        Public Const SetMotorMode As Byte = &HDC
        Public Const GetMotorMode As Byte = &HDD
        Public Const SetNumberPhases As Byte = &H85
        Public Const GetNumberPhases As Byte = &H86
        Public Const SetOutputMode As Byte = &HE0
        Public Const GetOutputMode As Byte = &H6E
        Public Const SetPhaseAngle As Byte = &H84
        Public Const GetPhaseAngle As Byte = &H2C
        Public Const SetPhaseCorrectionMode As Byte = &HE8
        Public Const GetPhaseCorrectionMode As Byte = &HE9
        Public Const SetPhaseCounts As Byte = &H75
        Public Const GetPhaseCounts As Byte = &H7D
        Public Const SetPhaseInitializeMode As Byte = &HE4
        Public Const GetPhaseInitializeMode As Byte = &HE5
        Public Const SetPhaseInitializeTime As Byte = &H72
        Public Const GetPhaseInitializeTime As Byte = &H7C
        Public Const SetPhaseOffset As Byte = &H76
        Public Const GetPhaseOffset As Byte = &H7B
        Public Const SetPhasePrescale As Byte = &HE6
        Public Const GetPhasePrescale As Byte = &HE7
        Public Const SetPosition As Byte = &H10
        Public Const GetPosition As Byte = &H4A
        Public Const SetPostionErrorLimit As Byte = &H97
        Public Const GetPostionErrorLimit As Byte = &H98
        Public Const SetProfileMode As Byte = &HA0
        Public Const GetProfileMode As Byte = &HA1
        Public Const SetSampleTime As Byte = &H38
        Public Const GetSampleTime As Byte = &H61
        Public Const SetSerialPortMode As Byte = &H8B
        Public Const GetSerialPortMode As Byte = &H8C
        Public Const SetSettleTime As Byte = &HAA
        Public Const GetSettleTime As Byte = &HAB
        Public Const SetSettleWindow As Byte = &HBC
        Public Const GetSettleWindow As Byte = &HBD
        Public Const SetSignalSense As Byte = &HA2
        Public Const GetSignalSense As Byte = &HA3
        Public Const SetStartMode As Byte = &HCC
        Public Const GetStartMode As Byte = &HCD
        Public Const SetStartVelocity As Byte = &H6A
        Public Const GetStartVelocity As Byte = &H6B
        Public Const SetStopMode As Byte = &HD0
        Public Const GetStopMode As Byte = &HD1
        Public Const SetSynchronizationMode As Byte = &HF2
        Public Const GetSynchronizationMode As Byte = &HF3
        Public Const SetTraceMode As Byte = &HB0
        Public Const GetTraceMode As Byte = &HB1
        Public Const SetTracePeriod As Byte = &HB8
        Public Const GetTracePeriod As Byte = &HB9
        Public Const SetTraceStart As Byte = &HB2
        Public Const GetTraceStart As Byte = &HB3
        Public Const SetTraceStop As Byte = &HB4
        Public Const GetTraceStop As Byte = &HB5
        Public Const SetTraceVariable As Byte = &HB6
        Public Const GetTraceVariable As Byte = &HB7
        Public Const SetTrackingWindow As Byte = &HA8
        Public Const GetTrackingWindow As Byte = &HA9
        Public Const SetVelocity As Byte = &H11
        Public Const GetVelocity As Byte = &H4B
        Public Const Update As Byte = &H1A
        Public Const WriteBuffer As Byte = &HC8
        Public Const WriteIO As Byte = &H82
    End Class



    'Sub subMoveTime(ByVal _iRightSpd As Integer, ByVal _iLeftSpd As Integer, ByVal _iDurat As UInteger)
    '    Try
    '        ftnSendER1SerialCommand(0, PilotSet.SetProfileMode, PLProfile.Contouring)
    '        ftnSendER1SerialCommand(1, PilotSet.SetProfileMode, PLProfile.Contouring)
    '        ftnSendER1SerialCommand(0, PilotSet.SetMotorCommand, &H4CC0)
    '        ftnSendER1SerialCommand(1, PilotSet.SetMotorCommand, &H4CC0)
    '        ftnSendER1SerialCommand(0, PilotSet.SetVelocity, -_iLeftSpd)
    '        ftnSendER1SerialCommand(1, PilotSet.SetVelocity, _iRightSpd)
    '        subUpdateAll()

    '        Dim time0 As UInteger = ftnGetTime(0)
    '        Dim time1 As UInteger = ftnGetTime(1)

    '        ftnSendER1SerialCommand(0, PilotSet.SetBreakpointValue, 0, time0 + _iDurat)
    '        ftnSendER1SerialCommand(1, PilotSet.SetBreakpointValue, 0, time1 + _iDurat)
    '        ftnSendER1SerialCommand(0, PilotSet.SetBreakpoint, 0, &H730)
    '        ftnSendER1SerialCommand(1, PilotSet.SetBreakpoint, 0, &H730)

    '        ftnSendER1SerialCommand(0, PilotSet.SetMotionCompleteMode, PLMotionCompleteMode.Commanded)
    '        ftnSendER1SerialCommand(1, PilotSet.SetMotionCompleteMode, PLMotionCompleteMode.Commanded)

    '        ftnSendER1SerialCommand(0, PilotSet.ResetEventStatus, &HFFFE)
    '        ftnSendER1SerialCommand(1, PilotSet.ResetEventStatus, &HFFFE)
    '    Catch ex As Exception
    '        frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subMoveTime " & ex.ToString)
    '    End Try
    'End Sub

    'Function ftnSegsToCycle(ByVal _dSegs As Double) As UInteger
    '    Try
    '        Return Convert.ToUInt32(1000000 * _dSegs / ER1Default.Cycle)
    '    Catch ex As Exception
    '        frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnSegsToCycle " & ex.ToString)
    '    End Try
    'End Function

    'Function ftnCSToCC(ByVal _dCS As Double) As Integer
    '    Try
    '        Return Convert.ToInt32(_dCS * (ER1Metrics.CountsPerRev / ER1Metrics.WheelPer) / (1000000 / ER1Default.Cycle) * 65536)
    '    Catch ex As Exception
    '        frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnCSToCC " & ex.ToString)
    '    End Try
    'End Function



End Module
