﻿

' Interface to the ER1 

Imports System
Imports System.Math
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.Threading
Imports Microsoft.VisualBasic
Imports System.EventArgs


Public Module modIF_ER1_Socket
    Public strER1SendMessage As String = ""
    Public strER1ReceiveMessage As String = ""
    Public evntER1DataWaitingToSend As New ManualResetEvent(False)
    Public boolER1DataWaitingToSend As Boolean = False
    Public evntER1DataSent As New ManualResetEvent(False)
    Public evntER1DataReceived As New ManualResetEvent(False)
    Public evntER1ClientDataPassed As New ManualResetEvent(False)
    Dim intNoResponseCounter As Integer = 0


    Public Function ftnER1_SocketCommunicate(ByRef strCommand As String, ByRef strResponse As String, ByRef inttimeOut As Integer) As String
        ftnER1_SocketCommunicate = ""
        Try
            If classER1Client.Connected And (Not boolShutDown) Then
                If Not boolBotConnected Then
                    strStatusDriving = "ER1 Not Logged In "
                    GotABotClass.subRedraw(tbpBotPose)
                    ftnLogin()
                ElseIf Not boolShutDown Then
                    If (String.CompareOrdinal(strTypeOfMove, "stop") = 0) Then boolER1_MoveComplete = True
                    ftnSendCommandER1(strCommand)
                    If (strResponse <> "") Then ftnER1_SocketCommunicate = ftnWaitForExpectedResponse(strResponse, inttimeOut)
                    If Not boolBotConnected Or CBool(InStr(ftnER1_SocketCommunicate, "login")) Then ftnLogin()
                    If boolDebugER1IF Then
                        frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}==== ")
                        frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}====     Sending to Bot:    " & strCommand)
                        frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}====     Received From Bot: " & ftnER1_SocketCommunicate)
                        frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}==== ")
                    Else
                        frmDebug.subDebugLog(Color.Purple, " }}}}}}}}}}==== ")
                        frmDebug.subDebugLog(Color.Purple, " }}}}}}}}}}====     Sending to Bot:    " & strCommand)
                        frmDebug.subDebugLog(Color.Purple, " }}}}}}}}}}====     Received From Bot: " & ftnER1_SocketCommunicate)
                        frmDebug.subDebugLog(Color.Purple, " }}}}}}}}}}==== ")
                    End If
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnER1_SocketCommunicate")
        End Try
    End Function

    Function ftnLogin() As String
        Try
            boolBotConnected = True
            ftnLogin = ftnER1_SocketCommunicate("Login " & strPassword, "OK", 1000)
            boolBotConnected = Not CBool(InStr(ftnLogin, "Login"))
            If boolBotConnected Then
                strStatusDriving = "ER1 Logged In "
                ftnER1_SocketCommunicate("sense speech off", "OK", 1000)
                ftnER1_SocketCommunicate("set collision detection off", "OK", 1000)
                ftnER1_SocketCommunicate("set obstacle avoidance off", "OK", 1000)
                ftnER1_SocketCommunicate("set linear velocity " & sngBotLinearVelocity, "OK", 1000)
                ftnER1_SocketCommunicate("set angular velocity " & sngBotAngularVelocity, "OK", 1000)
                ftnER1_SocketCommunicate("set power moving " & intPowerMoving, "OK", 1000)
                ftnER1_SocketCommunicate("set power stopped " & intPowerStopped, "OK", 1000)
                ftnER1_SocketCommunicate("sense objects on", "OK", 1000)
                If boolEnableEvolutionIR_ER1 Then ftnER1_SocketCommunicate("ir all threshold " & intEvolution_IR_Threshold, "OK", 1000)
                If boolEnableEvolutionIR_ER1 Then ftnER1_SocketCommunicate("ir all flash 7 ", "OK", 1000)
                If boolEnableEvolutionIR_ER1 Then ftnER1_SocketCommunicate("sense ir", "OK", 1000)
                ftnLogin = ftnER1_SocketCommunicate("sense objects on", "OK", 1000)
            End If
        Catch ex As Exception
            ftnLogin = ""
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnLogin")
        End Try
    End Function



    Private Function ftnSendCommandER1(ByVal strCommand As String) As String
        ftnSendCommandER1 = ""
        Try
            If classER1Client.Connected And (Not boolShutDown) And Not boolSimulatedMovement Then
                Try
                    evntER1ClientDataPassed.Reset()
                    strER1SendMessage = strCommand & vbCrLf
                    boolER1DataWaitingToSend = True
                    evntER1DataWaitingToSend.Set()
                Catch e As Exception
                    ftnSendCommandER1 = ""
                End Try
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnSendCommandER1")
        End Try
    End Function

    Dim boolMoveInProgress As Boolean = False
    Dim boolER1_MoveComplete As Boolean = False  ' set if ftnGetER1Response detects " done" or if a "stop" command is sent
    Public strMoveResponseForEvolutionIRs As String = ""  ' used by modCollision for Evolution IRs
    Function ftnWaitForExpectedResponse(ByRef strTextToWaitFor As String, ByRef inttimeOut As Integer) As String  '
        ftnWaitForExpectedResponse = ""
        Try
            If classER1Client.Connected Then
                Dim timeOut As DateTime = Now().AddMilliseconds(inttimeOut)
                Dim intTimeToPoll As Short = Min(100, inttimeOut)
                Dim boolMoveCommand As Boolean = CBool(InStr(strTextToWaitFor, "move done"))
                Dim intPriority As Short = Thread.CurrentThread.Priority
                If boolMoveCommand And boolMoveInProgress Then ' if this is a mid course correction, then wait for end of previous move commands
                    boolER1_MoveComplete = True
                    Dim Timeout1 As DateTime = Now().AddMilliseconds(300)
                    While (Now() < Timeout1) And boolMoveInProgress
                        ftnCollisionDetect(intPriority)
                        If boolCollisionDetected Then Exit Function
                        Thread.Sleep(25)
                    End While
                    boolER1_MoveComplete = False
                End If
                boolMoveInProgress = boolMoveCommand
                Do
                    ftnWaitForExpectedResponse &= ftnGetER1Response(intTimeToPoll)
                    If boolMoveCommand And Not boolCollisionDetected Then
                        ftnWaitForExpectedResponse &= ftnCollisionDetect(intPriority)
                        If Not boolCollisionDetected Then subUpdateMapDuringMove()
                        If boolEnableEvolutionIR_ER1 Then strMoveResponseForEvolutionIRs = ftnWaitForExpectedResponse
                    End If
                Loop Until ((Now() > timeOut) Or CBool(InStr(ftnWaitForExpectedResponse, strTextToWaitFor)) Or boolShutDown Or _
                            boolMoveCommand And (boolStop Or boolER1_MoveComplete Or boolCollisionDetected Or boolCollisionPredicted) Or classER1Client.boolErrorDetected)
                If classER1Client.boolErrorDetected Then ftnWaitForExpectedResponse &= " COM ERROR"
                If (Now() > timeOut) Then
                    ftnWaitForExpectedResponse &= ftnGetER1Response(100) ' empty the ER1 message queue
                    frmDebug.subWriteLogs(Color.Purple, ftnElapsedTime(timeMoveCommandSent) & "  WARNING: Bot Communication Timeout while waiting for response: " & strTextToWaitFor & " /// Actual Response = " & ftnWaitForExpectedResponse)
                    If boolMoveCommand Then ftnWaitForExpectedResponse &= "com timeout"
                End If
                If (ftnWaitForExpectedResponse <> "") And Not CBool(InStr(ftnWaitForExpectedResponse, vbCr)) And Not (boolMoveCommand And boolER1_MoveComplete) Then _
                    ftnWaitForExpectedResponse &= ftnGetER1Response(10) ' Only partial message received.  Try to get the remainder

                If boolMoveCommand And Not boolCollisionDetected And Not boolER1_MoveComplete Then
                    If Not CBool(InStr(ftnWaitForExpectedResponse, "OK")) Then _
                        ftnWaitForExpectedResponse &= ftnGetER1Response(10) ' empty the ER1 message queue, otherwise the 'OK' response after 'move done' may confuse the following messages
                End If
                boolER1_MoveComplete = CBool(InStr(ftnWaitForExpectedResponse, "move done"))
                boolMoveInProgress = Not boolMoveCommand
            Else
                ftnWaitForExpectedResponse = "COM ERROR"
                frmDebug.subWriteLogs(Color.Red, " :  WARNING - Bot not connected")
                strStatusDriving = ":  WARNING - Bot not connected"
                GotABotClass.subRedraw(tbpBotPose)
                boolBotConnected = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnWaitForExpectedResponse")
        End Try
    End Function


    Function ftnCollisionDetect(ByVal intPriority As Short) As String
        Try
            If boolEnableBumperSwitches_ER1 Then
                Thread.CurrentThread.Priority = ThreadPriority.Highest
                boolCollisionDetected = ftnCheckForCollision() ' 
                Thread.CurrentThread.Priority = intPriority
                ftnCollisionDetect = strGetDigital ' strGetDigital captures text when ftnCheckForCollision is checking the bumper switches
            Else
                ftnCollisionDetect = ""
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnCollisionCheck")
            ftnCollisionDetect = ""
        End Try
    End Function

    Function ftnGetER1Response(ByRef inttimeOut As Integer) As String  '
        ftnGetER1Response = ""
        Try  ' this function must be thread safe
            If (inttimeOut > 0) Then evntER1DataReceived.WaitOne(inttimeOut)
            evntER1DataReceived.Reset()
            ftnGetER1Response = strER1ReceiveMessage
            evntER1ClientDataPassed.Set()
            strER1ReceiveMessage = ""
            boolER1_MoveComplete = CBool(InStr(ftnGetER1Response, "move done")) Or boolER1_MoveComplete
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetER1Response")
        End Try
    End Function



    Private Sub subRemoveNonPrintable(ByRef strText As String)
        Dim charArray As Char() = strText.ToCharArray()
        strText = ""
        For Each c As Char In charArray
            Dim [cint] As Integer = Convert.ToInt32(c)
            If [cint] < 127 AndAlso [cint] > 31 Then
                strText = strText & c.ToString()
            End If
        Next
    End Sub









#Region "ER1Client"

    'TODO - Since we are already in a thread, convert to synchronous client
    '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    '
    '
    '   adapted from http://msdn.microsoft.com/en-us/library/bew39x2a(v=VS.100).aspx
    '
    '
    '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


    Public Class classER1Client
        Public Shared evntConnectDone As New ManualResetEvent(False) ' ManualResetEvent instances signal completion.
        Public Shared Connected As Boolean = False
        Public Shared boolErrorDetected As Boolean = False


        Public Sub subMain()
            Try
                While Not boolShutDown
                    classER1Client.Connected = False
                    boolErrorDetected = False
                    intNoResponseCounter = 0
                    Dim ER1EndPoint As New IPEndPoint(ipRobot_IPAddress, intRobot_Port) ' Create a TCP/IP socket.
                    Dim ER1ClientSocket As New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
                    ER1ClientSocket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReceiveTimeout, 1500)
                    ER1ClientSocket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.SendTimeout, 1500)
                    ER1ClientSocket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, 1)
                    ER1ClientSocket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.DontLinger, True)
                    If boolER1Selected And Not classER1Client.Connected And Not boolErrorDetected And Not boolShutDown Then 'Connect and initialize
                        Thread.Sleep(100)
                        evntConnectDone.Reset()
                        ER1ClientSocket.BeginConnect(ER1EndPoint, New AsyncCallback(AddressOf subConnectCallback), ER1ClientSocket)
                        evntConnectDone.WaitOne(1500)
                        If classER1Client.Connected Then subReceive(ER1ClientSocket)
                    End If

                    intNoResponseCounter = 0
                    While classER1Client.Connected And Not boolErrorDetected And Not boolShutDown And boolER1Selected ' subSend commands 
                        evntER1DataWaitingToSend.WaitOne(1000)
                        evntER1DataWaitingToSend.Reset()
                        If boolER1DataWaitingToSend And Not boolErrorDetected And Not boolShutDown Then
                            boolER1DataWaitingToSend = False
                            subSend(ER1ClientSocket, strER1SendMessage)
                            If (intNoResponseCounter > 24) Then boolErrorDetected = True
                            'GC.Collect()
                        End If
                    End While
                    subDisconnect(ER1ClientSocket)
                End While
            Catch ex As Exception
                frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subMain (modIF_ER1_AClient")
            End Try
        End Sub 'subMain

        Private Sub subDisconnect(ByRef client As Socket)
            Try
                classER1Client.Connected = False
                intNoResponseCounter = 0
                If (client IsNot Nothing) Then
                    If client.Connected Then
                        client.Shutdown(SocketShutdown.Both)
                        Thread.Sleep(500)
                        client.Disconnect(Not boolShutDown)
                        Thread.Sleep(500)
                    End If
                    client.Dispose()
                End If
                Thread.Sleep(500)
            Catch ex As Exception
                classER1Client.Connected = False
                boolErrorDetected = True
                Thread.Sleep(500)
                frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subDisconnect (modIF_ER1_AClient")
            End Try
        End Sub

        Private Shared Sub subConnectCallback(ByVal ar As IAsyncResult)
            Try
                If Not boolErrorDetected And Not boolShutDown And (ar IsNot Nothing) Then
                    Dim client As Socket = CType(ar.AsyncState, Socket) ' Retrieve the socket from the ER1ClientState object.
                    If (client IsNot Nothing) Then
                        If client.Connected And Not boolShutDown Then
                            client.EndConnect(ar) ' Complete the connection.
                            evntConnectDone.Set() ' Signal that the connection has been made.
                        End If
                        classER1Client.Connected = client.Connected
                    End If
                End If
            Catch e As Exception
                boolErrorDetected = True
                classER1Client.Connected = False
                frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subConnectCallback (modIF_ER1_AClient")
            End Try
        End Sub 'subConnectCallback


        Private Shared Sub subReceive(ByVal client As Socket)
            If classER1Client.Connected And Not boolShutDown And Not boolErrorDetected And (client IsNot Nothing) Then
                Try
                    Dim state As New typeSocketClass ' Create the state object
                    state.workSocket = client
                    ' Begin receiving the data from the remote device.
                    client.BeginReceive(state.byteReceiveBuffer, 0, typeSocketClass.BufferSize, 0, New AsyncCallback(AddressOf subReceiveCallback), state)
                Catch e As Exception
                    boolErrorDetected = True
                    frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subReceive (modIF_ER1_AClient")
                End Try
            End If
        End Sub 'subReceive


        Private Shared Sub subReceiveCallback(ByVal ar As IAsyncResult)
            Try
                If classER1Client.Connected And Not boolShutDown And Not boolErrorDetected And (ar IsNot Nothing) Then
                    Dim ER1SocketClassInstance As typeSocketClass = CType(ar.AsyncState, typeSocketClass)
                    Dim ER1ClientSocket As Socket = ER1SocketClassInstance.workSocket
                    Dim bytesRead As Integer = ER1ClientSocket.EndReceive(ar) ' Read data from the client socket.
                    strER1ReceiveMessage = ""
                    If classER1Client.Connected And Not boolErrorDetected And bytesRead > 0 And Not boolShutDown _
                        And (ER1ClientSocket IsNot Nothing) Then ' There  might be more data, so store the data received so far.
                        If (ER1SocketClassInstance.sbReceivedData.Length < (UBound(ER1SocketClassInstance.byteReceiveBuffer) - bytesRead)) Then
                            ER1SocketClassInstance.sbReceivedData.Append(Encoding.ASCII.GetString(ER1SocketClassInstance.byteReceiveBuffer, 0, bytesRead) & " ")
                            ER1SocketClassInstance.sbReceivedData.Append(" ")
                            If (strER1ReceiveMessage.Length + bytesRead) < UBound(ER1SocketClassInstance.byteReceiveBuffer) Then
                                strER1ReceiveMessage &= ER1SocketClassInstance.sbReceivedData.ToString() ' Throws exceptions - out of range
                                ER1SocketClassInstance.sbReceivedData.Clear()   'clear the buffer
                            End If
                        End If
                        If strER1ReceiveMessage.Length > 3 Then
                            If CBool(InStr(strER1ReceiveMessage, vbCr)) Then ' Or CBool(InStr(strER1ReceiveMessage, "OK")) Then
                                ER1SocketClassInstance.sbReceivedData.Clear()   'clear the buffer
                                evntER1DataReceived.Set() 'Signal the subMain thread to continue.
                                evntER1ClientDataPassed.WaitOne(500) ' subWait for subMain thread to get the data
                                evntER1ClientDataPassed.Reset()
                                ER1SocketClassInstance.sbReceivedData.Clear()   'clear the buffer
                            End If
                        End If
                    End If
                    If classER1Client.Connected And Not boolShutDown And Not boolErrorDetected And (ER1ClientSocket IsNot Nothing) Then _
                        ER1ClientSocket.BeginReceive(ER1SocketClassInstance.byteReceiveBuffer, 0, typeSocketClass.BufferSize, 0, New AsyncCallback(AddressOf subReceiveCallback), ER1SocketClassInstance)
                Else
                    boolErrorDetected = True
                End If 'If classER1Client.Connected
            Catch ex As Exception
                boolErrorDetected = True
                frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subReceiveCallback (modIF_ER1_AClient")
            End Try
        End Sub 'subReadCallback

        Private Sub subSend(ByVal ER1ClientSocket As Socket, ByVal strMessage As String)
            ' Convert the string strMessage to byte strMessage using ASCII encoding.
            Dim bytestrMessage As Byte() = Encoding.ASCII.GetBytes(strMessage)
            ' Begin sending strMessage to ER1.
            Try
                If classER1Client.Connected And Not boolErrorDetected And Not boolShutDown And (ER1ClientSocket IsNot Nothing) Then _
                  ER1ClientSocket.BeginSend(bytestrMessage, 0, bytestrMessage.Length, 0, New AsyncCallback(AddressOf subSendCallback), ER1ClientSocket)
            Catch ex As Exception
                boolErrorDetected = True
                frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subSend (modIF_ER1_AClient")
            End Try

            evntER1DataSent.WaitOne(300)
            evntER1DataSent.Reset()
        End Sub 'subSend


        Private Sub subSendCallback(ByVal ar As IAsyncResult)
            Try
                If classER1Client.Connected And Not boolErrorDetected And Not boolShutDown And (ar IsNot Nothing) Then
                    Dim ER1ClientSocket As Socket = CType(ar.AsyncState, Socket) ' Retrieve the socket from the ER1SocketClassInstance object.
                    evntER1DataSent.Set()
                End If
            Catch ex As Exception
                evntER1DataSent.Set()
                boolErrorDetected = True
                frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subSendCallback (modIF_ER1_AClient")
            End Try
        End Sub 'subSendCallback



    End Class 'ER1ClientServerClass


#End Region




End Module

