﻿Imports System.Speech.Synthesis
Imports System.Speech
Imports System.Math

Module modIF_ER1_Socket_Top

    Public Function ftnER1_SocketCommand(ByRef strCommand As String) As String
        ftnER1_SocketCommand = ""
        Try
            Dim strParsedText As String() = strCommand.Split(" "c)
            If (Not boolSimulatedMovement) Or (strParsedText(0) = "play") Then ' 
                Select Case strParsedText(0)
                    Case "move" : If Not boolStop Then _
                            ftnER1_SocketCommand = ftnMoveCommand(strParsedText, strCommand)
                    Case "battery" : ftnER1_SocketCommand = ftnGetBattery(strParsedText, strCommand)
                    Case "input" : If (UBound(strParsedText) > 0) Then
                            If (strParsedText(1) = "analog") Then  ' get  voltage
                                ftnER1_SocketCommand = ftnGetAnalog(strParsedText, strCommand)
                            ElseIf (strParsedText(1) = "digital") Then
                                ftnER1_SocketCommand = ftnGetDigital()
                            End If
                        End If
                    Case "play" : ftnER1_SocketCommand = ftnSpeak(strCommand)
                    Case "position" : ftnER1_SocketCommand = ftnGetPosition(strParsedText) ' get odometry data
                    Case "bumper" : ftnER1_SocketCommand = ftnGetBumper(strParsedText, strCommand) ' get bumper switch status
                    Case "set" : ftnER1_SocketCommand = ftnSet(strParsedText, strCommand) ' Set bot parameter
                    Case "stop" : ftnER1_SocketCommand = ftnStop(strParsedText, strCommand) 'stop
                    Case Else : ftnER1_SocketCommand = ftnER1_SocketCommunicate(strCommand, "OK", 1500)
                End Select
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnER1_SocketCommand " & ex.ToString)
        End Try
    End Function


    Private Function ftnMoveCommand(ByRef strParsedText As String(), ByVal strCommand As String) As String
        ftnMoveCommand = "OK"
        Try
            Dim boolMidCourseCorrectionCommand As Boolean = boolBotIsMoving
            Dim sngMoveDistanceOrAngle As Single
            If (String.CompareOrdinal(strTypeOfMove, "XY") = 0) Then
                sngMoveDistanceOrAngle = Sqrt(Convert.ToSingle(Val(strParsedText(2))) ^ 2 + Convert.ToSingle(Val(strParsedText(4))) ^ 2) / Cos(Atan(Convert.ToSingle(Val(strParsedText(4))) / Convert.ToSingle(Val(strParsedText(2)))))
            Else
                sngMoveDistanceOrAngle = Convert.ToSingle(Val(strParsedText(1)))
            End If
            Dim sngMovetimeOut As Single  ' Max time to wait for expected response

            If (String.CompareOrdinal(strTypeOfMove, "Turn") = 0) Then
                sngMovetimeOut = Abs(sngMoveDistanceOrAngle / sngBotAngularVelocity * 2500) + sngStartOfMoveDelay + 4000
                If (sngMoveDistanceOrAngle > 0) Then
                    sngMoveDistanceOrAngle += constER1TurnHysterises + sngMoveDistanceOrAngle / 30
                Else
                    sngMoveDistanceOrAngle -= constER1TurnHysterises + sngMoveDistanceOrAngle / 30
                End If
                strCommand = "move " & sngMoveDistanceOrAngle & " " & strParsedText(2)
            ElseIf (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Then
                sngMovetimeOut = Abs(ftnMapUnitsToInches(sngMoveDistanceOrAngle) / (sngBotLinearVelocity * 2.54) * 2200) + sngStartOfMoveDelay + 5000
                If (sngMoveDistanceOrAngle > 0) Then
                    sngMoveDistanceOrAngle += ftnInchesToMapUnits(constER1FwdHysterises)
                Else
                    sngMoveDistanceOrAngle -= ftnInchesToMapUnits(constER1FwdHysterises * 0.33333)
                End If
                strCommand = "move " & sngMoveDistanceOrAngle & " " & strParsedText(2)
            ElseIf (String.CompareOrdinal(strTypeOfMove, "XY") = 0) Then
                sngMovetimeOut = Abs(ftnMapUnitsToInches(sngMoveDistanceOrAngle) / (Min(sngBotLinearVelocity, 30) * 2.54) * 2200) + sngStartOfMoveDelay + 15000
            End If
            ftnER1_SocketCommunicate(strCommand, "OK", 1000)
            boolBotIsMoving = True
            timeMoveCommandSent = Now()
            If boolMidCourseCorrectionCommand Then
                ftnMoveCommand = ftnER1_SocketCommunicate("events", "", 0)
            Else
                If (boolEnableLocalizationWhileMoving Or boolEnableMidCourseCorrection) Then subStartImageRecognition()
                ftnMoveCommand = ftnER1_SocketCommunicate("events", "move done", sngMovetimeOut)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnMoveCommand")
        End Try
    End Function



    Private Function ftnGetPosition(ByVal strParsedText As String()) As String
        'Return position as x,y in map units
        ftnGetPosition = "ERROR :"
        Try
            Dim strResponse As String
            strResponse = ftnER1_SocketCommunicate("position", vbCr, 1000)
            strParsedText = strResponse.Split(" "c)
            If (UBound(strParsedText) = 5) Then
                If (strParsedText(0) = "OK") Then
                    ftnGetPosition = "OK "
                    ftnGetPosition &= ftnCmToMapUnits(Val(strParsedText(1))).ToString
                    ftnGetPosition &= " " & ftnCmToMapUnits(Val(strParsedText(2))).ToString
                Else
                    ftnGetPosition &= strResponse
                End If
            Else
                ftnGetPosition &= strResponse
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetPosition")
        End Try
    End Function


    Private Function ftnGetBumper(ByRef strParsedText As String(), ByRef strCommand As String) As String
        ftnGetBumper = "7"
        Try
            If boolEnableBumperSwitches_ER1 Then
                Dim byteGetDigital As Byte = ftnGetDigital() And 7
                If (byteGetDigital = 0) Then
                    ftnGetBumper = "7"  '  probably a COM error, ignore
                Else
                    ftnGetBumper = byteGetDigital.ToString
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetBumper")
        End Try
    End Function



    Private Function ftnStop(ByVal strParsedText As String(), ByVal strCommand As String) As String
        Try
            ftnStop = ftnER1_SocketCommunicate(strCommand, "OK", 1000)
        Catch ex As Exception
            ftnStop = ""
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnStop")
        End Try
    End Function


    Private Function ftnSet(ByRef strParsedText As String(), ByRef strCommand As String) As String
        Try
            ftnSet = ftnER1_SocketCommunicate(strCommand, "OK", 1000)
        Catch ex As Exception
            ftnSet = ""
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnSet")
        End Try
    End Function


    Private Function ftnGetBattery(ByVal strParsedText As String(), ByRef strCommand As String) As String
        Try
            Dim intBatteryPercentage As Integer = 0
            Dim strRecv As String
            If Not boolBotIsMoving Then
                strRecv = ftnER1_SocketCommunicate("input analog 15", "OK", 1100)
                strParsedText = strRecv.Split(" "c)
                If (UBound(strParsedText) >= 1) And (strParsedText(0) = "OK") Then
                    If (Val(strParsedText(1)) > 0) Then
                        sngBotBatteryVoltage = Convert.ToSingle(Val(strParsedText(1)) / 65536.0 * 16.4)
                    End If

                    strStatusBotVoltage = "Bot: " & sngBotBatteryVoltage.ToString("N1") & "V"
                ElseIf (strParsedText(0) = "Error:") Or (sngBotBatteryVoltage = 0) Then
                    sngBotBatteryVoltage = 0
                    strStatusBotVoltage = "   ??   "
                End If
            End If
            ftnGetBattery = strStatusBotVoltage
            If (ftnGetBattery = "   ??   ") Then ftnER1_SocketCommand("play phrase 'No power'")
            sngLaptopBatteryPercent = Int(SystemInformation.PowerStatus.BatteryLifePercent * 100)
            GotABotClass.subUpdateAllText(tbpBotPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetBattery")
            ftnGetBattery = ""
        End Try
    End Function


    Private Function ftnGetAnalog(ByVal strParsedText As String(), ByRef strCommand As String) As String
        ftnGetAnalog = ""
        Try
            Dim intAnalogReading As Short = 0
            Dim strRecv As String
            strRecv = ftnER1_SocketCommunicate(strCommand, "OK", 1500) '.1
            strParsedText = strRecv.Split(" "c)
            If (strParsedText(0) = "OK") Then
                If (UBound(strParsedText) >= 1) Then
                    intAnalogReading = 0
                    For I As Integer = 1 To UBound(strParsedText)
                        If (strParsedText(I) IsNot Nothing) And (strParsedText(I) <> "") Then
                            intAnalogReading = Int(Val(strParsedText(I)))
                        End If
                        ftnGetAnalog &= intAnalogReading.ToString & " "
                    Next I
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetAnalog")
        End Try
    End Function

    Private Function ftnGetDigital() As Byte
        Try
            Dim strParsedText As String()
            Dim strRecv As String
            ftnGetDigital = "&Hff"
            strRecv = ftnER1_SocketCommunicate("input digital", "OK f", 1500)  '.1
            strGetDigital = strRecv
            strParsedText = strRecv.Split(" "c)
            If (UBound(strParsedText) = 3) Then
                If (strParsedText(0) = "OK") Then _
                    If (Val("&H" & strParsedText(1)) > 0) Then _
                      ftnGetDigital = Val("&H" & strParsedText(1))
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetDigital")
        End Try
    End Function

    Private Function ftnSpeak(ByVal strCommand As String) As String
        Try
            ftnSpeak = "OK"
            Dim strParsedText As String() = strCommand.Split(" "c)
            If boolMute Then
                ftnSpeak = "OK"
            ElseIf Not boolPCVoice Then
                If CBool(InStr(strCommand, "phraseA")) Then _
                        strCommand = strCommand.Replace("phraseA", "phrase")
                ftnSpeak = ftnER1_SocketCommunicate(strCommand, "OK", 1000)
                ftnSpeak &= ftnER1_SocketCommunicate("events", "play done", 1500 + UBound(strParsedText) * 650)
            Else
                subSpeak(strCommand)
            End If
        Catch ex As Exception
            ftnSpeak = ""
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnSpeak")
        End Try
    End Function

 

End Module
