﻿


' Interface to GotAGlyph for image recognition

Imports System
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.Threading
Imports Microsoft.VisualBasic
Imports System.EventArgs



Module modIF_GotAGlyph_AClient
    Public strGotAGlyphSendMessage As String = ""
    Public strGotAGlyphReceiveMessage As String = ""
    Public evntGotAGlyphDataWaitingToSend As New ManualResetEvent(False)
    Public boolGotAGlyphDataWaitingToSend As Boolean = False
    Public evntGotAGlyphDataSent As New ManualResetEvent(False)
    Public evntGotAGlyphDataReceived As New ManualResetEvent(False)
    Public evntGotAGlyphClientDataPassed As New ManualResetEvent(False)

    Public Function ftnGotAGlyph_Communicate(ByVal strCommand As String, ByVal strResponse As String, ByVal inttimeOut As Integer) As String
        On Error Resume Next
        If classGotAGlyphClient.Connected And Not boolShutDown Then
            ftnSendCommandGotAGlyph(strCommand)
            If (strResponse <> "") Then ftnGotAGlyph_Communicate = ftnWaitForExpectedResponseGotAGlyph(strResponse, inttimeOut)
        End If
    End Function


    Function ftnSendCommandGotAGlyph(ByVal strCommand As String) As String  ' must be thread safe
        ftnSendCommandGotAGlyph = ""
        If classGotAGlyphClient.Connected And Not boolShutDown Then
            Try
                evntGotAGlyphClientDataPassed.Reset()
                strGotAGlyphSendMessage = strCommand & vbCrLf
                boolGotAGlyphDataWaitingToSend = True
                evntGotAGlyphDataWaitingToSend.Set()
                'GC.Collect()
            Catch e As Exception
                ftnSendCommandGotAGlyph = ""
            End Try
        End If
    End Function

    Public Function ftnWaitForExpectedResponseGotAGlyph(ByVal strTextToWaitFor As String, ByVal inttimeOut As Integer) As String
        Dim timeOut As DateTime
        timeOut = Now().AddMilliseconds(inttimeOut)
        ftnWaitForExpectedResponseGotAGlyph = ""
        Do
            ftnWaitForExpectedResponseGotAGlyph = ftnWaitForExpectedResponseGotAGlyph & ftnGetTextGotAGlyph(150)
        Loop Until ((Now() > timeOut) Or CBool(InStr(ftnWaitForExpectedResponseGotAGlyph, strTextToWaitFor)) Or boolStop Or boolShutDown)
        If CBool(InStr(strGotAGlyphReceiveMessage, "OK")) Then  ' Check for disconnect
            intNoResponseCounter = 0
        Else
            intNoResponseCounter += 1
            If boolEnableGotAGlyph And Not boolShutDown And (intNoResponseCounter > 3) Then ' Try to reconnect
                boolEnableGotAGlyph = False
                subWait(1200)
                boolEnableGotAGlyph = True
            End If
        End If
    End Function

    Dim intNoResponseCounter As Integer = 0
    Function ftnGetTextGotAGlyph(ByVal inttimeOut As Integer) As String
        On Error Resume Next
        ftnGetTextGotAGlyph = ""
        If classGotAGlyphClient.Connected And Not boolShutDown Then
            If (inttimeOut > 0) Then evntGotAGlyphDataReceived.WaitOne(inttimeOut) ' 
            ftnGetTextGotAGlyph = strGotAGlyphReceiveMessage
            strGotAGlyphReceiveMessage = ""
            evntGotAGlyphDataReceived.Reset()
            If Not boolShutDown Then evntGotAGlyphClientDataPassed.Set()
        End If
        If CBool(InStr(ftnGetTextGotAGlyph, "OK")) Then  ' Check for disconnect
            intNoResponseCounter = 0
        Else
            intNoResponseCounter += 1
        End If
    End Function



#Region "GotAGlyphClient"

    '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    '
    '
    '  Example adapted from http://msdn.microsoft.com/en-us/library/bew39x2a(v=VS.100).aspx
    '
    '
    '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



    Dim boolErrorDetected As Boolean = False

    Public Class classGotAGlyphClient
        Public Shared evntConnectDone As New ManualResetEvent(False) ' ManualResetEvent instances signal completion.
        Public Shared Connected As Boolean = False


        Public Sub subMain()
            On Error Resume Next
            While Not boolShutDown
                'GC.Collect()
                classGotAGlyphClient.Connected = False
                boolErrorDetected = False
                intNoResponseCounter = 0
                Dim GotAGlyphEndPoint As New IPEndPoint(IPAddress.Parse("127.0.0.1"), 9050) ' Create a TCP/IP socket.
                Dim GotAGlyphClientSocket As New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
                GotAGlyphClientSocket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReceiveTimeout, 1500)
                GotAGlyphClientSocket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.SendTimeout, 1500)
                GotAGlyphClientSocket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, 1)
                GotAGlyphClientSocket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.DontLinger, True)
                If boolEnableGotAGlyph And Not classGotAGlyphClient.Connected And Not boolErrorDetected And Not boolShutDown Then 'Connect and initialize
                    Thread.Sleep(100)
                    evntConnectDone.Reset()
                    GotAGlyphClientSocket.BeginConnect(GotAGlyphEndPoint, New AsyncCallback(AddressOf subConnectCallback), GotAGlyphClientSocket)
                    'GC.Collect()
                    evntConnectDone.WaitOne(1500)
                    If classGotAGlyphClient.Connected And Not boolShutDown Then subReceive(GotAGlyphClientSocket)
                End If

                intNoResponseCounter = 0
                While classGotAGlyphClient.Connected And Not boolErrorDetected And Not boolShutDown ' subSend commands 
                    evntGotAGlyphDataWaitingToSend.WaitOne(1000)
                    evntGotAGlyphDataWaitingToSend.Reset()
                    If boolGotAGlyphDataWaitingToSend And Not boolErrorDetected And Not boolShutDown Then
                        boolGotAGlyphDataWaitingToSend = False
                        subSend(GotAGlyphClientSocket, strGotAGlyphSendMessage)
                        'GC.Collect()
                        If (intNoResponseCounter > 24) Then boolErrorDetected = True
                    End If
                End While
                subDisconnect(GotAGlyphClientSocket)
            End While
        End Sub 'subMain

        Private Sub subDisconnect(ByRef client As Socket)
            Try
                classGotAGlyphClient.Connected = False
                intNoResponseCounter = 0
                If (client IsNot Nothing) Then
                    If client.Connected Then
                        client.Shutdown(SocketShutdown.Both)
                        Thread.Sleep(500)
                        client.Disconnect(Not boolShutDown)
                        Thread.Sleep(500)
                    End If
                    client.Dispose()
                End If
                Thread.Sleep(500)
                'GC.Collect()
            Catch ex As Exception
                classGotAGlyphClient.Connected = False
                boolErrorDetected = True
                Thread.Sleep(500)
            End Try
        End Sub

        Private Shared Sub subConnectCallback(ByVal ar As IAsyncResult)
            Try
                If Not boolErrorDetected And Not boolShutDown And (ar IsNot Nothing) Then
                    Dim client As Socket = CType(ar.AsyncState, Socket) ' Retrieve the socket from the GotAGlyphClientState object.
                    If (client IsNot Nothing) Then
                        If client.Connected And Not boolShutDown Then
                            client.EndConnect(ar) ' Complete the connection.
                            evntConnectDone.Set() ' Signal that the connection has been made.
                        End If
                        classGotAGlyphClient.Connected = client.Connected
                    End If
                End If
            Catch e As Exception
                boolErrorDetected = True
                classGotAGlyphClient.Connected = False
            End Try
        End Sub 'subConnectCallback


        Private Shared Sub subReceive(ByVal client As Socket)
            If classGotAGlyphClient.Connected And Not boolShutDown And Not boolErrorDetected And (client IsNot Nothing) Then
                Try
                    Dim state As New typeSocketClass ' Create the state object
                    state.workSocket = client
                    ' Begin receiving the data from the remote device.
                    client.BeginReceive(state.byteReceiveBuffer, 0, typeSocketClass.BufferSize, 0, New AsyncCallback(AddressOf subReceiveCallback), state)
                    'GC.Collect()
                Catch e As Exception
                    boolErrorDetected = True
                End Try
            End If
        End Sub 'subReceive


        Private Shared Sub subReceiveCallback(ByVal ar As IAsyncResult)
            Try
                If classGotAGlyphClient.Connected And Not boolShutDown And Not boolErrorDetected And (ar IsNot Nothing) Then
                    Dim GotAGlyphSocketClassInstance As typeSocketClass = CType(ar.AsyncState, typeSocketClass)
                    Dim GotAGlyphClientSocket As Socket = GotAGlyphSocketClassInstance.workSocket
                    Dim bytesRead As Integer = GotAGlyphClientSocket.EndReceive(ar) ' Read data from the client socket.
                    strGotAGlyphReceiveMessage = ""
                    If classGotAGlyphClient.Connected And Not boolErrorDetected And bytesRead > 0 And Not boolShutDown _
                        And (GotAGlyphClientSocket IsNot Nothing) Then ' There  might be more data, so store the data received so far.
                        If (GotAGlyphSocketClassInstance.sbReceivedData.Length < (UBound(GotAGlyphSocketClassInstance.byteReceiveBuffer) - bytesRead)) Then
                            GotAGlyphSocketClassInstance.sbReceivedData.Append(Encoding.ASCII.GetString(GotAGlyphSocketClassInstance.byteReceiveBuffer, 0, bytesRead) & " ")
                            GotAGlyphSocketClassInstance.sbReceivedData.Append(" ")
                            If (strGotAGlyphReceiveMessage.Length + bytesRead) < UBound(GotAGlyphSocketClassInstance.byteReceiveBuffer) Then
                                strGotAGlyphReceiveMessage &= GotAGlyphSocketClassInstance.sbReceivedData.ToString() ' Throws exceptions - out of range
                                GotAGlyphSocketClassInstance.sbReceivedData.Clear()   'clear the buffer
                            End If
                        End If
                        If strGotAGlyphReceiveMessage.Length > 3 Then
                            If CBool(InStr(strGotAGlyphReceiveMessage, vbCr)) Or CBool(InStr(strGotAGlyphReceiveMessage, ">")) Then
                                evntGotAGlyphDataReceived.Set() 'Signal the subMain thread to continue.
                                evntGotAGlyphClientDataPassed.WaitOne(300) ' subWait for subMain thread to get the data
                                'evntGotAGlyphDataReceived.Reset()
                                evntGotAGlyphClientDataPassed.Reset()
                                GotAGlyphSocketClassInstance.sbReceivedData.Clear()   'clear the buffer
                            End If
                        End If
                    End If
                    If classGotAGlyphClient.Connected And Not boolShutDown And Not boolErrorDetected And (GotAGlyphClientSocket IsNot Nothing) Then _
                        GotAGlyphClientSocket.BeginReceive(GotAGlyphSocketClassInstance.byteReceiveBuffer, 0, typeSocketClass.BufferSize, 0, New AsyncCallback(AddressOf subReceiveCallback), GotAGlyphSocketClassInstance)
                Else
                    boolErrorDetected = True
                End If 'If classGotAGlyphClient.Connected
            Catch ex As Exception
                boolErrorDetected = True
            End Try
        End Sub 'subReadCallback

        Private Sub subSend(ByVal GotAGlyphClientSocket As Socket, ByVal strMessage As String)
            ' Convert the string strMessage to byte strMessage using ASCII encoding.
            Dim bytestrMessage As Byte() = Encoding.ASCII.GetBytes(strMessage)
            ' Begin sending strMessage to GotAGlyph.
            Try
                If classGotAGlyphClient.Connected And Not boolErrorDetected And Not boolShutDown And (GotAGlyphClientSocket IsNot Nothing) Then _
                  GotAGlyphClientSocket.BeginSend(bytestrMessage, 0, bytestrMessage.Length, 0, New AsyncCallback(AddressOf subSendCallback), GotAGlyphClientSocket)
                'GC.Collect()
            Catch ex As Exception
                boolErrorDetected = True
            End Try

            evntGotAGlyphDataSent.WaitOne(300)
            evntGotAGlyphDataSent.Reset()
        End Sub 'subSend


        Private Sub subSendCallback(ByVal ar As IAsyncResult)
            Try
                If classGotAGlyphClient.Connected And Not boolErrorDetected And Not boolShutDown And (ar IsNot Nothing) Then
                    Dim GotAGlyphClientSocket As Socket = CType(ar.AsyncState, Socket) ' Retrieve the socket from the GotAGlyphSocketClassInstance object.
                    evntGotAGlyphDataSent.Set()
                End If
            Catch ex As Exception
                evntGotAGlyphDataSent.Set()
                boolErrorDetected = True
            End Try
        End Sub 'subSendCallback

    End Class 'GotAGlyphClientServerClass

#End Region



End Module
