﻿Imports System.Speech.Synthesis
Imports System.Speech
Imports System.Math


Module modIF_Hero_Top

    Public Function ftnHeroCommand(ByRef strCommand As String) As String
        ftnHeroCommand = ""
        Try
            Dim strParsedText As String() = strCommand.Split(" "c)
            If (Not boolSimulatedMovement) Or (strParsedText(0) = "play") Then ' 
                Select Case strParsedText(0)
                    Case "move" : If Not boolStop Then _
                            ftnHeroCommand = ftnMoveCommand(strParsedText, strCommand)
                    Case "battery" : ftnHeroCommand = ftnGetBattery(strParsedText, strCommand)
                    Case "input" : If (UBound(strParsedText) > 0) Then
                            If (strParsedText(1) = "analog") Then  ' get  voltage
                                ftnHeroCommand = ftnGetAnalog(strParsedText, strCommand)
                            ElseIf (strParsedText(1) = "digital") Then
                                ftnHeroCommand = ftnGetDigital()
                            End If
                        End If
                    Case "play" : ftnHeroCommand = ftnSpeak(strCommand)
                    Case "position" : ftnHeroCommand = ftnGetPosition(strParsedText) ' get odometry data
                    Case "bumper" : ftnHeroCommand = ftnGetBumper(strParsedText, strCommand) ' get bumper switch status
                    Case "set" : ftnHeroCommand = ftnSet(strParsedText, strCommand) ' Set bot parameter
                    Case "stop" : ftnHeroCommand = ftnStop(strParsedText, strCommand) 'stop
                    Case Else : ftnHeroCommand = ftnHero_Communicate(strCommand, ">", 30000)
                End Select
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnHeroCommand " & ex.ToString)
        End Try
    End Function


    Private Function ftnMoveCommand(ByRef strParsedText As String(), ByVal strCommand As String) As String
        ftnMoveCommand = "OK"
        Try
            Dim boolMidCourseCorrectionCommand As Boolean = boolBotIsMoving
            Dim sngMoveDistanceOrAngle As Single
            sngMoveDistanceOrAngle = Convert.ToSingle(Val(strParsedText(1)))

            If (String.CompareOrdinal(strTypeOfMove, "Turn") = 0) Then
                ftnMoveCommand = ftnHeroTurn(sngMoveDistanceOrAngle)
            ElseIf (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Then
                ftnMoveCommand = ftnHeroFwd(sngMoveDistanceOrAngle, strParsedText)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnMoveCommand")
        End Try
    End Function



    Private Function ftnGetPosition(ByVal strParsedText As String()) As String
        'Return position as x,y in map units
        ftnGetPosition = "ERROR :"
        Try
            ftnGetPosition = ftnGetHeroPosition(Val(strParsedText(1)))
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetPosition")
        End Try
    End Function


    Private Function ftnGetBumper(ByRef strParsedText As String(), ByRef strCommand As String) As String
        'Return position as x,y in map units
        ftnGetBumper = "7"
        Try
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetBumper")
        End Try
    End Function



    Private Function ftnStop(ByVal strParsedText As String(), ByVal strCommand As String) As String
        Try
            ftnStop = ftnHeroStop()
        Catch ex As Exception
            ftnStop = ""
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnStop")
        End Try
    End Function


    Private Function ftnSet(ByRef strParsedText As String(), ByRef strCommand As String) As String
        Try
            ftnSet = ""
        Catch ex As Exception
            ftnSet = ""
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnSet")
        End Try
    End Function


    Private Function ftnGetBattery(ByVal strParsedText As String(), ByRef strCommand As String) As String
        Try
            Dim intBatteryPercentage As Integer = 0
            Dim strRecv As String = ""
            sngBotBatteryVoltage = 12
            strStatusBotVoltage = "Bot: 12.0V"
            ftnGetBattery = strStatusBotVoltage
            If (ftnGetBattery = "   ??   ") Then ftnHeroCommand("play phrase 'No power'")
            sngLaptopBatteryPercent = Int(SystemInformation.PowerStatus.BatteryLifePercent * 100)
            GotABotClass.subUpdateAllText(tbpBotPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetBattery")
            ftnGetBattery = ""
        End Try
    End Function


    Private Function ftnGetAnalog(ByVal strParsedText As String(), ByRef strCommand As String) As String
        ftnGetAnalog = ""
        Try
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetAnalog")
        End Try
    End Function

    Private Function ftnGetDigital() As Byte
        Try
            ftnGetDigital = "&Hff"
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetDigital")
        End Try
    End Function

    Private Function ftnSpeak(ByVal strCommand As String) As String
        Try
            ftnSpeak = "OK"
            Dim strParsedText As String() = strCommand.Split(" "c)
            If boolMute Then
                ftnSpeak = "OK"
            ElseIf Not boolPCVoice Then
                If CBool(InStr(strCommand, "phraseA")) Then _
                        strCommand = strCommand.Replace("phraseA", "phrase")
                ftnSpeak = ftnHero_Communicate(strCommand, ">", 10000)
            Else
                subSpeak(strCommand)
            End If
        Catch ex As Exception
            ftnSpeak = ""
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnSpeak")
        End Try
    End Function

End Module
