﻿Imports System.Speech.Synthesis
Imports System.Speech
Imports System.Math

Module modIF_RoboRealm_Top
    Public Function ftnRoboRealmCommand(ByRef strCommand As String) As String
        ftnRoboRealmCommand = ""
        Try
            Dim strParsedText As String() = strCommand.Split(" "c)
            If (Not boolSimulatedMovement) Or (strParsedText(0) = "play") Then ' 
                Select Case strParsedText(0)
                    Case "move" : If Not boolStop Then _
                            ftnRoboRealmCommand = ftnMoveCommand(strParsedText, strCommand)
                    Case "battery" : ftnRoboRealmCommand = ftnGetBattery(strParsedText, strCommand)
                    Case "input" : If (UBound(strParsedText) > 0) Then
                            If (strParsedText(1) = "analog") Then  ' get  voltage
                                ftnRoboRealmCommand = ftnGetAnalog(strParsedText, strCommand)
                            ElseIf (strParsedText(1) = "digital") Then
                                ftnRoboRealmCommand = ftnGetDigital()
                            End If
                        End If
                    Case "play" : ftnRoboRealmCommand = ftnSpeak(strCommand)
                    Case "position" : ftnRoboRealmCommand = ftnGetPosition(strParsedText) ' get odometry data
                    Case "bumper" : ftnRoboRealmCommand = ftnGetBumper(strParsedText, strCommand) ' get bumper switch status
                    Case "set" : ftnRoboRealmCommand = ftnSet(strParsedText, strCommand) ' Set bot parameter
                    Case "stop" : ftnRoboRealmCommand = ftnStop(strParsedText, strCommand) 'stop
                    Case Else : ftnRoboRealmCommand = ftnTransmitRR(strCommand, "", 0)
                End Select
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnRoboRealmCommand " & ex.ToString)
        End Try
    End Function


    Private Function ftnMoveCommand(ByRef strParsedText As String(), ByVal strCommand As String) As String
        ftnMoveCommand = "OK"
        Try
            Dim boolMidCourseCorrectionCommand As Boolean = boolBotIsMoving
            Dim sngMoveDistanceOrAngle As Single
            If (String.CompareOrdinal(strTypeOfMove, "XY") = 0) Then
                sngMoveDistanceOrAngle = Sqrt(Convert.ToSingle(Val(strParsedText(2))) ^ 2 + Convert.ToSingle(Val(strParsedText(4))) ^ 2) / Cos(Atan(Convert.ToSingle(Val(strParsedText(4))) / Convert.ToSingle(Val(strParsedText(2)))))
            Else
                sngMoveDistanceOrAngle = Convert.ToSingle(Val(strParsedText(1)))
            End If

            If (boolEnableLocalizationWhileMoving Or boolEnableMidCourseCorrection) Then _
                  subStartImageRecognition()
            timeMoveCommandSent = Now()
            ControlRRBot(sngMoveDistanceOrAngle, strTypeOfMove)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnMoveCommand")
        End Try
    End Function



    Private Function ftnGetPosition(ByVal strParsedText As String()) As String
        'Return position as x,y in map units
        ftnGetPosition = "ERROR :"
        Try
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetPosition")
        End Try
    End Function


    Private Function ftnGetBumper(ByRef strParsedText As String(), ByRef strCommand As String) As String
        ftnGetBumper = "7"
        Try
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetBumper")
        End Try
    End Function



    Private Function ftnStop(ByVal strParsedText As String(), ByVal strCommand As String) As String
        Try
            ControlRRBot(0, "Fwd")
            ftnStop = ""
        Catch ex As Exception
            ftnStop = ""
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnStop")
        End Try
    End Function


    Private Function ftnSet(ByRef strParsedText As String(), ByRef strCommand As String) As String
        Try
            ftnSet = ""
        Catch ex As Exception
            ftnSet = ""
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnSet")
        End Try
    End Function


    Private Function ftnGetBattery(ByVal strParsedText As String(), ByRef strCommand As String) As String
        Try
            Dim intBatteryPercentage As Integer = 0
            sngBotBatteryVoltage = CSng(Val(ftnGetVariableFromRR("battery"))) / 127 * 12.5
            intBatteryPercentage = Int((100.0 * (sngBotBatteryVoltage - 11.35) / 0.75))
            If (intBatteryPercentage > 100) Then intBatteryPercentage = 100
            If (intBatteryPercentage < 0) Then intBatteryPercentage = 0
            intBatteryPercentage = (intBatteryPercentage \ 20) * 20
            If Not GotABotClass.InvokeRequired Then strStatusBotVoltage = "Bot: " & intBatteryPercentage.ToString & "%"

            ftnGetBattery = strStatusBotVoltage
            If (ftnGetBattery = "   ??   ") Then ftnRoboRealmCommand("play phrase 'No power'")
            sngLaptopBatteryPercent = Int(SystemInformation.PowerStatus.BatteryLifePercent * 100)
            GotABotClass.subUpdateAllText(tbpBotPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetBattery")
            ftnGetBattery = ""
        End Try
    End Function


    Private Function ftnGetAnalog(ByVal strParsedText As String(), ByRef strCommand As String) As String
        ftnGetAnalog = ""
        Try
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetAnalog")
        End Try
    End Function

    Private Function ftnGetDigital() As Byte
        Try
            ftnGetDigital = "&Hff"
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGetDigital")
        End Try
    End Function

    Private Function ftnSpeak(ByVal strCommand As String) As String
        Try
            ftnSpeak = "OK"
            Dim strParsedText As String() = strCommand.Split(" "c)
            If boolMute Then
                ftnSpeak = "OK"
            Else
                subSpeak(strCommand)
            End If
        Catch ex As Exception
            ftnSpeak = ""
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnSpeak")
        End Try
    End Function

End Module
