﻿
Imports System.Math
Imports System.Threading


Public Module modLWM_and_CourseCorrection
    Public strDebug As String = ""
    Public Class classCourseCorrection
        Dim intStartPoseCorrection As Short = 0

        Public Sub subCourseCorrection_Top()
            Try
                Dim intLocalizationsWhileMoving As Short = 0
                Dim intCourseCorrections As Short = 0
                Dim tbpScanPose, tbpDRPose As typeBotPose
                Dim boolValidLocation As Boolean = False
                Dim sngRMS__Error As Single
                Dim timeLocalizationStart As DateTime
                While Not boolShutDown
                    If Not boolSimulatedMovement And ftnScannerEnabled() And (boolEnableMidCourseCorrection Or boolEnableLocalizationWhileMoving) _
                        And Not boolStop And Not boolEnableRBPF And Not boolPause And (ftnPoseUncertaintyFactor(tbpStartingPose) < 400) Then
                        Dim sngMinDistanceFromTarget As Single = sngFifteenInches * sngBotLinearVelocity / 50
                        While boolBotIsMoving
                            sngRMS__Error = sngOneDotFiveSigma
                            If (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Or (String.CompareOrdinal(strTypeOfMove, "XY") = 0) Then
                                tbpDRPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, intScannerDelay, timeMoveCommandSent, tbpStartingPose, tbpTargetPoseGlobal, strTypeOfMove, True)
                                If (ftnDistanceBetweenLocations(tbpTargetPoseGlobal.Location, tbpDRPose.Location) > sngMinDistanceFromTarget) Then '  Abort localizations near end of a move which might delay the stationary localization
                                    If boolDebugLWM Then
                                        strDebug &= " ===============  " & intLocalizationsWhileMoving & " ===============  " & vbCrLf
                                        strDebug &= ftnElapsedTime(timeMoveCommandSent) & "  Course Correction pre localize :  " & vbCrLf
                                    End If
                                    tbpDRPose.LocationUncertainty.X = sngTenInchesGrid
                                    tbpDRPose.LocationUncertainty.Y = sngTenInchesGrid
                                    If (String.CompareOrdinal(strTypeOfMove, "XY") = 0) Then
                                        tbpDRPose.OrientationUncertainty = 15
                                    Else
                                        tbpDRPose.OrientationUncertainty = 10
                                    End If
                                    intLocalizationsWhileMoving += 1
                                    timeLocalizationStart = Now()
                                    tbpScanPose = ftnLocalizeFrom2DScan_Top(tbpDRPose, tbpDRPose, True, boolValidLocation, sngRMS__Error)
                                    If boolDebugLWM Then
                                        strDebug &= ftnElapsedTime(timeMoveCommandSent) & "  Course Correction post localize:  " & vbCrLf
                                        strDebug &= "  tbpDRPose = " & tbpDRPose.Location.X & ", " & tbpDRPose.Location.Y & " at " & tbpDRPose.Orientation & " degrees." & vbCrLf
                                        strDebug &= "  ScanPose =  " & tbpScanPose.Location.X & ", " & tbpScanPose.Location.Y & " at " & tbpScanPose.Orientation & " degrees." & vbCrLf
                                        strDebug &= "  sngRMS__Error =  " & sngRMS__Error & ", boolValidLocation = " & boolValidLocation & vbCrLf
                                    End If
                                End If
                                If (sngRMS__Error < sngGoodMatch) And boolValidLocation And boolEnableLocalizationWhileMoving Then subCorrectStartingOrientation(tbpScanPose)
                                If boolBotIsMoving And boolValidLocation Then
                                    If (sngRMS__Error < sngGoodMatch) And boolEnableMidCourseCorrection And _
                                        (ftnDistanceBetweenLocations(tbpTargetPoseGlobal.Location, tbpDRPose.Location) > sngTenInches) And _
                                        (ftnDistanceBetweenLocations(tbpStartingPose.Location, tbpDRPose.Location) > sngTenInches) Then ' perform course correction.  Assumes that acceleration time is completed and, if XY motion, motion is straight, not curved.
                                        Thread.CurrentThread.Priority = ThreadPriority.Highest
                                        'tbpDRPose = ftnLocalizeUsingDeadReckoning(tbpScanPose, -0.5, timeLocalizationStart, tbpScanPose, tbpTargetPoseGlobal, strTypeOfMove, True)  
                                        'TODO - Not accurate because of acceleration time
                                        'TODO - Need better delay factor then -0.5. Should be based upon actual delays, velocity and PC speed
                                        Dim tsElapsedTimeSpan As TimeSpan = Now().Subtract(timeLocalizationStart)
                                        Dim sngTimeSinceLocalizationInSec As Single = (Convert.ToSingle(tsElapsedTimeSpan.TotalMilliseconds.ToString) - sngStartOfMoveDelay) * 0.001
                                        Dim sngDistanceFromLocalization = ftnCmToMapUnits((sngTimeSinceLocalizationInSec + 0.2) * sngBotLinearVelocity)  '  0.2 = estimated delay from now to when correction is issued
                                        tbpDRPose.Location = ftnLocationFromEstimatedPose(tbpScanPose, 0, sngDistanceFromLocalization)   ' Predict where the Bot will be when the move correction is issued
                                        If boolDebugLWM Then strDebug &= "  tbpDRPose corrected for delay = " & tbpDRPose.Location.X & ", " & tbpDRPose.Location.Y & " at " & tbpDRPose.Orientation & " degrees." & vbCrLf
                                        Dim strMoveType As String = ftnTypeOfMove(tbpDRPose, tbpTargetPoseGlobal)
                                        If (strMoveType <> "Turn") Then
                                            intCourseCorrections += 1
                                            If boolDebugLWM Then strDebug &= "  ##############  Course Correction   " & vbCrLf
                                            tbpDRPose.LocationUncertainty.X += sngTwoInchesGrid
                                            tbpDRPose.LocationUncertainty.Y += sngTwoInchesGrid
                                            tbpDRPose.OrientationUncertainty += 5
                                            Select Case strTypeOfMove ' start move correction
                                                Case "Fwd"
                                                    tbpBotPose = ftnBotFwd(tbpDRPose, tbpTargetPoseGlobal)
                                                Case "XY"
                                                    tbpBotPose = ftnBotXY(tbpDRPose, tbpTargetPoseGlobal)
                                                Case "Stop"
                                                    tbpBotPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, 0, timeMoveCommandSent, tbpStartingPose, tbpBotPose, strTypeOfMove, True)
                                                    tbpBotPose = ftnBotStop(tbpDRPose, tbpTargetPoseGlobal)
                                            End Select
                                        End If
                                        Thread.CurrentThread.Priority = ThreadPriority.Normal
                                    End If
                                End If
                            ElseIf (String.CompareOrdinal(strTypeOfMove, "Turn") = 0) And (sngBotAngularVelocity <= 25) And boolEnableLocalizationWhileMoving Then  ' modify Starting Pose Location if good correlation
                                If Abs(ftnAngleDifference(tbpDRPose.Orientation, tbpTargetPoseGlobal.Orientation)) > 10 Then
                                    tbpDRPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, intScannerDelay, timeMoveCommandSent, tbpStartingPose, tbpTargetPoseGlobal, strTypeOfMove, True)
                                    tbpDRPose.OrientationUncertainty += 15
                                    tbpScanPose = ftnLocalizeFrom2DScan_Top(tbpDRPose, tbpDRPose, True, boolValidLocation, sngRMS__Error)
                                    If (sngRMS__Error < sngGoodMatch) Then
                                        tbpStartingPose.Location = ftnFindAvgPose(tbpStartingPose, tbpScanPose, 0).Location
                                        intStartPoseCorrection += 1
                                        If boolDebugLWM Then strDebug &= "  ##############  Start Location Corrected to " & tbpStartingPose.Location.X & ", " & tbpStartingPose.Location.Y & vbCrLf
                                    End If
                                End If
                            End If
                        End While  ' boolBotIsMoving
                        If (boolEnableMidCourseCorrection Or boolEnableLocalizationWhileMoving) And (intLocalizationsWhileMoving > 0) Then
                            If boolDebugLWM Then
                                frmDebug.subWriteLogs(Color.Black, strDebug)
                                frmDebug.subWriteLogs(Color.Black, "         2D Localized While Moving " & intLocalizationsWhileMoving & " times.  Course corrections = " & intCourseCorrections & " times. Starting Pose corrections = " & intStartPoseCorrection & " times. ")
                            End If
                        End If
                        intLocalizationsWhileMoving = 0
                        intCourseCorrections = 0
                        intStartPoseCorrection = 0
                        strDebug = ""
                        Thread.Sleep(200)
                    Else
                        Thread.Sleep(1000)
                    End If
                End While  ' Not boolShutDown
            Catch ex As Exception
                frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subCourseCorrection_Top")
            End Try
        End Sub



        Public Sub subCorrectStartingOrientation(ByVal tbpEstimatedPose As typeBotPose)
            Try
                If (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Then
                    If (tbpEstimatedPose.Orientation > 90) And (tbpEstimatedPose.Orientation < 270) Then
                        tbpStartingPose.Orientation = ftnConvertTo360(Convert.ToInt16((tbpEstimatedPose.Orientation + tbpStartingPose.Orientation + tbpStartingPose.Orientation)) * 0.33333)
                    Else
                        tbpStartingPose.Orientation = ftnConvertTo360(Convert.ToInt16((ftnConvertTo180(tbpEstimatedPose.Orientation) + ftnConvertTo180(tbpStartingPose.Orientation) + ftnConvertTo180(tbpStartingPose.Orientation)) \ 3))
                    End If
                    If boolDebugLWM Then strDebug &= "  ##############  Start Orientation Corrected to " & tbpStartingPose.Orientation & " degrees." & vbCrLf
                    intStartPoseCorrection += 1
                End If
            Catch ex As Exception
                frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subCorrectStartingOrientation")
            End Try
        End Sub

    End Class
End Module
