﻿Imports Microsoft.VisualBasic
Imports System.Net
Imports System.Drawing
Imports System.Math
Imports System.EventArgs


Public Module modLocalizeRBPF

    '  StochasticUniversalSampling() taken from http://mnemstudio.org/genetic-algorithms-simple-example-4.htm

    Dim sngPreviousWeights(intNumberOfParticles) As Single
    Dim intOddsLength As Integer
    Dim intMaxRange As Short = ftnInchesToMapUnits(intScanVectorsMaxRangeInches)
    Dim sngParticleWeightNormalized(intNumberOfParticles) As Single
    Dim colGrey As Color = ColorTranslator.FromOle(RGB(223, 223, 223))


    Public Sub subInitParticles(ByVal tbpEstimatedPose As typeBotPose, ByVal intNumberOfParticles As Short)
        Dim intParticleNumber As Short
        Try
            If boolEnableRBPF Or boolSlam Then
                If boolDebugRBPF Then frmDebug.subWriteLogs(Color.Black, "//  subInitParticles  //")
                Dim colorMapPixel As Color
                Dim sngInitialWeight As Single = 1 / sngWeakMatch
                Dim sngProbableWeight As Single = 1.1 / sngWeakMatch
                ReDim sngParticleWeight(intNumberOfParticles)
                ReDim byteParticleMapOdds(intNumberOfParticles, bmpMap.Width, bmpMap.Height)
                ReDim sngPreviousWeights(intNumberOfParticles)
                ReDim sngParticleWeightNormalized(intNumberOfParticles)
                ReDim tbpParticlePose(intNumberOfParticles)
                If boolEnableRBPF Then
                    boolEnableLocalizationWhileMoving = False
                    GotABotClass.mnuEnableLocalizationWhileMoving.Checked = False
                    boolEnableMidCourseCorrection = False
                    GotABotClass.mnuMidCourseCorrection.Checked = False
                End If
                intMaxRange = ftnInchesToMapUnits(intScanVectorsMaxRangeInches)
                tbpParticlePose(0) = tbpEstimatedPose
                tbpParticlePose(0).LocationUncertainty.X = sngTenInchesGrid
                tbpParticlePose(0).LocationUncertainty.Y = sngTenInchesGrid
                tbpParticlePose(0).OrientationUncertainty = 10
                sngParticleWeight(0) = sngProbableWeight
                sngPreviousWeights(0) = sngProbableWeight
                For intX As Short = 0 To bmpMap.Width - 1   ' Convert bmpMap into intOccupiedOddsArray.   
                    For intY As Short = 0 To bmpMap.Height - 1
                        colorMapPixel = bmpMap.GetPixel(intX, intY)
                        If ((colorMapPixel.R = 255) And (colorMapPixel.G = 216) And (colorMapPixel.B = 176)) Then ' Compass Uncertainty
                            byteParticleMapOdds(0, intX, intY) = 15  ' 
                        ElseIf ((colorMapPixel.R = 128) And (colorMapPixel.G = 1) And (colorMapPixel.B = 128)) Then ' Purple=NoGo Area, but empty
                            byteParticleMapOdds(0, intX, intY) = 15  ' 
                        ElseIf (colorMapPixel.G = 0) Then ' 
                            byteParticleMapOdds(0, intX, intY) = 255  ' 
                        ElseIf (colorMapPixel.G = 255) Then ' 
                            byteParticleMapOdds(0, intX, intY) = 0  ' 
                        Else
                            byteParticleMapOdds(0, intX, intY) = (255 - colorMapPixel.G) / 2 ' 16 = 1:1 odds or 50% probability
                        End If
                    Next intY
                    subDoEventsIfMainThread()
                Next intX
                Randomize()
                intOddsLength = byteParticleMapOdds.GetLength(1) * byteParticleMapOdds.GetLength(2)
                Dim sngTranslationFactor As Single = Max(sngThreeInches * (tbpEstimatedPose.LocationUncertainty.X + tbpEstimatedPose.LocationUncertainty.Y) / sngTwentyInches * Sqrt(intNumberOfParticles / 4096), sngTwoInches) 'TO DO - change to a function of Estimated uncertainty
                Dim sngRotationnFactor As Single = Max(5 * tbpEstimatedPose.OrientationUncertainty / 10 * (intNumberOfParticles / 4096), 2)
                For intParticleNumber = 1 To intNumberOfParticles - 1
                    Array.Copy(byteParticleMapOdds, 0, byteParticleMapOdds, intParticleNumber * intOddsLength, intOddsLength)
                    sngParticleWeight(intParticleNumber) = sngInitialWeight
                    tbpParticlePose(intParticleNumber).Location.X = tbpEstimatedPose.Location.X + ftnGenerateGaussian() * sngTranslationFactor   ' Generate initial Pose
                    tbpParticlePose(intParticleNumber).Location.Y = tbpEstimatedPose.Location.Y + ftnGenerateGaussian() * sngTranslationFactor
                    tbpParticlePose(intParticleNumber).Location = ftnCheckMapArrayLimits(tbpParticlePose(intParticleNumber).Location)
                    tbpParticlePose(intParticleNumber).LocationUncertainty = tbpParticlePose(0).LocationUncertainty
                    tbpParticlePose(intParticleNumber).Orientation = ftnConvertTo360(Convert.ToInt16(tbpEstimatedPose.Orientation + ftnGenerateGaussian() * sngRotationnFactor))
                    tbpParticlePose(intParticleNumber).OrientationUncertainty = tbpParticlePose(0).OrientationUncertainty
                    sngPreviousWeights(intParticleNumber) = sngInitialWeight
                Next
                intBestParticle = 0
                subConvertParticleOddsToBMP(intBestParticle)
                subConvertMapToArray()
                subGeneratePathArray()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, "ERROR:  " & ex.Message)
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subInitParticles")
            frmDebug.subWriteLogs(Color.Red, "     intParticleNumber = " & intParticleNumber)
            frmDebug.subWriteLogs(Color.Red, "     tbpParticlePose(intParticleNumber).Location = " & tbpParticlePose(intParticleNumber).Location.X & ", " & tbpParticlePose(intParticleNumber).Location.Y)
        End Try
    End Sub

    Dim timeRBPF_LocalizationStart As DateTime
    Dim intLocalizationsSinceResampled As Short = 0
    Function ftnLocalizeRBPF_Top(ByVal tbpEstimatedPose As typeBotPose, ByRef boolGoodLocalization As Boolean) As typeBotPose
        Try
            intNumberOfBeams = Max(16, intNumberOfBeamsDefault)
            ftnLocalizeRBPF_Top = ftnWaitWhileMoving(tbpEstimatedPose)
            If boolDebugRBPF Then timeRBPF_LocalizationStart = Now()
            Dim sngRMS_Error As Single
            boolGoodLocalization = False
            intLocalizationsSinceResampled += 1
            Dim boolStoppedB4Start As Boolean = (GotABotClass.picStop.BorderStyle = FormBorderStyle.Fixed3D)
            If (intNumberOfParticles >= 512) Then subReplaceWorstParticle(intNumberOfParticles, intBestParticle, ftnLocalizeRBPF_Top)
            If ftnGetScanVectors(tbpEstimatedPose, True) Then
                subMeasureProposalWeights(tbpEstimatedPose, intNumberOfParticles)  ' 
                intBestParticle = ftnBestParticle(tbpEstimatedPose, intNumberOfParticles)
                ftnLocalizeRBPF_Top = tbpParticlePose(intBestParticle)
                sngRMS_Error = 1 / sngParticleWeight(intBestParticle)
                If Not ftnLocationWithinPose(ftnLocalizeRBPF_Top.Location, tbpEstimatedPose) Or _
                   Not ftnAnglesWithinUncertainty(ftnLocalizeRBPF_Top.Orientation, tbpEstimatedPose.Orientation, tbpEstimatedPose.OrientationUncertainty) Then
                    ftnLocalizeRBPF_Top = tbpEstimatedPose
                    boolGoodLocalization = False
                Else
                    boolGoodLocalization = sngRMS_Error <= sngWeakMatch
                End If
                ftnLocalizeRBPF_Top = ftnParticleUncertainty(tbpEstimatedPose, ftnLocalizeRBPF_Top, sngRMS_Error, boolGoodLocalization)
                If boolGoodLocalization Then
                    subDrawScanVectors(ftnLocalizeRBPF_Top, True)
                    frmDebug.subWritePose(ftnElapsedTime(timeMoveCommandSent) & "       Pose Derived From (2D) Particle Filter  ", ftnLocalizeRBPF_Top)
                    frmDebug.subWriteLogs(Color.Green, "                         Scan Coefficient = " & FormatNumber(sngRMS_Error, 2) & "   (Particle (2D) localization success)")
                Else
                    frmDebug.subWritePose(ftnElapsedTime(timeMoveCommandSent) & "       Pose Derived From Particle Filter  ", ftnLocalizeRBPF_Top)
                    frmDebug.subWriteLogs(Color.Red, "                           Scan Coefficient = " & FormatNumber(sngRMS_Error, 2) & "   (Particle localization failed)")
                End If
                subStochasticUniversalSampling(tbpEstimatedPose, intNumberOfParticles, intLocalizationsSinceResampled)
                If boolDebugRBPF Then frmDebug.subWriteLogs(Color.Red, " intBestParticle = " & intBestParticle)
                If ((GotABotClass.picStop.BorderStyle = FormBorderStyle.Fixed3D) And Not boolStoppedB4Start) Then 'Stop button was pressed during localization - ignore result
                    ftnLocalizeRBPF_Top = tbpEstimatedPose
                Else
                    subUpdateSlamMaps()
                    frmSlam.subUpdateSlamFrameText(intBestParticle)
                End If
                If boolDebugRBPF Then frmDebug.subWriteLogs(Color.Red, " Loalization Time = " & Convert.ToSingle(Now().Subtract(timeRBPF_LocalizationStart).TotalMilliseconds.ToString))
                GotABotClass.subRedraw(ftnLocalizeRBPF_Top)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnLocalizeRBPF_Top")
        End Try
    End Function

    Function ftnWaitWhileMoving(ByVal tbpEstimatedPose As typeBotPose) As typeBotPose ' Waits for Bot to stop moving
        Try
            ftnWaitWhileMoving = tbpEstimatedPose
            If boolBotIsMoving Then
                strStatusDriving = intDrivingSequenceNumber & "Wait until Bot stops moving "
                frmDebug.subWriteLogs(Color.Red, ftnElapsedTime(timeMoveCommandSent) & "************ ftnLocalizeRBPF_Top called while Bot is moving  ")
                Dim timeOut As DateTime = Now().AddMilliseconds(16000)
                While boolBotIsMoving And (Now() < timeOut)
                    GotABotClass.subRedraw(tbpBotPose)
                    subWait(100)
                End While
                If boolBotIsMoving Then
                    MsgBox(" Wait until Bot stops moving ")
                    boolBotIsMoving = False
                End If
                ftnWaitWhileMoving = tbpBotPose
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subWaitForStopped")
        End Try
    End Function

    Sub subUpdateSlamMaps()
        Try
            If boolSlam Then
                If boolDebugRBPF Then frmDebug.subWriteLogs(Color.Red, " subConvertScanToOccupencyOdds Start Time = " & Convert.ToSingle(Now().Subtract(timeRBPF_LocalizationStart).TotalMilliseconds.ToString))
                subConvertScanToOccupencyOdds(intNumberOfParticles)
                If boolDebugRBPF Then frmDebug.subWriteLogs(Color.Red, " subConvertParticleOddsToBMP Start Time = " & Convert.ToSingle(Now().Subtract(timeRBPF_LocalizationStart).TotalMilliseconds.ToString))
                subConvertParticleOddsToBMP(intBestParticle)
                If boolDebugRBPF Then frmDebug.subWriteLogs(Color.Red, " subConvertMapToArray Start Time = " & Convert.ToSingle(Now().Subtract(timeRBPF_LocalizationStart).TotalMilliseconds.ToString))
                subConvertMapToArray()
                If boolDebugRBPF Then frmDebug.subWriteLogs(Color.Red, " subGeneratePathArray Start Time = " & Convert.ToSingle(Now().Subtract(timeRBPF_LocalizationStart).TotalMilliseconds.ToString))
                If boolDrivingToDestination Then subGeneratePathArray()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subUpdateSlamMaps")
        End Try
    End Sub


    Function ftnParticleUncertainty(ByVal tbpEstimatedPose As typeBotPose, ByVal tbpBestParticlePose As typeBotPose, ByVal sngRMS_Error As Single, ByVal boolValidLocalization As Boolean) As typeBotPose
        Try
            If Not boolValidLocalization Then
                ftnParticleUncertainty = tbpEstimatedPose
            Else
                ftnParticleUncertainty = tbpBestParticlePose
                If (ftnPoseDifferenceFactor(tbpEstimatedPose, tbpBestParticlePose) > 1.25) Then
                    ftnParticleUncertainty.OrientationUncertainty = tbpEstimatedPose.OrientationUncertainty
                    ftnParticleUncertainty.LocationUncertainty.X = tbpEstimatedPose.LocationUncertainty.X
                    ftnParticleUncertainty.LocationUncertainty.Y = tbpEstimatedPose.LocationUncertainty.Y
                Else
                    If (sngRMS_Error > sngGoodMatch) Then
                        ftnParticleUncertainty.OrientationUncertainty = Max(((tbpEstimatedPose.OrientationUncertainty + 20) / 2), 20)
                        ftnParticleUncertainty.LocationUncertainty.X = (tbpEstimatedPose.LocationUncertainty.X + sngTwentyInchesGrid) / 2
                        ftnParticleUncertainty.LocationUncertainty.Y = (tbpEstimatedPose.LocationUncertainty.Y + sngTwentyInchesGrid) / 2
                    ElseIf (sngRMS_Error > sngExcellentMatch) Then
                        ftnParticleUncertainty.OrientationUncertainty = Max(((tbpEstimatedPose.OrientationUncertainty + 20) / 2), 20)
                        ftnParticleUncertainty.LocationUncertainty.X = (tbpEstimatedPose.LocationUncertainty.X + sngTwentyInchesGrid) / 2
                        ftnParticleUncertainty.LocationUncertainty.Y = (tbpEstimatedPose.LocationUncertainty.Y + sngTwentyInchesGrid) / 2
                    Else
                        ftnParticleUncertainty.OrientationUncertainty = 20
                        ftnParticleUncertainty.LocationUncertainty.X = sngTenInchesGrid + sngFourInchesGrid
                        ftnParticleUncertainty.LocationUncertainty.Y = ftnParticleUncertainty.LocationUncertainty.X
                    End If
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnParticleUncertainty")
        End Try
    End Function

    Sub subGenerateProposalFromMotionModel(ByVal tbpEstimatedPose As typeBotPose, ByVal tbpStartingPose As typeBotPose, ByVal strTypeOfMove As String)
        Try
            If boolEnableRBPF Then
                Randomize()
                Dim tbpParticleTargetPose As typeBotPose = tbpEstimatedPose
                If (strTypeOfMove = "Turn") Then ' Turn
                    Dim intTurnAngle As Short = ftnTurnAngle(tbpStartingPose, tbpEstimatedPose)
                    For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                        tbpParticlePose(intParticleNumber).Orientation = ftnConvertTo360(tbpParticlePose(intParticleNumber).Orientation + intTurnAngle)
                    Next intParticleNumber
                ElseIf (strTypeOfMove = "Fwd") Then  'Fwd
                    Dim sngDistance As Single = ftnDistanceCommanded(tbpStartingPose, tbpEstimatedPose)
                    If sngDistance >= 0 Then
                        For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                            tbpParticlePose(intParticleNumber).Location = ftnLocationFromEstimatedPose(tbpParticlePose(intParticleNumber), 0, sngDistance)
                        Next intParticleNumber
                    Else
                        sngDistance = Abs(sngDistance)
                        For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                            tbpParticlePose(intParticleNumber).Location = ftnLocationFromEstimatedPose(tbpParticlePose(intParticleNumber), 180, sngDistance)
                        Next intParticleNumber
                    End If
                ElseIf (strTypeOfMove = "XY") Then ' move xy
                    Dim tmcXY_Offset As typeMapCoordinate = ftnFindXY_Parameters(tbpStartingPose, tbpEstimatedPose)
                    frmDebug.subWriteLogs(Color.Black, "  tmcXY_Offset =: " & tmcXY_Offset.X & ", " & tmcXY_Offset.Y)
                    For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                        'frmDebug.subWriteLogs(Color.Black, intParticleNumber & "      tbpParticlePose(intParticleNumber) =: " & tbpParticlePose(intParticleNumber).Location.X & ", " & tbpParticlePose(intParticleNumber).Location.Y & "  at " & tbpParticlePose(intParticleNumber).Orientation)
                        tbpParticleTargetPose.Location = ftnLocationFromEstimatedPose(tbpParticlePose(intParticleNumber), tmcXY_Offset)
                        tbpParticlePose(intParticleNumber) = ftnXY_DR(tbpParticlePose(intParticleNumber), 99999, tbpParticleTargetPose, False)
                        'frmDebug.subWriteLogs(Color.Black, intParticleNumber & "      tbpParticlePose(intParticleNumber) =: " & tbpParticlePose(intParticleNumber).Location.X & ", " & tbpParticlePose(intParticleNumber).Location.Y & "  at " & tbpParticlePose(intParticleNumber).Orientation)
                    Next intParticleNumber
                End If
                subAddPropsalNoise(tbpEstimatedPose, tbpStartingPose, strTypeOfMove) '  Add noise to each Particle's movement
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subGenerateProposalFromMotionModel")
        End Try
    End Sub

    Sub subReplaceInWallParticles(ByVal tbpEstimatedPose As typeBotPose, ByVal intBestParticle As Short, ByVal intParticleNumber As Short)
        Try
            If Not boolSlam Then
                If ftnInWall(tbpParticlePose(intParticleNumber).Location) Then subCopyParticle(intBestParticle, intParticleNumber)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subReplaceInWallParticles")
        End Try
    End Sub

    Sub subAddPropsalNoise(ByRef tbpEstimatedPose As typeBotPose, ByRef tbpStartingPose As typeBotPose, ByRef strTypeOfMove As String)
        Try
            If (strTypeOfMove = "Turn") Then ' Turn
                Dim sngAngleFactor As Single = Min(Abs(ftnTurnAngle(tbpStartingPose, tbpEstimatedPose)) / (20 * sngBotMovementAccuracy), 6) ' 45 degrees = 3,  10 degrees = 0.7
                sngAngleFactor = Max(sngAngleFactor, 1)
                Dim sngTurnLocationFactor As Single = 0.5 * sngGridSize
                For intParticleNumber As Short = 0 To intNumberOfParticles - 1 ' update each particles pose
                    tbpParticlePose(intParticleNumber).Location.X += sngTurnLocationFactor * ftnGenerateGaussian()
                    tbpParticlePose(intParticleNumber).Location.Y += sngTurnLocationFactor * ftnGenerateGaussian()
                    tbpParticlePose(intParticleNumber).Location = ftnCheckMapArrayLimits(tbpParticlePose(intParticleNumber).Location)
                    tbpParticlePose(intParticleNumber).Orientation += sngAngleFactor * ftnGenerateGaussian()
                    tbpParticlePose(intParticleNumber).Orientation = ftnConvertTo360(tbpParticlePose(intParticleNumber).Orientation)
                    subReplaceEdgeProposal(intParticleNumber)
                Next intParticleNumber
            ElseIf (strTypeOfMove = "Fwd") Then  'Fwd
                Dim sngDistanceFactor As Single = Min(ftnDistanceBetweenLocations(tbpStartingPose.Location, tbpEstimatedPose.Location) / (sngFifteenInches * sngBotMovementAccuracy * sngGridSize), sngThreeInchesGrid)  ' 10" = 1.43
                For intParticleNumber As Short = 0 To intNumberOfParticles - 1 ' update each particles pose
                    Dim sngOrientationRadians As Single = ftnDegreeToRadian(tbpParticlePose(intParticleNumber).Orientation)
                    tbpParticlePose(intParticleNumber).Location.X += sngDistanceFactor * Cos(sngOrientationRadians) * ftnGenerateGaussian()
                    tbpParticlePose(intParticleNumber).Location.Y += sngDistanceFactor * Sin(-sngOrientationRadians) * ftnGenerateGaussian()
                    tbpParticlePose(intParticleNumber).Location = ftnCheckMapArrayLimits(tbpParticlePose(intParticleNumber).Location)
                    tbpParticlePose(intParticleNumber).Orientation += ftnGenerateGaussian()
                    tbpParticlePose(intParticleNumber).Orientation = ftnConvertTo360(tbpParticlePose(intParticleNumber).Orientation)
                    subReplaceEdgeProposal(intParticleNumber)
                Next intParticleNumber
            ElseIf (strTypeOfMove = "XY") Then ' move xy
                Dim sngAngleFactor As Single = Min(Abs(ftnTurnAngle(tbpStartingPose, tbpEstimatedPose)) / (20 * sngBotMovementAccuracy), 6) ' 45 degrees = 3,  10 degrees = 0.7
                sngAngleFactor = Max(sngAngleFactor, 1)
                Dim sngDistanceFactor As Single = Min(ftnDistanceBetweenLocations(tbpStartingPose.Location, tbpEstimatedPose.Location) / (sngFifteenInches * sngBotMovementAccuracy * sngGridSize), sngThreeInchesGrid)  ' 10" = 1.43
                For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                    Dim sngOrientationRadians As Single = ftnDegreeToRadian(tbpParticlePose(intParticleNumber).Orientation)
                    tbpParticlePose(intParticleNumber).Location.X += sngDistanceFactor * Cos(sngOrientationRadians) * ftnGenerateGaussian() '
                    tbpParticlePose(intParticleNumber).Location.Y += sngDistanceFactor * Sin(-sngOrientationRadians) * ftnGenerateGaussian()
                    tbpParticlePose(intParticleNumber).Location = ftnCheckMapArrayLimits(tbpParticlePose(intParticleNumber).Location)
                    tbpParticlePose(intParticleNumber).Orientation += (1 + sngAngleFactor) * ftnGenerateGaussian()
                    tbpParticlePose(intParticleNumber).Orientation = ftnConvertTo360(tbpParticlePose(intParticleNumber).Orientation)
                    subReplaceEdgeProposal(intParticleNumber)
                Next intParticleNumber
            Else
                If boolDebugRBPF Then _
                   frmDebug.subWriteLogs(Color.Black, " ERROR in subGenerateProposalFromMotionModel.  Unexpected type of move = " & strTypeOfMove)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subAddPropsalNoise")
        End Try
    End Sub

    Sub subReplaceEdgeProposal(ByRef intParticleNumber As Short)
        Try
            If ftnLocationOnMapEdge(tbpParticlePose(intParticleNumber).Location) Then
                subCopyParticle(intBestParticle, intParticleNumber)
                tbpParticlePose(intParticleNumber).Location.X += ftnGenerateGaussian()
                tbpParticlePose(intParticleNumber).Location.Y += ftnGenerateGaussian()
                tbpParticlePose(intParticleNumber).Location = ftnCheckMapArrayLimits(tbpParticlePose(intParticleNumber).Location)
                tbpParticlePose(intParticleNumber).Orientation += ftnGenerateGaussian()
                tbpParticlePose(intParticleNumber).Orientation = ftnConvertTo360(tbpParticlePose(intParticleNumber).Orientation)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subReplaceEdgeProposal")
        End Try
    End Sub

   

    Sub subMeasureProposalWeights(ByRef tbpEstimatedPose As typeBotPose, ByRef intNumberOfParticles As Short)
        ' Weight is a measure of how well each Particle's pose correlates with the sensor readings
        Try
            If ftnNonFlatWall() Then
                Dim sngRMS_Error(intNumberOfParticles) As Single
                Dim boolValidPose As Boolean
                Dim sngFantasticMatch As Single = sngExcellentMatch * 0.5
                Dim sngLongestScanBeam As Single = ftnLongestBeamDistance()
                For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                    subGenerateDistanceFromWallSquaredSegmentArray(intParticleNumber, sngLongestScanBeam)
                    tbpParticlePose(intParticleNumber) = ftnCorrectedParticle(tbpEstimatedPose, tbpParticlePose(intParticleNumber), sngRMS_Error(intParticleNumber))
                    subDoEventsIfMainThread()
                    sngRMS_Error(intParticleNumber) = Min(sngRMS_Error(intParticleNumber) * ftnPoseDifferenceFactor(tbpEstimatedPose, tbpParticlePose(intParticleNumber)), sngOneDotFiveSigma)
                    sngParticleWeight(intParticleNumber) = ftnCalculateWeight(Max(sngRMS_Error(intParticleNumber), sngFantasticMatch), sngPreviousWeights(intParticleNumber))
                    If ftnInWall(tbpParticlePose(intParticleNumber).Location) Then
                        sngParticleWeight(intParticleNumber) = (sngRecipOneDotFiveSigma / 2)
                    Else
                        ftnValidatePose(tbpParticlePose(intParticleNumber), tbpEstimatedPose, boolValidPose)
                        If Not boolValidPose Then sngParticleWeight(intParticleNumber) = Max(sngParticleWeight(intParticleNumber) * 0.5, sngRecipOneDotFiveSigma)
                    End If
                Next intParticleNumber
                sngPreviousWeights = sngParticleWeight
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subMeasureProposalWeights")
        End Try
    End Sub

    Function ftnCalculateWeight(ByRef sngRMS_Error As Single, ByRef sngPreviousWeight As Single) As Single
        Try
            ftnCalculateWeight = (1 / Min(sngRMS_Error, (sngOneDotFiveSigma) + Max(sngPreviousWeight, sngRecipOneDotFiveSigma)) / 2) ' update weight - running average 
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnCalculateWeight")
        End Try
    End Function
    Function ftnCorrectedParticle(ByVal tbpEstimatedPose As typeBotPose, ByVal tbpParticlePose As typeBotPose, ByRef sngRMS_Error As Single) As typeBotPose
        Try
            ftnCorrectedParticle = tbpParticlePose
            ftnCorrectedParticle.LocationUncertainty.X = Max(sngTenInchesGrid, Abs(tbpEstimatedPose.Location.X - tbpParticlePose.Location.X))
            ftnCorrectedParticle.LocationUncertainty.Y = Max(sngTenInchesGrid, Abs(tbpEstimatedPose.Location.Y - tbpParticlePose.Location.Y))
            ftnCorrectedParticle.OrientationUncertainty = Max(15, Abs(ftnAngleDifference(tbpEstimatedPose.Orientation, tbpParticlePose.Orientation)))
            ftnCorrectedParticle = ftnPoseFrom2DScan(ftnCorrectedParticle, sngRMS_Error, True)
            ftnCorrectedParticle.OrientationUncertainty = tbpEstimatedPose.OrientationUncertainty  '  Unnecessary??
            ftnCorrectedParticle.LocationUncertainty = tbpEstimatedPose.LocationUncertainty  '  Unnecessary??
            'If boolDebugRBPF Then frmDebug.subWriteLogs(Color.Black, ":                    Corrected Particle = " & ftnCorrectedParticle.Location.X & ", " & ftnCorrectedParticle.Location.Y & " at " & ftnCorrectedParticle.Orientation & " degrees" & "/  Error = " & sngRMS_Error)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnCorrectedParticle")
            sngRMS_Error = sngOneDotFiveSigma
            ftnCorrectedParticle = tbpParticlePose
        End Try
    End Function

    Function ftnPoseDifferenceFactor(ByRef tbpEstimatedPose As typeBotPose, ByRef tbpParticlePose As typeBotPose) As Single
        Try  ' Used to increase the particle's RMS Error proportional to the difference between the Particle's and the Estimated's Pose
            ftnPoseDifferenceFactor = 1 + ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tbpParticlePose.Location) / sngfortyInches + _
                                      Abs(ftnAngleDifference(tbpEstimatedPose.Orientation, tbpParticlePose.Orientation)) / 60
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnPoseDifferenceFactor")
        End Try
    End Function

    Sub subConvertParticleOddsToBMP(ByRef intParticle As Short)
        Try
            If boolSlam Then
                'If boolDebugRBPF Then frmDebug.subWriteLogs(Color.Green, "  subConvertParticleOddsToBMP intParticle = " & intParticle)
                Dim bytePixelOdds As Byte
                For intX As Short = 0 To bmpMap.Width - 1   ' Convert byteParticleMapOdds into bmpMap.   white = free,  black = occupied
                    For intY As Short = 0 To bmpMap.Height - 1
                        bytePixelOdds = byteParticleMapOdds(intParticle, intX, intY)
                        If (bytePixelOdds = 16) Then
                            bmpMap.SetPixel(intX, intY, colGrey)
                        ElseIf (bytePixelOdds < 16) Then
                            bmpMap.SetPixel(intX, intY, Color.White)
                        Else
                            bmpMap.SetPixel(intX, intY, Color.Black)
                        End If
                    Next intY
                Next intX
                imgMap = bmpMap
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subConvertParticleOddsToBMP")
        End Try
    End Sub


    Sub subConvertScanToOccupencyOdds(ByRef intNumberOfParticles As Short)
        Try ' byteParticleMapOdds :  0 = Empty,  16 = 50% Odds of Empty or Occupied,  255 = Occupied
            If boolSlam And Not boolCollisionDetected Then
                Dim tbpThisParticlesPose As typeBotPose
                Dim trvVector As typeRangeVector
                Dim tmcEndPoint, tmcCheckPoint As typeMapCoordinate
                Dim boolRangeExceedsMapLimits As Boolean = False
                Dim tmcVectorOrigin As typeMapCoordinate
                Dim sngRangeRoundingError As Single = sngGridSize ' TODO Modify value based upon orientation -  0, 90 degrees = sngGridSize  * 0.5, 45 degrees = sngGridSize  * 1.414
                For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                    tbpThisParticlesPose = tbpParticlePose(intParticleNumber)
                    tmcVectorOrigin = ftnLocationFromEstimatedPose(tbpThisParticlesPose, tmcScanVectorOffset)
                    For intBeamNumber As Short = 0 To constMaxScannerBeams - 1 '
                        boolRangeExceedsMapLimits = False
                        If (trvScanVectors(intBeamNumber).sngRange <> 0) Then
                            trvVector.sngRange = Min(trvScanVectors(intBeamNumber).sngRange + sngRangeRoundingError, intMaxRange)
                            trvVector.sngAngle = ftnConvertTo360(Convert.ToInt16(trvScanVectors(intBeamNumber).sngAngle) + tbpThisParticlesPose.Orientation)
                            tmcEndPoint = ftnLocationFromLocation(tmcVectorOrigin, trvVector.sngAngle, trvVector.sngRange)
                            While ftnLocationOnMapEdge(tmcEndPoint) And (trvVector.sngRange > 0) ' Vector extends beyond map limits,  reduce it
                                boolRangeExceedsMapLimits = True
                                trvVector.sngRange -= sngOneInch
                                tmcEndPoint = ftnLocationFromLocation(tmcVectorOrigin, trvVector.sngAngle, trvVector.sngRange) ' 
                            End While
                            tmcCheckPoint = ftnFirstPointOnLine(tmcVectorOrigin, tmcEndPoint)
                            While Not ftnLocationsEqual(tmcCheckPoint, tmcEndPoint) And Not (byteParticleMapOdds(intParticleNumber, tmcCheckPoint.X, tmcCheckPoint.Y) > 16)
                                subUpdateCellOccupencyEmpty(tmcCheckPoint, intParticleNumber)  ' empty space
                                tmcCheckPoint = ftnNextPointOnLine(tmcCheckPoint, tmcEndPoint)
                            End While
                            If (trvVector.sngRange < intMaxRange) And Not boolRangeExceedsMapLimits Then
                                If (ftnDistanceBetweenLocations(tmcCheckPoint, tmcEndPoint) < sngTwoInches) Then
                                    subUpdateCellOccupencyFull(tmcEndPoint, intParticleNumber) ' wall
                                Else
                                    subUpdateCellOccupencyEmpty(tmcCheckPoint, intParticleNumber) ' empty space
                                End If
                            End If
                        End If
                    Next intBeamNumber
                    subUpdateParticleMap_BotFootprint(tbpThisParticlesPose.Location, intParticleNumber)
                Next intParticleNumber
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subConvertScanToOccupencyOdds")
        End Try
    End Sub



    Sub subUpdateParticleMap_BotFootprint(ByRef tmcBotLocation As typeMapCoordinate, ByRef intParticleNumber As Short)
        Try
            Dim intFootprintRadius As Integer = sngBotRadiusGrid * 0.67
            Dim tmcLocation As typeMapCoordinate
            For tmcLocation.X = tmcBotLocation.X - intFootprintRadius To tmcBotLocation.X + intFootprintRadius
                For tmcLocation.Y = tmcBotLocation.Y - intFootprintRadius To tmcBotLocation.Y + intFootprintRadius
                    subUpdateCellOccupencyEmpty(tmcLocation, intParticleNumber)
                Next tmcLocation.Y
            Next tmcLocation.X
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subUpdateParticleMap_BotFootprint")
        End Try
    End Sub


    Sub subUpdateCellOccupencyEmpty(ByRef tmcLocation As typeMapCoordinate, ByRef intParticleNumber As Short)  ' 
        Try
            'tmcLocation = ftnCheckMapArrayLimits(tmcLocation)
            Dim intLocationOdds As Short = byteParticleMapOdds(intParticleNumber, tmcLocation.X, tmcLocation.Y)
            If (intLocationOdds <> 255) Then _
                byteParticleMapOdds(intParticleNumber, tmcLocation.X, tmcLocation.Y) = intLocationOdds \ 3
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subUpdateCellOccupencyEmpty")
        End Try
    End Sub

    Sub subUpdateCellOccupencyFull(ByRef tmcLocation As typeMapCoordinate, ByRef intParticleNumber As Short)  ' 
        Try
            'tmcLocation = ftnCheckMapArrayLimits(tmcLocation)
            Dim intLocationOdds As Short = byteParticleMapOdds(intParticleNumber, tmcLocation.X, tmcLocation.Y)
            If (intLocationOdds <> 0) Then _
                byteParticleMapOdds(intParticleNumber, tmcLocation.X, tmcLocation.Y) = Min(intLocationOdds * 3, 255)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subUpdateCellOccupencyFull")
        End Try
    End Sub


    Function ftnGenerateGaussian() As Single
        Try ' Generate gaussian number with sigma = 0.5
            ftnGenerateGaussian = 0
            For i As Short = 1 To 12   ' 
                ftnGenerateGaussian += Rnd()
            Next i
            ftnGenerateGaussian -= 6
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnGenerateGaussian")
        End Try
    End Function

    Function ftnResampleRequired(ByRef intNumberOfParticles As Short, ByVal intLocalizationsSinceResampled As Short) As Boolean
        ' Normalize the weight array then calculate the Resample Factor
        Try
            subNormalizeWeights(intNumberOfParticles)
            Dim sngResampleFactor As Single = 0
            For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                sngResampleFactor += sngParticleWeightNormalized(intParticleNumber) * sngParticleWeightNormalized(intParticleNumber)
            Next intParticleNumber
            sngResampleFactor = 1 / sngResampleFactor
            ftnResampleRequired = (sngResampleFactor < (intNumberOfParticles * 0.6)) Or (intLocalizationsSinceResampled > 9) Or (intNumberOfParticles >= 512)

            If boolDebugSlam Then
                frmDebug.subWriteLogs(Color.Green, "  :    sngResampleFactor = " & sngResampleFactor & ": intLocalizationsSinceResampled = " & intLocalizationsSinceResampled)
                frmSlam.txtResample.Text = sngResampleFactor.ToString
                If ftnResampleRequired Then
                    frmSlam.txtResample.BackColor = Color.Red
                Else
                    frmSlam.txtResample.BackColor = Color.White
                End If
                frmSlam.Refresh()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnResampleRequired")
        End Try
    End Function

    Sub subNormalizeWeights(ByRef intNumberOfParticles As Short)
        Try
            Dim sngWeightTotal As Single = sngParticleWeight.Sum
            For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                sngParticleWeightNormalized(intParticleNumber) = sngParticleWeight(intParticleNumber) / sngWeightTotal
            Next intParticleNumber
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subNormalizeWeights")
        End Try
    End Sub

    Public Sub subStochasticUniversalSampling(ByVal tbpEstimatedPose As typeBotPose, ByVal intNumberOfParticles As Short, ByRef intLocalizationsSinceReSampled As Short)
        ' sample tpParticles using Stochastic Universal Sampling
        ' complexity of O(N)
        ' Stochastic Universal Sampling is an elaborately-named variation of roulette wheel selection. 
        ' Stochastic Universal Sampling ensures that the observed selection frequencies of each individual are in line 
        ' with the expected frequencies. So if we have an individual that occupies 4.5% of the wheel and we select 100 
        ' individuals, we would expect on average for that individual to be selected between four and five times.
        Try
            If ftnResampleRequired(intNumberOfParticles, intLocalizationsSinceResampled) Then
                'If boolDebugRBPF Then frmDebug.subWriteLogs(Color.Black, "========================  subStochasticUniversalSampling  ==========================================  ")
                'If boolDebugRBPF Then frmDebug.subWriteLogs(Color.Black, "Resample: Original intBestParticle = " & intBestParticle)
                Dim intOrignalParticle As Short = 0
                Dim dblCumulativeSum As Double = sngParticleWeightNormalized(0)
                Dim dblSelectionSum As Double = 0
                Dim tbpNewParticlePoses(intNumberOfParticles) As typeBotPose
                Dim byteNewParticleOdds(intNumberOfParticles, bmpMap.Width, bmpMap.Height) As Byte
                Dim sngNewParticleWeights(intNumberOfParticles) As Single
                Dim sngNewPreviousWeights(intNumberOfParticles) As Single
                subReplaceWorstParticle(intNumberOfParticles, intBestParticle, tbpEstimatedPose)
                For intNewSample As Short = 0 To intNumberOfParticles - 1
                    dblSelectionSum = intNewSample / intNumberOfParticles
                    While (dblSelectionSum > dblCumulativeSum)
                        intOrignalParticle += 1
                        If (intOrignalParticle = intNumberOfParticles) Then intOrignalParticle = 0
                        dblCumulativeSum += sngParticleWeightNormalized(intOrignalParticle)
                    End While
                    tbpNewParticlePoses(intNewSample) = tbpParticlePose(intOrignalParticle)
                    Array.Copy(byteParticleMapOdds, intOrignalParticle * intOddsLength, byteNewParticleOdds, intNewSample * intOddsLength, intOddsLength)
                    sngNewPreviousWeights(intNewSample) = sngPreviousWeights(intOrignalParticle)
                    sngNewParticleWeights(intNewSample) = sngParticleWeight(intOrignalParticle)
                Next intNewSample
                tbpParticlePose = tbpNewParticlePoses
                byteParticleMapOdds = byteNewParticleOdds
                sngParticleWeight = sngNewParticleWeights
                sngPreviousWeights = sngNewPreviousWeights
                intBestParticle = ftnBestParticle(tbpEstimatedPose, intNumberOfParticles)
                intLocalizationsSinceReSampled = 0
            End If
        Catch ex As Exception
            MsgBox("ERROR:  " & ex.Message)
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subStochasticUniversalSampling")
        End Try
    End Sub

    Sub subReplaceWorstParticle(ByVal intNumberOfParticles As Short, ByVal intbestParticle As Short, ByVal tbpEstimatedPose As typeBotPose)
        Try
            Dim intWorstParticle As Short = ftnWorstParticle(intNumberOfParticles)
            subCopyParticle(ftnBestParticle(tbpEstimatedPose, intNumberOfParticles), intWorstParticle)
            'subUnlockParticleMap(intWorstParticle)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subReplaceWorstParticle")
        End Try
    End Sub


    Public Sub subCopyParticle(ByVal intSourceParticle As Short, ByVal intDestinationParticle As Short)
        Try
            tbpParticlePose(intDestinationParticle) = tbpParticlePose(intSourceParticle)
            Array.Copy(byteParticleMapOdds, intSourceParticle * intOddsLength, byteParticleMapOdds, intDestinationParticle * intOddsLength, intOddsLength)
            sngPreviousWeights(intDestinationParticle) = sngPreviousWeights(intSourceParticle)
            sngParticleWeight(intDestinationParticle) = sngParticleWeight(intSourceParticle)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subCopyParticle")
        End Try
    End Sub



    Function ftnBestParticle(ByVal tbpEstimatedPose As typeBotPose, ByVal intNumberOfParticles As Short) As Short
        Try
            ftnBestParticle = 0
            If boolEnableRBPF Then
                For i As Short = 1 To intNumberOfParticles - 1
                    If (sngParticleWeight(i) > sngParticleWeight(ftnBestParticle)) Then _
                     If ftnLocationWithinPose(tbpParticlePose(i).Location, tbpEstimatedPose) Then _
                       If ftnAnglesWithinUncertainty(tbpParticlePose(i).Orientation, tbpEstimatedPose.Orientation, tbpEstimatedPose.OrientationUncertainty) Then _
                           ftnBestParticle = i
                Next i
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnBestParticle")
        End Try
    End Function

    Function ftnWorstParticle(ByVal intNumberOfParticles As Short) As Short
        Try
            ftnWorstParticle = 0
            If boolEnableRBPF Then
                For i As Short = 1 To intNumberOfParticles - 1
                    If (sngParticleWeight(i) < sngParticleWeight(ftnWorstParticle)) Then
                        ftnWorstParticle = i
                    End If
                Next
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnWorstParticle")
        End Try
    End Function


    Public Sub subUnlockParticleMap(ByVal intParticleNumber As Short)
        Try         ' UnLock the particle's map so that it can be changed
            If boolSlam Then
                For intX As Short = 0 To bmpMap.Width - 1   '
                    For intY As Short = 0 To bmpMap.Height - 1
                        byteParticleMapOdds(intParticleNumber, intX, intY) = Min(byteParticleMapOdds(intParticleNumber, intX, intY), 31)
                        byteParticleMapOdds(intParticleNumber, intX, intY) = Max(byteParticleMapOdds(intParticleNumber, intX, intY), 7)
                    Next intY
                Next intX
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subUnlockParticleMap")
        End Try
    End Sub




    Public Sub subGenerateDistanceFromWallSquaredSegmentArray(ByVal intParticleNumber As Short, ByVal sngLongestScanBeam As Single) ' 
        ' Precalculate  intDistanceFromWallSquaredArray() for a segment of a particle's map which encompasses the sensor's FOV
        Dim tmcMaxScanLeft, tmcMaxScanRight, tmcMaxScanForward As typeMapCoordinate
        Dim tmcSegmentStart, tmcSegmentEnd As typeMapCoordinate
        Dim intX_Min, intX_Max, intY_Min, intY_Max As Short
        Dim intDistanceFromWallSquared As Short
        Dim tmcLocation1, tmcLocation2 As typeMapCoordinate
        Try
            Dim intMaxDistance As Short = Max(Round(sngBotRadiusGrid + sngGridSize / 2), sngOneDotFiveSigma / sngGridSize) ' > larger bot radius requires larger intMaxDistance for ftnInWall
            Dim intMaxDistanceSquared As Short = intMaxDistance * intMaxDistance

            Dim tbpPose As typeBotPose = tbpParticlePose(intParticleNumber)
            Dim sngHalfScanFOV As Single = sngScanFOV / 2
            tmcMaxScanLeft = ftnLocationFromEstimatedPose(tbpPose, sngHalfScanFOV, sngLongestScanBeam)
            tmcMaxScanRight = ftnLocationFromEstimatedPose(tbpPose, -sngHalfScanFOV, sngLongestScanBeam)
            tmcMaxScanForward = ftnLocationFromEstimatedPose(tbpPose, 0, sngLongestScanBeam)
            tmcSegmentStart = ftnLocationFromEstimatedPose(tbpPose, tmcScanVectorOffset)
            tmcSegmentEnd = tmcSegmentStart
            tmcSegmentStart.X = Min(tmcSegmentStart.X, tmcMaxScanLeft.X)
            tmcSegmentStart.X = Min(tmcSegmentStart.X, tmcMaxScanRight.X)
            tmcSegmentStart.X = Min(tmcSegmentStart.X, tmcMaxScanForward.X) - intMaxDistance
            tmcSegmentStart.Y = Min(tmcSegmentStart.Y, tmcMaxScanLeft.Y)
            tmcSegmentStart.Y = Min(tmcSegmentStart.Y, tmcMaxScanRight.Y)
            tmcSegmentStart.Y = Min(tmcSegmentStart.Y, tmcMaxScanForward.Y) - intMaxDistance
            tmcSegmentStart = ftnCheckMapArrayLimits(tmcSegmentStart)

            tmcSegmentEnd.X = Max(tmcSegmentEnd.X, tmcMaxScanLeft.X)
            tmcSegmentEnd.X = Max(tmcSegmentEnd.X, tmcMaxScanRight.X)
            tmcSegmentEnd.X = Max(tmcSegmentEnd.X, tmcMaxScanForward.X) + intMaxDistance
            tmcSegmentEnd.Y = Max(tmcSegmentEnd.Y, tmcMaxScanLeft.Y)
            tmcSegmentEnd.Y = Max(tmcSegmentEnd.Y, tmcMaxScanRight.Y)
            tmcSegmentEnd.Y = Max(tmcSegmentEnd.Y, tmcMaxScanForward.Y) + intMaxDistance
            tmcSegmentEnd = ftnCheckMapArrayLimits(tmcSegmentEnd)
            For intX As Short = tmcSegmentStart.X + 1 To tmcSegmentEnd.X - 1   ' Convert the Particle's Odds Array into occupied / free cells for area which encompasses the sensor's FOV
                For intY As Short = tmcSegmentStart.Y + 1 To tmcSegmentEnd.Y - 1
                    boolOccupiedCell(intX, intY) = (byteParticleMapOdds(intParticleNumber, intX, intY) > 16)
                Next intY
            Next intX
            For tmcLocation1.X = tmcSegmentStart.X + 1 To tmcSegmentEnd.X - 1 ' Mark wall edges as Distance = 0, otherwise = intMaxDistanceSquared
                For tmcLocation1.Y = tmcSegmentStart.Y + 1 To tmcSegmentEnd.Y - 1
                    If boolOccupiedCell(tmcLocation1.X, tmcLocation1.Y) Then
                        If (Not boolOccupiedCell(tmcLocation1.X, tmcLocation1.Y + 1)) Then
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        ElseIf (Not boolOccupiedCell(tmcLocation1.X, tmcLocation1.Y - 1)) Then
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        ElseIf (Not boolOccupiedCell(tmcLocation1.X + 1, tmcLocation1.Y)) Then
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        ElseIf (Not boolOccupiedCell(tmcLocation1.X - 1, tmcLocation1.Y)) Then
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        Else
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = intMaxDistanceSquared
                        End If
                    Else
                        intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = intMaxDistanceSquared
                    End If
                Next tmcLocation1.Y
            Next tmcLocation1.X

            Dim intX_Diff As Short
            For intX As Short = tmcSegmentStart.X To tmcSegmentEnd.X
                For intY As Short = tmcSegmentStart.Y To tmcSegmentEnd.Y
                    tmcLocation1.X = intX
                    tmcLocation1.Y = intY
                    If (intDistanceFromWallSquaredArray(intX, intY) = 0) Then  ' location is a wall edge.  Populate nearby cells with distance from this location.
                        intX_Min = (intX - intMaxDistance)
                        intX_Max = (intX + intMaxDistance)
                        intY_Min = (intY - intMaxDistance)
                        intY_Max = (intY + intMaxDistance)
                        subCheckMapArrayLimits(intX_Min, intX_Max, intY_Min, intY_Max)
                        For tmcLocation2.X = intX_Min To intX_Max ' left and right neighbors
                            intX_Diff = Abs(tmcLocation2.X - intX)
                            For tmcLocation2.Y = intY_Min To intY_Max ' up and down neighbors
                                intDistanceFromWallSquared = intSquareDistanceArray(intX_Diff, Abs(tmcLocation2.Y - intY))
                                intDistanceFromWallSquaredArray(tmcLocation2.X, tmcLocation2.Y) = Min(intDistanceFromWallSquaredArray(tmcLocation2.X, tmcLocation2.Y), intDistanceFromWallSquared)
                            Next tmcLocation2.Y
                        Next tmcLocation2.X
                    End If
                Next intY
            Next intX
            'If boolDebugRBPF Then frmDebug.subWriteLogs(Color.Red, intParticleNumber & ": subGenerateDistanceFromWallSquaredSegmentArray End Time = " & Convert.ToSingle(Now().Subtract(timeRBPF_LocalizationStart).TotalMilliseconds.ToString))
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subGenerateDistanceFromWallSquaredSegmentArray")
            frmDebug.subWriteLogs(Color.Red, "ERROR:  " & ex.Message)
        End Try
    End Sub


    Function ftnLongestBeamDistance() As Single
        Try
            ftnLongestBeamDistance = 0
            For intBeamNumber As Short = 0 To constMaxScannerBeams - 1 ' 
                If (trvScanVectors(intBeamNumber).sngRange > ftnLongestBeamDistance) Then ftnLongestBeamDistance = trvScanVectors(intBeamNumber).sngRange
            Next intBeamNumber
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnLongestBeamDistance")
        End Try
    End Function

End Module

