﻿Imports System.Math

Module modLocalizeTop


    Public Function ftnLocalize_Top(ByVal tbpEstimatedPose As typeBotPose, ByRef boolGoodLocalization As Boolean) As typeBotPose
        Try
            ftnLocalize_Top = tbpEstimatedPose
            boolGoodLocalization = False
            If Not boolSimulatedMovement And Not boolShutDown And Not boolLocalizationInProgress Then
                boolLocalizationInProgress = True
                GotABotClass.Cursor = Cursors.WaitCursor
                Dim boolSettingsChangedOld As Boolean = boolSettingsChanged
                tbpEstimatedPose.Orientation = ftnConvertTo360(tbpEstimatedPose.Orientation)
                Dim tbp2DPose, tbpVisualPose As typeBotPose
                Dim boolGood2DLocalization As Boolean = False
                Dim boolGoodVisualLocalization As Boolean = False
                Dim boolStoppedB4Start As Boolean = (GotABotClass.picStop.BorderStyle = FormBorderStyle.Fixed3D)
                Dim sngRMSError As Single = 0
                strStatusDriving = intDrivingSequenceNumber & ":  Localize = "

                If ftnScannerEnabled() Or boolRangersAreEnabled Then
                    If boolEnableRBPF Then
                        tbp2DPose = ftnLocalizeRBPF_Top(tbpEstimatedPose, boolGood2DLocalization)
                    Else
                        tbp2DPose = ftnLocalizeFrom2DScan_Top(ftnLocalize_Top, tbpEstimatedPose, boolBotIsMoving, boolGood2DLocalization, sngRMSError)
                    End If
                End If

                If ftnVisualRecognizerEnabled() Then
                    If (Not boolGood2DLocalization Or (ftnPoseUncertaintyFactor(tbp2DPose) > 442)) Then  '(442 = (13 inches + 13 inches) * 17 degrees)
                        subStartImageRecognition()
                        tbpVisualPose = ftnLocalizeUsingVisualLMsTop(ftnLocalize_Top, tbpEstimatedPose, boolGoodVisualLocalization)
                    End If
                End If

                If boolGood2DLocalization And boolGoodVisualLocalization Then
                    ftnLocalize_Top = ftnFindAvgPose(tbp2DPose, tbpVisualPose, 0)
                ElseIf boolGood2DLocalization Then
                    ftnLocalize_Top = tbp2DPose
                ElseIf boolGoodVisualLocalization Then
                    ftnLocalize_Top = tbpVisualPose
                End If
                boolGoodLocalization = boolGood2DLocalization Or boolGoodVisualLocalization

                frmDebug.subWritePose(ftnElapsedTime(timeMoveCommandSent) & "       Pose Derived From All Data      ", ftnLocalize_Top)
                boolSettingsChanged = boolSettingsChangedOld
                If ((GotABotClass.picStop.BorderStyle = FormBorderStyle.Fixed3D) And Not boolStoppedB4Start) Then
                    ftnLocalize_Top = tbpEstimatedPose
                    tbpBotPose = tbpEstimatedPose
                End If
                If Not boolDrivingToDestination Then GotABotClass.subRedraw(ftnLocalize_Top)
            End If
            GotABotClass.Cursor = Cursors.Arrow
            boolLocalizationInProgress = False
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnLocalize_Top")
            ftnLocalize_Top = tbpEstimatedPose
            GotABotClass.Cursor = Cursors.Arrow
            boolLocalizationInProgress = False
        End Try
    End Function






    Public Function ftnAccelerometerCheck(ByVal tbpReferencePose As typeBotPose) As typeBotPose ' check for collision using Kinect Accelerometer 
        ftnAccelerometerCheck = tbpReferencePose
#If constCompile2dAccelerometer Then
        If (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Then
            ftnTransmitGotAKinect("get accelerometer distance ", "OK", 500)
            frmDebug.subWriteLogs(Color.Red, "Kinect Accelerometer Distances: " & tmcAccelerometerDistance.X & ", " & tmcAccelerometerDistance.Y)
            Dim tmcAccelerometer As typeMapCoordinate = ftnLocationFromLocation(tbpStartingPose.Location, tbpStartingPose.Orientation, tmcAccelerometerDistance.X)
            frmDebug.subWriteLogs(Color.Navy, "Kinect Accelerometer Pose: " & tmcAccelerometer.X & ", " & tmcAccelerometer.Y)
            If (ftnDistanceBetweenLocations(tbpReferencePose.Location, tmcAccelerometer) > sngTwelveInches) Then
                'tbpReferencePose.Location = tbpStartingPose.Location
                'ftnAccelerometerCheck.Location = ftnBotOffsetLocation(tmcAccelerometerDistance)
                'ftnAccelerometerCheck.LocationUncertainty.X += ftnInchesToMapUnits(9)
                'ftnAccelerometerCheck.LocationUncertainty.X += ftnInchesToMapUnits(9)
                'ftnAccelerometerCheck.OrientationUncertainty += 15
                frmDebug.subWritePose(" Pose after Collision Detected by Kinect sensor", ftnAccelerometerCheck)
            End If
        End If
#End If
    End Function




    Function ftnFindPoseOverlap(ByVal tbpNewPoseReading As typeBotPose, ByVal tbpReferencePose As typeBotPose) As typeBotPose
        Try
            ' Use the existing pose to reduce the uncertainties of a new pose reading
            Dim intMaxX, intMaxY, intMinX, intMinY As Short
            ftnFindPoseOverlap = tbpNewPoseReading
            If (tbpNewPoseReading.Location.X + tbpNewPoseReading.LocationUncertainty.X) > (tbpReferencePose.Location.X + tbpReferencePose.LocationUncertainty.X) Then
                intMaxX = (tbpReferencePose.Location.X + tbpReferencePose.LocationUncertainty.X)
            Else
                intMaxX = (tbpNewPoseReading.Location.X + tbpNewPoseReading.LocationUncertainty.X)
            End If
            If (tbpNewPoseReading.Location.Y + tbpNewPoseReading.LocationUncertainty.Y) > (tbpReferencePose.Location.Y + tbpReferencePose.LocationUncertainty.Y) Then
                intMaxY = (tbpReferencePose.Location.Y + tbpReferencePose.LocationUncertainty.Y)
            Else
                intMaxY = (tbpNewPoseReading.Location.Y + tbpNewPoseReading.LocationUncertainty.Y)
            End If
            If (tbpNewPoseReading.Location.X - tbpNewPoseReading.LocationUncertainty.X) < (tbpReferencePose.Location.X - tbpReferencePose.LocationUncertainty.X) Then
                intMinX = (tbpReferencePose.Location.X - tbpReferencePose.LocationUncertainty.X)
            Else
                intMinX = (tbpNewPoseReading.Location.X - tbpNewPoseReading.LocationUncertainty.X)
            End If
            If (tbpNewPoseReading.Location.Y - tbpNewPoseReading.LocationUncertainty.Y) < (tbpReferencePose.Location.Y - tbpReferencePose.LocationUncertainty.Y) Then
                intMinY = (tbpReferencePose.Location.Y - tbpReferencePose.LocationUncertainty.Y)
            Else
                intMinY = (tbpNewPoseReading.Location.Y - tbpNewPoseReading.LocationUncertainty.Y)
            End If
            ftnFindPoseOverlap.LocationUncertainty.X = (intMaxX - intMinX) \ 2
            ftnFindPoseOverlap.Location.X = intMaxX - ftnFindPoseOverlap.LocationUncertainty.X
            ftnFindPoseOverlap.LocationUncertainty.Y = (intMaxY - intMinY) \ 2
            ftnFindPoseOverlap.Location.Y = intMaxY - ftnFindPoseOverlap.LocationUncertainty.Y
            ftnFindPoseOverlap = ftnMinPoseUncertainty(ftnFindPoseOverlap)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnFindPoseOverlap")
        End Try
    End Function


End Module
