﻿Imports System.Math

Module modMapArray

    ''''''''''''''''''''''''''''''''''''''''''''''
    '
    '     Map Array Module: 
    '
    '  This module is responsible for:
    '    - converting a map (bmpMap) to a byte array (byteNavigationArray)
    '              0 = free,  255 = occupied
    '    - adding a buffer space around occupied cells 
    '
    ''''''''''''''''''''''''''''''''''''''''''''''
    Public Sub subConvertMapToArray()
        ' Occupied = (colorMapPixel.R = 0) And (colorMapPixel.G = 0) And (colorMapPixel.B = 0) 
        Try
            GotABotClass.Cursor = Cursors.WaitCursor
            strStatusDriving = "Generating Map Array"
            frmDebug.subWriteLogs(Color.Red, " Generating Map Array")
            Dim colorMapPixel As Color
            ReDim byteNavigationArray(bmpMap.Width, bmpMap.Height)
            ReDim boolOccupiedCell(bmpMap.Width, bmpMap.Height)
            ReDim boolGreySpace(bmpMap.Width, bmpMap.Height)
            ReDim boolCompassIsSuspect(bmpMap.Width, bmpMap.Height)
            ReDim intDistanceFromWallSquaredArray(bmpMap.Width, bmpMap.Height)
            For intX As Short = 0 To bmpMap.Width - 1   ' Convert the map image into byteNavigationArray.   0 = free,  255 = occupied, 32 = grey
                For intY As Short = 0 To bmpMap.Height - 1
                    colorMapPixel = bmpMap.GetPixel(intX, intY)
                    boolGreySpace(intX, intY) = (colorMapPixel.R = 223) And (colorMapPixel.G = 223) And (colorMapPixel.B = 223)
                    If boolSlam Then
                        boolCompassIsSuspect(intX, intY) = False
                        If (colorMapPixel.G > 127) Then
                            byteNavigationArray(intX, intY) = 0
                            boolOccupiedCell(intX, intY) = False
                        Else
                            byteNavigationArray(intX, intY) = 255
                            boolOccupiedCell(intX, intY) = True
                        End If
                    Else
                        boolCompassIsSuspect(intX, intY) = (colorMapPixel.R = 255) And (colorMapPixel.G = 216) And (colorMapPixel.B = 176)
                        boolOccupiedCell(intX, intY) = (colorMapPixel.R = 0) And (colorMapPixel.G = 0) And (colorMapPixel.B = 0)
                        If boolCompassIsSuspect(intX, intY) Then
                            byteNavigationArray(intX, intY) = 0
                        Else
                            byteNavigationArray(intX, intY) = 255 - colorMapPixel.G
                        End If
                    End If
                Next intY
                subDoEventsIfMainThread()  ' Jan2014 - i7 - For Loop = 148 ms with and without doevents
            Next intX
            subGenerateDistanceFromWallSquaredArray()
            strStatusDriving = "Map Array Generated "
            GotABotClass.subRedraw(tbpBotPose)
            GotABotClass.Cursor = Cursors.Arrow
        Catch ex As Exception
            GotABotClass.Cursor = Cursors.Arrow
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subConvertMapToArray")
        End Try
    End Sub

    Public Sub subGenerateDistanceFromWallSquaredArray() ' 
        Dim intX_Min, intX_Max, intY_Min, intY_Max As Short
        Dim intDistanceFromWallSquared As Short
        Dim tmcLocation1, tmcLocation2 As typeMapCoordinate
        Dim intMaxDistanceFromWallGridSquares As Short = Sqrt(intMaxDistanceFromWallSquared) / sngGridSize
        Dim intX_Diff, intY_Diff, intX, intY As Short
        Try
            For tmcLocation1.X = 1 To bmpMap.Width - 2 ' Mark wall edges as Distance = 0
                For tmcLocation1.Y = 1 To bmpMap.Height - 2
                    If boolOccupiedCell(tmcLocation1.X, tmcLocation1.Y) Then
                        If (Not boolOccupiedCell(tmcLocation1.X, tmcLocation1.Y + 1)) Then
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        ElseIf (Not boolOccupiedCell(tmcLocation1.X, tmcLocation1.Y - 1)) Then
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        ElseIf (Not boolOccupiedCell(tmcLocation1.X + 1, tmcLocation1.Y)) Then
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        ElseIf (Not boolOccupiedCell(tmcLocation1.X - 1, tmcLocation1.Y)) Then
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        Else
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = intMaxDistanceFromWallSquared
                        End If
                    Else
                        intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = intMaxDistanceFromWallSquared
                    End If
                Next tmcLocation1.Y
            Next tmcLocation1.X

            For intX = 0 To bmpMap.Width - 1
                For intY = 0 To bmpMap.Height - 1
                    If (intDistanceFromWallSquaredArray(intX, intY) = 0) Then  ' location is a wall edge.  Populate nearby cells with distance from this location.
                        intX_Min = (intX - intMaxDistanceFromWallGridSquares)
                        intX_Max = (intX + intMaxDistanceFromWallGridSquares)
                        intY_Min = (intY - intMaxDistanceFromWallGridSquares)
                        intY_Max = (intY + intMaxDistanceFromWallGridSquares)
                        subCheckMapArrayLimits(intX_Min, intX_Max, intY_Min, intY_Max)
                        For tmcLocation2.X = intX_Min To intX_Max ' left and right neighbors
                            intX_Diff = Abs(tmcLocation2.X - intX)
                            For tmcLocation2.Y = intY_Min To intY_Max ' up and down neighbors
                                intY_Diff = Abs(tmcLocation2.Y - intY)
                                intDistanceFromWallSquared = intSquareDistanceArray(intX_Diff, intY_Diff)
                                intDistanceFromWallSquaredArray(tmcLocation2.X, tmcLocation2.Y) = Min(intDistanceFromWallSquaredArray(tmcLocation2.X, tmcLocation2.Y), intDistanceFromWallSquared)
                            Next tmcLocation2.Y
                        Next tmcLocation2.X
                    End If
                Next intY
            Next intX
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subGenerateDistanceFromWallSquaredArray " & ex.Message)
            frmDebug.subWriteLogs(Color.Red, "    tmcLocation1:  " & tmcLocation1.X & ", " & tmcLocation1.Y)
            frmDebug.subWriteLogs(Color.Red, "    tmcLocation2:  " & tmcLocation2.X & ", " & tmcLocation2.Y)
            frmDebug.subWriteLogs(Color.Red, "    intX_Min:  " & intX_Min)
            frmDebug.subWriteLogs(Color.Red, "    intX_Max:  " & intX_Max)
            frmDebug.subWriteLogs(Color.Red, "    intY_Min:  " & intY_Min)
            frmDebug.subWriteLogs(Color.Red, "    intY_Max:  " & intY_Max)
            frmDebug.subWriteLogs(Color.Red, "    intX:  " & intY_Max)
            frmDebug.subWriteLogs(Color.Red, "    intY:  " & intY_Max)
        End Try
    End Sub



End Module
