﻿
Imports System.Math
Imports System.Threading

Module modObstacle
    '============================================   Obstacle Avoidance ==========================================================================

    Public Function ftnObstacleAvoid(ByRef tbpEstimatedPose As typeBotPose, ByVal tbpTargetPose As typeBotPose) As typeBotPose
        Try
            Dim boolGoodLocalization As Boolean = False
            If boolEnableRBPF Then
                ftnObstacleAvoid = tbpEstimatedPose
            Else
                ftnObstacleAvoid = ftnLocalize_Top(tbpEstimatedPose, boolGoodLocalization)
            End If
            If ((String.CompareOrdinal(strTypeOfMove, "Fwd") = 0)) And Not boolSimulatedMovement Then  'TODO - Add API Range Measurements, add XY calulations Or (String.CompareOrdinal(strTypeOfMove, "XY") = 0)  see also ftnControlDriving
                Dim sngFwdDistance As Single = ftnDistanceCommanded(ftnObstacleAvoid, tbpTargetPose)
                Dim sngObstacleFwdDistance As Single
                Dim tmcObstacleLocation As typeMapCoordinate
                Dim trvObstacleVector As typeRangeVector = ftnObstacleVectorTop(ftnObstacleAvoid, strTypeOfMove, tbpTargetPose)
                sngObstacleFwdDistance = ftnObstacleForwardDistance(trvObstacleVector)
                If (sngObstacleFwdDistance <= sngFwdDistance) Then
                    ftnSendCommand("play phraseA 'Oh Oh. Obstacle Detected'")
                    frmDebug.subWriteLogs(Color.Green, intDrivingSequenceNumber & ": ")
                    frmDebug.subWriteLogs(Color.Green, intDrivingSequenceNumber & ":#########################  Obstacle Detected  ##################################### ")
                    frmDebug.subWriteLogs(Color.Green, "               Obstacle Vector =" & trvObstacleVector.sngRange & " @ " & trvObstacleVector.sngAngle & " degrees")
                    tmcObstacleLocation = ftnLocationFromEstimatedPose(ftnObstacleAvoid, trvObstacleVector)
                    GotABotClass.subRedraw(ftnObstacleAvoid)
                    subDrawScanVectors(ftnObstacleAvoid, False)
                    subDrawSmallCircle(tmcObstacleLocation, Color.Purple)

                    subWait(2500)  ' check if obstacle disappears or was a false detect
                    trvObstacleVector = ftnObstacleVectorTop(ftnObstacleAvoid, strTypeOfMove, tbpTargetPose)

                    If (sngObstacleFwdDistance <= sngFwdDistance) Then
                        ftnObstacleAvoid = ftnChangeDistanceToObstacle(ftnObstacleAvoid, trvObstacleVector)
                        ftnObstacleAvoid = ftnAddObstacleToMap(ftnObstacleAvoid, tbpTargetPose)
                        If (ftnPoseUncertaintyFactor(tbpEstimatedPose) >= 350) Then ' Obstacle was not added to map
                            ftnObstacleAvoid = ftnTurnAwayFromObstacle(ftnObstacleAvoid, trvObstacleVector)
                        End If
                    End If
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnObstacleAvoid " & ex.ToString)
        End Try
    End Function

    Function ftnChangeDistanceToObstacle(ByVal tbpEstimatedPose As typeBotPose, ByVal trvObstacleVector As typeRangeVector) As typeBotPose
        ' move forward or back to confirm if we still detect the obstacle
        Try
            Dim tbpTargetPose As typeBotPose = tbpEstimatedPose
            Dim sngObstacleFwdDistance As Single = ftnObstacleForwardDistance(trvObstacleVector)
            ftnChangeDistanceToObstacle = tbpEstimatedPose
            If (sngObstacleFwdDistance > (sngTenInches + ftnInchesToMapUnits(intScanVectorsMinRangeInches))) Then ' Move and see if obstacle still there
                frmDebug.subWriteLogs(Color.Black, "  Move closer to Obstacle")
                Dim sngFwdDistance As Single = sngObstacleFwdDistance - sngSixInches - ftnInchesToMapUnits(intScanVectorsMinRangeInches)
                tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, sngFwdDistance)
            Else
                frmDebug.subWriteLogs(Color.Green, intDrivingSequenceNumber & ": Back away from obstacle")
                strStatusDriving = intDrivingSequenceNumber & ":  Avoiding Obstacle - Back Up"
                tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, sngSixInches)
            End If
            If Not ftnInWall(tbpTargetPose.Location) Then ftnChangeDistanceToObstacle = ftnBotFwd(ftnChangeDistanceToObstacle, tbpTargetPose) ' 
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnChangeDistanceToObstacle " & ex.ToString)
        End Try
    End Function

    Function ftnTurnAwayFromObstacle(ByVal tbpEstimatedPose As typeBotPose, ByVal trvObstacleVector As typeRangeVector) As typeBotPose
        ' Turn away from obstacle in hopes that we will have a successful localization
        Try
            Dim tbpTargetPose As typeBotPose
            ftnTurnAwayFromObstacle = tbpEstimatedPose
            If (ftnConvertTo180(trvObstacleVector.sngAngle) < 0) Then
                strStatusDriving = intDrivingSequenceNumber & ":  Avoiding Obstacle - Turning Left"
                frmDebug.subWriteLogs(Color.Green, intDrivingSequenceNumber & ": Avoiding Obstacle - Turning Left")
                GotABotClass.subRedraw(tbpEstimatedPose)
                tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + 15 * (sngTwelveInches / trvObstacleVector.sngRange))
                ftnTurnAwayFromObstacle = ftnBotTurn(ftnTurnAwayFromObstacle, False, tbpTargetPose)
            Else
                strStatusDriving = intDrivingSequenceNumber & ":  Avoiding Obstacle - Turning Right"
                frmDebug.subWriteLogs(Color.Green, intDrivingSequenceNumber & ": Avoiding Obstacle - Turning Right")
                GotABotClass.subRedraw(tbpEstimatedPose)
                tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation - 20 * (sngTwelveInches / trvObstacleVector.sngRange))
                ftnTurnAwayFromObstacle = ftnBotTurn(ftnTurnAwayFromObstacle, False, tbpTargetPose)
                GotABotClass.subRedraw(tbpEstimatedPose)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnTurnAwayFromObstacle " & ex.ToString)
        End Try
    End Function

    Function ftnAddObstacleToMap(ByVal tbpEstimatedPose As typeBotPose, ByVal tbpTargetPose As typeBotPose) As typeBotPose
        ' add obstacle (temporary) to map
        Try
            ftnAddObstacleToMap = tbpEstimatedPose
            If Not boolCollisionDetected And Not boolEnableRBPF And ftnScannerEnabled() And (ftnPoseUncertaintyFactor(tbpEstimatedPose) < 350) Then
                Dim sngFwdDistance As Single = ftnDistanceCommanded(tbpEstimatedPose, tbpTargetPose)
                Dim boolGoodLocalization As Boolean = False
                ftnAddObstacleToMap = ftnLocalize_Top(ftnAddObstacleToMap, boolGoodLocalization)
                If (ftnPoseUncertaintyFactor(tbpEstimatedPose) < 350) Then
                    Dim trvObstacleVector As typeRangeVector = ftnObstacleVectorTop(tbpEstimatedPose, strTypeOfMove, tbpTargetPose)
                    Dim sngObstacleFwdDistance As Single = ftnObstacleForwardDistance(trvObstacleVector)
                    If (sngObstacleFwdDistance <= sngFwdDistance) Then
                        Dim tmcObstacleLocation As typeMapCoordinate = ftnLocationFromEstimatedPose(tbpEstimatedPose, trvObstacleVector)
                        frmDebug.subWriteLogs(Color.Red, " Adding Obstacle to Map")
                        For intBeamNumber As Short = 0 To constMaxScannerBeams - 1 Step constMaxScannerBeams \ intNumberOfBeams
                            trvObstacleVector = ftnScannerToBotCenterVector(ftnAddObstacleToMap, trvScanVectors(intBeamNumber))
                            sngObstacleFwdDistance = ftnObstacleForwardDistance(trvObstacleVector)
                            If (sngObstacleFwdDistance <= sngFwdDistance) And (Abs(trvObstacleVector.sngAngle) < 90) Then
                                tmcObstacleLocation = ftnLocationFromEstimatedPose(ftnAddObstacleToMap, trvObstacleVector)
                                byteNavigationArray(tmcObstacleLocation.X, tmcObstacleLocation.Y) = 255
                                boolOccupiedCell(tmcObstacleLocation.X, tmcObstacleLocation.Y) = True
                                subDrawSmallCircle(tmcObstacleLocation, Color.Blue)
                                frmDebug.subWriteLogs(Color.Red, " Obstacle Added at " & tmcObstacleLocation.X & ", " & tmcObstacleLocation.Y)
                            End If
                        Next intBeamNumber
                        subWait(1000)
                        subGenerateDistanceFromWallSquaredArray()
                        strStatusDriving = "New Map Array Generated "
                        tbpBotPose = ftnAddObstacleToMap
                        subGeneratePathArray()
                        ftnGeneratePathCosts(tmcDestination, tbpBotPose.Location)
                        boolMapUpdatedWithObstacle = True
                    End If
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnAddObstacleToMap " & ex.ToString)
        End Try
    End Function

    '============================================   Obstacle Detection ===================all=======================================================
    Public Function ftnObstacleDetected(ByVal tbpEstimatedPose As typeBotPose, ByVal strTypeOfMove As String, ByVal tbpTargetPose As typeBotPose) As Boolean
        Try
            ftnObstacleDetected = False
            If ((String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Or (String.CompareOrdinal(strTypeOfMove, "XY") = 0)) And Not boolSimulatedMovement Then  'TODO - Add API Range Measurements
                Dim sngFwdDistance As Single = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tbpTargetPose.Location)
                Dim trvObstacleVector As typeRangeVector = ftnObstacleVectorTop(tbpEstimatedPose, strTypeOfMove, tbpTargetPose)
                Dim sngObstacleFwdDistance As Single = ftnObstacleForwardDistance(trvObstacleVector)
                ftnObstacleDetected = (sngObstacleFwdDistance < sngFwdDistance)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnObstacleDetected")
        End Try
    End Function



    Public Function ftnObstacleVectorTop(ByVal tbpEstimatedPose As typeBotPose, ByVal strTypeOfMove As String, ByVal tbpTargetPose As typeBotPose) As typeRangeVector ' returns a vector ( relative to bot center and orientation) of nearest obstacle.
        '  checks Evolution IRs, IRs, Kinect and the map for obstacles
        Try
            ftnObstacleVectorTop.sngAngle = 0
            ftnObstacleVectorTop.sngRange = 99999
            If boolDebugObstacle And boolBotIsMoving Then frmDebug.subWriteLogs(Color.Red, " Obstacle detect Moving  -      Start ftnObstacleVectorTop")
            If (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Or (String.CompareOrdinal(strTypeOfMove, "XY") = 0) And ftnXY_TurnCompleted_DR(tbpStartingPose, tbpTargetPose) Then  ' 
                Dim sngFwdDistance As Single = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tbpTargetPose.Location)
                If boolER1Selected And boolEnableEvolutionIR_ER1 And Not boolBotIsMoving Then   ' Accessing Evolution IRs or RCM connected IRs during movement may cause communication errors
                    Dim strParsedMessage As String()
                    strParsedMessage = ftnER1_SocketCommunicate("sense all", vbCrLf, 1500).Split(vbCr)
                    strParsedMessage = strParsedMessage(0).Split(" "c)
                    If (strParsedMessage(0) = "OK") And (UBound(strParsedMessage) >= 9) Then
                        If (Val(strParsedMessage(1)) >= intEvolution_IR_Threshold) Then
                            ftnObstacleVectorTop.sngRange = 0
                            ftnObstacleVectorTop.sngAngle = 45
                            sngFwdDistance = 0
                        End If
                        If (Val(strParsedMessage(4)) >= intEvolution_IR_Threshold) And (Val(strParsedMessage(4)) >= Val(strParsedMessage(1))) Then
                            ftnObstacleVectorTop.sngRange = 0
                            ftnObstacleVectorTop.sngAngle = 0
                            sngFwdDistance = 0
                        End If
                        If (Val(strParsedMessage(7)) >= intEvolution_IR_Threshold) And (Val(strParsedMessage(7)) >= Val(strParsedMessage(4))) And (Val(strParsedMessage(7)) >= Val(strParsedMessage(1))) Then
                            ftnObstacleVectorTop.sngRange = 0
                            ftnObstacleVectorTop.sngAngle = -45
                            sngFwdDistance = 0
                        End If
                    End If
                End If ' (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0)
                If boolER1Selected And Not boolBotIsMoving Then   ' Accessing Evolution IRs or RCM connected IRs during movement may cause communication errors
                    Dim trvRangerVector As typeRangeVector = ftnRangerObstacleVector(tbpEstimatedPose)
                    If (ftnObstacleForwardDistance(trvRangerVector) < sngFwdDistance) Then
                        ftnObstacleVectorTop = trvRangerVector
                        subDebugObstacleVector(tbpEstimatedPose, "Evolution IRs", ftnObstacleVectorTop)
                    End If
                End If
                If ftnScannerEnabled() Then
                    Dim trvScannerVector As typeRangeVector = ftnScannerObstacleVector(tbpEstimatedPose)
                    If (ftnObstacleForwardDistance(trvScannerVector) < sngFwdDistance) Then
                        ftnObstacleVectorTop = trvScannerVector
                        subDebugObstacleVector(tbpEstimatedPose, "Scanner", ftnObstacleVectorTop)
                    End If
                End If
                Dim trvMapVector As typeRangeVector = ftnMapObstacleVector(tbpEstimatedPose, tbpTargetPose, strTypeOfMove)
                If (ftnObstacleForwardDistance(trvMapVector) < sngFwdDistance) Then
                    ftnObstacleVectorTop = trvMapVector
                    subDebugObstacleVector(tbpEstimatedPose, "Map", ftnObstacleVectorTop)
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnObstacleVectorTop")
        End Try
    End Function

    Sub subDebugObstacleVector(ByRef tbpEstimatedPose As typeBotPose, ByRef strSource As String, ByRef trvObstacleVector As typeRangeVector)
        Try
            If boolDebugObstacle Then
                frmDebug.subWriteLogs(Color.Black, "            OBSTACLE DETECTED By " & strSource)
                frmDebug.subWritePose("       From Pose = ", tbpEstimatedPose)
                frmDebug.subWriteLogs(Color.Black, "            Obstacle Vector  = " & trvObstacleVector.sngRange & " at " & trvObstacleVector.sngAngle & " degrees.")
                Dim tmcObstacleLocation As typeMapCoordinate = ftnLocationFromEstimatedPose(tbpEstimatedPose, trvObstacleVector.sngAngle, trvObstacleVector.sngRange)
                frmDebug.subWriteLogs(Color.Black, "           Obstacle Location = " & tmcObstacleLocation.X & ", " & tmcObstacleLocation.Y)
                Dim sngFwdDistance As Single = ftnObstacleForwardDistance(trvObstacleVector)
                frmDebug.subWriteLogs(Color.Black, "           sngFwdDistance = " & sngFwdDistance)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subDebugObstacleVector")
        End Try
    End Sub

    Function ftnMapObstacleVector(ByVal tbpEstimatedPose As typeBotPose, ByVal tbpTargetPose As typeBotPose, ByVal strTypeOfMove As String) As typeRangeVector  ' Check the map for obstacles
        Try
            ftnMapObstacleVector.sngRange = 9999
            ftnMapObstacleVector.sngAngle = 0
            Dim tmcCheckLocationCenter As typeMapCoordinate
            Dim sngDistanceToTarget As Single = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tbpTargetPose.Location) - sngBotRadius
            Dim sngDistanceFromStart As Single = sngBotRadius
            ftnMapObstacleVector.sngAngle = 0
            Do
                If (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Then
                    'tmcCheckLocationCenter = ftnNextPointOnLine(tmcCheckLocationCenter, tbpTargetPose.Location)
                    tmcCheckLocationCenter = ftnLocationFromEstimatedPose(tbpEstimatedPose, 0, sngDistanceFromStart)
                ElseIf (String.CompareOrdinal(strTypeOfMove, "XY") = 0) Then
                    tmcCheckLocationCenter = ftnXY_DR(tbpStartingPose, sngDistanceFromStart, tbpTargetPose, False).Location
                End If
                If ftnInWall(tmcCheckLocationCenter) Then ftnMapObstacleVector.sngRange = sngDistanceFromStart
                sngDistanceFromStart += sngTwoInches
            Loop Until (sngDistanceFromStart > sngDistanceToTarget) Or (ftnMapObstacleVector.sngRange <> 9999) Or boolStop
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnMapObstacleVector")
        End Try
    End Function



    Public Function ftnScannerObstacleVector(ByVal tbpEstimatedPose As typeBotPose) As typeRangeVector ' returns a vector ( relative to bot center and orientation) of nearest obstacle. 
        Try
            ftnScannerObstacleVector.sngRange = 9999
            ftnScannerObstacleVector.sngAngle = 0
            If Not ftnIAmLost(tbpEstimatedPose) Then
                ftnGetScanVectors(tbpEstimatedPose, False)
                Dim sngFwdDistanceToObstacle As Single = 9999
                Dim sngLowestFwdDistanceToObstacle As Single = 9999
                Dim sngMinRange As Single = sngBotRadius
                Dim tbpScannerPose As typeBotPose = tbpEstimatedPose
                Dim trvVectorFromBotCenter As typeRangeVector
                tbpScannerPose.Location = ftnLocationFromEstimatedPose(tbpEstimatedPose, tmcScanVectorOffset)
                Dim tmcObstacleLocation As typeMapCoordinate
                For intBeamNumber As Short = 0 To constMaxScannerBeams - 1 Step 4   ' 
                    If (trvScanVectors(intBeamNumber).sngRange > sngMinRange) And (Abs(trvScanVectors(intBeamNumber).sngAngle) < 90) Then ' 
                        tmcObstacleLocation = ftnLocationFromEstimatedPose(tbpScannerPose, trvScanVectors(intBeamNumber))
                        trvVectorFromBotCenter.sngAngle = ftnTurnAngle(tbpEstimatedPose, tmcObstacleLocation)
                        If (Abs(trvVectorFromBotCenter.sngAngle) < 90) Then
                            trvVectorFromBotCenter.sngRange = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tmcObstacleLocation)
                            sngFwdDistanceToObstacle = ftnObstacleForwardDistance(trvVectorFromBotCenter)
                            If (sngFwdDistanceToObstacle < sngLowestFwdDistanceToObstacle) Then
                                sngLowestFwdDistanceToObstacle = sngFwdDistanceToObstacle
                                ftnScannerObstacleVector = trvVectorFromBotCenter
                            End If
                        End If
                    End If
                Next intBeamNumber
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnScannerObstacleVector")
        End Try
    End Function

    Function ftnScannerToBotCenterVector(ByVal tbpEstimatedPose As typeBotPose, ByVal trvScannerVector As typeRangeVector) As typeRangeVector
        Try
            ftnScannerToBotCenterVector = trvScannerVector
            Dim tbpScannerPose As typeBotPose = tbpEstimatedPose
            tbpScannerPose.Location = ftnLocationFromEstimatedPose(tbpEstimatedPose, tmcScanVectorOffset)
            Dim tmcVectorEnd As typeMapCoordinate = ftnLocationFromEstimatedPose(tbpScannerPose, trvScannerVector)
            ftnScannerToBotCenterVector.sngAngle = ftnTurnAngle(tbpEstimatedPose, tmcVectorEnd)
            ftnScannerToBotCenterVector.sngRange = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tmcVectorEnd)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnScannerToBotCenterVector")
        End Try
    End Function

    Function ftnRangerObstacleVector(ByVal tbpEstimatedPose As typeBotPose) As typeRangeVector ' returns a vector ( relative to bot center and orientation) of nearest obstacle. 
        Try
            ftnRangerObstacleVector.sngRange = 99999
            ftnRangerObstacleVector.sngAngle = 0
            If boolVerboseLogFile Then frmDebug.subWriteLogs(Color.DarkGray, Now() & " ************************************ Check Rangers for obstacles ")
            Dim sngObstacleRange As Single = 99999
            Dim sngFwdDistanceToObstacle As Single = 99999
            Dim sngLowestFwdDistanceToObstacle As Single = sngFwdDistanceToObstacle
            Dim tmcObstacleLocation As typeMapCoordinate
            Dim tbpRangerPose As typeBotPose = tbpEstimatedPose
            Dim trvVector As typeRangeVector
            Dim trvVectorFromBotCenter As typeRangeVector
            ftnRangerObstacleVector.sngRange = 99999
            ftnRangerObstacleVector.sngAngle = 0
            If boolER1Selected Then frmRangeFinder.subGetAllRangerReadingsER1()
            For intRangerNumber As Short = 1 To intHighestEnabledRangerNumber   ' For each IR Range Finder
                If trfRangeFinders(intRangerNumber).boolEnable And (sngObstacleRange < ftnCmToMapUnits(70)) And (sngObstacleRange <> 0) Then
                    trvVector.sngRange = trfRangeFinders(intRangerNumber).sngRange
                    If (Abs(trfRangeFinders(intRangerNumber).intOrientation) < 90) Then
                        tmcObstacleLocation = ftnLocationFromEstimatedPose(tbpRangerPose, ftnConvertToTRV(trfRangeFinders(intRangerNumber).sngRange, trfRangeFinders(intRangerNumber).intOrientation))
                        tbpRangerPose.Location = ftnLocationFromEstimatedPose(tbpEstimatedPose, trfRangeFinders(intRangerNumber).intOffset)
                        trvVectorFromBotCenter.sngAngle = ftnTurnAngle(tbpEstimatedPose, tmcObstacleLocation)
                        If (Abs(trvVectorFromBotCenter.sngAngle) < 90) Then
                            trvVectorFromBotCenter.sngRange = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tmcObstacleLocation)
                            sngFwdDistanceToObstacle = ftnObstacleForwardDistance(trvVectorFromBotCenter)
                            If (sngFwdDistanceToObstacle < sngLowestFwdDistanceToObstacle) Then
                                ftnRangerObstacleVector = trvVectorFromBotCenter
                            End If
                        End If
                    End If
                End If
            Next intRangerNumber
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnRangerObstacleVector")
        End Try
    End Function

    Public Function ftnObstacleForwardDistance(ByVal trvObstacleVector As typeRangeVector) As Single
        Try
            If ((trvObstacleVector.sngRange * Sin(ftnDegreeToRadian(Abs(trvObstacleVector.sngAngle)))) < sngBotRadius) Then
                ftnObstacleForwardDistance = trvObstacleVector.sngRange * Cos(ftnDegreeToRadian(Abs(trvObstacleVector.sngAngle))) - sngBotRadius
            Else
                ftnObstacleForwardDistance = 9999
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnObstacleForwardDistance")
        End Try
    End Function



    Public Function ftnRangerBackupObstacleDistance() As Single
        ' returns the distance from the bot center to the nearest object detected behind the bot.  Must have at least one Ranger orientated at 180 degrees
        Try
            ftnRangerBackupObstacleDistance = 9999
            If boolVerboseLogFile Then frmDebug.subWriteLogs(Color.DarkGray, Now() & " **** Check for obstacles")
            If boolRangersAreEnabled Then
                For intRangerNumber As Short = 1 To intHighestEnabledRangerNumber ' For each Range Finder
                    If trfRangeFinders(intRangerNumber).boolEnable And trfRangeFinders(intRangerNumber).intOrientation = 180 Then
                        ftnRangerBackupObstacleDistance = frmRangeFinder.ftnRangeFinderRange(intRangerNumber) + sngBotRadius - trfRangeFinders(intRangerNumber).intOffset.X * sngGridSize ' Get the Range Finder reading
                        Exit Function
                    End If
                Next
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnRangerBackupObstacleDistance")
        End Try
    End Function

End Module



Module modPreventCollisions
    '  Detects potential collisions while moving 
    Public Class classObstacleMoving
        Public Event evntCollisionPredicted()
        Public Sub subPreventCollisions()
            Try
                Dim trvObstacleVector As typeRangeVector
                Dim sngDistanceToObstacle As Single
                Dim sngSafeDistance As Single = sngfortyInches * sngBotLinearVelocity / 50
                Dim sngMinDistance As Single = sngSixInches * sngBotLinearVelocity / 50
                Dim intLoopCnt As Short = 0
                Dim tbpPoseWhileMovingDR As typeBotPose = tbpBotPose
                Dim sngCorrelation As Single = 0
                Dim boolValidLocation As Boolean = False
                Dim sngMaxDistanceToTravel As Single
                While Not boolShutDown
                    sngMaxDistanceToTravel = ftnDistanceBetweenLocations(tbpTargetPoseGlobal.Location, tbpStartingPose.Location)
                    While boolBotIsMoving And boolDrivingToDestination And Not boolSimulatedMovement And Not boolStop
                        intLoopCnt += 1
                        If boolDebugObstacle And boolBotIsMoving Then frmDebug.subWriteLogs(Color.Red, Now() & " Obstacle detect Moving  - Start subPreventCollisions")
                        If (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Or (String.CompareOrdinal(strTypeOfMove, "XY") = 0) Then
                            tbpPoseWhileMovingDR = ftnLocalizeUsingDeadReckoning(tbpPoseWhileMovingDR, intScannerDelay, timeMoveCommandSent, tbpStartingPose, tbpTargetPoseGlobal, strTypeOfMove, False)   ' 
                            Dim sngDistanceLeftToTravel As Single = Min(ftnDistanceBetweenLocations(tbpTargetPoseGlobal.Location, tbpPoseWhileMovingDR.Location), sngMaxDistanceToTravel)
                            If (sngDistanceLeftToTravel > sngMinDistance) Then
                                trvObstacleVector = ftnObstacleVectorTop(tbpPoseWhileMovingDR, strTypeOfMove, tbpTargetPoseGlobal)
                                sngDistanceToObstacle = Min(ftnObstacleForwardDistance(trvObstacleVector), sngMaxDistanceToTravel)
                                If (sngDistanceToObstacle < sngDistanceLeftToTravel) And (sngDistanceToObstacle < sngSafeDistance) And (sngDistanceLeftToTravel > sngMinDistance) And boolBotIsMoving Then
                                    RaiseEvent evntCollisionPredicted()
                                    subDoEventsOnMainThread()
                                    Thread.Sleep(100)
                                    While boolBotIsMoving And Not boolStop
                                        Thread.Sleep(100)
                                    End While
                                    frmDebug.subWriteLogs(Color.Black, " /// Collision was Predicted: Range = " & trvObstacleVector.sngRange & " at " & trvObstacleVector.sngAngle & " degrees.")
                                    If boolDebugObstacle Then
                                        frmDebug.subWriteLogs(Color.Black, Now() & " sngDistanceLeftToTravel = " & sngDistanceLeftToTravel & " sngDistanceToObstacle =  " & sngDistanceToObstacle)
                                        frmDebug.subWriteLogs(Color.Black, Now() & " sngMinDistance = " & sngMinDistance & " sngMaxDistanceToTravel =  " & sngMaxDistanceToTravel & " sngSafeDistance =  " & sngSafeDistance)
                                    End If
                                    Thread.Sleep(100)
                                End If
                            End If
                        End If
                        Thread.Sleep(100)
                    End While
                    If boolDebugObstacle Then _
                      If (intLoopCnt > 0) And (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Then _
                        frmDebug.subWriteLogs(Color.Black, "        (Checked for Obstacles " & intLoopCnt & " times)")
                    intLoopCnt = 0
                    Thread.Sleep(250)
                End While
            Catch ex As Exception
                frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subPreventCollisions")
            End Try
        End Sub

    End Class
End Module

