﻿

Imports System.Speech
Imports System.Speech.Recognition


Module modSpeechRecognition


    '================== Speech Recognition   ========================
    Dim strVoiceCommand As String = ""



    Public WithEvents reco As New SpeechRecognitionEngine

    Public Sub subStartSpeechRecognition()
        Try
            If reco IsNot Nothing Then
                reco.RecognizeAsyncStop()
                Dim gram As New Recognition.SrgsGrammar.SrgsDocument
                Dim GotAVoiceRule As New Recognition.SrgsGrammar.SrgsRule("GotAVoice")
                Dim GotAVoiceList As New Recognition.SrgsGrammar.SrgsOneOf("destination", "stop", "clockwise", "anticlockwise", "pausemode", _
                                                                           "alpha", "bravo", "charlie", "delta", "echo", _
                                                                            "elevate", "depress", "forwards", "backwards", _
                                                                             "recharge", _
                                                                           "status", "localize", "telltime", _
                                                                           "forecast", _
                                                                           "newscast", "npr", "bbc", "foxnews", _
                                                                           "batchfile", "funny", _
                                                                           "gotabot", _
                                                                           "thankyou", "goodbye", "hello")
                GotAVoiceRule.Add(GotAVoiceList)
                gram.Rules.Add(GotAVoiceRule)
                gram.Root = GotAVoiceRule
                reco.LoadGrammar(New Recognition.Grammar(gram))
                reco.SetInputToDefaultAudioDevice()
                reco.RecognizeAsync(RecognizeMode.Multiple)
                timeOut = Now().AddMonths(1)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subStartSpeechRecognition " & ex.ToString)
        End Try
    End Sub

    'Dim boolIgnoreSpeech As Boolean = False
    Public Sub subDisableSpeechRecognition()
        Try
            'strVoiceCommand = ""
            'reco.RecognizeAsyncCancel()
            'boolIgnoreSpeech = True
            'reco.SetInputToNull()
            'reco.UnloadAllGrammars()
            'reco.RecognizeAsyncStop()
            'reco.RecognizeAsyncCancel()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subDisableSpeechRecognition " & ex.ToString)
        End Try
    End Sub

 
    Public Sub subSpeechEnableChange()
        Try
            If GotABotClass.mnuVoiceCommandEnable.Checked Then
                subStartSpeechRecognition()
            Else
                subDisableSpeechRecognition()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subSpeechEnableChange")
        End Try
    End Sub

    Dim timeOut As DateTime
    Private Sub reco_SpeechRecognized(ByVal sender As Object, ByVal e As System.Speech.Recognition.RecognitionEventArgs) Handles reco.SpeechRecognized
        Try
            If boolVoiceCommandEnable Then
                strStatusDriving = strVoiceCommand & e.Result.Text
                If boolDebugSpeech Then _
                  frmDebug.subWriteLogs(Color.Black, Now() & " new speech = " & e.Result.Text)
                If boolBotIsMoving Then
                    strVoiceCommand = ""
                ElseIf (e.Result.Text = "gotabot") Then
                    strVoiceCommand = "command "
                    timeOut = Now().AddSeconds(7)
                    ftnSendCommand("play phrase prompt")
                ElseIf CBool(InStr(strVoiceCommand, "command")) Then
                    If (Now() > timeOut) Then
                        strVoiceCommand = ""
                        ftnSendCommand("play phrase wrong")
                        strStatusDriving = ""
                        strVoiceCommand = ""
                        GotABotClass.subRedraw(tbpBotPose)
                    ElseIf (strVoiceCommand = "command ") Then
                        Select Case e.Result.Text
                            Case "stop"
                                strVoiceCommand = ""
                                tbpBotPose = modBotMovementControl.ftnBotStop(tbpBotPose, tbpTargetPoseGlobal)
                                ftnSendCommand("play phrase 'I am stopped'")
                                tbpBotPose = ftnLocalize_Top(tbpBotPose, True)
                                strVoiceCommand = ""
                            Case "pausemode"
                                strVoiceCommand = ""
                                boolPause = Not boolPause
                                If boolPause Then ftnSendCommand("play phrase 'I am in pause mode.'")
                                If boolPause Then frmDebug.subWriteLogs(Color.Black, Now() & "    >>>>  PAUSE voice command received  >>> ")
                                strVoiceCommand = ""
                            Case "status"
                                strVoiceCommand = ""
                                ftnSendCommand("battery") ' allows extra time for Bot deacceleration 
                                If (sngBotBatteryVoltage < 11.4) Or (sngLaptopBatteryPercent < 40) Then
                                    ftnSendCommand("play phrase 'Battery is low'")
                                ElseIf (sngBotBatteryVoltage < 11.9) Or (sngLaptopBatteryPercent < 90) Then
                                    ftnSendCommand("play phrase 'Battery is OK'")
                                Else
                                    ftnSendCommand("play phrase 'Battery is full'")
                                End If
                                If Not GotABotClass.InvokeRequired Then subWait(300)
                                If ftnLocationsEqual(tbpBotPose.Location, tmcDock) Or boolDocked Then
                                    ftnSendCommand("play phrase 'I am at my docking station'")
                                ElseIf boolDock Then
                                    strVoiceCommand = ""
                                    ftnSendCommand("play phrase 'I am docking'")
                                ElseIf boolDrivingToDestination Then
                                    strVoiceCommand = ""
                                    ftnSendCommand("play phrase 'I am driving to destination'")
                                ElseIf ftnIAmLost(tbpBotPose) Then
                                    strVoiceCommand = ""
                                    ftnSendCommand("play phrase 'I am lost'")
                                End If
                                If boolPause Then ftnSendCommand("play phrase 'I am in pause mode'")
                                strVoiceCommand = ""
                            Case "thankyou"
                                strVoiceCommand = ""
                                subThanks()
                                strVoiceCommand = ""
                            Case "byebye"
                                strVoiceCommand = ""
                                subGoodBye()
                            Case "goodbye"
                                strVoiceCommand = ""
                                subGoodBye()
                                strVoiceCommand = ""
                            Case "hello"
                                strVoiceCommand = ""
                                subHi()
                                strVoiceCommand = ""
                            Case "localize"
                                tbpBotPose = ftnLocalize_Top(tbpBotPose, True)
                                strVoiceCommand = ""
                            Case "foxnews"
                                strVoiceCommand = ""
                                subVoiceAddWord("command ", "fox")
                            Case "npr"
                                strVoiceCommand = ""
                                subVoiceAddWord("command ", e.Result.Text)
                            Case "bbc"
                                strVoiceCommand = ""
                                subVoiceAddWord("command ", e.Result.Text)
                            Case "forecast"
                                strVoiceCommand = ""
                                Dim strWeather As String = ftnGetWeatherRSS(strWeatherURL)
                                strVoiceCommand = ""
                                ftnSendCommand("play phrase '" & strWeather & "'")
                                strVoiceCommand = ""
                            Case "telltime"
                                strVoiceCommand = ""
                                Dim strTime As String = DateTime.Now().ToShortTimeString()
                                ftnSendCommand("play phrase '" & strTime & "'")
                                strVoiceCommand = ""
                            Case "recharge"
                                frmDock.subDock()
                                strVoiceCommand = ""
                            Case "funny"
                                strVoiceCommand = ""
                                subJoke()
                                strVoiceCommand = ""
                            Case "newscast"
                                strVoiceCommand = ""
                                ftnSendCommand("play phraseA 'Starting news.'")
                                Process.Start(strNewsURL)
                                strVoiceCommand = ""
                            Case "forwards"
                                strVoiceCommand = ""
                                ftnSendCommand("play phraseA 'Moving forward.'")
                                Dim tbpTargetPose As typeBotPose = tbpBotPose
                                tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, sngTwelveInches)
                                tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                                strVoiceCommand = ""
                            Case "backwards"
                                strVoiceCommand = ""
                                ftnSendCommand("play phraseA 'Moving back.'")
                                Dim tbpTargetPose As typeBotPose = tbpBotPose
                                tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, -sngSixInches)
                                tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                                strVoiceCommand = ""
                            Case "clockwise"
                                strVoiceCommand = ""
                                ftnSendCommand("play phraseA 'Turning Right.'")
                                Dim tbpTargetPose As typeBotPose = tbpBotPose
                                tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation - 45)
                                tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                            Case "anticlockwise"
                                strVoiceCommand = ""
                                ftnSendCommand("play phraseA 'Turning Left.'")
                                Dim tbpTargetPose As typeBotPose = tbpBotPose
                                tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + 45)
                                tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                            Case "elevate"
                                If boolKinectDriversInstalled Then  ' KLUDGE
                                    If K_Sensor IsNot Nothing Then _
                                        K_Sensor.ElevationAngle() = K_Sensor.ElevationAngle() + 5
                                End If
                                strVoiceCommand = ""
                            Case "depress"
                                If boolKinectDriversInstalled Then  ' KLUDGE
                                    If K_Sensor IsNot Nothing Then _
                                        K_Sensor.ElevationAngle() = K_Sensor.ElevationAngle() - 5
                                End If
                                strVoiceCommand = ""
                            Case "destination"
                                timeOut = Now().AddSeconds(15)
                                subVoiceAddWord("command ", "move")
                            Case "batchfile"
                                subVoiceAddWord("command ", "batch")
                        End Select
                    Else
                        Select Case e.Result.Text
                            Case "newscast"
                                strVoiceCommand = ""
                                If (strVoiceCommand = "command fox ") Then
                                    ftnSendCommand("play phraseA 'Starting fox news.'")
                                    Process.Start(" http://affiliates.foxnewsradio.com/radio/player.html")
                                ElseIf (strVoiceCommand = "command bbc ") Then
                                    ftnSendCommand("play phraseA 'Starting b b c news.'")
                                    Process.Start("http://tunein.com/radio/Newshour-(BBC)-p5/")
                                ElseIf (strVoiceCommand = "command npr ") Then
                                    ftnSendCommand("play phraseA 'Starting n p r news.'")
                                    Process.Start("http://www.npr.org/player/v2/mediaPlayer.html?action=1&t=4&islist=false")
                                Else
                                    subVoiceError()
                                End If
                                strVoiceCommand = ""
                            Case "elevate"
                                If boolKinectDriversInstalled Then  ' KLUDGE
                                    If K_Sensor IsNot Nothing Then
                                        If (strVoiceCommand = "command elevate ") Then
                                            strVoiceCommand &= e.Result.Text
                                            K_Sensor.ElevationAngle() = K_Sensor.ElevationAngle() + 5
                                        Else
                                            subVoiceError()
                                        End If
                                    End If
                                End If
                                strVoiceCommand = ""
                            Case "depress"
                                If boolKinectDriversInstalled Then  ' KLUDGE
                                    If K_Sensor IsNot Nothing Then
                                        If (strVoiceCommand = "command elevate ") Then
                                            strVoiceCommand &= e.Result.Text
                                            K_Sensor.ElevationAngle() = K_Sensor.ElevationAngle() - 5
                                        Else
                                            subVoiceError()
                                        End If
                                    End If
                                End If
                                strVoiceCommand = ""
                            Case Else
                                subDriveToDestination_Voice(e.Result.Text)
                                subBatchFile(e.Result.Text)
                        End Select
                    End If
                    If (strVoiceCommand <> "") Then strStatusDriving = strVoiceCommand
                    GotABotClass.subUpdateStatusLine()
                    GotABotClass.Refresh()
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in reco_SpeechRecognized")
        End Try
    End Sub

    Sub subVoiceAddWord(ByVal strRequired As String, ByVal strRecognized As String)
        Try
            If (strVoiceCommand = strRequired) Then
                strVoiceCommand &= strRecognized & " "
            Else
                subVoiceError()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subVoiceAddWord")
        End Try
    End Sub




    Sub subBatchFile(ByVal strCommand As String)
        Try
            If (strVoiceCommand = "command batch ") Then
                Select Case strCommand
                    Case "alpha"
                        strVoiceCommand = ""
                        If (Dir("kbatch_alpha.bat") <> "") Then
                            ftnSendCommand("play phrase 'starting batch file alpha")
                            Process.Start("kbatch_alpha.bat")
                        Else
                            ftnSendCommand("play phrase 'Batch file not found")
                        End If
                    Case "bravo"
                        strVoiceCommand = ""
                        If (Dir("kbatch_bravo.bat") <> "") Then
                            ftnSendCommand("play phrase 'starting batch file bravo")
                            Process.Start("kbatch_bravo.bat")
                        Else
                            ftnSendCommand("play phrase 'Batch file not found")
                        End If
                    Case "charlie"
                        strVoiceCommand = ""
                        If (Dir("kbatch_charlie.bat") <> "") Then
                            ftnSendCommand("play phrase 'starting batch file charlie")
                            Process.Start("kbatch_charlie.bat")
                        Else
                            ftnSendCommand("play phrase 'Batch file not found")
                        End If
                    Case "delta"
                        strVoiceCommand = ""
                        If (Dir("kbatch_delta.bat") <> "") Then
                            ftnSendCommand("play phrase 'starting batch file delta")
                            Process.Start("kbatch_delta.bat")
                        Else
                            ftnSendCommand("play phrase 'Batch file not found")
                        End If
                    Case "echo"
                        strVoiceCommand = ""
                        If (Dir("kbatch_echo.bat") <> "") Then
                            ftnSendCommand("play phrase 'starting batch file echo")
                            Process.Start("kbatch_echo.bat")
                        Else
                            ftnSendCommand("play phrase 'Batch file not found")
                        End If
                End Select
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subBatchFile")
        End Try
    End Sub

    Sub subDriveToDestination_Voice(ByVal strCommand As String)
        Try
            If (strVoiceCommand = "command move ") Then
                Select Case strCommand
                    Case "alpha"
                        strVoiceCommand = ""
                        subDriveToUserChosenDestination(tmcDestinationAlpha)
                    Case "bravo"
                        strVoiceCommand = ""
                        subDriveToUserChosenDestination(tmcDestinationBravo)
                    Case "charlie"
                        strVoiceCommand = ""
                        subDriveToUserChosenDestination(tmcDestinationCharlie)
                    Case "delta"
                        strVoiceCommand = ""
                        subDriveToUserChosenDestination(tmcDestinationDelta)
                    Case "echo"
                        strVoiceCommand = ""
                        subDriveToUserChosenDestination(tmcDestinationEcho)
                End Select
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subDriveToDestination_Voice")
        End Try
    End Sub

    Function ftnsubDriveToDestination_Voice(ByVal tmcVoiceDestination As typeMapCoordinate) As Boolean
        Try
            ftnsubDriveToDestination_Voice = False
            GotABotClass.subRedraw(tbpBotPose)
            subDrawDestination(tmcVoiceDestination)
            If ftnInWall(tmcVoiceDestination) Then
                strStatusDriving = "In Wall"
                GotABotClass.subRedraw(tbpBotPose)
                ftnSendCommand("play phrase ' I'm sorry Dave. I'm afraid I can't do that '")
            Else
                frmDebug.subWriteLogs(Color.Black, " ")
                boolStop = False
                GotABotClass.picStop.BorderStyle = FormBorderStyle.None
                frmDebug.subWriteLogs(Color.Black, " ")
                frmDebug.subWriteLogs(Color.Black, " ")
                frmDebug.subWriteLogs(Color.Black, " ******************************************************************************************")
                frmDebug.subWriteLogs(Color.Black, " ")
                frmDebug.subWriteLogs(Color.Black, " GOTABOT       (Version " & My.Application.Info.Version.ToString(3) & ")")
                frmDebug.subWriteLogs(Color.Black, " New destination selected: Location = " & tmcVoiceDestination.X & ", " & tmcVoiceDestination.Y)
                ftnSendCommand("play phraseA OK")
                boolDock = False
                GotABotClass.mnuDock.Checked = False
                tmcDestination = tmcVoiceDestination
                ftnsubDriveToDestination_Voice = ftnDriveToDestination_Top(tbpBotPose, tmcVoiceDestination)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnsubDriveToDestination_Voice " & ex.ToString)
        End Try
    End Function



    Sub subVoiceError()
        Try
            strVoiceCommand = ""
            timeOut = Now().AddMonths(1)
            ftnSendCommand("play phrase wrong")
            frmDebug.subWriteLogs(Color.Red, "subVoiceError: " & strVoiceCommand)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subVoiceError")
        End Try
    End Sub

    Public Sub subTextToSpeech(ByVal strText As String)
        Try
            Dim synth As New Synthesis.SpeechSynthesizer
            synth.SetOutputToDefaultAudioDevice()
            synth.Volume = 100
            synth.Speak(strText)
            synth.Dispose()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subTextToSpeech")
        End Try
    End Sub


End Module

