﻿' This module contains subroutine and functions which are used by multiple modules

Imports System.Drawing.Imaging
Imports System.Drawing
Imports System.Math
Imports System.Threading
Imports System.EventArgs


Public Module modUtilities

    Public Function ftnConvertTo360(ByRef intAngle As Short) As Short
        ftnConvertTo360 = intAngle
        While ftnConvertTo360 >= 360
            ftnConvertTo360 -= 360
        End While
        While ftnConvertTo360 < 0
            ftnConvertTo360 += 360
        End While
    End Function

    Public Function ftnConvertTo360(ByRef sngAngle As Single) As Single
        ftnConvertTo360 = sngAngle
        While ftnConvertTo360 >= 360
            ftnConvertTo360 -= 360
        End While
        While ftnConvertTo360 < 0
            ftnConvertTo360 += 360
        End While
    End Function

    Public Function ftnConvertTo360(ByRef dblAngle As Double) As Double
        ftnConvertTo360 = dblAngle
        While ftnConvertTo360 >= 360
            ftnConvertTo360 -= 360
        End While
        While ftnConvertTo360 < 0
            ftnConvertTo360 += 360
        End While
    End Function

    Public Function ftnConvertTo180(ByRef intAngle As Short) As Short
        ftnConvertTo180 = intAngle
        While ftnConvertTo180 > 180
            ftnConvertTo180 -= 360
        End While
        While ftnConvertTo180 < -180
            ftnConvertTo180 += 360
        End While
        If ftnConvertTo180 = 360 Then ftnConvertTo180 = 0
    End Function

    Public Function ftnConvertTo180(ByRef sngAngle As Single) As Single
        ftnConvertTo180 = sngAngle
        While ftnConvertTo180 > 180
            ftnConvertTo180 -= 360
        End While
        While ftnConvertTo180 < -180
            ftnConvertTo180 += 360
        End While
        If ftnConvertTo180 = 360 Then ftnConvertTo180 = 0
    End Function




    Public Function ftnDistanceBetweenLocations(ByRef tmcLocation1 As typeMapCoordinate, ByRef tmcLocation2 As typeMapCoordinate) As Single
        Dim intDistanceX As Short = tmcLocation2.X - tmcLocation1.X
        Dim intDistanceY As Short = tmcLocation2.Y - tmcLocation1.Y
        ftnDistanceBetweenLocations = Sqrt(intDistanceX * intDistanceX + intDistanceY * intDistanceY) * sngGridSize
    End Function




    Public Function ftnMapUnitsToInches(ByRef sngDistanceInMapUnits As Single) As Single
        If String.CompareOrdinal(strUnits, "inch") = 0 Then
            ftnMapUnitsToInches = sngDistanceInMapUnits
        Else
            ftnMapUnitsToInches = sngDistanceInMapUnits * 0.3937
        End If
    End Function


    Public Function ftnMapUnitsToCm(ByRef sngDistanceInMapUnits As Single) As Single
        If String.CompareOrdinal(strUnits, "cm") = 0 Then
            ftnMapUnitsToCm = sngDistanceInMapUnits
        Else
            ftnMapUnitsToCm = sngDistanceInMapUnits * 2.54
        End If
    End Function


    Public Function ftnInchesToMapUnits(ByRef sngDistanceInMapUnits As Single) As Single
        If String.CompareOrdinal(strUnits, "cm") = 0 Then
            ftnInchesToMapUnits = sngDistanceInMapUnits * 2.54
        Else
            ftnInchesToMapUnits = sngDistanceInMapUnits
        End If
    End Function


    Public Function ftnCmToMapUnits(ByRef sngDistanceInMapUnits As Single) As Single
        If String.CompareOrdinal(strUnits, "cm") = 0 Then
            ftnCmToMapUnits = sngDistanceInMapUnits
        Else
            ftnCmToMapUnits = sngDistanceInMapUnits * 0.3937
        End If
    End Function




    Public Sub subWait(ByVal intMillseconds As Integer)
        Try
            Dim TimeEnd As DateTime
            TimeEnd = Now().AddMilliseconds(intMillseconds)
            Do
                If GotABotClass.InvokeRequired Then
                    subDoEventsOnMainThread()
                Else
                    subDoEventsIfMainThread()
                End If
                Thread.Sleep(15)
            Loop Until Now() > TimeEnd Or boolShutDown

            TimeEnd = Nothing
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subWait")
        End Try
    End Sub


    Public Function ftnLocationOnMapEdge(ByRef tmcLocation As typeMapCoordinate) As Boolean
        Try
            ftnLocationOnMapEdge = (tmcLocation.Y = 0) Or (tmcLocation.Y = UBound(byteNavigationArray, 2) - 1) Or _
                                   (tmcLocation.X = 0) Or (tmcLocation.X = UBound(byteNavigationArray, 1) - 1)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnLocationOnMapEdge")
        End Try
    End Function


    Public Sub subCheckMapArrayLimits(ByRef intX_Min As Short, ByRef intX_Max As Short, ByRef intY_Min As Short, ByRef intY_Max As Short)
        If intX_Min < 0 Then intX_Min = 0
        If intX_Max >= UBound(byteNavigationArray, 1) Then intX_Max = CShort(UBound(byteNavigationArray, 1) - 1)
        If intY_Min < 0 Then intY_Min = 0
        If intY_Max >= UBound(byteNavigationArray, 2) Then intY_Max = CShort(UBound(byteNavigationArray, 2) - 1)
    End Sub

    Public Sub subCheckMapArrayLimits(ByRef intX As Short, ByRef intY As Short)
        If intY < 0 Then intY = 0
        If intY >= UBound(byteNavigationArray, 2) Then intY = CShort(UBound(byteNavigationArray, 2) - 1)
        If intX < 0 Then intX = 0
        If intX >= UBound(byteNavigationArray, 1) Then intX = CShort(UBound(byteNavigationArray, 1) - 1)
    End Sub



    Public Function ftnCheckMapArrayLimits(ByRef tmcMapCoordinate As typeMapCoordinate) As typeMapCoordinate
        ftnCheckMapArrayLimits = tmcMapCoordinate
        If ftnCheckMapArrayLimits.Y < 0 Then ftnCheckMapArrayLimits.Y = 0
        If ftnCheckMapArrayLimits.Y >= UBound(byteNavigationArray, 2) Then ftnCheckMapArrayLimits.Y = CShort(UBound(byteNavigationArray, 2) - 1)
        If ftnCheckMapArrayLimits.X < 0 Then ftnCheckMapArrayLimits.X = 0
        If ftnCheckMapArrayLimits.X >= UBound(byteNavigationArray, 1) Then ftnCheckMapArrayLimits.X = CShort(UBound(byteNavigationArray, 1) - 1)
    End Function


    Public Function ftnGetLocalIPAddress() As String
        ' Author = Sam Malone 
        On Error Resume Next
        Dim h As System.Net.IPHostEntry = System.Net.Dns.GetHostEntry(System.Net.Dns.GetHostName)
        ftnGetLocalIPAddress = CType(h.AddressList.GetValue(0), System.Net.IPAddress).ToString
    End Function

    Public Function ftnAnglesWithinUncertainty(ByRef intAngle1 As Short, ByRef intAngle2 As Short, ByRef intMaxDifference As Short) As Boolean
        Try
            If (Abs(ftnAngleDifference(intAngle1, intAngle2)) <= intMaxDifference) Then
                ftnAnglesWithinUncertainty = True
            Else
                ftnAnglesWithinUncertainty = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnAnglesWithinUncertainty")
        End Try
    End Function

    Public Function ftnAnglesWithinUncertainty(ByRef sngAngle1 As Single, ByRef sngAngle2 As Single, ByRef sngMaxDifference As Single) As Boolean
        Try
            If (Abs(ftnAngleDifference(sngAngle1, sngAngle2)) <= sngMaxDifference) Then
                ftnAnglesWithinUncertainty = True
            Else
                ftnAnglesWithinUncertainty = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnAnglesWithinUncertainty")
        End Try
    End Function

    Public Function ftnOrientationPointsRight(ByVal intAngle As Short) As Boolean
        intAngle = ftnConvertTo360(intAngle)
        ftnOrientationPointsRight = (intAngle < 90) Or (intAngle > 270)
    End Function

    Public Function ftnOrientationPointsRight(ByVal sngAngle As Single) As Boolean
        sngAngle = ftnConvertTo360(sngAngle)
        ftnOrientationPointsRight = (sngAngle < 90) Or (sngAngle > 270)
    End Function

    Public Function ftnOrientationPointsUp(ByVal sngAngle As Single) As Boolean
        sngAngle = ftnConvertTo180(sngAngle)
        ftnOrientationPointsUp = (sngAngle > 0)
    End Function

    Public Function ftnP1ToP2Angle(ByRef tmcP1 As typeMapCoordinate, ByRef tmcP2 As typeMapCoordinate) As Single
        Try
            If (tmcP1.X = tmcP2.X) Then  ' don't want a divide by zero
                ftnP1ToP2Angle = 90
            Else
                ftnP1ToP2Angle = ftnRadianToDegree(Atan(Abs((tmcP1.Y - tmcP2.Y) / (tmcP1.X - tmcP2.X))))
            End If  ' only valid for quadrant 1
            If (tmcP1.X > tmcP2.X) Then ftnP1ToP2Angle = 180 - ftnP1ToP2Angle
            If (tmcP1.Y < tmcP2.Y) Then ftnP1ToP2Angle = 360 - ftnP1ToP2Angle
            ftnP1ToP2Angle = ftnConvertTo360(ftnP1ToP2Angle + 0.01)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnP1ToP2Angle")
        End Try
    End Function

    Public Function ftnP1ToP2RelativeAngle(ByRef tmcP1 As typeMapCoordinate, ByRef tmcP2 As typeMapCoordinate) As Single
        Try
            If (tmcP1.X = tmcP2.X) Then  ' don't want a divide by zero
                ftnP1ToP2RelativeAngle = 90
            Else
                ftnP1ToP2RelativeAngle = ftnRadianToDegree(Atan(Abs((tmcP1.Y - tmcP2.Y) / (tmcP1.X - tmcP2.X))))
            End If  ' 
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnP1ToP2RelativeAngle")
        End Try
    End Function

    Public Function ftnTurnAngle(ByRef tbpEstimatedPose As typeBotPose, ByRef tbpTargetPose As typeBotPose) As Single  ' 
        Try ' Returns the degrees required for the Bot to turn and point at tbpTargetPose 
            If ftnPosesEqual(tbpEstimatedPose, tbpTargetPose) Then
                ftnTurnAngle = ftnP1ToP2Angle(tbpEstimatedPose.Location, ftnLowestValueNeighbor(tbpEstimatedPose.Location)) - tbpEstimatedPose.Orientation
            ElseIf ftnLocationsEqual(tbpEstimatedPose.Location, tbpTargetPose.Location) Then
                ftnTurnAngle = ftnAngleDifference(tbpTargetPose.Orientation, tbpEstimatedPose.Orientation)
            Else
                ftnTurnAngle = ftnP1ToP2Angle(tbpEstimatedPose.Location, tbpTargetPose.Location) - tbpEstimatedPose.Orientation
            End If
            ftnTurnAngle = ftnConvertTo180(ftnTurnAngle)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnTurnAngle")
        End Try
    End Function

    Public Function ftnTurnAngle(ByRef tbpEstimatedPose As typeBotPose, ByRef tbpTargetLocation As typeMapCoordinate) As Single  ' 
        Try ' Returns the degrees required for the Bot to turn and point at tbpTargetLocation 
            ftnTurnAngle = ftnP1ToP2Angle(tbpEstimatedPose.Location, tbpTargetLocation) - tbpEstimatedPose.Orientation
            ftnTurnAngle = ftnConvertTo180(ftnTurnAngle)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnTurnAngle")
        End Try
    End Function



    Public Function ftnAngleDifference(ByRef intAngle1 As Short, ByRef intAngle2 As Short) As Short
        ftnAngleDifference = (intAngle1 - intAngle2)
        ftnAngleDifference = ftnConvertTo180(ftnAngleDifference)
    End Function

    Public Function ftnAngleDifference(ByRef sngAngle1 As Single, ByRef sngAngle2 As Single) As Single
        ftnAngleDifference = (sngAngle1 - sngAngle2)
        ftnAngleDifference = ftnConvertTo180(ftnAngleDifference)
    End Function

    Public Function ftnDegreeToRadian(ByRef sngDegress As Single) As Single
        ftnDegreeToRadian = sngDegress * 0.017453
    End Function

    Public Function ftnRadianToDegree(ByRef sngDegress As Single) As Single
        ftnRadianToDegree = sngDegress * 57.29578
    End Function




    Public Function ftnLocationFromLocation(ByRef tmcStartingLocation As typeMapCoordinate, ByRef sngAngle As Single, ByVal sngDistance As Single) As typeMapCoordinate
        Try
            sngDistance = sngDistance / sngGridSize
            ftnLocationFromLocation = tmcStartingLocation
            Dim sngAngleRadians = ftnDegreeToRadian(sngAngle)
            ftnLocationFromLocation.X += sngDistance * Math.Cos(sngAngleRadians)
            ftnLocationFromLocation.Y += sngDistance * -Math.Sin(sngAngleRadians)
            ftnLocationFromLocation = ftnCheckMapArrayLimits(ftnLocationFromLocation)
        Catch ex As Exception
            ftnLocationFromLocation = tmcStartingLocation
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnLocationFromLocation")
            frmDebug.subWriteLogs(Color.Green, " tmcStartingLocation =  " & tmcStartingLocation.X & ",  " & tmcStartingLocation.Y)
            frmDebug.subWriteLogs(Color.Green, " sngDistance = " & sngDistance)
            frmDebug.subWriteLogs(Color.Green, " sngAngle = " & sngAngle)
        End Try
    End Function

    Public Function ftnLocationFromEstimatedPose(ByRef tbpEstimatedPose As typeBotPose, ByRef tmcRelativeOffset As typeMapCoordinate) As typeMapCoordinate
        Try
            ftnLocationFromEstimatedPose = tbpEstimatedPose.Location
            Dim sngOrientationInRadians As Single = ftnDegreeToRadian(tbpEstimatedPose.Orientation)
            Dim sngCos As Single = Math.Cos(sngOrientationInRadians) / sngGridSize
            Dim sngSin As Single = Math.Sin(sngOrientationInRadians) / sngGridSize
            ftnLocationFromEstimatedPose.X = tbpEstimatedPose.Location.X + Int(tmcRelativeOffset.X * sngCos - tmcRelativeOffset.Y * sngSin)
            ftnLocationFromEstimatedPose.Y = tbpEstimatedPose.Location.Y - Int(tmcRelativeOffset.Y * sngCos + tmcRelativeOffset.X * sngSin)
            ftnLocationFromEstimatedPose = ftnCheckMapArrayLimits(ftnLocationFromEstimatedPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnLocationFromEstimatedPose")
        End Try
    End Function

    Public Function ftnLocationFromEstimatedPose(ByRef tbpEstimatedPose As typeBotPose, ByRef trvRangeVector As typeRangeVector) As typeMapCoordinate
        Try
            ftnLocationFromEstimatedPose = tbpEstimatedPose.Location
            Dim sngRange As Single = trvRangeVector.sngRange / sngGridSize
            Dim sngAbsoluteAngle As Single = ftnConvertTo180(tbpEstimatedPose.Orientation + trvRangeVector.sngAngle)
            Dim sngAbsoluteAngleRadians As Single = ftnDegreeToRadian(sngAbsoluteAngle)
            ftnLocationFromEstimatedPose.X += sngRange * Math.Cos(sngAbsoluteAngleRadians)
            ftnLocationFromEstimatedPose.Y += sngRange * -Math.Sin(sngAbsoluteAngleRadians)
            ftnLocationFromEstimatedPose = ftnCheckMapArrayLimits(ftnLocationFromEstimatedPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnLocationFromEstimatedPose")
        End Try
    End Function

    Public Function ftnLocationFromEstimatedPose(ByRef tbpEstimatedPose As typeBotPose, ByRef sngRelativeAngle As Single, ByVal sngDistance As Single) As typeMapCoordinate
        Try
            ftnLocationFromEstimatedPose = tbpEstimatedPose.Location
            sngDistance = sngDistance / sngGridSize
#If False Then
            Dim intAngle As Short = ftnConvertTo360(tbpEstimatedPose.Orientation + sngRelativeAngle) * 10
            ftnLocationFromEstimatedPose = tbpEstimatedPose.Location
            ftnLocationFromEstimatedPose.X += sngDistance * sngCoSineLookupTable(intAngle)
            ftnLocationFromEstimatedPose.Y += sngDistance * -sngSineLookupTable(intAngle)
#Else
            Dim sngAbsoluteAngle As Single = ftnConvertTo180(tbpEstimatedPose.Orientation + sngRelativeAngle)
            Dim sngAbsoluteAngleRadians As Single = ftnDegreeToRadian(sngAbsoluteAngle)
            ftnLocationFromEstimatedPose.X += sngDistance * Math.Cos(sngAbsoluteAngleRadians)
            ftnLocationFromEstimatedPose.Y += sngDistance * -Math.Sin(sngAbsoluteAngleRadians)
#End If
            ftnLocationFromEstimatedPose = ftnCheckMapArrayLimits(ftnLocationFromEstimatedPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnLocationFromEstimatedPose")
        End Try
    End Function


    Public Function ftnLocationsEqual(ByRef tmcLocation1 As typeMapCoordinate, ByRef tmcLocation2 As typeMapCoordinate) As Boolean
        If ((tmcLocation1.X = tmcLocation2.X) And (tmcLocation1.Y = tmcLocation2.Y)) Then
            ftnLocationsEqual = True
        Else
            ftnLocationsEqual = False
        End If
    End Function

    Public Function ftnPosesEqual(ByRef tbpBotPose As typeBotPose, ByRef tbpTargetPose As typeBotPose) As Boolean
        Try
            ftnPosesEqual = ftnLocationsEqual(tbpBotPose.Location, tbpTargetPose.Location) And (Abs(ftnAngleDifference(tbpBotPose.Orientation, tbpTargetPose.Orientation)) < 1)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnPosesEqual")
        End Try
    End Function

    Public Function ftnConvertToTMC(ByRef intX As Short, ByRef intY As Short) As typeMapCoordinate
        ftnConvertToTMC.X = intX
        ftnConvertToTMC.Y = intY
    End Function

    Public Function ftnConvertToTMC(ByRef intX As Integer, ByRef intY As Integer) As typeMapCoordinate
        ftnConvertToTMC.X = intX
        ftnConvertToTMC.Y = intY
    End Function

    Public Function ftnConvertToTRV(ByRef sngRange As Single, ByRef sngAngle As Single) As typeRangeVector
        ftnConvertToTRV.sngRange = sngRange
        ftnConvertToTRV.sngAngle = sngAngle
    End Function


    Public Function ftnGreyToColor(ByRef byteIntensity As Byte) As Color
        ftnGreyToColor = ColorTranslator.FromOle(RGB(byteIntensity, byteIntensity, byteIntensity))
    End Function



    Public Function ftnPoseUncertaintyFactor(ByRef tbpPose As typeBotPose) As Integer
        On Error Resume Next
        If (Int(sngGridSize) = sngGridSize) Then
            ftnPoseUncertaintyFactor = ftnMapUnitsToInches(tbpPose.LocationUncertainty.X + tbpPose.LocationUncertainty.Y) * tbpPose.OrientationUncertainty * Int(sngGridSize)
        Else
            ftnPoseUncertaintyFactor = ftnMapUnitsToInches(((tbpPose.LocationUncertainty.X + tbpPose.LocationUncertainty.Y) * tbpPose.OrientationUncertainty)) * sngGridSize
        End If
    End Function




    Public Function ftnMinPoseUncertainty(ByRef tbpPoseIn As typeBotPose) As typeBotPose
        ftnMinPoseUncertainty = tbpPoseIn
        Try
            If boolHeroSelected Then
                If tbpPoseIn.OrientationUncertainty < 10 Then ftnMinPoseUncertainty.OrientationUncertainty = 15
                If tbpPoseIn.LocationUncertainty.Y < sngTenInchesGrid Then ftnMinPoseUncertainty.LocationUncertainty.Y = sngTenInchesGrid
                If tbpPoseIn.LocationUncertainty.X < sngTenInchesGrid Then ftnMinPoseUncertainty.LocationUncertainty.X = sngTenInchesGrid
            Else
                If tbpPoseIn.OrientationUncertainty < 10 Then ftnMinPoseUncertainty.OrientationUncertainty = 10
                If tbpPoseIn.LocationUncertainty.Y < sngTenInchesGrid Then ftnMinPoseUncertainty.LocationUncertainty.Y = sngTenInchesGrid
                If tbpPoseIn.LocationUncertainty.X < sngTenInchesGrid Then ftnMinPoseUncertainty.LocationUncertainty.X = sngTenInchesGrid
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnMinPoseUncertainty")
        End Try
    End Function

    Public Function ftnRangeCorrectForHeight(ByRef tlmLandMark As typeLandMark, ByRef tirLandMark As typeImageRecognized) As Single
        On Error Resume Next
        ftnRangeCorrectForHeight = tirLandMark.Range
        If (tlmLandMark.intLandMarkHeight <> 0) Then  '  Correct range due to height difference between camera and LandMark
            ftnRangeCorrectForHeight = Sqrt(tirLandMark.Range * tirLandMark.Range - tlmLandMark.intLandMarkHeight * tlmLandMark.intLandMarkHeight)
        End If
    End Function



    Dim dblAvgPoseX As Double  ' used to keep a floating point representation of the average location.  Otherwise, the normal integer representation does not allow fine resolution with the averaging algorithm used  
    Dim dblAvgPoseY As Double
    Public Function ftnFindAvgPose(ByRef tbpAveragePose As typeBotPose, _
                                   ByRef tbpNewEstimatedPose As typeBotPose, _
                                   ByRef intPosesAveraged As Short) As typeBotPose
        Try
            Dim sngEstimateAccuracyFactor As Single
            sngEstimateAccuracyFactor = (tbpAveragePose.LocationUncertainty.X + tbpAveragePose.LocationUncertainty.Y) / _
                                        (tbpNewEstimatedPose.LocationUncertainty.X + tbpNewEstimatedPose.LocationUncertainty.Y)
            If (sngEstimateAccuracyFactor > 1) Then sngEstimateAccuracyFactor = 1
            intPosesAveraged += 1
            If (intPosesAveraged = 1) Then
                dblAvgPoseX = tbpAveragePose.Location.X
                dblAvgPoseY = tbpAveragePose.Location.Y
            End If
            Dim sngCurrentPoseFactor As Single = 1 + intPosesAveraged - sngEstimateAccuracyFactor
            dblAvgPoseX = (dblAvgPoseX * sngCurrentPoseFactor + tbpNewEstimatedPose.Location.X * sngEstimateAccuracyFactor) / (intPosesAveraged + 1)
            dblAvgPoseY = (dblAvgPoseY * sngCurrentPoseFactor + tbpNewEstimatedPose.Location.Y * sngEstimateAccuracyFactor) / (intPosesAveraged + 1)
            ftnFindAvgPose.Location.X = Round(dblAvgPoseX)
            ftnFindAvgPose.Location.Y = Round(dblAvgPoseY)
            ftnFindAvgPose.Location = ftnCheckMapArrayLimits(ftnFindAvgPose.Location)
            If (ftnInWall(ftnFindAvgPose.Location)) Then ftnFindAvgPose.Location = tbpAveragePose.Location

            tbpAveragePose.Orientation = ftnConvertTo360(tbpAveragePose.Orientation)
            tbpNewEstimatedPose.Orientation = ftnConvertTo360(tbpNewEstimatedPose.Orientation)
            If ftnOrientationPointsRight(tbpAveragePose.Orientation) Then
                ftnFindAvgPose.Orientation = ftnConvertTo360((ftnConvertTo180(tbpAveragePose.Orientation) * sngCurrentPoseFactor + ftnConvertTo180(tbpNewEstimatedPose.Orientation) * sngEstimateAccuracyFactor) / (intPosesAveraged + 1))
            Else
                ftnFindAvgPose.Orientation = ftnConvertTo360((tbpAveragePose.Orientation * sngCurrentPoseFactor + ftnConvertTo360(tbpNewEstimatedPose.Orientation) * sngEstimateAccuracyFactor) / (intPosesAveraged + 1))
            End If

            ftnFindAvgPose.OrientationUncertainty = ftnConvertTo360((tbpAveragePose.OrientationUncertainty * sngCurrentPoseFactor + tbpNewEstimatedPose.OrientationUncertainty * sngEstimateAccuracyFactor) / (intPosesAveraged + 1))
            ftnFindAvgPose.LocationUncertainty.X = (tbpAveragePose.LocationUncertainty.X * sngCurrentPoseFactor + tbpNewEstimatedPose.LocationUncertainty.X * sngEstimateAccuracyFactor) / (intPosesAveraged + 1)
            ftnFindAvgPose.LocationUncertainty.Y = (tbpAveragePose.LocationUncertainty.Y * sngCurrentPoseFactor + tbpNewEstimatedPose.LocationUncertainty.Y * sngEstimateAccuracyFactor) / (intPosesAveraged + 1)
            ftnFindAvgPose = ftnMinPoseUncertainty(ftnFindAvgPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnFindAvgPose")
        End Try
    End Function




    Public Function ftnIsValidIP(ByVal addr As String) As Boolean
        On Error Resume Next
        Dim pattern As String = "^([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(\." & _
        "([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3}$" 'create our match pattern
        Dim check As New System.Text.RegularExpressions.Regex(pattern)
        Dim valid As Boolean = False 'boolean variable to hold the status
        If addr = "" Then   'no address provided so return false
            valid = False
        Else
            valid = check.IsMatch(addr, 0) 'address provided so use the IsMatch Method
            If Not valid Then frmDebug.subWriteLogs(Color.Red, " EXCEPTION in invalid IP address")
        End If
        Return valid  'return the results
    End Function

    Public Function ftnVisualRecognizerEnabled() As Boolean
        ftnVisualRecognizerEnabled = boolEnableBotRCC Or boolEnableLocalRCC Or boolEnableLocalRR Or boolEnableGotAGlyph Or boolEnableAVM
    End Function

    Public Function ftnScannerEnabled() As Boolean
        ftnScannerEnabled = boolKinectConnected Or boolURGConnected Or (boolHeroSelected And Not boolBotIsMoving)
    End Function



    Public Sub subFindStartEndAngles(ByRef tbpEstimatedPose As typeBotPose, ByRef intStartAngle As Short, ByRef intEndAngle As Short)
        Try
            If ftnOrientationPointsRight(tbpEstimatedPose.Orientation) Then  ' Calculate the Orientation range to check for valid sightings
                intStartAngle = ftnConvertTo180(tbpEstimatedPose.Orientation - tbpEstimatedPose.OrientationUncertainty)
                intEndAngle = ftnConvertTo180(tbpEstimatedPose.Orientation + tbpEstimatedPose.OrientationUncertainty)
            Else
                intStartAngle = ftnConvertTo360(tbpEstimatedPose.Orientation - tbpEstimatedPose.OrientationUncertainty)
                intEndAngle = ftnConvertTo360(tbpEstimatedPose.Orientation + tbpEstimatedPose.OrientationUncertainty)
            End If
            If (intStartAngle > intEndAngle) And ((intStartAngle - intEndAngle + 1) < tbpEstimatedPose.OrientationUncertainty) Then _
                intStartAngle = intStartAngle - 360
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subFindStartEndAngles")
        End Try
    End Sub



    Delegate Sub DelegateSubMainThread()

    Public Sub subCheckForPause()
        Try
            If GotABotClass.InvokeRequired And Not boolShutDown Then
                Dim newDelegate As New DelegateSubMainThread(AddressOf subCheckForPause)
                GotABotClass.Invoke(newDelegate)
                Thread.Sleep(50)
            Else
                While boolPause And Not boolStop
                    strStatusDriving = " PAUSED"
                    System.Windows.Forms.Application.DoEvents()
                    Thread.Sleep(250)
                End While
                strStatusDriving = " "
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subCheckForPause")
        End Try
    End Sub



    '-----------------------------------------------------------------------------------------------------------------------------------------

    Dim dx, dy, e2, sx, sy, Err As Short
    Public Function ftnFirstPointOnLine(ByRef tmcStartingPoint As typeMapCoordinate, ByRef tmcEndPoint As typeMapCoordinate) As typeMapCoordinate
        'Bresenham's line algorithm - see http://en.wikipedia.org/wiki/Bresenham%27s_line_algorithm
        ' return the first point on a line defined by tmcStartingPoint and tmcEndPoint
        Try
            ftnFirstPointOnLine = tmcStartingPoint
            dx = Abs(tmcEndPoint.X - tmcStartingPoint.X)
            dy = Abs(tmcEndPoint.Y - tmcStartingPoint.Y)
            If tmcStartingPoint.X < tmcEndPoint.X Then sx = 1 Else sx = -1
            If tmcStartingPoint.Y < tmcEndPoint.Y Then sy = 1 Else sy = -1
            Err = dx - dy

            e2 = 2 * Err
            If e2 > -dy Then
                Err = Err - dy
                ftnFirstPointOnLine.X += sx
            End If
            If e2 < dx Then
                Err = Err + dx
                ftnFirstPointOnLine.Y += sy
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnFirstPointOnLine")
        End Try
    End Function


    Public Function ftnNextPointOnLine(ByRef tmcCurrentPoint As typeMapCoordinate, ByRef tmcEndPoint As typeMapCoordinate) As typeMapCoordinate
        'Bresenham's line algorithm - see http://en.wikipedia.org/wiki/Bresenham%27s_line_algorithm
        ' return the next point on a line defined by tmcCurrentPoint and tmcEndPoint
        Try
            ftnNextPointOnLine = tmcCurrentPoint
            e2 = 2 * Err
            If e2 > -dy Then
                Err = Err - dy
                ftnNextPointOnLine.X += sx
            End If
            If e2 < dx Then
                Err = Err + dx
                ftnNextPointOnLine.Y += sy
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnNextPointOnLine")
        End Try
    End Function







    Public Function ftnDistanceFromWallErrorSquared(ByRef tmcVectorOrigin As typeMapCoordinate, ByRef trvVector As typeRangeVector, _
                                             ByRef boolEndPointModel As Boolean, ByRef boolEndPointInGreySpace As Boolean) As Short
        ' returns the square of the error between where the vector says there is a wall vs where the map says there is a wall
        '  NOTE:  boolEndPointModel = does not check for intervening walls
        Dim tmcCheckLocation, tmcEndPoint As typeMapCoordinate
        Try
            tmcEndPoint = ftnLocationFromLocation(tmcVectorOrigin, trvVector.sngAngle, trvVector.sngRange)
            boolEndPointInGreySpace = boolGreySpace(tmcEndPoint.X, tmcEndPoint.Y)
            If ftnLocationOnMapEdge(tmcEndPoint) Then
                ftnDistanceFromWallErrorSquared = sngOneSigmaSquared
            ElseIf boolEndPointModel Then
                ftnDistanceFromWallErrorSquared = Min(intDistanceFromWallSquaredArray(tmcEndPoint.X, tmcEndPoint.Y), intOneDotFiveSigmaSquared) ' wall distance vs distance reported - squared
            Else ' Perform Ray Cast to check for intervening walls
                tmcCheckLocation = ftnFirstPointOnLine(tmcVectorOrigin, tmcEndPoint)
                While (Not ftnLocationsEqual(tmcCheckLocation, tmcEndPoint)) And _
                      Not (boolOccupiedCell(tmcCheckLocation.X, tmcCheckLocation.Y))
                    tmcCheckLocation = ftnNextPointOnLine(tmcCheckLocation, tmcEndPoint)
                    tmcCheckLocation = ftnCheckMapArrayLimits(tmcCheckLocation)
                End While
                If (boolOccupiedCell(tmcCheckLocation.X, tmcCheckLocation.Y)) Then
                    ftnDistanceFromWallErrorSquared = Min(Round((ftnDistanceBetweenLocations(tmcVectorOrigin, tmcCheckLocation) - trvVector.sngRange) ^ 2), intOneDotFiveSigmaSquared) ' 
                Else
                    ftnDistanceFromWallErrorSquared = Min(intDistanceFromWallSquaredArray(tmcCheckLocation.X, tmcCheckLocation.Y), intOneDotFiveSigmaSquared) ' wall distance vs distance reported - squared
                End If
            End If
            If (trvVector.sngRange > sngSixtyFiveInches) And Not boolEndPointInGreySpace Then _
                ftnDistanceFromWallErrorSquared *= 0.7
            If boolEndPointInGreySpace Then ftnDistanceFromWallErrorSquared *= 0.65
        Catch ex As Exception
            ftnDistanceFromWallErrorSquared = sngOneDotFiveSigma
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnDistanceFromWallErrorSquared " & ex.ToString)
            frmDebug.subWriteLogs(Color.Green, " tmcVectorOrigin =  " & tmcVectorOrigin.X & ",  " & tmcVectorOrigin.Y)
            frmDebug.subWriteLogs(Color.Green, " trvVector = " & trvVector.sngRange & " at " & trvVector.sngAngle & " degrees")
            frmDebug.subWriteLogs(Color.Green, " tmcEndPoint =  " & tmcEndPoint.X & ",  " & tmcEndPoint.Y)
            frmDebug.subWriteLogs(Color.Green, " tmcCheckLocation =  " & tmcCheckLocation.X & ",  " & tmcCheckLocation.Y)
        End Try
    End Function



    Public Function ftnFindXY_Parameters(ByRef tbpEstimatedPose As typeBotPose, ByRef tbpTargetPose As typeBotPose) As typeMapCoordinate
        ' Returns X and Y move distances
        Try
            Dim sngMoveDistanceOrAngle As Single = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tbpTargetPose.Location)
            Dim intTurnAngle As Short = ftnTurnAngle(tbpEstimatedPose, tbpTargetPose)
            Dim sngAngleOfTurnRadians As Single = ftnDegreeToRadian(intTurnAngle)
            ftnFindXY_Parameters.Y = Abs(sngMoveDistanceOrAngle * Sin(sngAngleOfTurnRadians))  '
            ftnFindXY_Parameters.X = Abs(sngMoveDistanceOrAngle * Cos(sngAngleOfTurnRadians))
            If (sngAngleOfTurnRadians < 0) Then ftnFindXY_Parameters.Y = -ftnFindXY_Parameters.Y
            If (Abs(intTurnAngle) > 90) Then ftnFindXY_Parameters.X = -ftnFindXY_Parameters.X
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnFindXY_Parameters")
        End Try
    End Function

    Public Function ftnDistanceCommanded(ByRef tbpStartingPose As typeBotPose, ByRef tbpTargetPose As typeBotPose) As Single
        ftnDistanceCommanded = ftnDistanceBetweenLocations(tbpStartingPose.Location, tbpTargetPose.Location)
        Dim intTurnAngle As Short = ftnTurnAngle(tbpStartingPose, tbpTargetPose)
        Dim boolBigTurn As Boolean = (Abs(intTurnAngle) > 160)
        If boolBigTurn Then ftnDistanceCommanded = -ftnDistanceCommanded
    End Function



    Public Sub subDoEventsIfMainThread()
        If Not GotABotClass.InvokeRequired Then System.Windows.Forms.Application.DoEvents()
    End Sub




    Public Sub subDoEventsOnMainThread()
        Try
            If GotABotClass.InvokeRequired And Not boolShutDown Then
                Dim newDelegate As New DelegateSubMainThread(AddressOf subDoEventsOnMainThread)
                GotABotClass.Invoke(newDelegate)
                Thread.Sleep(50)
            Else
                System.Windows.Forms.Application.DoEvents()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subDoEventsOnMainThread")
        End Try
    End Sub



    Public Function ftnInWall(ByRef tmcLocation As typeMapCoordinate) As Boolean
        Try
            tmcLocation = ftnCheckMapArrayLimits(tmcLocation)
            If boolOccupiedCell(tmcLocation.X, tmcLocation.Y) Then
                ftnInWall = True
            Else
                ftnInWall = (intDistanceFromWallSquaredArray(tmcLocation.X, tmcLocation.Y) < sngBotRadiusSquared)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnInWall")
            frmDebug.subWriteLogs(Color.Black, "                 tmcLocation = " & tmcLocation.X & ", " & tmcLocation.Y)
        End Try
    End Function




    Public Sub subRecalculateVariables()
        Try
            sngOneSigma = ftnInchesToMapUnits(4)
            sngOneSigmaSquared = sngOneSigma * sngOneSigma
            sngOneDotFiveSigma = 1.5 * sngOneSigma
            sngRecipOneDotFiveSigma = 1 / sngOneDotFiveSigma
            intOneDotFiveSigmaSquared = sngOneDotFiveSigma * sngOneDotFiveSigma
            sngTwoSigma = 2 * sngOneSigma
            sngOneInch = ftnInchesToMapUnits(1)
            sngOneInchGrid = sngOneInch / sngGridSize
            sngTwoInches = ftnInchesToMapUnits(2)
            sngTwoInchesGrid = sngTwoInches / sngGridSize
            sngThreeInches = ftnInchesToMapUnits(3)
            sngThreeInchesGrid = sngThreeInches / sngGridSize
            sngFourInches = ftnInchesToMapUnits(4)
            sngFourInchesGrid = sngFourInches / sngGridSize
            sngFiveInches = ftnInchesToMapUnits(5)
            sngSixInches = ftnInchesToMapUnits(6)
            sngTenInches = ftnInchesToMapUnits(10)
            sngTenInchesGrid = sngTenInches / sngGridSize
            sngTwelveInches = ftnInchesToMapUnits(12)
            sngFifteenInches = ftnInchesToMapUnits(15)
            sngTwentyInches = ftnInchesToMapUnits(20)
            sngTwentyInchesGrid = sngTwentyInches / sngGridSize
            sngTwentyFiveInches = ftnInchesToMapUnits(25)
            sngfortyInches = ftnInchesToMapUnits(40)
            sngSixtyFiveInches = ftnInchesToMapUnits(65)
            sngBotDiameterGrid = sngBotDiameter / sngGridSize
            sngBotRadius = sngBotDiameter / 2
            sngBotRadiusGrid = sngBotRadius / sngGridSize
            sngBotRadiusSquared = sngBotRadius * sngBotRadius
            sngWeakMatch = ftnMapUnitsToInches(sngOneSigma * 0.75)
            sngGoodMatch = sngWeakMatch * 0.6
            sngExcellentMatch = sngWeakMatch * 0.375
            intMaxDistanceFromWallSquared = (sngBotRadius + 0.5 + ftnInchesToMapUnits(8)) ^ 2
            If boolHeroSelected Then intMaxDistanceFromWallSquared *= 1.4 ' Hero has very poor movement control
            intSafeDistanceFromWallSquared = (sngBotRadius + 0.5 + sngThreeInches) ^ 2
            intMinDistanceFromWallSquared = (sngBotRadius + 0.5 + sngOneInch) ^ 2
            subGenerateSquaredDistanceArray()
            subRecalculateBotSpeeds()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subRecalculateVariables")
        End Try
    End Sub

    Sub subGenerateSquaredDistanceArray()
        Dim sngGridSizeSquared As Single = sngGridSize * sngGridSize
        Dim intMaxDistanceGridSquare As Short = Sqrt(intMaxDistanceFromWallSquared) / sngGridSize + 1
        ReDim intSquareDistanceArray(intMaxDistanceGridSquare, intMaxDistanceGridSquare)
        Dim intX, intY As Short
        Try
            For intX = 0 To intMaxDistanceGridSquare - 1
                For intY = 0 To intMaxDistanceGridSquare - 1
                    intSquareDistanceArray(intX, intY) = (intX * intX * sngGridSizeSquared + intY * intY * sngGridSizeSquared)
                Next intY
            Next intX
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subGenerateSquaredDistanceArray")
        End Try
    End Sub


    Sub subRecalculateBotSpeeds()
        Try
            sngBotLinearAccelerationTime = sngBotLinearVelocity / sngBotLinearAcceleration
            sngBotLinearAccelerationDistance = ftnCmToMapUnits(sngBotLinearAcceleration * sngBotLinearAccelerationTime * sngBotLinearAccelerationTime * 0.5)
            sngBotLinearVelocityXY = Min(sngBotLinearVelocity, 30)
            sngBotLinearAccelerationTimeXY = sngBotLinearVelocityXY / sngBotLinearAcceleration
            sngBotLinearAccelerationDistanceXY = ftnCmToMapUnits(sngBotLinearAcceleration * sngBotLinearAccelerationTimeXY * sngBotLinearAccelerationTimeXY * 0.5)
            sngBotAngularAccelerationTime = sngBotAngularVelocity / sngBotAngularAcceleration
            sngBotAngularAccelerationDistance = (sngBotAngularAcceleration * sngBotAngularAccelerationTime * sngBotAngularAccelerationTime * 0.5)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subRecalculateBotSpeeds")
        End Try
    End Sub

    Function ftnCheckForStopMode() As Boolean
        Try
            If (GotABotClass.picStop.BorderStyle = FormBorderStyle.Fixed3D) Then
                ftnCheckForStopMode = True
                ftnSendCommand("play phrase Beep")
                frmDebug.subWriteLogs(Color.Green, " Please exit STOP mode first")
                strStatusDriving = "Please exit STOP mode"
                GotABotClass.subRedraw(tbpStartingPose)
                MsgBox(" Please exit STOP mode first")
                strStatusDriving = ""
                GotABotClass.subRedraw(tbpStartingPose)
            Else
                ftnCheckForStopMode = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in ftnCheckForStopMode")
        End Try
    End Function


    Public Sub subUpdateMapDuringMove()
        Try
            If boolBotIsMoving Then
                tbpBotPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, 0, timeMoveCommandSent, tbpStartingPose, tbpTargetPoseGlobal, strTypeOfMove, True)
                GotABotClass.subRedraw(tbpBotPose)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Red, " EXCEPTION in subUpdateMapDuringMove")
        End Try
    End Sub



End Module
